<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);

require_once('../_include/checkaccess.inc.php');

$zugang = 0;
require(CPO_BASEDIR.'_include/check.php');

$uploadErrors = array(
    __('File was successfully uploaded.'),
    __('Note: The uploaded file exceeds the allowed size.'),
    __('Note: The uploaded file exceeds the allowed size.'),
    __('Note: The file was not uploaded completely. Please try again.'),
    __('Note: No file was received. Please try again.')
);
$imageTypes = array(
    'unknown', 
    'GIF', 
    'JPG', 
    'PNG', 
    'SWF', 
    'PSD', 
    'BMP', 
    'TIFF(intel byte order)', 
    'TIFF(motorola byte order)', 
    'JPC', 
    'JP2', 
    'JPX', 
    'JB2', 
    'SWC', 
    'IFF');

$fileNameReplacements = array(
    '//' => 'Ae',
    '//' => 'Oe',
    '//' => 'Ue',
    '//' => 'ss',
    '//' => 'ae',
    '//' => 'oe',
    '//' => 'ue',
    '//' => 'A',
    '//' => 'A',
    '//' => 'E',
    '//' => 'E',
    '//' => 'O',
    '//' => 'O',
    '//' => 'U', 
    '//' => 'U', 
    '//' => 'I', 
    '//' => 'I', 
    '//' => 'a', 
    '//' => 'a', 
    '//' => 'e', 
    '//' => 'e', 
    '//' => 'o', 
    '//' => 'o', 
    '//' => 'u', 
    '//' => 'u', 
    '//' => 'i', 
    '//' => 'i', 
    '/[^a-z0-9_\.-]/i' => '_',
);


if (isset($_FILES['uppedFiles'])){

$upped  = false;
for($i=0; $i<count($_FILES['uppedFiles']['size']); $i++) {
    if ($_FILES['uppedFiles']['name'][$i]=='') continue;
    $upped = true;
    break;
}

for($i=0; $i<count($_FILES['uppedFiles']['size']); $i++) {
    if ($_FILES['uppedFiles']['name'][$i]=='') {
        continue;
    }
    ?>
    <tr>
        <td class="leftrow"><?php echo htmlspecialchars($_FILES['uppedFiles']['name'][$i], ENT_COMPAT, 'ISO-8859-15'); ?></td>
        <td class="rightrow"> 
    <?php

    // check for errors
    if (!$_FILES['uppedFiles']['size'][$i]) {
        if (isset($_FILES['uppedFiles']['error'][$i])) // this exists since PHP 4.2
             $error = $uploadErrors[$_FILES['uppedFiles']['error'][$i]];
        // else guess the error...
        else $error = __('Unknown ERROR: Please check if the size of the file exceeds the maximum uploadable file size.');
        continue;
     }

    // upload ok
    $path = CPO_BASEDIR.'_data/';

    // modify filename to exclude characters that are not a-z A-Z 0-9 _ or .
    $filename = $_FILES['uppedFiles']['name'][$i];
    $filename = preg_replace(array_keys($fileNameReplacements), array_values($fileNameReplacements), $filename);

    // add a postfix if file exists
    $pathInfo  = pathinfo($filename);
    // 'filename' was added in PHP5.2.0, but we need to support older installations
    if (!isset($pathInfo['filename'])) {
        $pathInfo['filename'] = basename($pathInfo['basename'], $pathInfo['extension']);
    }

    $newFilename = $pathInfo['filename'] . (isset($pathInfo['extension']) ? '.' . $pathInfo['extension'] : '');

    $postfix   = '';
    $postfixNo = 0;
    while (file_exists($path . $newFilename)) {
        $postfixNo++;
        $newFilename = $pathInfo['filename'] . '-' . $postfixNo . (isset($pathInfo['extension']) ? '.' . $pathInfo['extension'] : '');
    }

    $newFilename = $path . $newFilename;
    // move the uploaded file to the new place
    if (!@move_uploaded_file($_FILES['uppedFiles']['tmp_name'][$i], $newFilename)) {
        continue;
    }
    @chmod($newFilename, 0666);

    // Check if it is an image suitable for web pages
    $checkImage = @getimagesize($newFilename);
    if ($checkImage && (
        $imageTypes[$checkImage[2]]=='JPG' || 
        $imageTypes[$checkImage[2]]=='PNG' ||
        $imageTypes[$checkImage[2]]=='GIF')) {

        // if the image-file is too big, delete it and continue
        if ($_FILES['uppedFiles']['size'][$i] > $cpoSystem['max_image']) {
            @unlink($newFilename);
            continue;
        }
        $query = "INSERT INTO ".CPO_DATA." ("
                ."beschreibung, alttext, datum, type, datei, format, user_id, rubric_id, c_time, changer) "
                ."VALUES ("
                ."'', "
                ."'', "
                ."'".date('Y-m-d H:i:s', time())."', "
                ."'".$_FILES['uppedFiles']['type'][$i]."', "
                ."'" . addslashes(basename($newFilename)) . "', "
                ."'2', "
                ."'".$_SESSION['SID_user']['id']."', "
                ."'".$_POST['filerubric']."', "
                ."'".date('Y-m-d H:i:s', time())."', "
                ."'".$_SESSION['SID_login']."')";
    } else {
        // no image 

        // if the file is too big, delete it and continue
        if ($_FILES['uppedFiles']['size'][$i] > $cpoSystem['max_file']) {
            @unlink($newFilename);
            continue;
        }

        printf(__('The file is a data file.').'<br />');
        $query = "INSERT INTO ".CPO_DATA." ("
            ."beschreibung, alttext, datum, type, datei, format, user_id, rubric_id, c_time, changer) values("
            ."'', "                    // beschreibung
            ."'', "                                 // alttext
            ."'".date('Y-m-d H:i:s', time())."', "  // datum
            ."'".$_FILES['uppedFiles']['type'][$i]."', " // type
            ."'" . addslashes(basename($newFilename)) . "', " // datei
            ."'1', "                             // format
            ."'".$_SESSION['SID_user']['id']."', "     // user_id
            ."'".$_POST['filerubric']."', "         // rubric_id
            ."'".date('Y-m-d H:i:s', time())."', "  // c_time
            ."'".$_SESSION['SID_login']."')";       // changer
    }
    // store in database
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);

    logaction('drop upload file', basename($newFilename));
}


} 


?>
