<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/checkaccess.inc.php');

$views = array('list'); // set default view
$placeholder = array();

// define some vars
initVar($_REQUEST['id'],'');

$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);

while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'templates_create': // {{{
        $_REQUEST['name'] = '';
        $_REQUEST['tpl_first'] = '';
        $_REQUEST['tpl_detail'] = '';
        $_REQUEST['tpl_javascript'] = '';
        $views = array('create');
        break; // }}}
    case 'templates_modify': // {{{ templates_copy 
    case 'templates_copy':
        $query = "SELECT name, tpl_first, tpl_detail, tpl_javascript "
                ."FROM ".CPO_TEMPLATES." "
                ."WHERE id='".addslashes($_REQUEST['id'])."' ";
        DEBUG(2, $query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query);
        $_REQUEST['name'] = '';
        $_REQUEST['tpl_first'] = '';
        $_REQUEST['tpl_detail'] = '';
        $_REQUEST['tpl_javascript'] = '';
        while ($db->next_record()) {
            $origname = $db->v('name');
            $_REQUEST['name']           = $db->v('name');
            $_REQUEST['tpl_first']      = $db->v('tpl_first');
            $_REQUEST['tpl_detail']     = $db->v('tpl_detail');
            $_REQUEST['tpl_javascript'] = $db->v('tpl_javascript');
        }

        $q = 'SELECT ttype, fieldname FROM '.CPO_PLACEHOLDERS.' '
            .'WHERE templates_id='.(int)$_REQUEST['id'].' '
            .'ORDER by pos';
        $db->query($q);
        while ($db->next_record()) {
            $pos = $db->v('fieldname').' ('.$typeNames[$db->v('ttype')].')';
            $placeholder[$pos]['type'] = $typeNames[$db->v('ttype')];
            $placeholder[$pos]['name'] = $db->v('fieldname');
        }

        $views = array('modify');
        if ($nextaction=='templates_copy') {
	        $_REQUEST['copiedFrom'] = $_REQUEST['id'];
	        $_REQUEST['id'] = 0;
	        $_REQUEST['name'] = sprintf(__('Copy of %s'), $_REQUEST['name']);
	        $views = array('copy');
        }
        break; // }}}
    case 'templates_save': // {{{ templates_new, templates_copied
    case 'templates_new':
    case 'templates_copied':
        // remove color-spans, <br />, etc.
        foreach (array('tpl_first', 'tpl_detail', 'tpl_javascript') as $v) {
            if ($_REQUEST[$v.'_editor']>0) {
                // Mozilla wrongly converts space to CR+LF in innerHTML so let's try to fix that
                // https://bugzilla.mozilla.org/show_bug.cgi?id=89780
                $_REQUEST[$v] = preg_replace("/(\r\n|\n|\r)/", ' ', $_REQUEST[$v]);
                $_REQUEST[$v] = preg_replace('%<br( /)?>%i', "\n", $_REQUEST[$v]);
                // MS-Edge produces &nbsp; when using spacebar in editor
                $_REQUEST[$v] = preg_replace('/&nbsp;/', ' ', $_REQUEST[$v]); // FIX: removes non breaking spaces
                $_REQUEST[$v] = preg_replace('//', '&nbsp;', $_REQUEST[$v]); // FIX: removes non breaking spaces

                $_REQUEST[$v] = strip_tags($_REQUEST[$v]);

                // there is no str_ireplace() in PHP4, so use preg_replace()
                // BALU: also replace &quot;?
                $_REQUEST[$v] = preg_replace(
                    array('/&gt;/i', '/&lt;/i', '/&amp;/i'), 
                    array('>',       '<',       '&'), 
                    $_REQUEST[$v]
                );
            }
        }

        if ($nextaction=='templates_save')   $views = array('modify');
        if ($nextaction=='templates_new')    $views = array('create');
        if ($nextaction=='templates_copied') $views = array('copy');
        if (empty($_REQUEST['name'])) {
            $message[] = ___('Please enter a name for the article-template.');
            break;
        }

        $query = "SELECT COUNT(*) FROM ".CPO_TEMPLATES." "
                ."WHERE name='".addslashes($_REQUEST['name'])."' "
                ."AND id!='".addslashes($_REQUEST['id'])."'";
        DEBUG(2, 'Inserting or updating article-template.<br /><br />'.$query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query); 
        $db->next_record();
        if ($db->v('COUNT(*)')>0) {
            $message[] = __('Please change the name of this article-template. Another article-template with this name does already exist.');
            break;
        }

        $query = "REPLACE INTO ".CPO_TEMPLATES." "
                ."(id, name, tpl_first, tpl_detail, tpl_javascript, c_time, changer) VALUES ("
                ."'".addslashes($_REQUEST['id'])."', "
                ."'".addslashes($_REQUEST['name'])."', "
                ."'".addslashes($_REQUEST['tpl_first'])."', "
                ."'".addslashes($_REQUEST['tpl_detail'])."', "
                ."'".addslashes($_REQUEST['tpl_javascript'])."', "
                ."'".date('Y-m-d H:i:s')."', "
                ."'".addslashes($_SESSION['SID_login'])."')";
        DEBUG(2, 'Inserting or updating article-template.<br /><br />'.$query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query); 

        if ($_REQUEST['id']==0) {
            $query = "SELECT last_insert_id()";
            $db->query($query);
            $db->next_record();
            $_REQUEST['id'] = $db->v('last_insert_id()');
        }

        // create a list of all placeholders in this template and add a positional counter for each.
        $template_datei_full = $_REQUEST['tpl_first']."\n".$_REQUEST['tpl_detail']."\n".$_REQUEST['tpl_javascript'];

        // find all used Fields used in the templates
        preg_match_all($tagsPreg, $template_datei_full, $matches, PREG_SET_ORDER);
        $placeholder = array();
        foreach ($matches as $match) {
            $_type = strtolower(trim($match[1]));
            $_name = preg_replace("/(\r\n|\n|\r)/", ' ', trim($match[2]));

            if ($_name=='') { 
                // FIXME put this in the parser too? / Should something be displayed anyway?
                printf('<br /><strong>Warning</strong>: found field of type <em>%s</em> with no name in article-template. Ignoring it.<br />',
                    $_type);
                continue;
            }

            // skip Value, ifSet, ifNotSet, because those don't have "input settings"
            if ($_type=='value') continue;

            $pos = $_name.' ('.$_type.')';
            $placeholder[$pos]['type'] = $_type;
            $placeholder[$pos]['name'] = $_name;
        }

        $placeholderSource = $_REQUEST['id'];
        if (!empty($_REQUEST['copiedFrom'])) {
        	$placeholderSource = $_REQUEST['copiedFrom'];
        }
        // fetch old positions and data
        $q = "SELECT ttype, fieldname, pos, ddata "
            ."FROM ".CPO_PLACEHOLDERS . " "
            ."WHERE templates_id='" . (int)$placeholderSource . "' ";
        $dbq = new DB;
        DEBUG(1, $q, __FILE__, __LINE__);
        $dbq->query($q);

        while($dbq->next_record()) {
            $phname = $dbq->v('fieldname').' ('.$typeNames[$dbq->v('ttype')].')';

            // if the placeholder does not exist in the template, don't use its settings
            // if (!array_key_exists($phname, $placeholder)) continue; // deprecated, since we allow adding of placeholders directly

            $placeholder[$phname]['type'] = $typeNames[$dbq->v('ttype')];
            $placeholder[$phname]['name'] = $dbq->v('fieldname');
            $placeholder[$phname]['pos']  = $dbq->v('pos');
            $placeholder[$phname]['data'] = $dbq->v('ddata');
        }

        // sort array by pos / Name
        $_pos = array();
        foreach ($placeholder as $k=>$v) {
            if (isset($v['pos'])) $_pos[$k] = $v['pos'];
            else                  $_pos[$k] = strtolower($k);
        }
        array_multisort($_pos, SORT_ASC, $placeholder);

        // delete all old settings and positions
        $dbq = new DB;
        $q = "DELETE FROM ".CPO_PLACEHOLDERS." "
            ."WHERE templates_id='".addslashes($_REQUEST['id'])."' ";
        $dbq->query($q);

        // add a positional counter to all elements and store them in the database
        $pos = 1;
        foreach ($placeholder as $k=>$v) {
            $placeholder[$k]['pos'] = $pos++;
            initVar($placeholder[$k]['data'],'');

            $q = "INSERT INTO ".CPO_PLACEHOLDERS." "
                ."(templates_id, ttype, fieldname, pos, ddata) VALUES ("
                ."'".addslashes($_REQUEST['id'])."', "
                ."'".addslashes(array_search($placeholder[$k]['type'], $typeNames))."', " 
                ."'".addslashes($placeholder[$k]['name'])."', "
                ."'".addslashes($placeholder[$k]['pos'])."', "
                ."'".addslashes($placeholder[$k]['data'])."' "
                .")";
            $dbq = new DB;
            DEBUG(1, $q, __FILE__, __LINE__);
            $dbq->query($q);
        }

        $views = array('list');
        if ($nextaction=='templates_save')   {
            logaction('edit article-template', $_REQUEST['name']);
            $message[] = sprintf(___('Modified article-template %s was saved.'), '<em>'.$_REQUEST['name'].'</em>');
        }
        if ($nextaction=='templates_new')    {
            logaction('create template', $_REQUEST['name']);
            $message[] = sprintf(___('New article-template %s was saved.'), '<em>'.$_REQUEST['name'].'</em>');
        }
        if ($nextaction=='templates_copied') {
            logaction('copy article-template', $_REQUEST['name']);
            $message[] = sprintf(___('Copied article-template %s was saved.'), '<em>'.$_REQUEST['name'].'</em>');
        }
        break; // }}}
    case 'templates_delete': // {{{
        $db = new DB;
        $db->query("SELECT name "
                  ."FROM ".CPO_TEMPLATES." "
                  ."WHERE id='".addslashes($_GET['id'])."'");
        $db->next_record();
        $name = $db->v('name');
        $views = array('reallydelete');
        break; // }}}
    case 'templates_delete_really': // {{{
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('delete article-template', 'CSRF check failed.');
            break;
        }
        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The article-template %s was not deleted.'),
                '<em>'.htmlspecialchars($_POST['name'], ENT_COMPAT, 'ISO-8859-15').'</em>'
            );
            break;
        }

        $query = "SELECT name FROM ".CPO_TEMPLATES." "
                ."WHERE id='".addslashes($_REQUEST['id'])."'";
        DEBUG(1, 'Fetching name of article-template<br /><br />'.$query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query);

        $db->next_record();
        $name = $db->v('name');

        $query = "DELETE FROM ".CPO_TEMPLATES." "
                ."WHERE id='".addslashes($_REQUEST['id'])."'";
        DEBUG(1, 'Deleting article-template.<br /><br />'.$query, __FILE__, __LINE__);
        $db->query($query); 

        $query = "DELETE FROM ".CPO_TPL_ASSIGNMENT." "
                ."WHERE templates_id='".addslashes($_REQUEST['id'])."'";
        DEBUG(1, 'Deleting article-template.<br /><br />'.$query, __FILE__, __LINE__);
        $db->query($query); 

        $query = "DELETE FROM ".CPO_PLACEHOLDERS." "
                ."WHERE templates_id='".addslashes($_REQUEST['id'])."'";
        DEBUG(1, 'Deleting article-template.<br /><br />'.$query, __FILE__, __LINE__);
        $db->query($query); 

        $message[] = sprintf(__('The article-template %s was successfully deleted.'), 
            '<em>'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );
        $views = array('list');
        logaction('delete article-template', $name);
        break; // }}}
    }
}

require(CPO_BASEDIR.'_include/header.php');
while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'modify': // {{{ create, copy
    case 'create':
    case 'copy':
        switch ($nextview) {
        case 'modify': 
            printPageHeader(
                __('Edit article-template'),
                sprintf(__('In this view you can edit the article-templates %s.'), '<em>'.htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15').'</em>'),
                'templates-workonarticletemplates.html#templates-workonarticletemplates-workonarticletemplate'
            );
            break;
        case 'create':
            printPageHeader(
                __('Create article-template'),
                __('In this view you can create a new article-template.'),
                'templates-createarticletemplate.html#templates-createarticletemplate'
            );
            break;
        case 'copy':
            printPageHeader(
                __('Copy article-template'),
                sprintf(__('In this view you create a new article-template based on a copy of %s.'), '<em>'.htmlspecialchars($origname, ENT_COMPAT, 'ISO-8859-15').'</em>'),
                'templates-workonarticletemplates.html#templates-workonarticletemplates-copy'
            );
            break;
        }
        include(CPO_BASEDIR.'_include/message.php');

        $editor_allowed = false;
        if (RTECheck()) {
            $editor_allowed = true;
            $html_texts = array();
        }

        if ($editor_allowed) {
            print('<script type="text/javascript"> var placeholder = new Array();');
            foreach ($placeholder as $k=>$v) {
                print("placeholder.push('".$v['type']."', '".addslashes($v['name'])."');\n");
            }
            print('</script>');

            printf('<form method="post" action="%s" name="template_form" onSubmit="return innerToHidden();">', htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'));
        } else { 
            printf('<form method="post" action="%s">', htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'));
        }
        if ($nextview=='modify') printf('<input type="hidden" name="action[]" value="templates_save">');
        if ($nextview=='create') printf('<input type="hidden" name="action[]" value="templates_new">');
        if ($nextview=='copy')   printf('<input type="hidden" name="action[]" value="templates_copied">');
        if (!empty($_REQUEST['copiedFrom'])) {
        	printf('<input type="hidden" name="copiedFrom" value="%s" />', 
                (int)$_REQUEST['copiedFrom']
            ); 
        }
        printf('<input type="hidden" name="id" value="%s">', htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15'));
        
        print('<table class="colored" style="width: 100%;"><thead><tr>');
        printf('<th colspan="2"><span>%s</span></th>', ___('Article-template'));
        print('</tr></thead><tbody>');

        printf('<tr><td class="leftrow">%s</td>', ___('Name:'));
        printf('<td class="rightrow"><input type="text" name="name" value="%s" size="55" maxlength="255" class="text inputwidth">%s</td>',
            htmlspecialchars($_REQUEST['name'], ENT_COMPAT, 'ISO-8859-15'),
            help('templates-workonarticletemplates.html#templates-workonarticletemplates-workonarticletemplate-name')
        );
        print('</tr>');

        foreach (array('Rubric page:'=>'tpl_first', 'Article page:'=>'tpl_detail', 'Javascript/PHP:'=>'tpl_javascript') as $k=>$v) {
            printf('<tr><td>%s</td>', ___($k));
            printf('<td>');
            if (!$editor_allowed) {
                printf('<input type="hidden" name="%s_editor" value="0">', $v);
                printf('<textarea name="%s" cols="80" rows="15" class="inputwidth">%s</textarea>',
                    $v,
                    htmlspecialchars($_REQUEST[$v], ENT_COMPAT, 'ISO-8859-15')
                );
                print(help('templates-workonarticletemplates.html#templates-workonarticletemplates-workonarticletemplate-rubricpage')); 
            } else {
                printf('<input type="hidden" name="%s_editor" value="1" />', $v);
                printf('<input type="hidden" name="%s" value="" />', $v);
                printf('<iframe id="iframe_%s" frameborder="0" height="200" class="iframe inputwidth"></iframe>', $v);
                print(help('templates-workonarticletemplates.html#templates-workonarticletemplates-workonarticletemplate-rubricpage'));

                $text_value = htmlspecialchars($_REQUEST[$v], ENT_COMPAT, 'ISO-8859-15');
                // to avoid problems with the document.writeln below
                //$text_value = preg_replace ("/(\015\012)|(\015)|(\012)/", '<br />', $text_value); // Don't use nl2br. It does not replace the newlines, but inserts <br /> before...
                $text_value = preg_replace ("/(\r\n|\n|\r)/", '<br />', $text_value); // Don't use nl2br. It does not replace the newlines, but inserts <br /> before...
                $text_value = addslashes($text_value); // FIXME hm?
                $text_value = preg_replace(
                    array('/&lt;!--\s*(file|html|image|text|url|value|ifset|ifnotset)\s*:.*?--&gt;/si', '/&lt;!--\s*\/(ifSet|ifNotSet)\s*--&gt;/si'), 
                    '<span style="color: #f00;">\0</span>', 
                    $text_value
                );

                print('<script type="text/javascript">');
                printf('document.getElementById(\'iframe_%s\').contentWindow.document.clear();', $v);
                printf('document.getElementById(\'iframe_%s\').contentWindow.document.open();', $v);
                printf('document.getElementById(\'iframe_%s\').contentWindow.document.writeln(\'%s\');', $v, $text_value);
                printf('document.getElementById(\'iframe_%s\').contentWindow.document.close();', $v);
                print('</script>');
                printf('<br /><a href="#" onClick="window.open(\''.BASE_REL.'_editor/templates.php?saveto=iframe_%1$s&%2s\', \'editor_popup\', \'width=750,height=570,scrollbars=no,resizable=yes,status=yes\');">'
                    .'<img src="'.SKIN_URL.'edit.gif" width="20" height="18" align="absmiddle" alt="%3$s" border="0">%3$s'
                    .'</A>',
                    $v,
                    SID,
                    ___('-edit')
                );
            }
            print('</td>');
            print('</tr>');
        }

        print('<tr><td>&nbsp;</td>');
        if ($editor_allowed) {
            print('<script type="text/javascript">function innerToHidden() {');
            foreach (array('tpl_first', 'tpl_detail', 'tpl_javascript') as $v) {
                printf('window.document.template_form.%1$s.value = document.getElementById(\'iframe_%1$s\').contentWindow.document.body.innerHTML;', $v);
            }
            print('return true; }</script>');
        }

        printf('<td><input type="submit" class="button" value="%s"></td>', ___('save'));
        print('</tr>');
        print('</tbody></table>');
        print('</form>');
        break; // }}}
    case 'list': // {{{
        printPageHeader(
            __('Work on article-templates'),
            __('In this view you can work on your article-templates.'),
            'templates-workonarticletemplates.html#templates-workonarticletemplates'
        );
        $query = "SELECT id, name, tpl_first, tpl_detail, tpl_javascript, changer, c_time "
                ."FROM ".CPO_TEMPLATES." "
                ."ORDER BY name";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query);
            
        if ($db->num_rows()<=0) {
            if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
                $message[] =  __('No article-templates found.').' '
                    .sprintf(___('You can %screate a new article-template%s.'),
                        '<a href="'.BASE_REL.'_admin/templates.php?action[]=templates_create">',
                        '</a>'
                    );
            } else {
                $message[] =  __('No article-templates found.');
            }
            include(CPO_BASEDIR.'_include/message.php');
            break;
        }
        include(CPO_BASEDIR.'_include/message.php');

        print('<table class="ruler" style="width: 100%"><thead><tr>');
        printf('<th style="width: 45%%;"><span>%s</span></th>', ___('Name').help('templates-workonarticletemplates.html#templates-workonarticletemplates-name'));
        printf('<th style="width: 10%%;"><span>%s</span></th>', ___('Manage').help('templates-workonarticletemplates.html#templates-workonarticletemplates-edit'));
        printf('<th style="width: 20%%;"><span>%s</span></th>', ___('Author').help('templates-workonarticletemplates.html#templates-workonarticletemplates-author'));
        printf('<th style="width: 20%%;"><span>%s</span></th>', ___('Last modified').help('templates-workonarticletemplates.html#templates-workonarticletemplates-lastedit'));
        printf('<th style="width:  5%%;"><span>%s</span></th>', ___('Info').help('templates-workonarticletemplates.html#templates-workonarticletemplates-info'));
        print('</tr></thead><tbody>');
        while($db->next_record()) {
            print('<tr>');
            printf('<td>%s</td>', htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15'));

            print('<td>');
            printf('<a href="%s?action[]=%s"><img src="'.SKIN_URL.'%s" class="pic" alt="%4$s" title="%4$s"></a>',
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'),
                'templates_modify&amp;id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'),
                'pic_edit.gif',
                ___('edit article-template')
            );

            printIcon('manage_placeholders.php?template='.$db->v('id'), SKIN_URL.'pic_settings.gif', __('edit placeholder'), true);
    
            printf('<a href="%s?action[]=%s"><img src="'.SKIN_URL.'%s" class="pic" alt="%4$s" title="%4$s"></a>',
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'),
                'templates_copy&amp;id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'),
                htmlspecialchars('pic_copy.gif', ENT_COMPAT, 'ISO-8859-15'),
                ___('copy article-template')
            );

            $query = "SELECT COUNT(*) FROM ".CPO_NEWS." "
                    ."WHERE templates_id='".addslashes($db->v('id'))."'";
            DEBUG(2, $query, __FILE__, __LINE__);
            $dbq = new DB;
            $dbq->query($query);
            $dbq->next_record();
            if ($dbq->v('COUNT(*)')<=0) {
                printIcon('templates.php?action[]=templates_delete&id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'), SKIN_URL.'pic_del.gif', __('delete article-template'), true);
            } else {
                printIcon('templates.php?action[]=templates_delete&id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'), SKIN_URL.'pic_del.gif', __('The article-template is in use and can not be deleted.'), false);
            } 

            echo '</td>';

            printf('<td>%s</td>', htmlspecialchars($db->v('changer'), ENT_COMPAT, 'ISO-8859-15'));

            // Last modified
            printf('<td>%s</td>', htmlspecialchars(date($cpoSystem['date_format'], strtotime($db->v('c_time'))), ENT_COMPAT, 'ISO-8859-15'));

            // Info
            $t = '&nbsp;';
            $c = '';
            if ($db->v('tpl_first')=='' || $db->v('tpl_detail')=='' || $db->v('tpl_javascript')=='') {
                $t = __('Article-template does not contain code for:').' ';
                if ($db->v('tpl_first')=='') { $t .= __('Rubric page'); $c = ', ';}
                if ($db->v('tpl_detail')=='') { $t .= $c.__('Article page'); $c = ', ';}
                if ($db->v('tpl_javascript')=='') { $t .= $c.__('Javascript / PHP'); }
                $t = sprintf('<img src="'.SKIN_URL.'sym_info.gif" width="13" height="13" alt="%1$s" title="%1$s">', htmlspecialchars($t, ENT_COMPAT, 'ISO-8859-15'));
            }
            printf('<td>%s</td>', $t);
            print('</tr>');
        }
        echo '</tbody></table>';
        break; // }}}
    case 'reallydelete': // {{{
        printPageHeader(
            ___('Delete article-template'),
            sprintf(___('You are going to delete the article-template %s.'),
                '<em>'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            'templates-workonarticletemplates.html#templates-workonarticletemplates-delete'
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to delete the article-template %s?'),
            '<em>'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('templates_delete_really');
        $message .= '<input type="hidden" name="id" value="'.htmlspecialchars($_GET['id'], ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="hidden" name="name" value="'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, delete').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not delete').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        break; // }}}

    }
}
require(CPO_BASEDIR.'_include/footer.php');