<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/common.inc.php');
?>
<!-- vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4 nowrap: -->
<!-- this.edit = bse_conWin.document -->
<!-- this.cw = bse_conWin; -->
<html>
<head>
    <title><?php echo htmlspecialchars($CPO['product'].'-Editor', ENT_COMPAT, 'ISO-8859-15'); ?></title>
    <meta http-equiv="pragma"   content="no-cache">
    <meta name="robots" content="noindex, nofollow" />
    <link rel="stylesheet" type="text/css" href="<?php echo SKIN_URL.'style_cpo.css.php'; ?>">

    <script type="text/javascript">
    var storage = window.opener.document.getElementById('<?php echo $_REQUEST['saveto']; ?>').contentWindow;
    </script>
    <script src="<?php echo BASE_REL.'_editor/editor.js'; ?>" type="text/javascript"></script>
    <style>
    .buttonLowered   {margin: 0 2px; border-top: #357 1px solid; border-left: #357 1px solid; border-right: #e8ebf0 1px solid; border-bottom: #e8ebf0 1px solid; cursor: pointer;}
    .buttonRaised    {margin: 0 2px; border-top: #e8ebf0 1px solid; border-left: #e8ebf0 1px solid; border-right: #357 1px solid; border-bottom: #357 1px solid; cursor: pointer;}
    .buttonRaised:active   {margin: 0 2px; border-top: #357 1px solid; border-left: #357 1px solid; border-right: #e8ebf0 1px solid; border-bottom: #e8ebf0 1px solid; cursor: pointer;}
    .buttonFlattened {margin: 0 2px; border-top: #e8ebf0 1px solid; border-left: #e8ebf0 1px solid; border-right: #e8ebf0 1px solid; border-bottom: #e8ebf0 1px solid; cursor: pointer; }
    </style>
<script type="text/javascript"><!--
    var placeholder = window.opener.placeholder;

    // add new entries
    function populate_s_placeholder()
    {
        for (i=0; i<placeholder.length; i=i+2) {
            document.getElementById('s_placeholder').options[i/2] = new Option(placeholder[i+1], i);
        }
        return;
    }
    
    var phTypes = ['Image', 'File', 'Text', 'HTML', 'URL'];
    var phSpecial = ['Value: Title;', 'Value: Author;', 'Value: Editor;', 'Value: pub_date;', 'Value: exp_date', 'Value: chg_date;', 'Value: articlenr', 'Value: template;', 'Value: articleidx;', 'Value: rubric;' ];

    function changeSettings()
    {
        var a = [
            ['file', 'alttext', 'width', 'height', 'description'],  // Image
            ['file', 'description', 'hrsize', 'size', 'starttag'], // File
            ['strip_tags', 'nl2br'], // Text
            ['strip_tags', 'htmlspecialchars'], // HTML
            ['strip_tags', 'starttag', 'url', 'text', 'target'] // URL 
        ];
        // remove entries from the list
        for (i=0; i<=document.getElementById('s_settings').length; i++) {
            document.getElementById('s_settings').options[0] = null
        }
        // add new entries
        for (i=0; i<a[document.getElementById('s_newType').value].length; i++) {
            document.getElementById('s_settings').options[i] = new Option(a[document.getElementById('s_newType').value][i], a[document.getElementById('s_newType').value][i]);
        }
    }

    function changeSpecialSettings()
    {
        var a = [
            ['strip_tags', 'urlencode', 'htmlspecialchars'], // Value: title 
            ['name', 'email', 'initials', 'urlencode'],  // Value: Author;
            ['name', 'email', 'initials', 'urlencode'],  // Value: editor;
            ['timestamp', 'format='], // Value: pub_date 
            ['timestamp', 'format='], // Value: exp_date 
            ['timestamp', 'format='], // Value: chg_date 
            [], // Value: articlenr
            [], // Value: template
            [], // Value: articleidx
            ['id', 'directory', 'name', 'title', 'strip_tags', 'urlencode'], // Value: rubric
        ];
        // remove entries from the list
        while (document.getElementById('s_specialSettings').length > 0) {
            document.getElementById('s_specialSettings').options[0] = null
        }
        // add new entries
        for (i=0; i<a[document.getElementById('s_specialType').value].length; i++) {
            document.getElementById('s_specialSettings').options[i] = 
                new Option(a[document.getElementById('s_specialType').value][i], 
                           a[document.getElementById('s_specialType').value][i]);
        }
    }


    function newPlaceholder()
    {
        // alert(editArea.document.selection.createRange().parentElement().innerText)
        var phName = prompt('<?php print(___('Please enter a name for this placeholder:')); ?>', '');
        if (phName=='' || phName==null) {
            alert('<?php print(___('You have to enter a name for the new placeholder. No Placeholder created.')); ?>');
            return;
        }
        encloseSelection('<span style="color: #f00;">&lt;!-- '+phTypes[document.getElementById('s_newType').value]+': '+phName+'; --&gt;</span>');
        bse_conWin.focus();
        document.getElementById('s_placeholder').options[document.getElementById('s_placeholder').length] = new Option(phName, placeholder.length);
        placeholder.push(phTypes[document.getElementById('s_newType').value], phName);
    }
    function newSpecial()
    {
        encloseSelection('<span style="color: #f00;">&lt;!-- '+phSpecial[document.getElementById('s_specialType').value]+' --&gt;</span>');
        bse_conWin.focus();
    }
    function existingPlaceholder()
    {
        var counter = parseInt(document.getElementById('s_placeholder').value);
        encloseSelection('<span style="color: #f00;">&lt;!-- '+placeholder[counter]+': '+placeholder[counter+1]+'; --&gt;</span>');
        bse_conWin.focus();
    }
    function ifSet()
    {
        var counter = parseInt(document.getElementById('s_placeholder').value);
        encloseSelection(
            '<span style="color: #f00;">&lt;!-- '+document.getElementById('s_ifset').value+': '+placeholder[counter+1]+'; --&gt;</span>'+
            '<span style="color: #f00;">&lt;!-- /'+document.getElementById('s_ifset').value+' --&gt;</span>'
        );
        bse_conWin.focus();
    }


    function addSetting()
    {
        var phSetting = document.getElementById('s_settings').value;
        encloseSelection(phSetting+'; ');
        bse_conWin.focus();
    }
    function addSpecialSetting()
    {
        var phSetting = document.getElementById('s_specialSettings').value;
        encloseSelection(phSetting+'; ');
        bse_conWin.focus();
    }

    function addToolbarButton(bCommand, title)
    {
        switch (bCommand) {
        default:
            document.write('<a href="#" onClick="doExecCommand(\''+bCommand+'\');">');
            document.write('<img src="images/btn_'+bCommand+'.gif" bCmd="'+bCommand+'" class="buttonRaised" title="'+title+'" />');
            document.write('</a>');
            break;
        }
    }

//--></script>
</head>
<body class="darker" style="margin: 1em;" onLoad="updateSView = false; initializeEditor(); populate_s_placeholder(); changeSpecialSettings();">
<form>
<table style="width: 100%; height: 100%;"><tbody>
<tr><td>
    <script>
    document.write('<table style="padding:0; margin: 0;"><tbody><tr>');
    document.write('<td>');
    addToolbarButton('_new', '<?php echo ___('new'); ?>');
    document.write('<a href="#" onClick="window.opener.placeholder = placeholder; doExecCommand(\''+'_save'+'\');">');
    document.write('<img src="images/btn_'+'_save'+'.gif" bCmd="'+'_save'+'" class="buttonRaised" title="<?php echo ___('save');?>" />');
    document.write('</a>');
    document.write('</td>');
    document.write('<td>&nbsp;</td>');

    document.write('<td>');
    addToolbarButton('cut', '<?php echo ___('cut'); ?>');
    addToolbarButton('copy', '<?php echo ___('copy'); ?>');
    addToolbarButton('paste', '<?php echo ___('paste'); ?>'); 
    addToolbarButton('selectall', '<?php echo ___('select all'); ?>');
    document.write('</td>');
    document.write('<td>&nbsp;</td>');

    document.write('<td>');
    addToolbarButton('undo', '<?php echo ___('undo'); ?>');
    addToolbarButton('redo', '<?php echo ___('redo'); ?>');
    document.write('</td>');
    document.write('<td>');
    <?php if ($cpoSystem['help']) { ?>
    document.write('<span href="" target="_blank" title="<?php echo ___('Sorry, this help is not available.'); ?>">');
    document.write('<img src="images/btn_'+'_help'+'.gif" class="buttonRaised help" />');
    document.write('</span>');
    <?php } ?>
    document.write(' ');
    document.write('</td>');
    document.write('<td>&nbsp;</td>');
    document.write('</tbody></table>');

    </script>


    <div>
        <?php print(___('Generic types:')); ?>
        <select id="s_newType" onChange="bse_conWin.focus(); changeSettings();">
            <option value="0"><?php print('Image'); ?></option>
            <option value="1"><?php print('File'); ?></option>
            <option value="2"><?php print('Text'); ?></option>
            <option value="3"><?php print('HTML'); ?></option>
            <option value="4"><?php print('URL'); ?></option>
        </select>
        <a href="javascript:newPlaceholder();"><?php print(___('create')); ?></a>

        <?php print(___('- possible options:')); ?>
        <select id="s_settings" onChange="bse_conWin.focus();">
            <option value="file"><?php print('file'); ?></option>
            <option value="alttext"><?php print('alttext'); ?></option>
            <option value="width"><?php print('width'); ?></option>
            <option value="height"><?php print('height'); ?></option>
            <option value="description"><?php print('description'); ?></option>
        </select>
        <a href="javascript:addSetting();"><?php echo ___('insert'); ?></a>
    </div>

    <div>
        <?php print(___('Special placeholders:')); ?>
        <select id="s_specialType" onChange="bse_conWin.focus(); changeSpecialSettings();">
            <option value="0"><?php print('Title'); ?></option>
            <option value="1"><?php print('Author'); ?></option>
            <option value="2"><?php print('Editor'); ?></option>
            <option value="3"><?php print('Publication date'); ?></option>
            <option value="4"><?php print('Expiration date'); ?></option>
            <option value="5"><?php print('Last changed date'); ?></option>
            <option value="6"><?php print('Article number'); ?></option>
            <option value="7"><?php print('Article-template number'); ?></option>
            <option value="8"><?php print('Article Index'); ?></option>
            <option value="9"><?php print('Rubric'); ?></option>
        </select>
        <a href="javascript:newSpecial();"><?php print(___('create')); ?></a>
        <?php print(___('- possible options:')); ?>
        <select id="s_specialSettings" onChange="bse_conWin.focus();">
            <option value="strip_tags"><?php print('strip_tags'); ?></option>
        </select>
        <a href="javascript:addSpecialSetting();"><?php echo ___('insert'); ?></a>
    </div>
    <div>
        <?php print(___('Existing placeholders:')); ?>
        <select id="s_placeholder" onChange="bse_conWin.focus();">
        </select>
        <a href="javascript:existingPlaceholder();"><?php echo ___('insert'); ?></a>

        <?php print(___('- conditional:')); ?>
        <select id="s_ifset" onChange="bse_conWin.focus();">
            <option value="ifSet"><?php print('ifSet'); ?></option>
            <option value="ifNotSet"><?php print('ifNotSet'); ?></option>
        </select>
        <a href="javascript:ifSet();"><?php echo ___('insert'); ?></a>
    </div>
</td></tr>
<tr><td style="height: 100%;">
    <iframe id="bse_iFrame" style="width: 100%; height: 100%; margin: 0; border: 1px solid #000;" src="empty.html"></iframe>
</td></tr></table>
</form>
</body>
</html>
