<?php

/* unprotected, because of structural problems using the class are:
   mod_search/common-module.inc.php 
   mod_search/includes/inc_options.inc.php
   mod_search/search.php
   _include/form_permission.php
   _includesite/i_file_upload.php
   _views/navigation_edit.inc.php
   _admin/preview.php
   _admin/system_preferences.php
   _admin/templates.php
   _include/user_permission.php
   _setup/step{0,1,2} - not necessary
 */

class antiCSRF 
{
    public function __construct() {
        if (!array_key_exists('CSRF', $_SESSION) || !is_array($_SESSION['CSRF'])) { 
            $_SESSION['CSRF'] = array();
        }
    }
    
    public function getToken($action)
    {
        $token = md5(uniqid(rand(), TRUE));

        $_SESSION['CSRF'][$token] = $action;
        
        // limit number of tokens
        while (1000 < count($_SESSION['CSRF'])) {
            array_shift($_SESSION['CSRF']);
        }
        
        if (function_exists('fb')) fb('Get token (' . count($_SESSION['CSRF']) . '): ' . $token . ' / ' . $action);
        return $token;
    }
    
    public function checkToken($action = null, $token = null)
    {
        if (null == $action) $action = $_POST['action'];
        if (null == $token)  $token  = $_POST['csrfToken'];

        $returnValue = true;
        if (!array_key_exists($token, $_SESSION['CSRF'])
                || $_SESSION['CSRF'][$token] != $action) $returnValue = false;
        
        if (function_exists('fb')) fb('Check token: ' . $token . ' / ' . $action . ' ' . ($returnValue ? 'ok' : 'NICHT OK'));

        // remove token either way
        $this->removeToken($token);
        
        return $returnValue;
    }
    
    public function removeToken($token)
    {
        if (function_exists('fb')) fb('Remove token: ' . $token);
        unset($_SESSION['CSRF'][$token]);
    }

    public function printInput($action, $printAction = true)
    {
        echo $this->getInput($action, $printAction);
    }
    
    public function getInput($action, $printAction = true)
    {
        $input = '';
        if ($printAction) {
            $input .= '<input type="hidden" name="action" value="' . htmlspecialchars($action, ENT_COMPAT, 'ISO-8859-15') . '" />';
        }
        $token = $this->getToken($action);
        $input .= '<input type="hidden" name="csrfToken" value="' . $token . '" />';
        
        return $input;
    }
}