<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

$divider = '<!-- Divider -->';
$divider.= '<tr class="divider"><td colspan="2"><div></div></td></tr>';
$divider = '';

initVar($_POST['auth'],'');

?>
<!-- Filebegin: article_form.php -->
<table class="colored" style="width: 100%;">
<thead><tr><th colspan="2"><span><?php print(___('Article metadata').help('articles-createarticle.html#articles-createarticle-metadata')); ?></span></th></tr></thead>
<tbody>
    <!-- Title -->
    <tr>
        <td class="leftrow"><?php print(___('Title:')); ?></td>
        <td class="rightrow">
            <input type="text" name="titel" value="<?php echo htmlspecialchars(isset($_POST['titel']) ? $_POST['titel'] : '', ENT_COMPAT, 'ISO-8859-15'); ?>" size="80" maxlength="255" class="inputwidth">
            <?php print(help('articles-createarticle.html#articles-createarticle-metadata-title')); ?>
        </td>
    </tr>
    <?php echo $divider; ?>

    <?php if ($cpoRubricSettings['edit_index']) { ?>
        <!-- Index -->
        <tr>
            <td class="leftrow"><?php echo __('Article index:'); ?></td>
            <td class="rightrow"> 
                <input type="text" name="idx" value="<?php echo htmlspecialchars(isset($_POST['idx']) ? $_POST['idx'] : '', ENT_COMPAT, 'ISO-8859-15'); ?>" size="8" maxlength="8" />
            <?php echo help(''); // helpme ?>
            </td>
        </tr>
        <?php echo $divider; ?>
    <?php } else { ?>
        <input type="hidden" name="idx" value="<?php echo htmlspecialchars(isset($_POST['idx']) ? $_POST['idx'] : '', ENT_COMPAT, 'ISO-8859-15'); ?>" />
    <?php } ?>

    <!-- keywords -->
    <tr>
        <td class="leftrow"><?php echo __('Keywords:'); ?></td>
        <td class="rightrow"> 
            <input type="text" name="keywords" value="<?php echo htmlspecialchars(isset($_POST['keywords']) ? $_POST['keywords'] : '', ENT_COMPAT, 'ISO-8859-15'); ?>" size="80" maxlength="255" class="inputwidth">
            <?php print(help('articles-createarticle.html#articles-createarticle-metadata-keywords')); ?>
        </td>
    </tr>

    <!-- Comment -->
    <tr>
        <td class="leftrow"><?php echo __('Comment:'); ?></td>
        <td class="rightrow">
            <textarea class="inputwidth" name="commentary" cols="80" rows="5"><?php echo htmlspecialchars(isset($_POST['commentary']) ? $_POST['commentary'] : '', ENT_COMPAT, 'ISO-8859-15'); ?></textarea>
            <?php print(help('articles-createarticle.html#articles-createarticle-metadata-comment')); ?>
        </td>
    </tr>

    <?php echo $divider; ?>

    <!-- Group rights only for personalized rubrics. -->
    <?php if ($cpoRubric['seclevel']==SECLEVEL_PERSONALIZED) { ?>
        <tr>
            <td class="leftrow"><?php echo __('Group access:'); ?></td>
            <td class="rightrow">
                <?php
                $auth_explode = explode('#', $_POST['auth']);

                $query = "SELECT id, usergroup "
                        ."FROM ".CPO_USERGROUPS." "
                        ."ORDER BY usergroup";
                DEBUG(1, 'Fetching all usergroups.<br /><br />'.$query, __FILE__, __LINE__);
                $db = new DB;
                $db->query($query);
            
                if ($db->num_rows()<=0) { 
                    print('<img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> ');
                    print(___('No usergroups available.'));
                } else {
                    $br = '';
                    while($db->next_record()) {
                        printf($br.'<input class="checkbox" type="checkbox" name="usergroup[]" id="usergroup_'.(int)$db->v('id').'" value="%s" %s><label for="usergroup_'.(int)$db->v('id').'">&nbsp;%s</label>',
                            htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'),
                            (in_array($db->v('id'), $auth_explode)) ? 'checked' : '',
                            htmlspecialchars($db->v('usergroup'), ENT_COMPAT, 'ISO-8859-15')
                        );
                        $br = '<br />';
                    }
                }
                ?>
            <?php echo help(''); // helpme ?>
            </td>
        </tr>

        <?php 
        echo $divider; 
    } ?>

    <script type="text/javascript">
    function setdate(field, values) 
    {
        day=''; month=''; year=''; hour=''; min=''
        eval(values);
        if (year>=2036) { day=''; month=''; year=''; hour=''; min=''; }

        if (day=='' || day>=10) eval('window.document.article_form.'+field+'_day.value = "'+day+'";');
        else eval('window.document.article_form.'+field+'_day.value = "0'+day+'";');

        if (month=='' || month>=10) eval('window.document.article_form.'+field+'_month.value = "'+month+'";');
        else eval('window.document.article_form.'+field+'_month.value = "0'+month+'";');

        eval('window.document.article_form.'+field+'_year.value = "'+year+'";');

        if (hour=='' || hour>=10) eval('window.document.article_form.'+field+'_hour.value = "'+hour+'";');
        else eval('window.document.article_form.'+field+'_hour.value = "0'+hour+'";');

        if (min=='' || min>=10) eval('window.document.article_form.'+field+'_min.value = "'+min+'";');
        else eval('window.document.article_form.'+field+'_min.value = "0'+min+'";');
    }
    </script>

    <!-- publication date -->
    <tr>
        <td class="leftrow"><?php print(___('Publication date:')); ?></td>
        <td class="rightrow">
        <?php 
        if (empty($_POST['pub_datum'])) $_POST['pub_datum'] = date('Y-m-d H:i:s');
        $_POST['pub_date_day'] = date('d', strtotime($_POST['pub_datum']));
        $_POST['pub_date_month'] = date('m', strtotime($_POST['pub_datum']));
        $_POST['pub_date_year'] = date('Y', strtotime($_POST['pub_datum']));
        $_POST['pub_date_hour'] = date('H', strtotime($_POST['pub_datum']));
        $_POST['pub_date_min'] = date('i', strtotime($_POST['pub_datum']));
        ?>
            <select name="pubquick" size="1" onChange="setdate('pub_date', this.value); this.selectedIndex=0;">
                <option value="" selected><?php echo ___('at this time'); ?> ---&gt;</option>
                <?php 
                $dates = array(
                    __('now')         => strtotime('now'),
                    __('tomorrow')    => strtotime('tomorrow 00:00'),
                    __('in 2 days')   => strtotime('2 days 00:00'),
                    __('in 3 days')   => strtotime('3 days 00:00'),
                    __('in 5 days')   => strtotime('5 days 00:00'),
                    __('in one week') => strtotime('7 days 00:00'),
                    __('in 14 days')  => strtotime('14 days 00:00')
                );
                foreach ($dates as $k=>$v) {
                    printf('<option value="day=%d; month=%d; year=%d; hour=%d; min=%d;">%s</option>',
                        date('d', $v), date('m', $v), date('Y', $v),
                        date('H', $v), date('i', $v),
                        htmlspecialchars($k, ENT_COMPAT, 'ISO-8859-15')
                    );
                }
                ?>
            </select> &nbsp;
            <input 
            value="<?php echo $_POST['pub_date_day']; ?>"   name="pub_date_day"   type="text" size="2" maxlength="2">.<input 
            value="<?php echo $_POST['pub_date_month']; ?>" name="pub_date_month" type="text" size="2" maxlength="2">.<input 
            value="<?php echo $_POST['pub_date_year']; ?>"  name="pub_date_year"  type="text" size="4" maxlength="4">&nbsp;&nbsp;<input 
            value="<?php echo $_POST['pub_date_hour']; ?>"  name="pub_date_hour"  type="text" size="2" maxlength="2">:<input 
            value="<?php echo $_POST['pub_date_min']; ?>"   name="pub_date_min"   type="text" size="2" maxlength="2">
            <?php print(help('articles-createarticle.html#articles-createarticle-metadata-publication')); ?>
        </td>
    </tr>

    <!-- Verfallsdatum -->
    <tr class="same">
        <td class="leftrow"><?php print(___('Expiration date:')); ?></td>
        <td class="rightrow">
        <?php 
        if (!isset($_POST['verfallsdatum'])) {
            $_POST['exp_date_year']=2036;
        } else {
            $_POST['exp_date_day']   = date('d', strtotime($_POST['verfallsdatum']));
            $_POST['exp_date_month'] = date('m', strtotime($_POST['verfallsdatum']));
            $_POST['exp_date_year']  = date('Y', strtotime($_POST['verfallsdatum']));
            $_POST['exp_date_hour']  = date('H', strtotime($_POST['verfallsdatum']));
            $_POST['exp_date_min']   = date('i', strtotime($_POST['verfallsdatum']));
        }
        ?>
            <select name="expquick" size="1" onChange="setdate('exp_date', this.value); this.selectedIndex=0;">
                <option value="" selected><?php echo ___('at this time'); ?> ---&gt;</option>
                <?php 
                if ($_POST['exp_date_year'] >=2036) {
                    $_POST['exp_date_hour']  = '';
                    $_POST['exp_date_min']   = '';
                    $_POST['exp_date_month'] = '';
                    $_POST['exp_date_day']   = '';
                    $_POST['exp_date_year']  = '';
                }

                $dates = array(
                    __('never')       => strtotime('2036-01-01'),
                    __('now')         => strtotime('now'),
                    __('today')       => strtotime('today 23:59'),
                    __('tomorrow')    => strtotime('tomorrow 23:59'),
                    __('in 2 days')   => strtotime('2 days 23:59'),
                    __('in 3 days')   => strtotime('3 days 23:59'),
                    __('in 5 days')   => strtotime('5 days 23:59'),
                    __('in one week') => strtotime('7 days 23:59'),
                    __('in 14 days')  => strtotime('14 days 23:59'),
                    __('in a month')  => strtotime('1 month 23:59'),
                    __('in 2 months') => strtotime('2 months 23:59'),
                    __('in 3 months') => strtotime('3 months 23:59'),
                    __('in 4 months') => strtotime('4 months 23:59'),
                    __('in 6 months') => strtotime('6 months 23:59'),
                    __('in a year')   => strtotime('1 year 23:59'),
                );
                foreach ($dates as $k=>$v) {
                    printf('<option value="day=%d; month=%d; year=%d; hour=%d; min=%d;">%s</option>',
                        date('d', $v), date('m', $v), date('Y', $v),
                        date('H', $v), date('i', $v),
                        htmlspecialchars($k, ENT_COMPAT, 'ISO-8859-15')
                    );
                }
                ?>
            </select> &nbsp;
            <input 
            value="<?php echo $_POST['exp_date_day']; ?>" name="exp_date_day"     type="text" size="2" maxlength="2">.<input 
            value="<?php echo $_POST['exp_date_month']; ?>" name="exp_date_month" type="text" size="2" maxlength="2">.<input 
            value="<?php echo $_POST['exp_date_year']; ?>" name="exp_date_year"   type="text" size="4" maxlength="4">&nbsp;&nbsp;<input 
            value="<?php echo $_POST['exp_date_hour']; ?>" name="exp_date_hour"   type="text" size="2" maxlength="2">:<input 
            value="<?php echo $_POST['exp_date_min']; ?>" name="exp_date_min"     type="text" size="2" maxlength="2">
            <?php print(help('articles-createarticle.html#articles-createarticle-metadata-expiration')); ?>
            <!-- 2036-01-01 00:00 = never -->
        </td>
    </tr>

    <?php echo $divider; ?>

     <!-- author -->
    <?php 
    $same = '';
    if (empty($_POST['autor']))   $_POST['autor']   = $_SESSION['SID_user']['name'];
    if (empty($_POST['email']))   $_POST['email']   = $_SESSION['SID_user']['email'];
    if (empty($_POST['initial'])) $_POST['initial'] = $_SESSION['SID_user']['initial'];
    if ($cpoRubricSettings['edit_author']) { ?>
        <tr>
            <td class="leftrow"><?php print(___('Author:')); ?></td>
            <td class="rightrow">
                <?php 
                printf('<input type="text" name="autor" size="80" maxlength="255" value="%s" class="inputwidth" />',
                    htmlspecialchars($_POST['autor'], ENT_COMPAT, 'ISO-8859-15')
                );
                print(help('articles-createarticle.html#articles-createarticle-metadata-author')); ?>
            </td>
        </tr>
    <?php 
    $same = 'same';
    } else { ?>
        <input type="hidden" name="autor" value="<?php echo htmlspecialchars($_POST['autor'], ENT_COMPAT, 'ISO-8859-15'); ?>" />
    <?php } ?>

    <!-- e-mail -->
    <?php if ($cpoRubricSettings['edit_email']) { ?>
        <tr class="<?php echo $same; ?>">
            <td class="leftrow"><?php echo __('E-mail:'); ?></td>
            <td class="rightrow">
                <?php
                printf('<input type="text" name="email" size="80" maxlength="255" value="%s" class="inputwidth" />',
                    htmlspecialchars($_POST['email'], ENT_COMPAT, 'ISO-8859-15')
                );
                print(help('articles-createarticle.html#articles-createarticle-metadata-email')); ?>
            </td>
        </tr>
    <?php 
    $same = 'same';
    } else { ?>
        <input type="hidden" name="email" value="<?php echo htmlspecialchars($_POST['email'], ENT_COMPAT, 'ISO-8859-15'); ?>" />
    <?php } ?>

    <!-- Initialien -->
    <?php if ($cpoRubricSettings['edit_initial']) { ?>
        <tr class="<?php echo $same; ?>">
            <td class="leftrow"><?php echo __('Initials:'); ?></td>
            <td class="rightrow">
                <?php
                printf('<input type="text" name="initial" size="80" maxlength="255" value="%s" class="inputwidth" />',
                    htmlspecialchars($_POST['initial'], ENT_COMPAT, 'ISO-8859-15')
                );
                print(help('articles-createarticle.html#articles-createarticle-metadata-initials')); ?>
            </td>
        </tr>
    <?php } else { ?>
        <input type="hidden" name="initial" value="<?php echo htmlspecialchars($_POST['initial'], ENT_COMPAT, 'ISO-8859-15'); ?>" />
    <?php } ?>
    <?php echo $divider; ?>

    <!-- template -->
    <tr>
        <td class="leftrow"><?php print(___('Article-template:')); ?></td>
        <td class="rightrow">
            <?php
            $query = "SELECT ".CPO_TEMPLATES.".id, name "
                    ."FROM ".CPO_TPL_ASSIGNMENT.", ".CPO_TEMPLATES." "
                    ."WHERE templates_id=".CPO_TEMPLATES.".id "
                    ."AND ".CPO_TPL_ASSIGNMENT.".rubric_id = '".$_SESSION['SID_rubric_source_rubric_id']."' "
                    ."ORDER BY name";
            DEBUG(1, 'Fetching article-templates for this rubric.<br /><br />'.$query, __FILE__, __LINE__);
            $db = new DB;
            $db->query($query);

            $templates = array();
            while($db->next_record()) {
                $templates[$db->v('id')] = $db->v('name');
            }
            
            if (isset($_POST['templates_id']) && !array_key_exists($_POST['templates_id'], $templates)) {
                $query = "SELECT id, name "
                       . "FROM " . CPO_TEMPLATES . " "
                       . "WHERE id=" . (int)$_POST['templates_id'];
                $db->query($query);
                if ($db->next_record()) {
                    $templates = array($db->v('id') => $db->v('name') . ' ' . __('(not allowed)')) 
                               + $templates;
                }
            }

            // if there is no template chosen yet, choose the rubric standard template
            if (empty($_POST['templates_id']) && !empty($cpoRubricSettings['standard_template'])) {
                $_POST['templates_id'] = $cpoRubricSettings['standard_template'];
            }
            // if the standard template was empty either, select the first template
            if (empty($_POST['templates_id'])) {
                $firstTemplate = reset($templates);
                if ($firstTemplate !== FALSE) $_POST['templates_id'] = $firstTemplate;;
            }

            if (count($templates)>0) {
                echo '<select name="templates_id" id="templates_id" onChange="document.article_form.displayAgain.click();">';
                foreach ($templates as $templateId => $templateName) {
                    printf('<option value="%s" %s>%s</option>',
                        $templateId,
                        $_POST['templates_id']==$templateId ? 'selected' : '',
                        htmlspecialchars($templateName, ENT_COMPAT, 'ISO-8859-15')
                    );
                }
                echo '</select>';
                print(help('articles-createarticle.html#articles-createarticle-metadata-articletemplate'));

                ?><div id="loadTemplateButtonDiv">
                <br />
                <input type="submit" class="button" name="displayAgain" id="displayAgain" value="<?php echo __('load new article-template'); ?>">
                </div>
                <script type="text/javascript">
                document.getElementById('loadTemplateButtonDiv').style.display = 'none';
                </script>
                <?php
            } else {
                print('<br /><br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> ');
                print(__('No admin or superuser assigned an article-template to this rubric yet!').'<br /> ');
                if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
                    printf(__('Please do so in the %srubric settings%s.'), 
                        '<a href="'.BASE_REL.'_admin/rubrics.php?action=rubrics_showsettings&amp;id='.htmlspecialchars($_SESSION['SID_rubric_source_rubric_id'], ENT_COMPAT, 'ISO-8859-15').'">', 
                        '</a>'
                    );
                }
            }
            ?>
        </td>
    </tr>

    <?php echo $divider; 

if (count($templates)==0) { 
    print('</tbody></table>');
    return;
}
?>
</tbody></table>

<table class="colored" style="width: 100%;">
<thead><tr><th colspan="2"><span><?php print(___('Article content').help('articles-createarticle.html#articles-createarticle-articlecontent')); ?></span></th></tr></thead>
<tbody>
<?php 

// get all template-variants for this article
$db_form = new DB;
$query = "SELECT COUNT(*) FROM ".CPO_TEMPLATES." "
        ."WHERE id='".addslashes($_POST['templates_id'])."'";
DEBUG(1, 'Fetch number of article-template variants for this article.<br /><br />'.$query, __FILE__, __LINE__);
$db_form->query($query);
$db_form->next_record();

if ($db_form->v('COUNT(*)')<=0) {
    print('</tbody></table>');
    print(__('Please choose an article-template to edit the content for this article.'));
    return;
}

// fetch placeholders to list them
$q = "SELECT id, ttype, fieldname, pos, ddata FROM ".CPO_PLACEHOLDERS." "
    ."WHERE templates_id='".addslashes($_POST['templates_id'])."' "
    ."ORDER BY pos";
$dbq = new DB;
DEBUG(1, $q, __FILE__, __LINE__);
$dbq->query($q);

$placeholder = array();
while($dbq->next_record()) {
    $phname = $dbq->v('fieldname').' ('.$typeNames[$dbq->v('ttype')].')';
    $placeholder[$phname] = unserialize($dbq->v('ddata'));
    $placeholder[$phname]['name']  = $dbq->v('fieldname');
    $placeholder[$phname]['type']  = $typeNames[$dbq->v('ttype')];
    $placeholder[$phname]['pos']   = $dbq->v('pos');
    $placeholder[$phname]['id']    = $dbq->v('id');
}

// print all used cpoFields and their values and make them editable
$html_texts = array();
$content    = $_POST['content']; 
$_content   = $_POST['content'];
foreach ($placeholder as $key=>$value) {
    include(CPO_BASEDIR.'_include/form_fields.inc.php');
}
?>

    <!-- Send form -->
    <tr>
        <td class="leftrow">&nbsp;</td>
        <td class="rightrow">
            <input type="submit" class="button" value="<?php echo __('save article'); ?>">
            <?php
            // admins are allowed to save and release the article
            if ($_SESSION['SID_stufe4']==1 && $cpoSystem['release']) {
                print('<input name="article_free" type="submit" class="button" value="'.__('save and release article').'">');
            }
            ?>
        </td>
    </tr>
</tbody>
</table>

<?php
// print all fields that are not used anymore....
if (count($_content)>0) {
    print('<br />');
    print('<table class="colored" style="width: 100%;">');
    print('<thead><tr><th colspan="2"><span>'.__('Old article content (not used in this article-template)').help('').'</span></th></tr></thead>'); // helpme
    print('<tbody>');
    foreach ($_content as $key=>$value) {
        include(CPO_BASEDIR.'_include/form_fields.inc.php');
    }
    print('</tbody></table>');
}
?>

<?php
print('<script type="text/javascript">function innerToHidden() {');
foreach ($html_texts as $v) {
    printf('window.document.article_form.feld_%1$s.value = document.getElementById(\'iframe_%1$s\').contentWindow.document.body.innerHTML;', $v);
}
print('return true; }</script>');
?>
<!-- Fileend: form.php -->
