<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

if ($GLOBALS['CPODEBUG'] & DEBUG_RUNNING_TIME) {
    list($usec, $sec) = explode(' ', microtime());
    $_line = sprintf('%s: %8.4fs', ___('Running time'), (float)$usec + (float)$sec - $CPODEBUGRUNNINGSTART);
    if (!function_exists('fb')) echo $_line . '<br />';
    else fb($_line);
}

if ($GLOBALS['CPODEBUG'] & DEBUG_COUNT_QUERIES) {
    $_line = sprintf(___('Used database queries: %d'), $CPODEBUGQUERYCOUNT);
    if (!function_exists('fb')) echo $_line . '<br />';
    else fb($_line);
}

$_lines = '';
echo '<ul>';
if ($GLOBALS['CPODEBUG'] & DEBUG_LOG_QUERIES) {
    foreach ($CPODEBUGLOG as $v) {
    	if (!function_exists('fb')) $_lines .= '<li>'.htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15').'</li>' . "\n";
    	else fb($_line);
    }
    echo nl2br($_lines);
}
echo '</ul>';
//flush();

if (function_exists('fb')) fb('Session-ID: ' . session_id());
if (function_exists('fb')) fb($_SESSION);

if ($varDEBUG<=0) return;
?>
<div style="border: 1px solid #a00; background: #fcc; color: #a00;">
    <strong><?php echo __('Session-Data:'); ?></strong><br />
    <?php 
    $t = $_SESSION;
    ksort($t);
    foreach ($t as $k=>$v) print( (!is_array($v)) ? '<b>'.$k.':</b> '.$v.'<br />' : '<b>'.$k.':</b> <pre>'."\n".var_export($v, true)."\n".'</pre><br />');
    ?>
</div>
