<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

initVar($_SESSION['SID_user']['admin'],NULL);

$chance = floor((time()-90*24*60*60-$cpoSystem['installed']) / 60/60/24) * 5;
if (!license($cpoSystem['lkey']) && rand(0, 100)<=$chance) {
    $message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
        htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
    $message['license'] .= sprintf(___('This is a fully functional, but not registered version of %1$s. Please contact your %2$sadministrator%3$s.'),
        htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'),
        '<a href="mailto:'.htmlspecialchars($cpoSystem['admin_email'], ENT_COMPAT, 'ISO-8859-15').'">',
        '</a>'
    );

    if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
        $message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
        $message['license'] .= sprintf(__('The %s-license model differs between commercial and non-commercial use.'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'));
        $message['license'] .= ' ';
        $message['license'] .= sprintf(__('To use the system in commercial environments you need to purchase a "license for commercial use" in the moment of project release. This license can be ordered on the %s Website%s.'), '<a href="'.$CPO['productlink'].'" target="_blank">'.htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'), '</a>');
        $message['license'] .= ' ';
        $message['license'] .= sprintf(___('If you are using %s non-commercially, you can register for free at this point in time on the %s Website%s.'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'), '<a href="'.$CPO['productlink'].'" target="_blank">'.htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'), '</a>');
    }
}

if (empty($GLOBALS['DEVELOPMENT']) && isset($_SESSION['SID_user']) && $_SESSION['SID_user']['admin']>=ROLE_SUPERUSER && @is_readable(CPO_BASEDIR.'_setup')) {
    $message[] = ___('Please make sure that the _setup directory gets removed as it could be called externally. Another solution might be to remove all access rights to this directory.');
}

?>
<!DOCTYPE HTML>
<html>
<head>
    <?php echo '<!-- SessID: '.(empty($cpoSystem['lkey'])?time():md5($cpoSystem['lkey'])).':'.$cpoSystem['installed'].'-->'."\n"; ?>
    <title><?php echo htmlspecialchars($cpoSystem['project'], ENT_COMPAT, 'ISO-8859-15') . ' &middot; ' . $cpoTitle ?></title>
    <meta http-equiv="pragma"   content="no-cache">
    <?php if (!$notimeout) { ?>
        <meta http-equiv="refresh"  content="<?php echo $cpoSystem['timeout'] ?>; URL=<?php echo BASE_REL.'_admin/index.php?action=timeout'; ?>">  
    <?php } ?>
    <link rel="stylesheet" type="text/css" href="<?php echo SKIN_URL.'style_cpo.css.php'; ?>">
    <script src="<?php echo BASE_REL.'_include/tables.js'; ?>" type="text/javascript"></script>
</head>
        
<body style="padding: 1em;">
<div>
