<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

if (!isset($data['content']) || !is_array($data['content'])) return;

foreach ($data['content'] as $key=>$value) {
    // define some vars
    initVar($value['id'],NULL);

    $query = '';
    if (!nametype($key, $name, $type)) continue;

    switch ($type) {
    case 'file': 
        // Update if something was entered
        if ($value['file_id']!='') {
            $query = sprintf("INSERT INTO ".CPO_CONTENT_FILES." "
                ."SET id='%s', "
                ."article_id='%s', "
                ."fieldname='%s', "
                ."file_id='%s'",
                addslashes($value['id']), 
                $nr, 
                addslashes($name), 
                addslashes($value['file_id'])
            );
            DEBUG(1, $query, __FILE__, __LINE__);
            $db->query($query); 
        }
        break;

    case 'image': 
        // Update if something was entered
        if ($value['image_id']!='') {
            $query = sprintf("INSERT INTO ".CPO_CONTENT_IMAGES." "
                ."SET id='%s', "
                ."article_id='%s', "
                ."fieldname='%s', "
                ."image_id='%s'",
                addslashes($value['id']), 
                $nr, 
                addslashes($name), 
                addslashes($value['image_id'])
            );
            DEBUG(1, $query, __FILE__, __LINE__);
            $db->query($query); 
        }
        break;

    case 'html': 
        // Update if something was entered
        if ($value['html']!='') {
            $value['html'] = preg_replace(
                array(
                    '@<br>@',
                    '@<img((\s+[a-zA-Z]+\s*=\s*(("[^"]*")|(\'[^\']*\')))*)\s*>@' // based on http://concepts.waetech.com/unclosed_tags/
                ),
                array(
                    '<br />',
                    '<img\1 />'
                ),
                $value['html']
            ); 
            $query = sprintf("INSERT INTO ".CPO_CONTENT_HTML." "
                ."SET id='%s', "
                ."article_id='%s', "
                ."fieldname='%s', "
                ."html='%s'",
                addslashes($value['id']), 
                $nr, 
                addslashes($name), 
                addslashes($value['html'])
            );
            DEBUG(1, $query, __FILE__, __LINE__);
            $db->query($query); 
        }
        break;

    case 'url': 
        // Update if something was entered
        if ($value['url']!='' || $value['urltext']!='' || $value['urltarget']!='') {
            $query = sprintf("INSERT INTO ".CPO_CONTENT_URLS." "
                ."SET id='%s', "
                ."article_id='%s', "
                ."fieldname='%s', "
                ."url='%s', "
                ."urltext='%s', "
                ."urltarget='%s'",
                addslashes($value['id']), 
                $nr, 
                addslashes($name), 
                addslashes($value['url']),
                addslashes($value['urltext']),
                addslashes($value['urltarget'])
            );
            DEBUG(1, $query, __FILE__, __LINE__);
            $db->query($query); 
        }
        break;

    case 'text': 
        // Update if something was entered
        if ($value['text']!='') {
            $query = sprintf("INSERT INTO ".CPO_CONTENT_TEXT." "
                ."SET id='%s', "
                ."article_id='%s', "
                ."fieldname='%s', "
                ."text='%s'",
                addslashes($value['id']), 
                $nr, 
                addslashes($name), 
                addslashes($value['text'])
            );
            DEBUG(1, $query, __FILE__, __LINE__);
            $db->query($query); 
        }
        break;
    }
}
?>
