<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

global $content, $key, $parameters, $replacement, $db_nr, $cpoRubrics, $db_rubric_id, $cpoSystem;

$_t = $content[$key]['urltext'];
if (array_key_exists('strip_tags', $parameters)) {
    $_t = strip_tags($_t);
}

switch ($content[$key]['linktype']) {
case 1: // more
    $content[$key]['url'] = sprintf('%s%s/detail.php?nr=%s' . (SID!='' ? '&' . SID : ''),
        BASE_ABS,
        $cpoRubrics[$db_rubric_id]['directory'],
        $db_nr
    );
    if ($cpoRubrics[$db_rubric_id]['directory']!=$cpoRubrics[$db_rubric_id]['name']) {
        $content[$key]['url'] = sprintf('%s%s/detail.php?rubric=%s&nr=%s' . (SID!='' ? '&' . SID : ''),
            BASE_ABS,
            $cpoRubrics[$db_rubric_id]['directory'],
            urlencode($cpoRubrics[$db_rubric_id]['name']),
            $db_nr
        );
    }
    if ($GLOBALS['cpoSystem']['PATH_INFO']) {
        $content[$key]['url'] = sprintf('%s%s/detail.php/%s/%s' . (SID!='' ? '?' . SID : ''),
            BASE_ABS,
            $cpoRubrics[$db_rubric_id]['directory'],
            urlencode($cpoRubrics[$db_rubric_id]['name']),
            $db_nr
        );
    }
    break;
case 2: // back
    $content[$key]['url'] = 'javascript:history.back()';
    break;
case 3: // rubric
    $content[$key]['url'] = sprintf('%s%s/index.php' . (SID!='' ? '?' . SID : ''),
        BASE_ABS,
        $cpoRubrics[$db_rubric_id]['directory']
    );
    if ($cpoRubrics[$db_rubric_id]['directory']!=$cpoRubrics[$db_rubric_id]['name']) {
        $content[$key]['url'] = sprintf('%s%s/index.php?rubric=%s' . (SID!='' ? '&' . SID : ''),
            BASE_ABS,
            $cpoRubrics[$db_rubric_id]['directory'],
            urlencode($cpoRubrics[$db_rubric_id]['name'])
        );
    }
    if ($cpoSystem['PATH_INFO']) {
        $content[$key]['url'] = sprintf('%s%s/index.php/%s' . (SID!='' ? '?' . SID : ''),
            BASE_ABS,
            $cpoRubrics[$db_rubric_id]['directory'],
            urlencode($cpoRubrics[$db_rubric_id]['name'])
        );
    }

    break;
}

$_target = $content[$key]['urltarget'];
if (trim($_target)!='') {
    $_target = ' target="'.htmlspecialchars($_target, ENT_COMPAT, 'ISO-8859-15').'"';
}
$replacement = sprintf('<a href="%s"%s>%s</a>',
    htmlspecialchars($content[$key]['url'], ENT_COMPAT, 'ISO-8859-15'),
    $_target,
    htmlspecialchars($_t, ENT_COMPAT, 'ISO-8859-15')
);

if (array_key_exists('starttag', $parameters)) {
    $replacement = sprintf('<a href="%s"%s>',
        htmlspecialchars($content[$key]['url'], ENT_COMPAT, 'ISO-8859-15'),
        $_target,
        htmlspecialchars($_t, ENT_COMPAT, 'ISO-8859-15')
    );
}

if (array_key_exists('url', $parameters)) {
    $replacement = htmlspecialchars($content[$key]['url'], ENT_COMPAT, 'ISO-8859-15');
}

if (array_key_exists('text', $parameters)) {
    $_t = $content[$key]['urltext'];
    if (array_key_exists('strip_tags', $parameters)) {
        $_t = strip_tags($_t);
    }
    if (!array_key_exists('htmlspecialchars', $parameters)
    || in_array(strtolower($parameters['htmlspecialchars']), array('1', 'true', 'on'))) {
        $_t = htmlspecialchars($_t, ENT_COMPAT, 'ISO-8859-15');
    }
    $replacement = $_t;

}

if (array_key_exists('target', $parameters)) {
    $replacement = htmlspecialchars($content[$key]['urltarget'], ENT_COMPAT, 'ISO-8859-15');
}
