<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

global $key, $replacement, $content, $parameters, $db_rubric_id, $cpoRubrics, $translator;

switch (true) {
case stristr(strtolower($key), 'editor'):
    $replacement = sprintf('<a href="mailto:%s">%s</a>', 
        htmlspecialchars($content[$key]['editoremail'], ENT_COMPAT, 'ISO-8859-15'), 
        htmlspecialchars($content[$key]['editorname'], ENT_COMPAT, 'ISO-8859-15')
    );
    if (array_key_exists('name', $parameters)) {
        $replacement = htmlspecialchars($content[$key]['editorname'], ENT_COMPAT, 'ISO-8859-15');
    }
    if (array_key_exists('email', $parameters)) {
        $replacement = htmlspecialchars($content[$key]['editoremail'], ENT_COMPAT, 'ISO-8859-15');
    }
    if (array_key_exists('initials', $parameters)) {
        $replacement = htmlspecialchars($content[$key]['editorinitials'], ENT_COMPAT, 'ISO-8859-15');
    }
    if (array_key_exists('urlencode', $parameters)) {
        $replacement = urlencode($replacement);
    }
    break;

case stristr(strtolower($key), 'author'):
    $replacement = sprintf('<a href="mailto:%s">%s</a>', 
        htmlspecialchars($content[$key]['authoremail'], ENT_COMPAT, 'ISO-8859-15'), 
        htmlspecialchars($content[$key]['authorname'], ENT_COMPAT, 'ISO-8859-15')
    );
    if (array_key_exists('name', $parameters)) {
        $replacement = htmlspecialchars($content[$key]['authorname'], ENT_COMPAT, 'ISO-8859-15');
    }
    if (array_key_exists('email', $parameters)) {
        $replacement = htmlspecialchars($content[$key]['authoremail'], ENT_COMPAT, 'ISO-8859-15');
    }
    if (array_key_exists('initials', $parameters)) {
        $replacement = htmlspecialchars($content[$key]['authorinitials'], ENT_COMPAT, 'ISO-8859-15');
    }
    if (array_key_exists('urlencode', $parameters)) {
        $replacement = urlencode($replacement);
    }
    break;

case stristr(strtolower($key), 'articlenr'):
    $replacement = htmlspecialchars($content[$key]['articlenr'], ENT_COMPAT, 'ISO-8859-15'); 
    break;

case stristr(strtolower($key), 'template'):
    $replacement = htmlspecialchars($content[$key]['template'], ENT_COMPAT, 'ISO-8859-15'); 
    break;

case stristr(strtolower($key), 'articleidx'):
    $replacement = htmlspecialchars($content[$key]['articleidx'], ENT_COMPAT, 'ISO-8859-15'); 
    break;

case stristr(strtolower($key), 'pub_date'): 
    $replacement = htmlspecialchars(date($cpoRubrics[$db_rubric_id]['settings']['date_format'], strtotime($content[$key]['pub_date'])), ENT_COMPAT, 'ISO-8859-15'); 
    $replacement = htmlspecialchars($translator->getDateTranslation($replacement, $cpoRubrics[$db_rubric_id]['settings']['language']), ENT_COMPAT, 'ISO-8859-15');
    if (array_key_exists('timestamp', $parameters)) {
        $replacement = htmlspecialchars(strtotime($content[$key]['pub_date']), ENT_COMPAT, 'ISO-8859-15'); 
        break;
    }
    if (array_key_exists('format', $parameters)) {
        $replacement = date($parameters['format'], strtotime($content[$key]['pub_date'])); 
        $replacement = htmlspecialchars($translator->getDateTranslation($replacement, $cpoRubrics[$db_rubric_id]['settings']['language']), ENT_COMPAT, 'ISO-8859-15');
    }
    break;

case stristr(strtolower($key), 'exp_date'):
    $replacement = htmlspecialchars(date($cpoRubrics[$db_rubric_id]['settings']['date_format'], strtotime($content[$key]['exp_date'])), ENT_COMPAT, 'ISO-8859-15');
    $replacement = htmlspecialchars($translator->getDateTranslation($replacement, $cpoRubrics[$db_rubric_id]['settings']['language']), ENT_COMPAT, 'ISO-8859-15');
    if (array_key_exists('timestamp', $parameters)) {
        $replacement = htmlspecialchars(strtotime($content[$key]['exp_date']), ENT_COMPAT, 'ISO-8859-15');
        break;
    }
    if (array_key_exists('format', $parameters)) {
        $replacement = date($parameters['format'], strtotime($content[$key]['exp_date'])); 
        $replacement = htmlspecialchars($translator->getDateTranslation($replacement, $cpoRubrics[$db_rubric_id]['settings']['language']), ENT_COMPAT, 'ISO-8859-15');
    }
    break;

case stristr(strtolower($key), 'chg_date'): 
    $replacement = htmlspecialchars(date($cpoRubrics[$db_rubric_id]['settings']['date_format'], strtotime($content[$key]['chg_date'])), ENT_COMPAT, 'ISO-8859-15'); 
    $replacement = htmlspecialchars($translator->getDateTranslation($replacement, $cpoRubrics[$db_rubric_id]['settings']['language']), ENT_COMPAT, 'ISO-8859-15');
    if (array_key_exists('timestamp', $parameters)) {
        $replacement = htmlspecialchars(strtotime($content[$key]['chg_date']), ENT_COMPAT, 'ISO-8859-15'); 
        break;
    }
    if (array_key_exists('format', $parameters)) {
        $replacement = date($parameters['format'], strtotime($content[$key]['chg_date'])); 
        $replacement = htmlspecialchars($translator->getDateTranslation($replacement, $cpoRubrics[$db_rubric_id]['settings']['language']), ENT_COMPAT, 'ISO-8859-15');
    }
    break;

/* commentary is an internal field that should not be used in templates...
case stristr(strtolower($key), 'commentary'):
    $_t = $content[$key]['commentary'];
    if (array_key_exists('strip_tags', $parameters)) {
        $_t = strip_tags($_t);
    }

    $_t = htmlspecialchars($_t, ENT_COMPAT, 'ISO-8859-15');

    if (array_key_exists('nl2br', $parameters)) {
        $_t = nl2br($_t);
    }
    $replacement = $_t;
    break;
/* */

case stristr(strtolower($key), 'title'):
    $_t = $content[$key]['title'];
    if (array_key_exists('strip_tags', $parameters)) {
        $_t = strip_tags($_t);
    }
    if (array_key_exists('urlencode', $parameters)) {
        $_t = urlencode($_t);
    }
    if (!array_key_exists('htmlspecialchars', $parameters)
        || in_array(strtolower($parameters['htmlspecialchars']), array('1', 'true', 'on'))) {
        $_t = htmlspecialchars($_t, ENT_COMPAT, 'ISO-8859-15');
    }
    $replacement = $_t;
    break;

case stristr(strtolower($key), 'rubric'):
    $_t = sprintf('<a href="../%s/index.php?rubric=%s">%s</a>', 
        htmlspecialchars($content[$key]['rubricdirectory'], ENT_COMPAT, 'ISO-8859-15'), 
        urlencode($content[$key]['rubricid']), 
        htmlspecialchars($content[$key]['rubrictitle'], ENT_COMPAT, 'ISO-8859-15') 
    ); 
    $htmlspecialchars = false;

    if (array_key_exists('id', $parameters)) {
        $_t = (int)$content[$key]['rubricid'];
        $htmlspecialchars = true;
    }
    if (array_key_exists('directory', $parameters)) {
        $_t = $content[$key]['rubricdirectory'];
        $htmlspecialchars = true;
    }
    if (array_key_exists('name', $parameters)) {
        $_t = $content[$key]['rubricname'];
        $htmlspecialchars = true;
    }
    if (array_key_exists('title', $parameters)) {
        $_t = $content[$key]['rubrictitle'];
        $htmlspecialchars = true;
    }

    if (array_key_exists('strip_tags', $parameters)) {
        $_t = strip_tags($_t);
    }
    if (array_key_exists('urlencode', $parameters)) {
        $_t = urlencode($_t);
    }
    
    if ($htmlspecialchars) {
        $_t = htmlspecialchars($_t, ENT_COMPAT, 'ISO-8859-15');
    }

    $replacement = $_t;
    break;

    /* TODO These fields might be used too
    kategory
    datum bigint
    freigabe_name
    freigabe_datum bigint
    timestamp timestamp
    last_modify bigint
    c_time datetime
    changer
    sort_id 
    */
}