<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

// define some vars
initVar($_POST['rightsFor'],array());
initVar($_GET['rubric_id'],NULL);
initVar($_GET['user_id'],NULL);



if (empty($_POST['rightsFor'])) return;

$rubric_id = (int)$_GET['rubric_id'];
$user_id   = (int)$_GET['user_id'];
foreach ($_POST['rightsFor'] as $rightFor) {
    if (!empty($_GET['rubric_id'])) {
        $user_id   = (int)$rightFor;
    } else {
        $rubric_id = (int)$rightFor;
    }

    $db = new DB;
    $db->query('SELECT id FROM ' . CPO_PERMISSION . ' ' .
             'WHERE user_id = '   . (int)$user_id   . ' ' .
             'AND   rubric_id = ' . (int)$rubric_id . ' '
    );
    $id = 'null';
    if ($db->next_record()) $id = $db->v('id');
    
    $query = '';

    logaction('change rubric (' . $rubric_id . ') rights', $user_id . ': ' .
        (!empty($_POST['rights'][$rightFor][1]) ? 1 : 0) .
        (!empty($_POST['rights'][$rightFor][2]) ? 1 : 0) .
        (!empty($_POST['rights'][$rightFor][3]) ? 1 : 0) .
        (!empty($_POST['rights'][$rightFor][4]) ? 1 : 0)
    );

    // some older parts of CPO require no-access (0000) rubrics to not be listed
    if (empty($_POST['rights'][$rightFor][1]) &&
        empty($_POST['rights'][$rightFor][2]) && 
        empty($_POST['rights'][$rightFor][3]) &&
        empty($_POST['rights'][$rightFor][4]) &&
        $id != 'null') {
        $query = 'DELETE FROM ' . CPO_PERMISSION . ' ' .
                 'WHERE id = ' . $id;
        DEBUG(1, $query, __FILE__, __LINE__);
        $db->query($query);
    } else if (!empty($_POST['rights'][$rightFor][1]) ||
               !empty($_POST['rights'][$rightFor][2]) || 
               !empty($_POST['rights'][$rightFor][3]) ||
               !empty($_POST['rights'][$rightFor][4])) {
        $query = 'REPLACE ' . CPO_PERMISSION . ' SET ' .
                 'id = '        . $id        . ', ' .
                 'user_id = '   . $user_id   . ', ' .
                 'rubric_id = ' . $rubric_id . ', ' .
                 'stufe1 = '    . (!empty($_POST['rights'][$rightFor][1]) ? 1 : 0) . ', ' .
                 'stufe2 = '    . (!empty($_POST['rights'][$rightFor][2]) ? 1 : 0) . ', ' .
                 'stufe3 = '    . (!empty($_POST['rights'][$rightFor][3]) ? 1 : 0) . ', ' .
                 'stufe4 = '    . (!empty($_POST['rights'][$rightFor][4]) ? 1 : 0) . ' ';
        DEBUG(1, $query, __FILE__, __LINE__);
        $db->query($query);
    }
}
    $message[] = __('The changes were successfully saved.');
