<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

// -- User
// -- Usergroup

$counter_free   = 0;
$counter_block  = 0;
$counter_wait   = 0;
$counter_reject = 0;

$counter_free = 0;
if ($cpoSystem['release']) {
    $query1 = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv=0 AND freigabe='".STATE_RELEASED."'";
    DEBUG(1, $query1, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query1);
    $db_2->next_record();
    $counter_free = $counter_free + $db_2->v('COUNT(*)');
} else {
    $query1 = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv=0 AND (freigabe=0 OR freigabe='".STATE_WAITING."' OR freigabe=3)";
    DEBUG(1, $query1, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query1);
    $db_2->next_record();
    $counter_free = $counter_free + $db_2->v('COUNT(*)');
} 

$query1 = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv=0 AND freigabe=2";
DEBUG(1, $query1, __FILE__, __LINE__);
$db_2 = new DB;
$db_2->query($query1);
$db_2->next_record();
if ($db_2->num_rows()!=0) {
    $freigabe_OK = 1;
    $counter_block = $counter_block + $db_2->v('COUNT(*)');
} 

if ($cpoSystem['release']) {
    $query1 = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv=0 AND freigabe=1";
    DEBUG(1, $query1, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query1);
    $db_2->next_record();
    if ( $db_2->v('COUNT(*)') != 0 ) {
        $freigabe_OK = 1;
        $counter_wait = $counter_wait + $db_2->v('COUNT(*)');
    }

    $query1 = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv=0 AND freigabe=3";
    DEBUG(1, $query1, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query1);
    $db_2->next_record();
    if ( $db_2->v('COUNT(*)') != 0 ) {
        $freigabe_OK = 1;
        $counter_reject = $counter_reject + $db_2->v('COUNT(*)');
    } 
}

// --  bearbeitete Artikel
$jetzt  = time();
$myear  = date('Y');
if (date('m')-1<=0) {
    $myear = date('Y')-1;
} 

$midnight   = mktime(0,0,0,date("m"),date ("d"),date("Y"));
$month      = mktime(0,0,0,date("m"),1,date("Y"));
$lastmonth  = mktime(0,0,0,date("m")-1,1, $myear);
$year       = mktime(0,0,0,1,1,date("Y"));
$lastyear   = mktime(0,0,0,1,1,date("Y")-1);
$anzahl_tage_seit_sonntag = date("w");
$week = $midnight - ($anzahl_tage_seit_sonntag+1)*86400+(86400*2);

$day = "86400"; // 24 Stunden
$today = $midnight;             // today
$yesterday = $midnight-$day;   // yesterday
$lastweek = $week-(86400*7);

// Today
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." "
        ."WHERE artikel_archiv<2 AND last_modify>'".date('Y-m-d H:i:s', $today)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleToday = $db->v('COUNT(*)');

// Month
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv<2 AND last_modify>'".date('Y-m-d H:i:s', $month)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleMonth = $db->v('COUNT(*)');

// Year
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv<2 AND last_modify>'".date('Y-m-d H:i:s', $year)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleYear = $db->v('COUNT(*)');

// this Week
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv<2 AND last_modify>'".date('Y-m-d H:i:s', $week)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleWeek = $db->v('COUNT(*)');

// Yesterday
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv<2 AND last_modify<'".date('Y-m-d H:i:s', $today)."' AND last_modify>'".date('Y-m-d H:i:s', $yesterday)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleYesterday = $db->v('COUNT(*)');

// last Week
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv<2 AND last_modify<'".date('Y-m-d H:i:s', $week)."' AND last_modify>'".date('Y-m-d H:i:s', $lastweek)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleLastWeek = $db->v('COUNT(*)');

// last Week
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv<2 AND last_modify<'".date('Y-m-d H:i:s', $month)."' AND last_modify>'".date('Y-m-d H:i:s', $lastmonth)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleLastMonth = $db->v('COUNT(*)');

// last Year
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv<2 AND last_modify<'".date('Y-m-d H:i:s', $year)."' AND last_modify>'".date('Y-m-d H:i:s', $lastyear)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleLastYear = $db->v('COUNT(*)');

// Offline
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv < 2 AND pub_datum > '".date('Y-m-d H:i:s', $jetzt)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleOffline = $db->v('COUNT(*)');

// Online
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv < 2 AND pub_datum < '".date('Y-m-d H:i:s', $jetzt)."' AND verfallsdatum > '".date('Y-m-d H:i:s', $jetzt)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleOnline = $db->v('COUNT(*)');

// Archiv
$query = "SELECT COUNT(*) FROM ".CPO_NEWS." WHERE artikel_archiv < 2 AND verfallsdatum < '".date('Y-m-d H:i:s', $jetzt)."'";
DEBUG(2, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();
$cpo_counter_ArticleArchiv = $db->v('COUNT(*)');


?>
<table class="colored" style="width: 100%;">
    <thead><tr>
        <th colspan="2"><span><?php echo __('Rubrics'); ?></span></th>
    </tr></thead><tbody><tr>
        <td class="leftrow"><?php echo __('Number of rubrics:'); ?></td>
        <td class="rightrow">
            <?php
            $query = "SELECT COUNT(*) FROM ".CPO_RUBRIC." ";
            DEBUG(1, $query, __FILE__, __LINE__);
            $db->query($query);
            $db->next_record();
            echo '<strong>'.$db->v('COUNT(*)').'</strong>';
            ?>
            <?php echo help('system-statistics.html#system-statistics-rubriccount'); ?>
        </td>
    </tr><tr>
        <td><?php echo __('Number of rubric directories:'); ?></td>
        <td>
            <?php
            $d = dir('..');
            $cpo_counter_rubrik = 0;
            while( $directory=$d->read() ) {
                if ($directory=='.' || $directory=='..') continue;
                if ((!is_readable(CPO_BASEDIR.$directory)) || (!is_dir(CPO_BASEDIR.$directory))) continue;

                $files = CPO_BASEDIR.$directory.'/rubric.cpo';
                if (!file_exists($files)) continue;
                if (!is_file($files)) continue;

                $cpo_counter_rubrik++;
            }
            echo '<strong>'.$cpo_counter_rubrik.'</strong>';
            ?>
            <?php echo help('system-statistics.html#system-statistics-rubricdircount'); ?>
        </td>
    </tr></tbody>
</table>

<table class="colored" style="width: 100%;">
    <thead><tr>
        <th colspan="2"><span><?php echo __('Users'); ?></span></th>
    </tr></thead><tbody><tr>
        <td class="leftrow"><?php echo ___('Number of users:'); ?></td>
        <td class="rightrow">
            <?php
            $cpo_counter_member = 0;
            $cpo_counter_redakteur = 0;
            $cpo_counter_chefredakteur = 0;
            $cpo_counter_superuser = 0;
            $cpo_counter_administrator = 0;
            $cpo_counter_gesamt = 0;
            $query = "SELECT admin, COUNT(*) as anzahl FROM ".CPO_USER." "
                    ."GROUP BY admin";
            DEBUG(1, $query, __FILE__, __LINE__);
            $db = new DB;
            $db->query($query);
            while ($db->next_record()) {
                $cpo_counter_gesamt = $cpo_counter_gesamt+$db->v('anzahl');

                switch($db->v('admin')) {
                case 0:
                    $cpo_counter_member = $db->v('anzahl');
                    break;
                case 1:
                    $cpo_counter_redakteur = $db->v('anzahl');
                    break;
                case 2:
                    $cpo_counter_chefredakteur = $db->v('anzahl');
                    break;
                case 3:
                    $cpo_counter_superuser = $db->v('anzahl');
                    break;
                case 4:
                    $cpo_counter_administrator = $db->v('anzahl');
                    break;
                }
            }
            ?>
            <table cellpadding="0" cellspacing="0" >
            <tr>
                <td style="text-align: right;"><strong>&nbsp;<?php print(htmlspecialchars($cpo_counter_member, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('Member')); echo help('system-statistics.html#system-statistics-usercount'); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong>&nbsp;<?php print(htmlspecialchars($cpo_counter_redakteur, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(__('Editor')); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong>&nbsp;<?php print(htmlspecialchars($cpo_counter_chefredakteur, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('Chief editor')); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong>&nbsp;<?php print(htmlspecialchars($cpo_counter_superuser, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(    __('Superuser')); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong>&nbsp;<?php print(htmlspecialchars($cpo_counter_administrator, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('Administrator')); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong>&nbsp;<?php print(htmlspecialchars($cpo_counter_gesamt, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><strong><?php print(___('Total')); ?></strong></td>
            </tr>
            </table>
            
        </td>
    </tr><tr>
        <td><?php echo __('Number of user groups:'); ?></td>
        <td>
            <?php 
            $query = "SELECT COUNT(*) FROM ".CPO_USERGROUPS;
            DEBUG(1, $query, __FILE__, __LINE__);
            $db->query($query);
            $db->next_record();
            
            echo '<table cellpadding="0" cellspacing="0" ><tr><td style="text-align: right;">&nbsp;';
            print('<strong>'.$db->v('COUNT(*)').'</strong>').help('system-statistics.html#system-statistics-usergroupcount');
            echo '</td></tr><tr></table>';
            ?>
        </td>
    </tr></tbody>
</table>

<table class="colored" style="width: 100%;">
    <thead><tr>
        <th colspan="2"><span><?php print(___('Content')); ?></span></th>
    </tr></thead><tbody><tr>
        <td class="leftrow"><?php print(___('Number of existing articles:')); ?></td>
        <td class="rightrow">
            <table cellpadding="0" cellspacing="0" ><tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($counter_free, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('released articles')); echo help('system-statistics.html#system-statistics-articlecount'); ?>
                
                    <!-- added by MR -->
                    <table cellpadding="0" cellspacing="0" ><tr>
                        <tr>
                            <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleOffline, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                            <td><?php print(___('upcoming articles')); ?></td>
                        </tr>
                        <tr>
                            <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleOnline-$counter_block, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                            <td><?php print(___('online articles')); ?></td>
                        </tr>
                        <tr>
                            <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleArchiv, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                            <td><?php print(___('expired articles')); ?></td>
                        </tr>
                    </table>
                    <!-- / added by MR -->
                
                </td>
            </tr><tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($counter_block, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('blocked articles')); ?></td>
            </tr>
                <?php if ($cpoSystem['release']) { ?>
                <tr>
                    <td style="text-align: right;"><strong><?php print(htmlspecialchars($counter_wait, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                    <td><?php print(___('waiting articles')); ?></td>
                </tr><tr>
                    <td style="text-align: right;"><strong><?php print(htmlspecialchars($counter_reject, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                    <td><?php print(___('rejected articles')); ?></td>
                </tr>
                <?php } 

                // -- deleted articles
                $query = "SELECT COUNT(*) FROM ".CPO_NEWS." "
                        ."WHERE artikel_archiv=9"; // FIXME ??? .ARCHIV_DELETED;
                DEBUG(1, $query, __FILE__, __LINE__);
                $db->query($query);
                $db->next_record();
                ?>
            <tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($db->v('COUNT(*)'), ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('deleted articles')); ?></td>
            </tr></table>
        </td>
    </tr><tr>
        <td><?php print(___('Number of worked on articles:')); ?></td>
        <td>
            <table cellpadding="0" cellspacing="0" ><tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleToday    , ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('today')); echo help('system-statistics.html#system-statistics-articleslasstedit'); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleYesterday, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('yesterday')); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleWeek     , ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('this week')); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleLastWeek , ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('last week')); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleMonth    , ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('this month')); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleLastMonth, ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('last month')); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleYear     , ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('this year')); ?></td>
            </tr><tr>
                <td style="text-align: right;"><strong><?php print(htmlspecialchars($cpo_counter_ArticleLastYear , ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                <td><?php print(___('last year')); ?></td>
            </tr></table>
        </td>
    </tr><tr>
        <td><?php print(___('Articles by editor:')); ?></td>
        <td>
            <?php 
            $query = "SELECT user, name FROM ".CPO_USER." WHERE admin > 0 ORDER BY name";
            DEBUG(2, $query, __FILE__, __LINE__);
            $db->query($query);

            if ($db->num_rows()>0) {
                print('<table cellpadding="0" cellspacing="0" >');
                $firstlinehelp = help('system-statistics.html#system-statistics-articlesbyeditor');
                while($db->next_record()) {
                    $user = $db->v('user');
                    $name = $db->v('name');

                    $query = "SELECT COUNT(*) FROM ".CPO_NEWS." "
                            ."WHERE artikel_archiv<2 "
                            ."AND changer='".$user."' ";
                    DEBUG(2, $query, __FILE__, __LINE__);
                    $db2 = new DB;
                    $db2->query($query);
                    $db2->next_record();
                    ?>
                    <tr> 
                        <td style="text-align: right;"><strong><?php print(htmlspecialchars($db2->v('COUNT(*)'), ENT_COMPAT, 'ISO-8859-15')); ?>&nbsp;</strong></td>
                        <td><?php print(htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').' ('.htmlspecialchars($user, ENT_COMPAT, 'ISO-8859-15').')').$firstlinehelp; $firstlinehelp = '';?>&nbsp;</td>
                    </tr>
                    <?php
                }
                print('</table>');
            }
            ?>
        </td>
    </tr></tbody>
</table>

<table class="colored" style="width: 100%;">
    <thead><tr>
        <th colspan="2"><span><?php print(___('Templates')); ?></span></th>
    </tr></thead><tbody><tr>
        <td class="leftrow"><?php print(___('Article-templates')); ?>:</td>
        <td class="rightrow">
            <?php
            $query = "SELECT COUNT(*), name FROM ".CPO_NEWS.", ".CPO_TEMPLATES." "
                    ."WHERE templates_id=".CPO_TEMPLATES.".id "
                    ."AND nr=article_nr "
                    ."AND artikel_archiv!=9 "
                    ."GROUP BY templates_id";
            DEBUG(2, $query, __FILE__, __LINE__);
            $db->query($query);

            if ($db->num_rows()>0) {
                print('<table cellpadding="0" cellspacing="0" >');
                $firstlinehelp = help('system-statistics.html#system-statistics-articletemplates');
                while($db->next_record()) {
                    echo '<tr>';
                    echo '<td style="text-align: right;"><strong>'.htmlspecialchars($db->v('COUNT(*)'), ENT_COMPAT, 'ISO-8859-15').'&nbsp;</strong></td>';
                    echo '<td>'.htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15').$firstlinehelp; 
                    echo '&nbsp;</td>';
                    echo '</tr>';
                    $firstlinehelp = '';
                }
                echo '</table>';
            }
            ?>
        </td>
    </tr></tbody>
</table>

<?php 
echo '<table class="colored" style="width: 100%;">';
echo '<thead><tr>';
echo '<th colspan="2"><span>'.___('Accesses').'</span></th>';
echo '</tr></thead>';
    
if ($cpoSystem['statistics']) {
    $db = new DB;
    $db->query('SELECT name, index_site, detail_site, archive_site, last_hit '
              .'FROM '.CPO_STATISTICS.', '.CPO_RUBRIC.' '
              .'WHERE rubric_id = '.CPO_RUBRIC.'.id '
              .'ORDER BY name');
    if ($db->num_rows()==0) {
        echo '<tr><td colspan="2">'.___('Sorry, no records found.').help('system-statistics.html#system-statistics-accesscounter').'</td></tr>';
    }
    while ($db->next_record()) {
        echo '<tr>';
        echo '<td class="leftrow">'.htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15').'</td>';
        echo '<td class="rightrow">';
        echo ___('Index:').' '.(int)$db->v('index_site').'&nbsp;&nbsp;&nbsp;';
        echo ___('Detail:').' '.(int)$db->v('detail_site').'&nbsp;&nbsp;&nbsp;';
        echo ___('Archive:').' '.(int)$db->v('archive_site').help('system-statistics.html#system-statistics-accesscounter');
        echo '<br />';
        echo ___('Last access:').' '.htmlspecialchars(date($cpoSystem['date_format'], strtotime($db->v('last_hit'))), ENT_COMPAT, 'ISO-8859-15');
        echo '</td>';
        echo '</tr>';
    }
} else {
    echo '<tr><td colspan="2">'
        .__('The statistics are disabled in the system settings.')
        .help('system-statistics.html#system-statistics-statsinactive')
        .'</td></tr>';
}
?>
</table>
