<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

$queryFrom = 'FROM ' . CPO_USER . ' ' . 'LEFT JOIN ' . CPO_PERMISSION . ' ' .
             'ON ' . CPO_USER . '.id=' . CPO_PERMISSION . '.user_id ' .
                'AND rubric_id=' . (int)$_GET['rubric_id'] . ' ' .
             'WHERE admin>0 ' .
                'AND ' . CPO_USER . '.id>=0 ';
$db = new DB;
$db->query('SELECT COUNT(*) ' . $queryFrom);
$db->next_record();
$maxData = $db->v('COUNT(*)');

$_pos = 0;
if (!empty($_REQUEST['pos'])) $_pos = (int)$_REQUEST['pos'];
if ($_pos<0) $_pos=0;

$perPageDefault = 10;
$perPage = $perPageDefault;
if (!empty($_REQUEST['perPage'])) $perPage = (int)$_REQUEST['perPage'];
if (!empty($_REQUEST['newPerPage'])) {$perPage = $_REQUEST['newPerPage']; $_pos=0;}

$suhosinMaxVars = ini_get('suhosin.post.max_vars');
if (ini_get('suhosin.request.max_vars')<$suhosinMaxVars)
    $suhosinMaxVars = ini_get('suhosin.request.max_vars');

$expectedRowCount = $perPage;
if ($perPage=='all' || $expectedRowCount>$maxData) $expectedRowCount = $maxData;
$maxExpectedVars = (10 + 5 * $expectedRowCount);
if (!empty($suhosinMaxVars) && 
    $suhosinMaxVars < $maxExpectedVars) {
        $perPage = floor(($suhosinMaxVars - 3) / 5);
        $message[] = sprintf(___('Because of a restriction on your server you can not edit more than %s entries at once.'), 
            $perPage
        );
    }

$query = 'SELECT ' . CPO_USER . '.id as user_id, user, name, admin, rubric_id, ' .
         'CONCAT(stufe1, stufe2, stufe3, stufe4) as statusall ' .
         $queryFrom .
         'ORDER BY user ' .
         'LIMIT ' . $_pos . ',' . ($perPage!='all' ? (int)$perPage : $maxData);
DEBUG(1, $query, __FILE__, __LINE__);
$db->query($query);

include CPO_BASEDIR . '_include/message.php';

next_page($_pos, 
          $maxData, 
          $perPage, 
          true, 
          'rubric_id=' . urlencode($_GET['rubric_id']) . '&amp;perPage=' . htmlspecialchars($perPage, ENT_COMPAT, 'ISO-8859-15'), 
          BASE_REL . '_admin/rubric_rights.php',
          array(),
          $perPageDefault);

// count vars: 1 rubric_id, 2 pos, 3 perPage, x * 5 (rightsFor, rights[4])
          
echo '<br /><form method="post" action="' . htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15') . '?rubric_id=' . (int)$_GET['rubric_id'] . '">';
echo '<input type="hidden" name="pos" value="' . htmlspecialchars($_pos, ENT_COMPAT, 'ISO-8859-15') . '" />';
echo '<input type="hidden" name="perPage" value="' . htmlspecialchars($perPage, ENT_COMPAT, 'ISO-8859-15') . '" />';
echo '<table class="ruler" style="width: 100%">';
echo '<thead><tr>';
echo '<th style="width: 40%;"><span>'.__('User')    . help('rubrics-listrubrics.html#rubrics-rubricsettings-rubricrights-user').'</span></th>';
echo '<th style="width: 10%;"><span>'.__('Create')  . help('rubrics-listrubrics.html#rubrics-rubricsettings-rubricrights-create').'</span></th>';
echo '<th style="width: 10%;"><span>'.__('Edit')    . help('rubrics-listrubrics.html#rubrics-rubricsettings-rubricrights-edit').'</span></th>';
echo '<th style="width: 10%;"><span>'.__('Upload')  . help('rubrics-listrubrics.html#rubrics-rubricsettings-rubricrights-upload').'</span></th>';
echo '<th style="width: 10%;"><span>'.__('Release') . help('rubrics-listrubrics.html#rubrics-rubricsettings-rubricrights-release').'</span></th>';
echo '<th style="width: 10%;"><span>'.__('Global')  . help('rubrics-listrubrics.html#rubrics-rubricsettings-rubricrights-global').'</span></th>';
echo '</tr></thead><tbody>';

while($db->next_record()) {
    echo '<tr id="' . md5($db->v('user_id')) . '">';
    echo '<td>';
    echo htmlspecialchars(formatUserName($db->v('user_id'), $db->v('user'), $db->v('name')), ENT_COMPAT, 'ISO-8859-15');
    echo '<input type="hidden" name="rightsFor[]" value="' . htmlspecialchars($db->v('user_id'), ENT_COMPAT, 'ISO-8859-15') . '" />';
    
    $statusall = $db->v('statusall');

    $disabled = '';
    if ($_SESSION['SID_user']['admin']<$db->v('admin')) { 
        $disabled = ' title="' . __('You are not allowed to change the rights of a higher role.') . '" disabled';
    }

    for ($i=0; $i<4; $i++) {
        echo '<td style="text-align: center;">';
        
        $checked = '';
        if ($statusall[$i]=='1') {
            $checked .= ' checked ';
        }
        echo '<input type="checkbox" id="r' . $db->v('user_id') . $i . '" name="rights[' . $db->v('user_id') . '][' . ($i+1) . ']" ' . 
             'value="1" ' .  $disabled . $checked . ' />';
        echo '</td>';
    }
        
    echo '<td style="text-align: center;">';
    if ($_SESSION['SID_user']['admin']<$db->v('admin')) { 
    } else {
        echo '<img src="' . SKIN_URL . 'pic_rights_all_on.gif" class="pic" onClick="' .
             'document.getElementById(\'r' . $db->v('user_id') . '0\').checked = true; ' .
             'document.getElementById(\'r' . $db->v('user_id') . '1\').checked = true; ' .
             'document.getElementById(\'r' . $db->v('user_id') . '2\').checked = true; ' .
             'document.getElementById(\'r' . $db->v('user_id') . '3\').checked = true; ' .
             'return false;' .
             '" title="' . ___('switch all rights on') . '" alt="' . ___('switch all rights on') . '" />&nbsp;';
        echo '<img src="' . SKIN_URL . 'pic_rights_all_off.gif" class="pic" onClick="' .
             'document.getElementById(\'r' . $db->v('user_id') . '0\').checked = false; ' .
             'document.getElementById(\'r' . $db->v('user_id') . '1\').checked = false; ' .
             'document.getElementById(\'r' . $db->v('user_id') . '2\').checked = false; ' .
             'document.getElementById(\'r' . $db->v('user_id') . '3\').checked = false; ' .
             'return false;' .
             '"  title="' . ___('switch all rights off') . '" title="' . ___('switch all rights off') . '" />';
    }
    echo '</td>';

    echo '</tr>';

}  // while($db->next_record()) {
if ($_SESSION['SID_user']['admin']>=$db->v('admin')) {
    echo '<tr><td>&nbsp;</td><td colspan="5"><input type="submit" value="' . ___('save') . '" /></td></tr>';
}
echo '</table>';

echo '</form>';

next_page($_pos, 
          $maxData, 
          $perPage, 
          true, 
          'rubric_id=' . urlencode($_GET['rubric_id']) . '&amp;perPage=' . htmlspecialchars($perPage, ENT_COMPAT, 'ISO-8859-15'), 
          BASE_REL . '_admin/rubric_rights.php',
          array(),
          $perPageDefault);