<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

$query = "SELECT id, datei, alttext, beschreibung, format, rubric_id "
        ."FROM ".CPO_DATA." "
        ."WHERE id='".addslashes($_REQUEST['id'])."'";
DEBUG(1, $query, __FILE__, __LINE__);
$db = new DB;
$db->query($query);

if ($db->num_rows()<=0){ 
    $message = ___('No pictures found.');
    require(CPO_BASEDIR.'_include/message.php');
    return;
} 
$db->next_record();

if ($db->v('format')!='2') {
    printPageHeader(
        __('Edit file description'),
        __('In this view you can edit the information for this file.'),
        'files-workonfiles.html#files-workonfiles-editfilesettings'
    );
} else {
    printPageHeader(
        __('Edit image description'),
        __('In this view you can edit the information for this image.'),
        'files-workonimage.html#files-workonimage-editimagesettings'
    );
}

$formaction = '_admin/manage_files.php';
if ($db->v('format')==2) $formaction = '_admin/manage_images.php'; // image

echo '<form method="post" action="'.BASE_REL.$formaction.'" name="newsentry">';
$antiCSRF->printInput('update');
echo '<input type="hidden" name="id"     value="'.htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15').'">';
echo '<input type="hidden" name="file"   value="'.htmlspecialchars($db->v('datei'), ENT_COMPAT, 'ISO-8859-15').'">';
echo '<input type="hidden" name="format" value="'.htmlspecialchars($db->v('format'), ENT_COMPAT, 'ISO-8859-15').'">';

echo '<table class="colored" style="width: 100%;"><thead>';

echo '<tr>';
if ($db->v('format')!='2') {
    echo '<th colspan="2"><span>'.___('File properties').'</span></th>';
} else {
    echo '<th colspan="2"><span>'.___('Image properties').'</span></th>';
}
echo '</tr></thead><tbody>';
?>
<tr>
    <td class="leftrow"><?php echo ___('Filename:'); ?></td>
    <td class="rightrow">
        <?php echo htmlspecialchars($db->v('datei'), ENT_COMPAT, 'ISO-8859-15'); ?>
        <?php 
        if ($db->v('format')!='2') echo help('files-workonfiles.html#files-workonfiles-editfilesettings-filename'); 
        else echo help('files-workonimage.html#files-workonimage-editimagesettings-filename');
        ?>
    </td>
</tr>
<?php 

if ($db->v('format')!='2') {
    print('<input type="hidden" name="alttext" value="">');
} else {
    if (!isset($_POST['alttext'])) $_POST['alttext'] = $db->v('alttext');
    ?>
    <tr>
        <td><?php echo ___('Alternative text (\'ALT\'):'); ?></td>
        <td>
            <input type="text" name="alttext" class="text inputwidth" value="<?php echo htmlspecialchars($_POST['alttext'], ENT_COMPAT, 'ISO-8859-15'); ?>" size="55" maxlength="255">
            <?php echo help('files-workonimage.html#files-workonimage-editimagesettings-alttext'); ?>
        </td>
    </tr>
    <?php
}

if (!isset($_POST['description'])) $_POST['description'] = $db->v('beschreibung'); ?>
<tr>
    <td><?php echo ___('Description:'); ?></td>
    <td>
        <textarea name="description" class="inputwidth" cols="55" rows="7"><?php echo htmlspecialchars($_POST['description'], ENT_COMPAT, 'ISO-8859-15'); ?></textarea>
        <?php 
        if ($db->v('format')!='2')  echo help('files-workonfiles.html#files-workonfiles-editfilesettings-filedescription'); 
        else echo help('files-workonimage.html#files-workonimage-editimagesettings-imagedescription');
        ?>
    </td>
</tr>

<?php
if (!isset($_POST['rubric_id'])) $_POST['rubric_id'] = $db->v('rubric_id'); ?>
<tr>
    <td><?php echo ___('Available in:'); ?></td>
    <td>
        <?php
        $br = '';
        if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
            print($br.'<input type="radio" name="rubric_id" id="rubric_id" value="'
                 .'-2"'.($_POST['rubric_id']==-2 ? ' checked' : '').'>'
                 .__('article-templates'));
            $br = '<br />';
        }
        print($br.'<input type="radio" name="rubric_id" id="rubric_id" value="'
             .'-1"'.($_POST['rubric_id']==-1 ? ' checked' : '').'>'
             .__('all rubrics'));
        $br = '<br />';

        if ($_POST['rubric_id']>=0 && $_SESSION['SID_rubric_id']!=$_POST['rubric_id']) {
            $query = "SELECT name "
                    ."FROM ".CPO_RUBRIC." "
                    ."WHERE id='".addslashes($_POST['rubric_id'])."'";
            DEBUG(1, $query, __FILE__, __LINE__);
            $db2 = new DB;
            $db2->query($query);
            $db2->next_record();
            if ($_POST['rubric_id']>0) {
                print($br.'<input type="radio" name="rubric_id" id="rubric_id" value="'
                     .htmlspecialchars($_POST['rubric_id'], ENT_COMPAT, 'ISO-8859-15').'"'.($_POST['rubric_id']>=0 ? ' checked' : '').'>'
                     .sprintf(___('in rubric %s'), '<em>'.htmlspecialchars($db2->v('name'), ENT_COMPAT, 'ISO-8859-15')).'</em> ');
            }
            $br = '<br />';
        }

        if ($_SESSION['SID_rubric_id']!='' && ($_SESSION['SID_stufe3'] || $_SESSION['SID_user']['admin']>ROLE_EDITOR)) {
            print($br.'<input type="radio" name="rubric_id" id="rubric_id" value="'
                 .htmlspecialchars($_SESSION['SID_rubric_id'], ENT_COMPAT, 'ISO-8859-15').'"'.($_SESSION['SID_rubric_id']==$_POST['rubric_id'] ? ' checked': '').'>'
                 .sprintf(___('in rubric %s'), '<em>'.htmlspecialchars($_SESSION['SID_rubric_name'], ENT_COMPAT, 'ISO-8859-15').'</em> '));
            $br = '<br />';
        } 

        if ($db->v('format')!='2') echo help('files-workonfiles.html#files-workonfiles-editfilesettings-availablein'); 
        else echo help('files-workonimage.html#files-workonimage-editimagesettings-availablein');
        ?>
    </td>
</tr>
<tr>
    <td>&nbsp;</td>
    <td>
        <input type="submit" class="button" value="<?php echo ___('save'); ?>">
    </td>
</tr>
</tbody></table>
</form>