<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id: index.php 7 2005-07-31 13:07:39Z balu $ */
define('CPO', true);

if (isset($_GET['ref']) && substr($_GET['ref'], 0, 5)=='setup') define('SETUP', true);
$showHelpInSpiteOfSetup = true;
require_once('../_include/common.inc.php');
initVar($_SESSION['SID_user']['language'],'deutsch');
?>
<html>
<head>
    <meta name="robots" content="noindex, nofollow" />
    <title><?php echo htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15').' '.___('Help'); ?></title>
</head>

<?php
if (!isset($_GET['ref'])) {
    $_GET['ref'] = 'index.html';
}

if (isset($_GET['ref'])) {
    if (substr($_GET['ref'], 0, 5)=='http:') {
        $linkUrl = $_GET['ref'];
    } else {
        // use local file for manual
        $fileref = $_GET['ref'];
        if (strstr($fileref, '#'))
            $fileref = substr($fileref, 0, strpos($fileref, '#'));

        // an absolute path is meant to be searched based from basedir
        if (substr($fileref, 0, 1)=='/') {
            $linkFile = CPO_BASEDIR . substr($fileref, 1);
            $linkUrl  = BASE_ABS    . substr($_GET['ref'], 1);
        // a relative path is to be searched in a language specific folder
        } else {
            $linkFile = CPO_BASEDIR . '_manual/' . $_SESSION['SID_user']['language'] . '/' . $fileref;
            $linkUrl  = BASE_ABS    . '_manual/' . $_SESSION['SID_user']['language'] . '/' . $_GET['ref'];

            if (!empty($_GET['language'])) {
                $linkFile = CPO_BASEDIR . '_manual/' . $_GET['language'] . '/' . $fileref;
                $linkUrl  = BASE_ABS    . '_manual/' . $_GET['language'] . '/' . $_GET['ref'];
            }

            // switch to english if version in user language is not available
            if (!file_exists($linkFile) || !is_readable($linkFile)) {
                $linkFile = CPO_BASEDIR . '_manual/english/' . $fileref;
                $linkUrl  = BASE_ABS    . '_manual/english/' . $_GET['ref'];
            }
        }

        if (!file_exists($linkFile) || !is_readable($linkFile)) {
            $linkUrl = BASE_ABS . '_manual/missing.php';
        }
    }
}

if (!isset($_GET['show'])) $_GET['show'] = '';
$anchor = '';
if (strpos($_GET['show'], '#')!==false) $anchor = '#'.urlencode(substr($_GET['show'], strpos($_GET['show'], '#')+1));
if (!empty($_GET['language'])) $anchor = '&language=' . urlencode($_GET['language']) . $anchor;
echo '<frameset cols="340,*">';
if (defined('SETUP'))
    echo '<frame name="manual_navigation" scrolling="auto" src="toc.php?s=1&amp;show='.urlencode($_GET['show']).$anchor.'">';
else
    echo '<frame name="manual_navigation" scrolling="auto" src="toc.php?show='.urlencode($_GET['show']).$anchor.'">';
echo '<frame name="manual_content"    scrolling="auto" src="'.htmlspecialchars($linkUrl, ENT_COMPAT, 'ISO-8859-15').'">';
echo '</frameset>';
?>
</html>
