<?php // vim: set syntax=css :
header('Content-Type: text/css');
?>

/* Basis-Blau: #294865*/
body {
	text-decoration: none;      
	color: #357; 
	font-family: Verdana, Arial, Helvetica, sans-serif; 
	background-color: #fff; 
	margin: 0px; 
}

body, table {/* Why do tables use larger font otherwise? */
	font-size: 11px; 
}

/* default alignment of table cells */
td {vertical-align: top; text-align: left;}

/* no borders on images */
img {border: 0px;}

/* header formatting */
h1, h2, h3, h4, h5, h6 {margin: 0 0 1em 0; padding: 0; font-weight: bold;}
h1                 {font-size: 16px;}
h2, h3, h4, h5, h6 {font-size: 14px;} /* default font size */

/* no margin around forms */
form {margin: 0;}

a {font-weight: bold; text-decoration: none; color: #357;}
a:hover   {text-decoration: underline;} 

/* navigation frame */
a.nav   {font-weight:normal;} /* for links in the backend navigation */
.navigation_body {margin: 1em 1em 1em 0;  background: url(cpo4b_navback.jpg)  repeat-y; color: white; }
.navigation_body ul { margin-left:0 !important; font-size: 14px;}
.navigation_body ul li a { padding-left:30px; margin-left:-25px; color:white; }
.navigation_body ul li a { display: block; width: 150px; padding-top: 3px; padding-bottom: 3px; }
.navigation_body ul li a:hover { text-decoration: none; }
.navigation_body ul li ul {  margin-top: 3px !important;  font-size: 11px;}
.navigation_body ul li ul li a {  font-size: 11px; display: inline; border: none; background: none; padding-left:17px; margin-left:-17px; position:relative;}
.navigation_body ul li ul li a:hover { text-decoration: underline; background: none; }

/* Warning and Message boxes */
.warning {margin: 1em 0 2em 0; padding: 10px; border: 1px solid #ffa800; background-color: #ffa800; } 
.message {margin: 1em 0 1em 0; padding: 20px; border: none; background-color: #294865; color: white; } 
.message legend {font-size: 11px; color: #ffa800;}
.message a {font-size: 11px; color: #ffa800;}
.confirmation {margin: 0; padding: 0; border: none; }

/* header on backend pages */ /* FIXME used elsewhere too - remove there */
.header {margin-bottom: 3em; } 

/* CSS for alternating table rows based on javascript */
/* table headers */

table { border-spacing: 0 !important; }
table tr td.rightrow td:first-child { padding-left: none !important; } 
table.ruler tr td:first-child, table.colored tr td:first-child { padding-left: 10px !important; } 


table thead th {
	padding: 1em 0;
	text-align: left;
	background: white;
}
table thead th span {
	font-size: 12px;
	font-weight: bold;
	white-space: nowrap;
}

/* settings for both types of table */
table.colored tr.colorlight, 
tr strong.colorlight,
table.ruler tr.colorlight {background: #f0f3f7; border-top: 0px;}  

table.colored td { border-left: 2px solid white; border-right: 2px solid white; }
table.colored tr.colordark,
table.ruler tr.colordark,
tr strong.colordark,
.darker {background: #e8ebf0; border-top: 0px; }  
/* editor */
body.darker {background: #e8ebf0 url(cpo4b_editorback.jpg)  repeat-x; color:white;}
/*body.darker table tr:first-child {background: #e8ebf0 url(cpo4b_editorback.jpg); color:white;}*/
body.darker a { color: #ffa800; }
body.darker fieldset, body.darker fieldset a, body.darker fieldset td { color: #357; }
body.darker select { border: 1px solid #b1c1d0; padding: 1px !important; background: #f8f8f8; }


table.colored tbody td,
table.ruler tbody td {padding: 0.3em; border-left: 2px solid white; border-right: 2px solid white; }

/* width of left and right row of system tables - length of input fields */
.leftrow    {width: 25%;}
.rightrow   {width: 75%;}
.inputwidth {width: 95%;}

/* data tables with ruler */
table.ruler {border-collapse: collapse; margin-bottom: 3em;} 
table.ruler td {border-left: 2px solid white;} 
table.ruler th {border-left: 2px solid white;} 
table.ruler tr {border-top: 2px solid white;}
table tbody tr.selected,
table.ruler tr.ruled {background: #C9D3DE; border-top: 0px;} 

/* alternating colored tables */
table.colored {border-collapse: collapse; border: 2px solid white; margin-bottom: 3em;} 
table.colored tr {border-top: 2px solid white;}

/* inner tables */
table.colored table td { background: none; border: none; }

/* FIXME the active article in version view */
table tbody tr.table_system_active {background: #C9D3DE; border-top: 0px;} 

/* form elements */
input.text, select {margin: 2px 0; border: 1px solid #b1c1d0; color: #294867; padding: 0; }
input.checkbox {margin: 1px 0 1px 0;  padding: 3px;}

fieldset { position: relative; border: 1px solid #357; padding: 0.5em; margin: 0; padding-top:15px; margin-top: 15px !important;}
.message legend {position: relative; padding-top: 35px; margin-bottom:5px; color: #ffa800; font-size: 12px; font-weight: bold;}
.confirmation legend {position: relative; padding-top: 35px; margin-bottom:5px; color: #357; font-size: 12px; font-weight: bold;}
.darker legend { font-size: 12px; font-weight: bold; background: #e8ebf0;}

input, textarea, select, iframe { border: 1px solid #b1c1d0; padding: 2px !important; background: #f8f8f8; }
input::-ms-browse, input::-ms-check { border: 1px solid #b1c1d0; padding: 2px !important; background: #f8f8f8; }
input:focus, textarea:focus, select:focus, iframe:focus, .buttonRaised:hover { background: #fff; border: 1px solid #357; }
input[type=image] { border: none; background: none; }
input[type=file] { border: none; background: none; }
input.button, input[type=submit] { font-weight: bold; padding: 10px 20px !important; background: #294865; color: white; cursor: pointer; border: none; }
input.button:hover, input[type=submit]:hover { background: #5492cc; }
/* editor */
.buttonRaised, .buttonLowered { border: 2px solid white !important; margin: 2px !important; background: #e8ebf0; }
.buttonLowered { background: #5492cc; border: 2px solid white !important; }

/* add help icon on help areas */
.help {cursor: help;}

/* DEBUG hover-effect */
.debug {position: relative; top: 0; left: 0; color: #a00; background-color: #fcc; font-weight: bold;}
.debug span:hover {color: #fcc; background: #a00; border: 0px;}
.debug span span {display: none;}
.debug span:hover span {
	display: block;
	min-width: 250px;
	font-weight: normal;
	position: absolute;
	top: 13px;
	left: 0;
	padding: 0.5em;
	background: #fcc;
	color: #a00;
	border: 1px solid #a00;
	font-size: 10px;
	z-index: 100;
}

/* color of placeholders in template editor */
.placeholder {
	color: #f00;
}

/* .pic {width: 18px; height: 21px;} */

.pager {font-size: 10px; margin-top: -1em; text-align: left; padding-bottom: 5px;}
.pager .active {color: #ffa800;}
.pager .passive {color: #b1c1d0;}

#titleBody { background: url(cpo4b_navback.jpg)  repeat-y; background-color: #eee;}
#titleLogo {position: absolute; top: 0; left: 0;}
#titleBar1 {height: 60px; position: relative; margin-bottom:10px; font-size: 12px; } /* project, login and date */
#titleBar1 div { left: 210px !important; } /* project, login and date */
#titleBar2 {padding: 6px 110px 6px 210px; font-size: 14px; font-weight: bold; height:30px; }      /* rubric information */
#titleBar2 select { font-size: 16px; }      /* rubric information */
/*#titleBar2, #titleBar2 a {color: #fff;}*/        /* dark background in header frame */

#previewSelectorBody {border-bottom: 5px solid #357;}
#previewSelector {}
#previewContent {}
option[disabled] {color: #aaa;}

#bse_iFrame { width: 99% !important; border: 1px solid #b1c1d0 !important; }