<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Auto-Login"                                          |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.0 / December 2018

*/

if (!defined('CPO')) exit;
$translator->addTranslation('autologin', CPO_BASEDIR.$moduleDirectory.'/lang');

define('CPO_AUTOLOGIN',$dbPrefix."_securitytokens");

$GLOBALS['modules']['autologin'] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'Auto Login',
    'install'   => 'function: autologin_install',
    'activate'  => 'function: autologin_activate',
    'deactivate'=> 'function: autologin_deactivate',
    'uninstall' => 'function: autologin_uninstall'
	);

function autologin_install()
{
    $db = new DB;
    $query = "CREATE TABLE IF NOT EXISTS ".CPO_AUTOLOGIN." (
              id int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
              user_id int(11) NOT NULL,
              user_name varchar(255) NOT NULL,
              identifier varchar(255) NOT NULL,
              securitytoken varchar(255) NOT NULL,
              created_at timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
              PRIMARY KEY (id)
              )";
    $db->query($query);
    $GLOBALS['message'][] = ___('The autologin-module was successfully installed!');
}
function autologin_uninstall()
{
    $db = new DB;
    $query = "DROP TABLE IF EXISTS ".CPO_AUTOLOGIN." ";
    $db->query($query);
	 $GLOBALS['message'][] = sprintf(__('The autologin-module was removed from the ConPresso-system. To finally uninstall the autologin-module, please remove the module directory <i>%s</i>.'),$GLOBALS['modules']['autologin']['directory']);

}
function autologin_activate()
{
    $GLOBALS['message'][] = ___('The autologin-module got activated.');
}

function autologin_deactivate()
{
    $GLOBALS['message'][] = ___('The autologin-module got deactivated.');
}

function random_string() {
   if(function_exists('random_bytes')) {
      $bytes = random_bytes(16);
      $str = bin2hex($bytes); 
   } else if(function_exists('openssl_random_pseudo_bytes')) {
      $bytes = openssl_random_pseudo_bytes(16);
      $str = bin2hex($bytes); 
   } else if(function_exists('mcrypt_create_iv')) {
      $bytes = mcrypt_create_iv(16, MCRYPT_DEV_URANDOM);
      $str = bin2hex($bytes); 
   } else {
      //Bitte euer_geheim_string durch einen zuflligen String mit >12 Zeichen austauschen
      $str = md5(uniqid('euer_geheimer_string', true));
   }   
   return $str;
}

?>