<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Backup"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1a / October 2013 ==

*/

if (!defined('CPO')) exit;

if ($activeModules['Backup']['type'] == 'full')  {
	$activeModules['Backup']['type'] = 'tables';
	include(CPO_BASEDIR.$activeModules['Backup']['directory'].'/backup.inc.php');
	$activeModules['Backup']['type'] = 'data';
}


fputs ($file, "\n\n\n");
fputs ($file, '-- ----------------------------------------------------------------'."\n");
fputs ($file, '-- Datenbank-Backup vom '.date('d.m.Y').' (type: '.$activeModules['Backup']['type'].")\n");
fputs ($file, '-- mod_backup von Markus Rsel -- www.conpresso4.de'."\n");
fputs ($file, '-- ----------------------------------------------------------------'."\n");

fputs ($file, "\n\n".'SET CHARACTER SET '.$charSet.';'."\n\n");


// Tabellen lesen
	$dbm = new DB;
	$dbm->query('SHOW TABLES;');
	while($dbm->next_record()) {
		$table = $dbm->v('Tables_in_'.$dbm->Database);
        if (substr($table,0,2) != 'a ') { // avoid views
            $tables[] = "`".$table."`";
            $dbt = new DB;
            $dbt->query('SHOW CREATE TABLE '.$table);
            while($dbt->next_record()) {
                $create[$table] = $dbt->v('Create Table');
            }
        }
	}

switch ($activeModules['Backup']['type'])  {
	case 'tables':
		foreach ($create AS $table=>$createsql)  {
			fputs ($file, "\n\n\n".'-- Tabelle: '.$table.' --------------------------------------------------'."\n\n");
			if ($activeModules['Backup']['dropTables'] == "yes") fputs ($file, "DROP TABLE IF EXISTS `".$table."`; \n");
			fputs ($file, $createsql.";");
		}
		break;
	case 'data':
		// Felder auslesen
		foreach ($tables AS $table)  {
			fputs ($file, "\n\n\n".'-- Daten: '.$table.' --------------------------------------------------'."\n\n");
			$fields = array();
			$fieldnames = array();
			$fieldsequalsvalues = array();
			$dbm = new DB;
			$dbm->query('SHOW COLUMNS FROM '.$table);
			while($dbm->next_record()) {
				$fieldnames[] = $dbm->v('Field');
				$fields[] = "`".$dbm->v('Field')."`";
				$fieldstring = implode(", ", $fields);
			}
			$dbm = new DB;
			$dbm->query('SELECT '.$fieldstring.' FROM '.$table);
			while($dbm->next_record()) {
				$fieldsequalsvalues = array();
				foreach ($fieldnames AS $field)  {
					$value = str_replace("'","''",$dbm->v($field));
					$value = addcslashes($value,'\\');
//					$value = str_replace("\r\n",'\r\n',$value);
					$value = str_replace("\r",'\r',$value);
					$value = str_replace("\n",'\n',$value);
					$fieldsequalsvalues[] = ($charSet == 'utf8') ? "'".utf8_encode($value)."'" : "'".$value."'";
				}
				$fieldsequalsvaluesstring = implode(", ", $fieldsequalsvalues);
				$insertstring = "INSERT INTO ".$table." (".$fieldstring.") VALUES (".$fieldsequalsvaluesstring."); "."\n";
				fputs ($file, $insertstring);
			}
		}
		break;
}

unset ($dbm, $table, $tables, $dbt, $create, $createsql, $fields, $insertstring, $fieldsequalsvaluesstring, $fieldnames, $fieldsequalsvalues);

$log = fopen($dir."/last_backup.dat", "w");
fputs ($log, time());
fclose ($log);

?>