<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Backup"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1a / October 2013 ==

*/

if (!defined('CPO')) exit;
$translator->addTranslation('backup', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['Backup'] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'Backup',
    'install'   => 'function: Backup_install '.$moduleDirectory,
    'activate'  => 'function: Backup_activate '.$moduleDirectory,
    'deactivate'=> 'function: Backup_deactivate',
    'uninstall' => 'function: Backup_uninstall '.$moduleDirectory,
    'manage'	=> 'function: Backup_manage',
	'owner'		=> $cpoSystem['owner'],
	'lkey'		=> '',
	'mod_id'	=> 21,
	'helptoc'	=> array(
		'bersicht' 
			=> 'http://manual.conpresso4.de/backup/index.htm',
		'1. Was macht das Modul "Backup"?' 
			=> 'http://manual.conpresso4.de/backup/features.htm',
		'2. Installation' 
			=> 'http://manual.conpresso4.de/backup/setup.htm',
		'3. Einstellungen' 
			=> 'http://manual.conpresso4.de/backup/settings.htm',
		'4. Anwendung' 
			=> 'http://manual.conpresso4.de/backup/application.htm'
	),
	'externalHelpUrl'	=> 'http://manual.conpresso4.de',
	// presets
	'active'		=> 'no',
	'periodinhours'	=> 24,
    'days'			=> 14,
    'type'			=> 'full',
    'dropTables'	=> 'yes',
    'sendMail'		=> 'no',
    'sender'		=> $cpoSystem['system_email'],
    'recipient'		=> $cpoSystem['admin_email'],
    'subject'		=> __('Database backup')." ".$_SERVER['HTTP_HOST']
	);

$ok  = '<span style="color: #0c0; font-weight: bold;">'.__('Ok,').'</span> ';
$nok = '<span style="color: #f00; font-weight: bold;">'.__('Problem:').'</span> ';
$pok = '<span style="color: #fa0; font-weight: bold;">'.__('Note:').'</span> ';
$sol = '<span style="color: #00f; font-weight: bold;">'.__('Solution:').'</span> ';

function Backup_install($moduleDirectory)
{
	global $ok, $nok, $pok, $sol;
	$mdb = new DB;
	$mdb->query("INSERT INTO ".CPO_OPTION." (type, options, id) VALUES ('backup', '".serialize(array("installed"=>time()))."', '') ");
    $GLOBALS['message'][] = __('The backup module was successfully installed!');
	if (!is_writeable(CPO_BASEDIR.$moduleDirectory)) { 
		$GLOBALS['message'][] = $nok.sprintf(__('The directory <em>%s</em> is not writeable.'),$moduleDirectory);
		$GLOBALS['message'][] = $sol.sprintf(__('Please make sure that the user your webserver is running as has write access to the <em>%s</em> directory. Usually you can use your FTP client or command line tools to do so.'),$moduleDirectory);
	}
}
function Backup_uninstall($moduleDirectory)
{
	 $GLOBALS['message'][] = sprintf(__('The backup module was removed from the ConPresso system. Please remove the module directory <i>%s</i> to finally uninstall the backup-module.'),$moduleDirectory);

}
function Backup_activate($moduleDirectory)
{
	global $ok, $nok, $pok, $sol;
    $GLOBALS['message'][] = __('The backup module got activated.');
	if (!is_writeable(CPO_BASEDIR.$moduleDirectory)) { 
		$GLOBALS['message'][] = $nok.sprintf(__('The directory <em>%s</em> is not writeable.'),$moduleDirectory);
		$GLOBALS['message'][] = $sol.sprintf(__('Please make sure that the user your webserver is running as has write access to the <em>%s</em> directory. Usually you can use your FTP client or command line tools to do so.'),$moduleDirectory);
	}
}

function Backup_deactivate()
{
    $GLOBALS['message'][] = __('The backup module got deactivated.');
}

function Backup_manage()
{
	global $dbPrefix, $db, $k, $module_status, $newsletter_rubric_id;
	if(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE)  {
		echo '<a href="'.BASE_ABS.$GLOBALS['modules']['Backup']['directory'].'/edit.php"><img src="'.SKIN_URL.'pic_edit.gif" title="'.__('backup actions').'" alt="'.__('backup actions').'"></a>';
		echo '<a href="'.BASE_ABS.$GLOBALS['modules']['Backup']['directory'].'/settings.php"><img src="'.SKIN_URL.'pic_settings.gif" title="'.__('backup settings').'" alt="'.__('backup settings').'"></a>';
	} else {
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_edit.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_settings.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
	}
}

if (!function_exists('cleanSQLfiles'))  {
	function cleanSQLfiles($dir,$days)  {
		$h = opendir($dir);
		while($dirfile = readdir($h))  {
			if (substr($dirfile,-7)=='.sql.gz' OR substr($dirfile,-4)=='.sql')  {
				$path = $dir.'/'.$dirfile;
				if (time()-filemtime($path)>(($days*24*60*60)+3600))  {			// lter als $days Tage (plus etwas Toleranz)
					@unlink($path);
				}
			}
		}
		closedir($h);
	}
}

if (!function_exists('gzcompressfile'))  {
	function gzcompressfile($source,$level=false){ 
		$dest=$source.'.gz'; 
		$mode='wb'.$level; 
		$error=false; 
		if($fp_out=gzopen($dest,$mode)){ 
			if($fp_in=fopen($source,'rb')){ 
				while(!feof($fp_in)) 
					gzwrite($fp_out,fread($fp_in,1024*512)); 
				fclose($fp_in); 
				} 
			else $error=true; 
			gzclose($fp_out); 
			} 
		else $error=true; 
		if($error) return false; 
		  else return $dest; 
	} 
}

if (array_key_exists('Backup', $activeModules))  {

	if (!is_writeable(CPO_BASEDIR.$activeModules['Backup']['directory'])) { 
		$GLOBALS['message'][] = $nok.sprintf(__('The directory <em>%s</em> is not writeable.'),$activeModules['Backup']['directory']);
		$GLOBALS['message'][] = $sol.sprintf(__('Please make sure that the user your webserver is running as has write access to the <em>%s</em> directory. Usually you can use your FTP client or command line tools to do so.'),$activeModules['Backup']['directory']);
	}

	$mdb = new DB;
	$mdb->query('SELECT options FROM '.CPO_OPTION.' '
			  ."WHERE type='backup' ORDER BY id ASC LIMIT 0,1");
	while ($mdb->next_record()) {
		$options = $mdb->v('options');
		$backupOpt = unserialize($options);
		if (!is_array($backupOpt)) break;
		foreach ($backupOpt as $key=>$v) {
			$activeModules['Backup'][$key] = $v;
		}
	}

	// Das automatische Backup **************************************************************************
	$dir = CPO_BASEDIR.$activeModules['Backup']['directory'];
	if (!file_exists($dir."/last_backup.dat"))  {
		$log = fopen($dir."/last_backup.dat", "wb");
		fputs ($log, '0');
		fclose ($log);
	}
	$last_backup = file_get_contents($dir."/last_backup.dat");
	if ($last_backup && $activeModules['Backup']['active'] == 'yes' && $last_backup < (time()-($activeModules['Backup']['periodinhours']*3600)))  // Autobackup wenn Zeit abgelaufen
	{
		// character_set_connection lesen
			$dbm = new DB;
			$dbm->query("SHOW VARIABLES LIKE 'character_set_connection';");
			$dbm->next_record();
			$charSet = $dbm->v('Value');
		$filename = ".".$activeModules['Backup']['type'].".".$_SERVER['HTTP_HOST'].".".date('Y-m-d.H-i-s').".".$charSet.".sql";
		$file = fopen($dir."/files/".$filename, "wb");
			include(CPO_BASEDIR.$activeModules['Backup']['directory'].'/backup.inc.php');
		fclose ($file);
		if ($activeModules['Backup']['gzip']=="yes")  {
			gzcompressfile($dir."/files/".$filename,9);
			unlink ($dir."/files/".$filename);
			$filename = $filename.".gz";
		}
		include(CPO_BASEDIR.$activeModules['Backup']['directory'].'/sendmail.inc.php');
		cleanSQLfiles(CPO_BASEDIR.$activeModules['Backup']['directory'].'/files',$activeModules['Backup']['days']);
	}
}

?>