<?php 
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Backup"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1a / October 2013 ==

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 

// Moduleinstellungen speichern (neue Version mit automatischem Einlesen neuer Variablen)************
if (isset($_POST['go'])) {
	$new_settings = $_POST;
    foreach ($activeModules['Backup'] as $k=>$v) {
        if (!isset($_POST['cpoBackupNew'][$k])) continue;
        if (is_bool($activeModules['Backup'][$k])) {
            $activeModules['Backup'][$k] = (bool) $_POST['cpoBackupNew'][$k];
        } else {
			$activeModules['Backup'][$k] = $_POST['cpoBackupNew'][$k];
		}
		if (array_key_exists($k, $new_settings['cpoBackupNew'])) unset($new_settings['cpoBackupNew'][$k]);
    }
    foreach ($new_settings['cpoBackupNew'] as $k=>$v) {
		$activeModules['Backup'][$k] = $new_settings['cpoBackupNew'][$k];
	}
    $c_datum = date ("Y-m-d H:i:s", time());
    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = '%s'", 
            addslashes(serialize($activeModules['Backup'])),
			'Backup'
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = __('Module settings were updated!');
}

require(CPO_BASEDIR.'_include/header.php');

printPageHeader(
    __('Backup'),
    __('In this view you can work on the backup module settings.'),
	'http://manual.conpresso4.de/backup/settings.htm',
	true,
	'modules'
);
include(CPO_BASEDIR.'_include/message.php');
include('./producer.inc.php');

if(array_key_exists('Backup', $activeModules))  {

	
echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="modulesettings">';
echo '<input type="hidden" name="go" value="1">';

    // table header {{{
    echo '<table class="colored" style="width: 100%;">';
    echo '<thead><tr>';

    echo '<th colspan="2"><span>'.__('Backup settings').'</span></th>';

    echo '</tr></thead><tbody>';
    // }}}

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Activate autobackup:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpoBackupNew[active]" size="1">';
        $selyes = ($activeModules['Backup']['active']=="yes") ? ' selected="selected"' :'';
        $selno = ($activeModules['Backup']['active']=="no") ? ' selected="selected"' :'';
        echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
        echo '<option value="no"'.$selno.'>'.__('no').'</option>';
        echo '</select>';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Auto backup period in hours:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text" name="cpoBackupNew[periodinhours]" value="'.$activeModules['Backup']['periodinhours'].'" size="5" maxlength="5">';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Days to store backups:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text" name="cpoBackupNew[days]" value="'.$activeModules['Backup']['days'].'" size="5" maxlength="5">';
        echo '</td>';
    echo '</tr>';


    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Drop tables:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpoBackupNew[dropTables]" size="1">';
        $selyes = ($activeModules['Backup']['dropTables']=="yes") ? ' selected="selected"' :'';
        $selno = ($activeModules['Backup']['dropTables']=="no") ? ' selected="selected"' :'';
        echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
        echo '<option value="no"'.$selno.'>'.__('no').'</option>';
        echo '</select>';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Autobackup type:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpoBackupNew[type]" size="1">';
        $selyes = ($activeModules['Backup']['type']=="full") ? ' selected="selected"' :'';
        $selno = ($activeModules['Backup']['type']=="data") ? ' selected="selected"' :'';
        echo '<option value="full"'.$selyes.'>'.__('full backup').'</option>';
        echo '<option value="data"'.$selno.'>'.__('data only').'</option>';
        echo '</select>';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Compress with GZIP:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpoBackupNew[gzip]" size="1">';
        $selyes = ($activeModules['Backup']['gzip']=="yes") ? ' selected="selected"' :'';
        $selno = ($activeModules['Backup']['gzip']=="no") ? ' selected="selected"' :'';
        echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
        echo '<option value="no"'.$selno.'>'.__('no').'</option>';
        echo '</select>';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Send backup via mail:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpoBackupNew[sendMail]" size="1">';
        $selyes = ($activeModules['Backup']['sendMail']=="yes") ? ' selected="selected"' :'';
        $selno = ($activeModules['Backup']['sendMail']=="no") ? ' selected="selected"' :'';
        echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
        echo '<option value="no"'.$selno.'>'.__('no').'</option>';
        echo '</select>';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Sender email adress:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text inputwidth" name="cpoBackupNew[sender]" value="'.$activeModules['Backup']['sender'].'" maxlength="255">';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Recipient email adress:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text inputwidth" name="cpoBackupNew[recipient]" value="'.$activeModules['Backup']['recipient'].'" maxlength="255">';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Backup mail subject:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text inputwidth" name="cpoBackupNew[subject]" value="'.$activeModules['Backup']['subject'].'" maxlength="255">';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo '&nbsp;';
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
        echo '</td>';
    echo '</tr>';
    echo '</tbody></table>';

echo '</form>';

}
require(CPO_BASEDIR.'_include/footer.php');
?>
