<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/common.inc.php');

require(CPO_BASEDIR.'_include/var_category.php');
//require(CPO_BASEDIR.'_include/rubric_admin.php');

$views = array('login');

if (!isset($_REQUEST['action'])) $_REQUEST['action'] = 'login';

$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);

while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'dologin': // {{{
        // crypt password
        $_REQUEST['password'] = md5($_REQUEST['password']);

        // if the user is still logged in, set his username and password...
        if (isset($_SESSION['SID_log_login_id'])) { 
            $db = new DB;
            $query = "SELECT user, passwd "
                    ."FROM ".CPO_USER.", ".CPO_LOG_LOGIN." " 
                    ."WHERE ".CPO_USER.".id=".CPO_LOG_LOGIN.".user_id "
                    ."AND ".CPO_LOG_LOGIN.".id='".addslashes($_SESSION['SID_log_login_id'])."' ";
            $db->query($query);
            if ($db->next_record()) {
                $_REQUEST['username'] = $db->v('user');
                $_REQUEST['password'] = $db->v('passwd');
            }
        }

        $_SESSION['SID_login'] = '';
        if (isset($_REQUEST['username'])) $_SESSION['SID_login'] = $_REQUEST['username'];

        if (empty($_REQUEST['username'])) {
            $message[] = __('Please specify a username to log in.', $cpoRubricSettings['language']);
            break;
        }

        $db = new DB;
        $query = "SELECT id, name, admin, email, initial, usergroups_id, editor, language "
                ."FROM ".CPO_USER." "
                ."WHERE admin>=0 "
                .'AND id>=0 '
                ."AND user='".addslashes($_REQUEST['username'])."' "
                ."AND passwd='".addslashes($_REQUEST['password'])."'";
        $db->query($query);

        if (!$db->next_record()) {
            // no corresponding user with that login / password found.
            // reset session data
            // we need to destroy the session here because everything else does not work
            // in PHP 4.1.2 where sessions are kinda broken (e.g. session_encode() is):-/
            // other noticed behaviour: session variables are brought back after
            // setting them to "", etc...
            $message[] = ___('Sorry, this user/password combination does not exist.', $cpoRubricSettings['language']);
            $_SESSION = array();
            session_destroy();
            CPOsession_start();
            include(CPO_BASEDIR.'mod_brute_force/brute_force.inc.php');
            break;
        } 
        $hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
        $hostaddr = gethostbyname($_SERVER['REMOTE_ADDR']);
                                                            // FIXME rename for common scheme:
        // $_SESSION['SID_login']                           // SID_user_user 
        // $_SESSION['SID_log_login_id']  
        $_SESSION['SID_user']          = array(
                                            'id'=>$db->v('id'), 
                                            'usergroups_id'=>$db->v('usergroups_id'),
                                            'editor'=>$db->v('editor'), 
                                            'initial'=>$db->v('initial'),
                                            'email'=>$db->v('email'),
                                            'admin'=>$db->v('admin'),
                                            'language'=>$db->v('language'),
                                            'name'=>$db->v('name')
                                        );
        /*
        $_SESSION['SID_rubric_secure'] = '';                // SID_rubric_seclevel
        $_SESSION['SID_Rubrik']        = '';                // SID_rubric_name
        $_SESSION['SID_rubric_id']     = '';
        $_SESSION['SID_rubric_source_rubric_id'] = '';
        $_SESSION['SID_rubric_name']   = ''; 
        */

        $_SESSION['SID_IP']             = $hostaddr;
        // $_SESSION['SID_pagers']         = array('articles'=>0, 'users'=>0, 'users_deactivated'=>0);
        // $_SESSION['SID_display']        = 0; // which articles are to be displayed in list view // FIXME Not needed?

        // user was not logged in yet?
        if (!isset($_SESSION['SID_log_login_id'])) {
            $query = "INSERT INTO ".CPO_LOG_LOGIN." "
                    ."(user_id, login, last_action, ip, ip_name, browser) "
                    ."VALUES ("
                    ."'".addslashes($_SESSION['SID_user']['id'])."', " // user_id
                    ."'".date('Y-m-d H:i:s')."', "                     // login
                    ."'".date('Y-m-d H:i:s')."', "                     // last_action
                    ."'".addslashes($hostaddr)."', "                   // ip
                    ."'".addslashes($hostname)."', "                   // ip_name
                    ."'".$_SERVER['HTTP_USER_AGENT']."') ";            // browser
            $db->query($query);

            $query = "SELECT last_insert_id()";
            $db->query($query);
            $db->next_record();
            $_SESSION['SID_log_login_id'] = $db->v('last_insert_id()');

            logaction('login', '');
        }


        $usergroup_OK = FALSE;

        // personalized rubrics always allow access
        if ($cpoRubric['seclevel']==SECLEVEL_PERSONALIZED
        || $cpoRubric['seclevel']==SECLEVEL_PUBLIC) 
            $usergroup_OK = true;

        // check all allowed usergroups
        $query = "SELECT usergroups_id "
                ."FROM ".CPO_RUBRIC_PERMISSION." "
                ."WHERE rubric_id = ".(int)$cpoRubric['id'];
        $db->query($query);

        while($db->next_record()){
            if ($db->v('usergroups_id')!=$_SESSION['SID_user']['usergroups_id'])  continue;
            $usergroup_OK = true;
            break;
        }

        $views = array('login');
        if (isset($_SESSION['SID_log_login_id']) && ($usergroup_OK==true || $_SESSION['SID_user']['admin']>ROLE_CHIEFEDITOR)) {
            $views = array('jumptorubric');
            if (!empty($_REQUEST['nview']))
                $views = array($_REQUEST['nview']);
        } 

        break; // }}}}
    case 'logout': // {{{
        $views = array('jumptorubric');
        if (isset($_SESSION['SID_log_login_id'])) {
            $db = new DB;
            $query = "DELETE FROM ".CPO_LOG_LOGIN." " 
                    ."WHERE id=".(int)$_SESSION['SID_log_login_id'];
            $db->query($query);
        }

        switch ($nextaction) {
        case 'logout':
            logaction('logout', '');
            break;
        case 'timeout':
            logaction('timeout', '');
            break;
        }

        // reset session data 
        // we need to destroy the session here because everything else does not work
        // in PHP 4.1.2 where sessions are kinda broken (e.g. session_encode() is):-/
        // other noticed behaviour: session variables are brought back after
        // setting them to "", etc...
        $_SESSION = array();
        session_destroy();
        CPOsession_start();
        break; // }}}
    case 'timeout': // {{{
        break; // }}}}
    case 'password': // {{{
        if (!isset($_SESSION['SID_log_login_id'])) {
            $message[] = ___('You have to be logged in to change your password.', $cpoRubricSettings['language']);
            $_nview = 'change_password';
            break;
        }
        $views = array('change_password');
        break; // }}}}
    case 'password_change': // {{{
        if (!isset($_SESSION['SID_log_login_id'])) {
            $message[] = ___('You have to be logged in to change your password.', $cpoRubricSettings['language']);
            $_nview = 'change_password';
            break;
        }

        $views = array('change_password');

        // check old password
        $db = new DB;
        $query = "SELECT COUNT(*) "
                ."FROM ".CPO_USER." "
                ."WHERE admin>=0 "
                .'AND id>=0 '
                ."AND user='".addslashes($_SESSION['SID_login'])."' "
                ."AND passwd='".addslashes(md5($_POST['oldpassword']))."'";
        $db->query($query);
        $db->next_record();
        if ($db->v('COUNT(*)')<=0) {
            $message[] = ___('Please check your old password.', $cpoRubricSettings['language']);
            break;
        }

        // compare new passwords
        if ($_POST['password1']!=$_POST['password2']) {
            $message[] = ___('Please make sure the two new passwords match.', $cpoRubricSettings['language']);
            break;
        }

        // update password
        $query = "UPDATE ".CPO_USER." "
            ."SET passwd='".addslashes(md5($_POST['password1']))."' "
            ."WHERE user='".addslashes($_SESSION['SID_login'])."' ";
        $db->query($query);

        $message[] = ___('You have changed your password.', $cpoRubricSettings['language']);
        logaction('changed password', '');
        $views = array('message');
        break; // }}}
    case 'profile': // {{{
        if (!isset($_SESSION['SID_log_login_id'])) {
            $message[] = ___('You have to be logged in to update your profile.', $cpoRubricSettings['language']);
            $_nview = 'change_userprofile';
            break;
        }
        $views = array('change_userprofile');
        break; // }}}}
    case 'userprofile_change': // {{{
        if (!isset($_SESSION['SID_log_login_id'])) {
            $message[] = ___('You have to be logged in to update your profile.', $cpoRubricSettings['language']);
            $_nview = 'change_userprofile';
            break;
        }

        $views = array('change_userprofile');

        // update username
        $query = 'UPDATE '.CPO_USER.' SET '
            ."name='".addslashes($_POST['newusername'])."', "
            ."email='".addslashes($_POST['newemail'])."' "
            .'WHERE id='.(int)$_SESSION['SID_user']['id'];
        $db->query($query);

        $_SESSION['SID_user']['name'] = $_POST['newusername'];
        $_SESSION['SID_user']['email'] = $_POST['newemail'];

        $message[] = ___('You have updated your profile.', $cpoRubricSettings['language']);
        logaction('changed username', '');
        $views = array('message');
        break; // }}} 
    case 'password_reset': // {{{
        $views = array('reset_password');
        break; // }}}
    case 'dopassword_reset': // {{{
        $views = array('reset_password');

        if (empty($_POST['account'])) {
            $message[] = __('Please specify a login.', $cpoRubricSettings['language']);
            break;
        }

        $message[] = __('If you specified an existing login its password was set to a new random value. The new password was sent by e-mail to the address stored in the user account settings.', $cpoRubricSettings['language']);

        $query = "SELECT name, email, id FROM ".CPO_USER." "
                ."WHERE (user='".addslashes($_POST['account'])."' "
                //."OR email='".addslashes($_POST['account'])."'"
                .") "
                ."AND admin=0 "
                .'AND id>=0 '
                ."LIMIT 0,1";
        $db = new DB;
        $db->query($query);
        if ($db->next_record()) {
            $email  = $db->v('email'); 
            $name   = $db->v('name');
            $id     = $db->v('id'); 

            $new_passwd     = substr(md5(time().$email), 0, 5);
            $new_passwd_md5 = md5($new_passwd);

            $query = "UPDATE ".CPO_USER." SET "
                     ."passwd = '".$new_passwd_md5."', "
                     ."c_time = '".date('Y-m-d H:i:s')."', "
                     ."changer = 'SYSTEM' "
                     ."WHERE id = '".$id."'";
            DEBUG(2, $query, __FILE__, __LINE__);   
            $db_2 = new DB;
            $db_2->query($query); 
            
            require(CPO_BASEDIR.'_include/email_passwd.php');
            logaction('reset password', $_POST['account']);
        }
        $views = array('login');

        break; // }}}}
    }
}

while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'login': // {{{
        include(CPO_BASEDIR.$directory.'/loadheaders.php');
        include(CPO_BASEDIR.'_include/message.php'); // FIXME STEFFEN, wirklich diese Messages benutzen?
        echo '<form method="post" action="'.htmlspecialchars($_SERVER['PHP_SELF']).'">';
        echo '<input type="hidden" name="action" value="dologin">';
        echo '<input type="hidden" name="rubric" value="'.(int)$cpoRubric['id'].'">';
        if (!empty($_nview))
            echo '<input type="hidden" name="nview" value="'.htmlspecialchars($_nview).'">';
        echo ___('Please enter your username and password.', $cpoRubricSettings['language']).'<br /><br />';
        echo ___('Login:', $cpoRubricSettings['language']).'<br />';
        echo '<input type="text" name="username"><br />';
        echo ___('Password:', $cpoRubricSettings['language']).'<br />';
        echo '<input type="password" name="password"> ';

        echo '<input type="submit" class="button" value="'.___('log in', $cpoRubricSettings['language']).'">';
        echo '<br />';
        if ($GLOBALS['cpoSystem']['send_pw']) {
            echo '<a href="'.htmlspecialchars($_SERVER['PHP_SELF']).'?action=password_reset">'.__('Reset password', $cpoRubricSettings['language']).'</a>';
        }
        echo '</form>';
        require(CPO_BASEDIR.$directory.'/loadfooters.php');
        break; // }}}
    case 'change_password': // {{{
        include(CPO_BASEDIR.$directory.'/loadheaders.php');
        include(CPO_BASEDIR.'_include/message.php'); // FIXME STEFFEN, wirklich diese Messages benutzen?
        echo '<form method="post" action="'.htmlspecialchars($_SERVER['PHP_SELF']).'">';
        echo '<input type="hidden" name="action" value="password_change">';
        echo '<input type="hidden" name="rubric" value="'.(int)$cpoRubric['id'].'">';
        echo ___('Please enter your old and new password.', $cpoRubricSettings['language']).'<br />';
        echo ___('Old password:', $cpoRubricSettings['language']).'<br />';
        echo '<input type="text" name="oldpassword"><br />';
        echo ___('New password:', $cpoRubricSettings['language']).'<br />';
        echo '<input type="password" name="password1"><br />';
        echo ___('Confirm new password:', $cpoRubricSettings['language']).'<br />';
        echo '<input type="password" name="password2"><br />';
        echo '<input type="submit" class="button" value="'.___('change password', $cpoRubricSettings['language']).'">';
        echo '</form>';
        include(CPO_BASEDIR.$directory.'/loadfooters.php');
        break; // }}}
    case 'change_userprofile': // {{{
        include(CPO_BASEDIR.$directory.'/loadheaders.php');
        include(CPO_BASEDIR.'_include/message.php'); 
        echo '<form method="post" action="'.htmlspecialchars($_SERVER['PHP_SELF']).'">';
        echo '<input type="hidden" name="action" value="userprofile_change">';
        echo '<input type="hidden" name="rubric" value="'.(int)$cpoRubric['id'].'">';

        echo ___('Please update your user profile.', $cpoRubricSettings['language']).'<br />';

        echo ___('Username:', $cpoRubricSettings['language']).'<br />';
        echo '<input type="text" name="newusername" value="'.$_SESSION['SID_user']['name'].'"><br />';

        echo ___('E-Mail:', $cpoRubricSettings['language']).'<br />';
        echo '<input type="text" name="newemail" value="'.$_SESSION['SID_user']['email'].'"><br />';

        echo '<input type="submit" class="button" value="'.___('update profile', $cpoRubricSettings['language']).'">';
        echo '</form>';
        include(CPO_BASEDIR.$directory.'/loadfooters.php');
        break; // }}} 
    case 'message': // {{{
        include(CPO_BASEDIR.$directory.'/loadheaders.php');
        include(CPO_BASEDIR.'_include/message.php'); // FIXME STEFFEN, wirklich diese Messages benutzen?
        include(CPO_BASEDIR.$directory.'/loadfooters.php');
        break; // }}}
    case 'jumptorubric': // {{{
        header('Location: '.BASE_ABS.$directory.'/index.php?rubric='.$cpoRubric['id'].'&'.SID); 
        break; // }}}
    case 'reset_password': // {{{
        include(CPO_BASEDIR.$directory.'/loadheaders.php');
        include(CPO_BASEDIR.'_include/message.php'); // FIXME STEFFEN, wirklich diese Messages benutzen?
        echo '<form method="post" action="'.htmlspecialchars($_SERVER['PHP_SELF']).'" name="form">';
        echo ___('To reset your password please specify your username below.', $cpoRubricSettings['language']).'<br /><br />';
        echo '<input type="hidden" name="action" value="dopassword_reset">';
        echo ___('Username:', $cpoRubricSettings['language']).'<br />';
        echo '<input type="text" name="account" ><br />';
        echo '<input type="submit" class="button" value="'.___('Reset password', $cpoRubricSettings['language']).'">';
        echo '</form>';
        include(CPO_BASEDIR.$directory.'/loadfooters.php');
        break; // }}}
    }
}
?>
