<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Modification "mod_colorpicker"	Pimp my colorpicker        |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.0b / January 2014 ==

*/

if (!defined('CPO')) exit;
$translator->addTranslation('colorpicker', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['colorpicker'] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'Colorpicker',
    'install'   => 'function: colorpicker_install',
    'activate'  => 'function: colorpicker_activate',
    'deactivate'=> 'function: colorpicker_deactivate',
    'uninstall' => 'function: colorpicker_uninstall '.$moduleDirectory,
    'manage'	=> 'function: colorpicker_manage',
	'customColors' => "#00FF55 #DDDD00 #0055FF #996633 #FFFF00 #FFA0DD #FF0000 #FF6600",
	'steps' => '5',
	'diff' => '15',
	);

function colorpicker_install()
{
    $GLOBALS['message'][] = ___('The colorpicker module was successfully installed!');
}
function colorpicker_uninstall($moduleDirectory)
{
	 $GLOBALS['message'][] = sprintf(__('The colorpicker module was removed from the ConPresso system. Please remove the module directory <i>%s</i> to finally uninstall the colorpicker module.'),$moduleDirectory);

}
function colorpicker_activate()
{
    $GLOBALS['message'][] = ___('The colorpicker module got activated.');
}

function colorpicker_deactivate()
{
    $GLOBALS['message'][] = ___('The colorpicker module got deactivated.');
}

function colorpicker_manage()
{
	global $dbPrefix, $db, $k, $module_status;
	if(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE)  {
		echo '<a href="'.BASE_ABS.$GLOBALS['modules']['colorpicker']['directory'].'/settings.php"><img src="'.SKIN_URL.'pic_settings.gif" title="'.__('settings').'" alt="'.__('settings').'"></a>';
	} else {
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_settings.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
	}
}

function mixColors($basecolor, $mixcolor, $ratio, $addHash = true) {

    $baseComponentOffset = strlen($basecolor) == 7 ? 1 : 0;
    $baseComponentRed = hexdec(substr($basecolor, $baseComponentOffset, 2));
    $baseComponentGreen = hexdec(substr($basecolor, $baseComponentOffset+2, 2));
    $baseComponentBlue = hexdec(substr($basecolor, $baseComponentOffset+4, 2));

    $mixComponentOffset = strlen($mixcolor) == 7 ? 1 : 0;
    $mixComponentRed = hexdec(substr($mixcolor, $mixComponentOffset, 2));
    $mixComponentGreen = hexdec(substr($mixcolor, $mixComponentOffset+2, 2));
    $mixComponentBlue = hexdec(substr($mixcolor, $mixComponentOffset+4, 2));

    $Rsum = $baseComponentRed+$mixComponentRed;
    $Gsum = $baseComponentGreen+$mixComponentGreen;
    $Bsum = $baseComponentBlue+$mixComponentBlue;

    $R = ($baseComponentRed*(100-$ratio) + $mixComponentRed*$ratio) / 100;
    $G = ($baseComponentGreen*(100-$ratio) + $mixComponentGreen*$ratio) / 100;
    $B = ($baseComponentBlue*(100-$ratio) + $mixComponentBlue*$ratio) / 100;

    $redPercentage = max($R, $G, $B) > 255 ? $R/max($Rsum, $Gsum, $Bsum) : $R/255;
    $greenPercentage = max($R, $G, $B) > 255 ? $G/max($Rsum, $Gsum, $Bsum) : $G/255;
    $bluePercentage = max($R, $G, $B) > 255 ? $B/max($Rsum, $Gsum, $Bsum) : $B/255;

    $redRGB = floor(255*$redPercentage);
    $greenRGB = floor(255*$greenPercentage);
    $blueRGB = floor(255*$bluePercentage);

    $color = sprintf("%02X%02X%02X", $redRGB, $greenRGB, $blueRGB);
    return $addHash ? '#'.$color : $color;
}
 
function colorColumn($basecolor, $showPercentage=false, $width=30)  {
    global $steps, $diff, $maxHeight, $maxWidth, $gap, $squareHeight;
    $StartColor = $basecolor;
    $StartColor = strlen($StartColor) == 7 ? $StartColor : '#'.$StartColor;
    $mixcolor   = '#000000';
    $width      = $width.'px';

    echo '<table cellpadding="0" cellspacing="0" style="font-size:'.min($squareHeight-2,10).'px;">';

    for ($d=$steps;$d>0;$d--)  {
        $hexColor = mixColors($StartColor, $mixcolor, $d*$diff);
        echo '<tr>';
        echo '<td onmouseout=\'mouseOutMap()\' onclick=\'clickColor("'.$hexColor.'",-1,-1)\' onmouseover=\'mouseOverColor("'.$hexColor.'")\' style=\'width:'.$width.';height:'.$squareHeight.'px;background:'.$hexColor.'\' title="-'.($d*$diff).'%">&nbsp;</td>';
        if ($showPercentage) echo '<td style=" vertical-align:middle !important;">&nbsp;-'.($d*$diff).'%</td>';
        echo '</tr>';

    }

    echo '<tr>';
    echo '<td onmouseout=\'mouseOutMap()\' onclick=\'clickColor("'.$StartColor.'",-1,-1)\' onmouseover=\'mouseOverColor("'.$StartColor.'")\' style=\'width:'.$width.';height:30px;background:'.$StartColor.';border-top:'.$gap.'px solid white;border-bottom:'.$gap.'px solid white;\'>&nbsp;</td>';
   if ($showPercentage)  echo '<td>&nbsp;</td>';
    echo '</tr>';

    $mixcolor   = '#FFFFFF';
    for ($d=1;$d<=$steps;$d++)  {
        $hexColor = mixColors($StartColor, $mixcolor, $d*$diff);
        echo '<tr>';
        echo '<td onmouseout=\'mouseOutMap()\' onclick=\'clickColor("'.$hexColor.'",-1,-1)\' onmouseover=\'mouseOverColor("'.$hexColor.'")\' style=\'width:'.$width.';height:'.$squareHeight.'px;background:'.$hexColor.'\' title="+'.($d*$diff).'%">&nbsp;</td>';
        if ($showPercentage) echo '<td style=" vertical-align:middle !important;">&nbsp;+'.($d*$diff).'%</td>';
        echo '</tr>';

    }
    echo '</table>';
}

if (isset($activeModules['colorpicker']))  {
    // some values
    $customColors = $activeModules['colorpicker']['customColors'];
    $steps = $activeModules['colorpicker']['steps'];
    $diff = $activeModules['colorpicker']['diff'];

    $maxHeight = 280;
    $maxWidth  = 200;
    $gap = 2;

    // some calculation
    if (trim($customColors) != '') {
        $colorArray = explode(" ",trim($customColors));
        $columnWidth = floor($maxWidth/count($colorArray));
    }
    $squareHeight = floor(($maxHeight-30-(2*$gap))/(2*$steps));
}

?>