<?php

/*
+------------------------------------------------------------------------+
| ConPresso-Module "CopyRights"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1 / April 2013 ==

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 

$directory = basename(dirname($_SERVER['PHP_SELF'])); 
initVar($usergrpid, array());
initVar($queries, array());
initVar($group_members, array());

// Ergnzung: Kopierte User-Rechte
if (isset($_POST['action']) && $_POST['action']=='copy_rights') {
   if (class_exists('antiCSRF')) {
	   if (!$antiCSRF->checkToken()) { 
			$message[] = ___('Security check failed. Please try again.'); 
			logaction('copy_rights', 'CSRF check failed.'); 
			exit;
	   }
   }

	if (isset($_POST['rightsto']) && isset($_POST['rightsfrom']) && $_POST['rightsto'] != '' && $_POST['rightsfrom'] != '' && $_POST['rightsto'] != $_POST['rightsfrom'])  {
		if (substr($_POST['rightsto'], 0, 4) == 'grp_')  {  // Gruppe mit Rechten beaufschlagen
			$query = "SELECT user FROM ".$dbPrefix."_user WHERE id = ".$_POST['rightsfrom'];
			$db->query($query);
			$db->next_record();
			$user_from = $db->v("user");
			$query = "SELECT usergroup FROM ".$dbPrefix."_usergroups WHERE id = ".substr($_POST['rightsto'], 4);
			$db->query($query);
			$db->next_record();
			$group_to = $db->v("usergroup");
			// alte User-Rechte lschen
			$query = "SELECT id FROM ".$dbPrefix."_user WHERE usergroups_id = ".substr($_POST['rightsto'], 4);
			$db->query($query);
			while($db->next_record()):
				$queries[] = "DELETE FROM ".$dbPrefix."_permission WHERE user_id = ".$db->v('id');
				$group_members[] = $db->v('id');
			endwhile;
			for ($i=0;$i<count($queries);$i++)  {
				$db->query($queries[$i]);
			}
			// Rechte lesen und eintragen
			$query = "SELECT * FROM ".$dbPrefix."_permission WHERE user_id = ".$_POST['rightsfrom'];
			$db->query($query);
			while($db->next_record()):
				for ($i=0;$i<count($group_members);$i++)  {
					$queries[] = "INSERT INTO " . $dbPrefix . "_permission (id, user_id, rubric_id, stufe1, stufe2, stufe3, stufe4) VALUES ('', '" . $group_members[$i] . "', '" . $db->v('rubric_id') . "', '" . $db->v('stufe1') . "', '" . $db->v('stufe2') . "', '" . $db->v('stufe3') . "', '" . $db->v('stufe4') . "')";
				}
			endwhile;
			for ($i=0;$i<count($queries);$i++)  {
				$db->query($queries[$i]);
			}
			logaction('rights copied', $user_from.' -> Group: '.$group_to);
			$message[] = sprintf(__('User-rights have been copied from <i>%s</i> to the whole group <i>%s</i>!'), $user_from, $group_to);


		} elseif (is_numeric($_POST['rightsto']))  {  // nur Userrechte kopieren
			$db = new DB;
			$query = "SELECT user FROM ".$dbPrefix."_user WHERE id = ".$_POST['rightsto'];
			$db->query($query);
			$db->next_record();
			$user_to = $db->v("user");
			$query = "SELECT user FROM ".$dbPrefix."_user WHERE id = ".$_POST['rightsfrom'];
			$db->query($query);
			$db->next_record();
			$user_from = $db->v("user");
			// alte User-Rechte lschen
			$query = "DELETE FROM ".$dbPrefix."_permission WHERE user_id = ".$_POST['rightsto'];
			$db->query($query);
			// Rechte lesen und eintragen
			$query = "SELECT * FROM ".$dbPrefix."_permission WHERE user_id = ".$_POST['rightsfrom'];
			$db->query($query);
			while($db->next_record()):
				$queries[] = "INSERT INTO " . $dbPrefix . "_permission (id, user_id, rubric_id, stufe1, stufe2, stufe3, stufe4) VALUES ('', '" . $_POST['rightsto'] . "', '" . $db->v('rubric_id') . "', '" . $db->v('stufe1') . "', '" . $db->v('stufe2') . "', '" . $db->v('stufe3') . "', '" . $db->v('stufe4') . "')";
			endwhile;
			for ($i=0;$i<count($queries);$i++)  {
				$db->query($queries[$i]);
			}
			logaction('rights copied', $user_from.' -> '.$user_to);
			$message[] = sprintf(__('User-rights have been copied from <i>%s</i> to <i>%s</i>!'), $user_from, $user_to);
		}
	} else {
		$message[] = __('Insufficient selection!');
	}
}


// seitenausgabe
require(CPO_BASEDIR.'_include/header.php');

printPageHeader(
    __('Copy rights'),
    __('In this view you can copy the rubic rights from one user to another.')
);

include(CPO_BASEDIR.'_include/message.php');
include(CPO_BASEDIR.$activeModules['CopyRights']['directory'].'/producer.inc.php');

// User Rechte kopieren
    $query = "SELECT id, user FROM ".$dbPrefix."_user WHERE user != '' ORDER BY user";
    DEBUG(2, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
	while($db->next_record()):
		$userid[] = $db->v('id');
		$usertext[] = $db->v('user');
	endwhile;

    $query = "SELECT id, usergroup FROM ".$dbPrefix."_usergroups WHERE usergroup != '' ORDER BY usergroup";
    DEBUG(2, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);
	while($db->next_record()):
		$usergrpid[] = $db->v('id');
		$usergrptext[] = $db->v('usergroup');
	endwhile;

		echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
		if (class_exists('antiCSRF')) { 
			$antiCSRF->printInput('copy_rights'); 
		} else {
			echo '<input type="hidden" name="action" value="copy_rights">';
		}
 
		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="5"><span>'.__('Copy rights').'</span></th>';

		echo '</tr></thead><tbody>';
        // }}}

		echo '<tr>';
            echo '<td style="width: 10%;" nowrap="nowrap">';
            echo __('Transfering rights from:');
            echo '</td><td style="width: 10%;">';
            echo '<select name="rightsfrom">'."\n";
			echo '<option value="">'.__('Please choose').'</option>'."\n";
			for ($i=0;$i<count($userid);$i++)  {
				echo '<option value="'.$userid[$i].'">'.$usertext[$i].'</option>'."\n";
			}
			echo '</select>'."\n";
			echo '</td><td style="width: 5%;" nowrap="nowrap">';
			echo ' -> '.__('To:');
			echo '</td><td style="width: 10%;">';
            echo '<select name="rightsto">'."\n";
			echo '<option value="">'.__('Please choose').'</option>'."\n";
			for ($i=0;$i<count($userid);$i++)  {
				echo '<option value="'.$userid[$i].'">'.$usertext[$i].'</option>'."\n";
			}
			if (count($usergrpid) > 0)  {
				echo '<option value="">&nbsp;</option>';
				echo '<option value="">Gruppen:</option>'."\n";
			}
			for ($i=0;$i<count($usergrpid);$i++)  {
				echo '<option value="grp_'.$usergrpid[$i].'">'.$usergrptext[$i].'</option>'."\n";
			}
			echo '</select>'."\n";
			echo '</td><td>';
            echo '<input type="submit" class="button" value="'.__('Transfer rights').'">';
            echo '</td>';
		echo '</tr>';
		echo '</tbody></table>';
		echo '</form>';


require(CPO_BASEDIR.'_include/footer.php');
?>
