<?php 
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Database Cleanup"		                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.0b / October 2020

*/

if (!defined('CPO')) exit;

$translator->addTranslation('dbclean', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['db_actions'] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'Database cleanup',
    'install'   => 'function: Datenbankaktionen_install',
    'activate'  => 'function: Datenbankaktionen_activate',
    'deactivate'=> 'function: Datenbankaktionen_deactivate',
    'uninstall' => 'function: Datenbankaktionen_uninstall '.$moduleDirectory
	);

function Datenbankaktionen_install()
{
    $GLOBALS['message'][] = ___('The database cleanup module was successfully installed!');
}
function Datenbankaktionen_uninstall($moduleDirectory)
{
	 $GLOBALS['message'][] = sprintf(__('The database cleanup module was successfully removed from the ConPresso system. Please remove the module directory <i>%s</i> to finally uninstall the module.'),$moduleDirectory);

}
function Datenbankaktionen_activate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";

    $GLOBALS['message'][] = ___('The database cleanup module got activated.').$reload_navigation;
}

function Datenbankaktionen_deactivate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";

    $GLOBALS['message'][] = ___('The database cleanup module got deactivated.').$reload_navigation;
}

function Datenbankaktionen_navigation($moduleDirectory)
{
    $GLOBALS['navigation']['System'][] = 'space'; 
    
    $GLOBALS['navigation']['System'][] = array(
            'caption'=>'database cleanup',
            'url'=>BASE_REL.$moduleDirectory.'/database_cleanup.php'
        );
}

if (isset($_SESSION['SID_user']['admin']) && $_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
    $hdlr_navigation[] = 'function: Datenbankaktionen_navigation '.$moduleDirectory;
}

?>