<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Dropzone"                                            |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 1.0 / 2022

*/

if (!defined('CPO')) exit;
$translator->addTranslation('dropzone',CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules'][ucfirst($moduleDirectory)] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'DropZone File Upload',
    'install'   => 'function: dropzone_install',
    'activate'  => 'function: dropzone_activate',
    'deactivate'=> 'function: dropzone_deactivate',
    'uninstall' => 'function: dropzone_uninstall '.$moduleDirectory
	);

function dropzone_install()
{
    $GLOBALS['message'][] = ___('The dropzone module was successfully installed!');
}
function dropzone_uninstall($moduleDirectory)
{
	 $GLOBALS['message'][] = sprintf(__('The dropzone module was removed from the ConPresso-system. To finally uninstall the module, please remove the module directory <i>%s</i>.'),$moduleDirectory);

}
function dropzone_activate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";

    $GLOBALS['message'][] = ___('The dropzone module got activated.').$reload_navigation;
}

function dropzone_deactivate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";

    $GLOBALS['message'][] = ___('The dropzone module got deactivated.').$reload_navigation;
}

function dropzone_navigation()
{
    foreach($GLOBALS['navigation']['Files'] AS $fkey=>$fval) {
        if ($GLOBALS['navigation']['Files'][$fkey]['caption'] == 'upload files') $GLOBALS['navigation']['Files'][$fkey]['url'] = BASE_REL.'mod_dropzone/upload_files.php';
    }
}

if (isset($_SESSION['SID_user']['admin']) && $_SESSION['SID_user']['admin']>=ROLE_EDITOR) {
    $hdlr_navigation[] = 'function: dropzone_navigation ';
}

?>