<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Dropzone"                                            |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 1.0 / 2022

*/

define('CPO', true);

require_once('../_include/checkaccess.inc.php');

$zugang = 0;
require(CPO_BASEDIR.'_include/check.php');

initVar($fileoverwrite, array());

$uploadErrors = array(
    __('File was successfully uploaded.'),
    __('Note: The uploaded file exceeds the allowed size.'),
    __('Note: The uploaded file exceeds the allowed size.'),
    __('Note: The file was not uploaded completely. Please try again.'),
    __('Note: No file was received. Please try again.')
);
$imageTypes = array(
    'unknown', 
    'GIF', 
    'JPG', 
    'PNG', 
    'SWF', 
    'PSD', 
    'BMP', 
    'TIFF(intel byte order)', 
    'TIFF(motorola byte order)', 
    'JPC', 
    'JP2', 
    'JPX', 
    'JB2', 
    'SWC', 
    'IFF');

$fileNameReplacements = array(
    '//' => 'Ae',
    '//' => 'Oe',
    '//' => 'Ue',
    '//' => 'ss',
    '//' => 'ae',
    '//' => 'oe',
    '//' => 'ue',
    '//' => 'A',
    '//' => 'A',
    '//' => 'E',
    '//' => 'E',
    '//' => 'O',
    '//' => 'O',
    '//' => 'U', 
    '//' => 'U', 
    '//' => 'I', 
    '//' => 'I', 
    '//' => 'a', 
    '//' => 'a', 
    '//' => 'e', 
    '//' => 'e', 
    '//' => 'o', 
    '//' => 'o', 
    '//' => 'u', 
    '//' => 'u', 
    '//' => 'i', 
    '//' => 'i', 
    '/[^a-z0-9_\.-]/i' => '_',
);


if (isset($_FILES['uppedFiles'])){

$upped  = false;
for($i=0; $i<count($_FILES['uppedFiles']['size']); $i++) {
    if ($_FILES['uppedFiles']['name'][$i]=='') continue;
    $upped = true;
    break;
}

for($i=0; $i<count($_FILES['uppedFiles']['size']); $i++) {
    if ($_FILES['uppedFiles']['name'][$i]=='') {
        continue;
    }
    echo '<div style="border: 1px solid #ccc; margin-bottom: 2px; padding: 2px;">';
    echo '<img src="'.SKIN_URL.'sym_info.gif" style="vertical-align: text-bottom;" alt="'.__('Info').'" title="'.__('Info').'"> ';
    // echo htmlspecialchars($_FILES['uppedFiles']['name'][$i], ENT_COMPAT, 'ISO-8859-15'); 

    // check for errors
    if (!$_FILES['uppedFiles']['size'][$i]) {
        if (isset($_FILES['uppedFiles']['error'][$i])) // this exists since PHP 4.2
             $error = $uploadErrors[$_FILES['uppedFiles']['error'][$i]];
        // else guess the error...
        else $error = __('Unknown ERROR: Please check if the size of the file exceeds the maximum uploadable file size.');
        printf(___('ERROR: There was an error: %s').'<br />', 
            htmlspecialchars($error, ENT_COMPAT, 'ISO-8859-15')
        );
        continue;
     }

    // upload ok
    $path = CPO_BASEDIR.'_data/';

    // modify filename to exclude characters that are not a-z A-Z 0-9 _ or .
    $filename = $_FILES['uppedFiles']['name'][$i];
    $filename = preg_replace(array_keys($fileNameReplacements), array_values($fileNameReplacements), $filename);

    // add a postfix if file exists
    $pathInfo  = pathinfo($filename);
    // 'filename' was added in PHP5.2.0, but we need to support older installations
    if (!isset($pathInfo['filename'])) {
        $pathInfo['filename'] = basename($pathInfo['basename'], $pathInfo['extension']);
    }

    $newFilename = $pathInfo['filename'] . (isset($pathInfo['extension']) ? '.' . $pathInfo['extension'] : '');

    $postfix   = '';
    $postfixNo = 0;
    $fileoverwrite[$filename] = false;
    if (isset($_POST['fileoverwrite']) && $_POST['fileoverwrite']=='true' && file_exists($path.$newFilename)) {
		$db = new DB;
        $db->query("SELECT id, beschreibung FROM ".CPO_DATA." WHERE datei='".$filename."' ");
		$db->next_record();
		$updatefileid = $db->v('id');
		$updatefiledesc = $db->v('beschreibung');
		unlink ($path.$filename);
		$fileoverwrite[$filename]=true;
	}
    while (file_exists($path . $newFilename)) {
        $postfixNo++;
        $newFilename = $pathInfo['filename'] . '-' . $postfixNo . (isset($pathInfo['extension']) ? '.' . $pathInfo['extension'] : '');
    }

    if ($filename != $newFilename) {
        printf(__('This file does already exist. To avoid overwriting the old file, it was renamed to <em>%s</em>.').'<br />',
            $newFilename);
    }

    $newFilename = $path . $newFilename;
    // move the uploaded file to the new place
    if (!@move_uploaded_file($_FILES['uppedFiles']['tmp_name'][$i], $newFilename)) {
        // FIXME: warning-Bild
        printf(__('Unable to move the file <em>%s</em>! Make sure the webserver has write-access to the directory <em>%s</em>').'<br />',
            htmlspecialchars($newFilename, ENT_COMPAT, 'ISO-8859-15'),
            htmlspecialchars(dirname($newFilename), ENT_COMPAT, 'ISO-8859-15')
        );
        continue;
    }
    @chmod($newFilename, 0666);

    // Check if it is an image suitable for web pages
    $checkImage = @getimagesize($newFilename);
    if ($checkImage && (
        $imageTypes[$checkImage[2]]=='JPG' || 
        $imageTypes[$checkImage[2]]=='PNG' ||
        $imageTypes[$checkImage[2]]=='GIF')) {

        // if the image-file is too big, delete it and continue
        if ($_FILES['uppedFiles']['size'][$i] > $cpoSystem['max_image']) {
            @unlink($newFilename);
            printf(___('The file was %s bigger than the allowed maximum size of %s for images. Because of that the file was deleted. Please contact your administrator if you think this is an error.'),
                '<em>'.printHumanReadable($cpoSystem['max_image']-$_FILES['uppedFiles']['size'][$i]).'</em>',
                '<em>'.printHumanReadable($cpoSystem['max_image']).'</em>'
            );
            print('<br />');
            continue;
        }

        // Imagetool-Mod
        if (array_key_exists('Imagetool', $activeModules))  include(CPO_BASEDIR . $activeModules['Imagetool']['directory'] . '/includes/inc_resize.php'); 

        printf(__('The file is an image of type <em>%s</em> and is suitable for webpages.').'<br />',
            $imageTypes[$checkImage[2]]);
	    if (isset($_POST['fileoverwrite']) && $_POST['fileoverwrite']=='true' && $fileoverwrite[$filename]) {
        $query = "REPLACE INTO ".CPO_DATA." SET "
                ." id='".$updatefileid."', "
                ." beschreibung='".$updatefiledesc."', "
                ." alttext='', "
                ." datum='".date('Y-m-d H:i:s', time())."', "
                ." type='".$_FILES['uppedFiles']['type'][$i]."', "
                ." datei='".$filename."', "
                ." format='2', "
                ." user_id='".$_SESSION['SID_user']['id']."', "
                ." rubric_id='".$_POST['filerubrik']."', "
                ." c_time='".date('Y-m-d H:i:s', time())."', "
                ." changer='".$_SESSION['SID_login']."' ";

		} else {
        $query = "INSERT INTO ".CPO_DATA." ("
                ."beschreibung, alttext, datum, type, datei, format, user_id, rubric_id, c_time, changer) "
                ."VALUES ("
                ."'', "
                ."'', "
                ."'".date('Y-m-d H:i:s', time())."', "
                ."'".$_FILES['uppedFiles']['type'][$i]."', "
                ."'" . addslashes(basename($newFilename)) . "', "
                ."'2', "
                ."'".$_SESSION['SID_user']['id']."', "
                ."'".$_POST['filerubrik']."', "
                ."'".date('Y-m-d H:i:s', time())."', "
                ."'".$_SESSION['SID_login']."')";
        }
    } else {
        // no image 

        // if the file is too big, delete it and continue
        if ($_FILES['uppedFiles']['size'][$i] > $cpoSystem['max_file']) {
            @unlink($newFilename);
            printf(__('The file was %s bigger than the allowed maximum size of %s for data files. Because of that the file was deleted. Please contact your administrator if you think this is an error.'),
                '<em>'.printHumanReadable($cpoSystem['max_file']-$_FILES['uppedFiles']['size'][$i]).'</em>',
                '<em>'.printHumanReadable($cpoSystem['max_file']).'</em>'
            );
            echo '<br />';
            continue;
        }

        printf(__('The file is a data file.').'<br />');
	    if (isset($_POST['fileoverwrite']) && $_POST['fileoverwrite']==true && $fileoverwrite[$filename]) {
        $query = "REPLACE INTO ".CPO_DATA." SET "
                ." id='".$updatefileid."', "
                ." beschreibung='".$updatefiledesc."', "
                ." alttext='', "
                ." datum='".date('Y-m-d H:i:s', time())."', "
                ." type='".$_FILES['uppedFiles']['type'][$i]."', "
                ." datei='".$filename."', "
                ." format='1', "
                ." user_id='".$_SESSION['SID_user']['id']."', "
                ." rubric_id='".$_POST['filerubrik']."', "
                ." c_time='".date('Y-m-d H:i:s', time())."', "
                ." changer='".$_SESSION['SID_login']."' ";

		} else {
        $query = "INSERT INTO ".CPO_DATA." ("
            ."beschreibung, alttext, datum, type, datei, format, user_id, rubric_id, c_time, changer) values("
            ."'', "                    // beschreibung
            ."'', "                                 // alttext
            ."'".date('Y-m-d H:i:s', time())."', "  // datum
            ."'".$_FILES['uppedFiles']['type'][$i]."', " // type
            ."'" . addslashes(basename($newFilename)) . "', " // datei
            ."'1', "                             // format
            ."'".$_SESSION['SID_user']['id']."', "     // user_id
            ."'".$_POST['filerubrik']."', "         // rubric_id
            ."'".date('Y-m-d H:i:s', time())."', "  // c_time
            ."'".$_SESSION['SID_login']."')";       // changer
        }
    }
    // store in database
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);

    printf(__('File was uploaded and saved as <em>%s</em>.').'<br />'.
           __('The file has a size of <em>%s</em>.'),
        htmlspecialchars(basename($newFilename), ENT_COMPAT, 'ISO-8859-15'),
        printHumanReadable($_FILES['uppedFiles']['size'][$i]));
    echo '</div>';
    logaction('drop upload file', basename($newFilename));
}


} 


?>
