<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Dropzone"                                            |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 1.0 / 2022

*/

if (!defined('CPO')) exit;

initVar($parallelUploads, 3); // parallele Uploads
initVar($timeout, 60000);     // Wartezeit auf Serverantwort (in Millisekunden)
initVar($clearAfter, 4000);   // Wartezeit bis zum Lschen der Thumbnails (in Millisekunden, 0 = nicht Lschen)
initVar($retries, 3);         // Anzahl der Versuche fr Upload
initVar($maxSize, intval($cpoSystem['max_image']/1048576));         // Maximale Dateigre in MiB(CPO-Einstellung)
initVar($waiting, __('Waiting for the files...'));  // angezeigter Text im Protokoll

?>

<!-- DropZone JS/CSS -->
    <link href="<?php echo BASE_REL.'mod_dropzone/dropzone.min.css'; ?>" type="text/css" rel="stylesheet" />
    <script src="<?php echo BASE_REL.'mod_dropzone/dropzone.min.js'; ?>" type="text/javascript"></script>
    <script type="text/javascript">
    function setFileRubric(id)  {
        document.getElementById("filerubric").value = id;
    }
    function setOverwrite()  {
        if (document.getElementById("setfileoverwrite").checked == true)  {
            document.getElementById("fileoverwrite").value = true;
        } else {
            document.getElementById("fileoverwrite").value = false;
        }
    }
    Dropzone.options.dropDiv = {
        paramName: "uppedFiles[]",
        dictDefaultMessage: "<?php echo __('<p><strong>Drop here one or more files</strong></p><p>or click for browsing files</p>'); ?>",
        parallelUploads: <?php echo $parallelUploads; ?>,
        timeout: <?php echo $timeout; ?>,
        maxFilesize: <?php echo $maxSize; ?>,
        maxThumbnailFilesize: <?php echo $maxSize; ?>,
        dictFileTooBig: "<?php printf(__('The file was bigger than the allowed maximum size of %s for images.'), printHumanReadable($cpoSystem['max_image']) ); ?>",
        init: function() {
            var retryTimes = <?php echo $retries; ?>;
            this.on("success", function(file, responseText) {
                var resultsDiv = document.getElementById('dropResults');
                var results = resultsDiv.innerHTML;
                if (results == "<?php echo $waiting; ?>") results = ""; //  Platzhalter lschen
                resultsDiv.innerHTML = results + responseText;  // Ergebnis ins DIV schreiben
                resultsDiv.scrollTop = resultsDiv.scrollHeight; // nach unten scrollen
                <?php 
                    if($clearAfter>0) echo 'setTimeout(() => { this.removeFile(file); }, '.$clearAfter.');'."\n"; 
                ?>
            });
            this.on("error", function(file, errorMessage, xhr) {
                if (file.size > this.options.maxFilesize * 1024 * 1024) {
                    file.retryTimes = retryTimes; // no more try if too big
                }
                if(!file.retryTimes){
                    file.retryTimes = 0;
                }
                file.retryTimes = file.retryTimes + 1;
                if(file.retryTimes < retryTimes) {
                    file.status = "queued";
                    setTimeout(() => { this.processQueue() }, 4000);
                }
            });
        }
    }
    </script>
    <style>
        #dropDiv { min-height: 230px; }
        #dropResults { margin: 5px; padding: 2px; border: 1px solid #aaa; height: 85px; overflow: auto; }
    </style>
<!-- DropZone JS/CSS -->

<table class="colored" style="width: 100%;">
<thead><tr>
    <th colspan="2"><span><?php echo __('File selection'); ?></span></th>
</tr>
</thead><tbody>
<tr>
    <td class="leftrow"><?php 
        echo __('Available in:'); 
        if (empty($_SESSION['SID_rubric_id'])) {
            print('<br /><br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> '); 
            print(__('To upload files only available in one rubric please select the rubric first.').'<br />'); 
        }
    ?></td>
    <td class="rightrow"> 
        <input type="hidden" name="MAX_FILE_SIZE" value="<?php print($cpoSystem['max_file']>$cpoSystem['max_image'] ? $cpoSystem['max_file'] : $cpoSystem['max_image']); ?>">
        <?php 
        if (!empty($_SESSION['SID_rubric_id']) && $_SESSION['SID_stufe3']) {
            print('<input type="radio" name="filerubrik" id="filerubrik" value="'.$_SESSION['SID_rubric_id'].'" checked onChange="setFileRubric(this.value)">'.sprintf(__('this rubric (%s)'), $_SESSION['SID_rubric_name']).help('files-uploadfiles.html#files-uploadfiles-inthisrubric').'<br />');
            print('<input type="radio" name="filerubrik" id="filerubrik" value="-1" onChange="setFileRubric(-1)">'.__('all rubrics').help('files-uploadfiles.html#files-uploadfiles-inallrubrics').'<br />');
        } else {
            print('<input type="radio" name="filerubrik" id="filerubrik" value="-1" checked onChange="setFileRubric(-1)">'.__('all rubrics').help('files-uploadfiles.html#files-uploadfiles-inallrubrics').'<br />');
        }


        if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
            print('<input type="radio" name="filerubrik" id="filerubrik" value="-2" onChange="setFileRubric(-2)">'.__('article-templates').help('files-uploadfiles.html#files-uploadfiles-inarticletemplates').'<br />');;
        }

        ?>
        <div id="dropResults"><?php echo $waiting; ?></div>
        <input type="checkbox" id="setfileoverwrite" name="setfileoverwrite" value="true" onChange="setOverwrite()" /> <label for="setfileoverwrite"><?php echo __('overwrite'); ?></label>
        <?php
        // Imagetool-Mod 
        if (array_key_exists('Imagetool', $activeModules))  include(CPO_BASEDIR . $activeModules['Imagetool']['directory'] . '/includes/inc_dropform.php'); 
        // Imagetool-Mod 
        ?>
    </td>
</tr>
</tbody>
</table>
<form
    action="drop_upload.php"
    name="dropDiv"
    id="dropDiv"
    method="post"
    enctype="multipart/form-data"
    class="dropzone">
    <input type="hidden" id="filerubric" name="filerubrik" value="<?php echo (!empty($_SESSION['SID_rubric_id']) && $_SESSION['SID_stufe3']) ? $_SESSION['SID_rubric_id'] : '-1';?>" />
    <!-- fileoverwrite -->
    <input type="hidden" id="fileoverwrite" name="fileoverwrite" value="false" />
    <?php if (array_key_exists('Imagetool', $activeModules)) { 
        $imagetool_presets = explode("\n",$activeModules['Imagetool']['presets']);
    ?>
    <!-- imagesize -->
    <input type="hidden" id="preset[]" name="preset[]" value="<?php echo $imagetool_presets[0]; // der erste Eintrag ?>" />
    <input type="hidden" id="width[]"  name="width[]" value="" />
    <input type="hidden" id="height[]" name="height[]" value="" />
    <input type="hidden" id="nozoom[]" name="nozoom[]" value="" />
    <input type="hidden" id="noresize[]" name="noresize[]" value="" />
    <?php } ?>

</form>
<?php
return;

?>
