<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Enhanced Delete"                                     |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.0b / January 2014

*/

if (!defined('CPO')) exit;
$translator->addTranslation('enhanced_delete',CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['EnhancedDelete'] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'Enhanced Delete',
    'install'   => 'function: ED_install',
    'activate'  => 'function: ED_activate',
    'deactivate'=> 'function: ED_deactivate',
    'uninstall' => 'function: ED_uninstall',
    'manage'	=> 'function: ED_manage'
	);

function ED_install()
{
    $GLOBALS['message'][] = ___('The enhanced delete module was successfully installed!');
}
function ED_uninstall()
{
	 $GLOBALS['message'][] = sprintf(__('The enhanced delete module was removed from the ConPresso-system. To finally uninstall the module, please remove the module directory <i>%s</i>.'),$GLOBALS['modules']['EnhancedDelete']['directory']);

}
function ED_activate()
{
    $GLOBALS['message'][] = ___('The enhanced delete module got activated.');
}

function ED_deactivate()
{
    $GLOBALS['message'][] = ___('The enhanced delete module got deactivated.');
}

function ED_manage()
{
	global $dbPrefix, $db, $k, $module_status, $newsletter_rubric_id;
	if(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE)  {
		echo '<a href="'.BASE_ABS.$GLOBALS['modules']['EnhancedDelete']['directory'].'/edit.php"><img src="'.SKIN_URL.'pic_settings.gif" title="'.__('settings').'" alt="'.__('settings').'"></a>';
	} else {
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_settings.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
	}
}


$inc_enhanced_delete_producer = CPO_BASEDIR.$moduleDirectory.'/includes/producer.inc.php';
$inc_tab_files = array(
    1 => CPO_BASEDIR.$moduleDirectory.'/includes/inc_tab_files_1.inc.php',
    2 => CPO_BASEDIR.$moduleDirectory.'/includes/inc_tab_files_2.inc.php',
    3 => CPO_BASEDIR.$moduleDirectory.'/includes/inc_tab_files_3.inc.php'
);
$inc_manage_files = array(
    1 => CPO_BASEDIR.$moduleDirectory.'/includes/inc_manage_files_1.inc.php',
    2 => CPO_BASEDIR.$moduleDirectory.'/includes/inc_manage_files_2.inc.php'
);
?>