<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Enhanced Delete"                                     |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.0b / January 2014

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 
$translator->addTranslation('enhanced_delete',CPO_BASEDIR.$moduleDirectory.'/lang');

// Moduleinstellungen speichern (neue Version mit automatischem Einlesen neuer Variablen)************
if (isset($_POST['go'])) {
	$new_settings = $_POST;
    foreach ($activeModules['EnhancedDelete'] as $k=>$v) {
        if (!isset($_POST['cpoEnhancedDeleteNew'][$k])) continue;
        if (is_bool($activeModules['EnhancedDelete'][$k])) {
            $activeModules['EnhancedDelete'][$k] = (bool) $_POST['cpoEnhancedDeleteNew'][$k];
        } else {
			$activeModules['EnhancedDelete'][$k] = $_POST['cpoEnhancedDeleteNew'][$k];
		}
		if (array_key_exists($k, $new_settings['cpoEnhancedDeleteNew'])) unset($new_settings['cpoEnhancedDeleteNew'][$k]);
    }
    foreach ($new_settings['cpoEnhancedDeleteNew'] as $k=>$v) {
		$activeModules['EnhancedDelete'][$k] = $new_settings['cpoEnhancedDeleteNew'][$k];
	}
    $c_datum = date ("Y-m-d H:i:s", time());
    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = '%s'", 
            addslashes(serialize($activeModules['EnhancedDelete'])),
			'EnhancedDelete'
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = __('Module settings were updated!');
}

if (isset($_REQUEST['files']) && $_REQUEST['files'] == 'purge')  { //delete preserved files
    $fileDir = './preserve/';
    $numDel = 0;
    foreach (glob($fileDir."*") as $filename) {
        if (str_replace($fileDir,'',$filename) == "index.php") continue; // keep index.php
        $messageText = str_replace($fileDir,'',$filename)." - ".__('size:')." " . printHumanReadable(filesize($filename))." ... ".__('DELETED!');
        if (unlink($filename))  {
            $message[] = $messageText;
            $numDel += 1;
        }
    }
    $message[] = sprintf(__('%s files were deleted!'), $numDel);
}
require(CPO_BASEDIR.'_include/header.php');

printPageHeader(
    __('Enhanced Delete'),
    __('In this view you can work on the enhanced delete settings.')
);
include(CPO_BASEDIR.'_include/message.php');
include($inc_enhanced_delete_producer);

if(array_key_exists('EnhancedDelete', $activeModules))  {
	// table header {{{
	echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="modulesettings">';
	echo '<input type="hidden" name="go" value="1">';
	echo '<table class="colored" style="width: 100%;">';
	echo '<thead><tr>';

	echo '<th colspan="2"><span>'.__('Enhanced delete settings').'</span></th>';

	echo '</tr></thead><tbody>';
	// }}}

	echo '<tr>';
		echo '<td class="leftrow">';
		echo __('Keep files:');
		echo '</td>';
		echo '<td class="rightrow">';
			echo '<select name="cpoEnhancedDeleteNew[keepFiles]" size="1">';
			$selyes = ($activeModules['EnhancedDelete']['keepFiles']=="yes") ? ' selected="selected"' :'';
			$selno = ($activeModules['EnhancedDelete']['keepFiles']=="no") ? ' selected="selected"' :'';
			echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
			echo '<option value="no"'.$selno.'>'.__('no').'</option>';
			echo '</select>';
			echo ' '.sprintf(__('the files will be stored in %s.'),'<em>mod_enhanced_delete/preserve</em>');
            $num_files = count(scandir('./preserve'))-3;
            echo ' ('.__('Actual number of files: ').$num_files.' <a href="edit.php?files=purge">'.__('purge').'</a>)';
		echo '</td>';
	echo '</tr>';
    if(array_key_exists('Imagetool', $activeModules))  {
        echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Handle imagesize module pictures:');
            echo '</td>';
            echo '<td class="rightrow">';
                echo '<select name="cpoEnhancedDeleteNew[handleImageTool]" size="1">';
                $selyes = ($activeModules['EnhancedDelete']['handleImageTool']=="yes") ? ' selected="selected"' :'';
                $selno = ($activeModules['EnhancedDelete']['handleImageTool']=="no") ? ' selected="selected"' :'';
                echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
                echo '<option value="no"'.$selno.'>'.__('no').'</option>';
                echo '</select>';
            echo '</td>';
        echo '</tr>';
    }
	echo '<tr>';
		echo '<td class="leftrow">';
		echo '&nbsp;';
		echo '</td>';
		echo '<td class="rightrow">';
		echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
		echo '</td>';
	echo '</tr>';
	echo '</tbody></table>';

	echo '</form>';

}
require(CPO_BASEDIR.'_include/footer.php');
?>
