<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Enhanced Delete"                                     |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.0b / January 2014

*/

if (!defined('CPO')) exit;
include($inc_enhanced_delete_producer);

// define some vars
initVar($messageText, '');

if ( (isset($_GET['id']) && isset($_GET['file'])) || isset($_POST['files']) )  {
   $db = new DB; 
   $articles = array(); 
   // fetch all articles and states 
   $db->query("SELECT nr, article_nr, titel, rubric_id, artikel_archiv, freigabe, pub_datum, verfallsdatum FROM ".CPO_NEWS); 
   while ($db->next_record()) { 
      $nr = $db->v('nr'); 
      $articleData[$nr]['title'] = $db->v('titel'); 
      $articleData[$nr]['rubric_id'] = $db->v('rubric_id'); 
      $articleData[$nr]['article_nr'] = $db->v('article_nr'); 
      $articleData[$nr]['state'] = __('online'); 
      $articleData[$nr]['color'] = 'red'; 
      if ($db->v('pub_datum') >= date('Y-m-d H:i:s')) { 
         $articleData[$nr]['state'] = 'not published yet'; 
         $articleData[$nr]['color'] = 'red'; 
      } 
      if ($db->v('verfallsdatum') <= date('Y-m-d H:i:s')) { 
         $articleData[$nr]['state'] = __('expired'); 
         $articleData[$nr]['color'] = 'red'; 
      } 
      if ($db->v('artikel_archiv') == 5) { 
         $articleData[$nr]['state'] = __('old article version'); 
         $articleData[$nr]['color'] = 'green'; 
      } 
      if ($db->v('artikel_archiv') == 9) { 
         $articleData[$nr]['state'] = __('deleted article'); 
         $articleData[$nr]['color'] = 'green'; 
      } 
      if ($db->v('freigabe') != 0) { 
         $articleData[$nr]['state'] = __('blocked article'); 
         $articleData[$nr]['color'] = 'green'; 
      } 
      if ($db->v('freigabe') == 1) { 
         $articleData[$nr]['state'] = __('waiting article'); 
         $articleData[$nr]['color'] = 'red'; 
      } 
   } 
   $multimode = false; 

   if (isset($_GET['id']) && isset($_GET['file'])) { 
      $query4files = ($show_only_images) ? "SELECT article_id FROM ".CPO_CONTENT_IMAGES." WHERE image_id=".(int)$_GET['id'] : "SELECT article_id FROM ".CPO_CONTENT_FILES." WHERE file_id=".(int)$_GET['id']; 
      $query4articles = "SELECT article_id FROM ".CPO_CONTENT_HTML." WHERE html like '%".addslashes($_GET['file'])."%'"; 
      $fileNameColonString = htmlspecialchars($_GET['file'], ENT_COMPAT, 'ISO-8859-15'); 
      $givenFileIDs[] = $_GET['id']; 
   } elseif (isset($_POST['files'])) { 
      $multimode = (count($_POST['files']) > 1) ? true : false ; 
      foreach($_POST['files'] AS $givenFile)  { 
         $givenFileInfo=explode('#CPO#',$givenFile); 
         $givenFiles[$givenFileInfo[0]]=$givenFileInfo[1]; 
         $givenFileIDs[]=$givenFileInfo[0]; 
         $givenFileNames[]=$givenFileInfo[1]; 
         $messageText .= '['.$givenFileInfo[0].'] '.$givenFileInfo[1].'<br />'; 
      } 
      $fileIdString = implode(',',$givenFileIDs); 
      $fileNameString = implode("%' OR  html like '%",$givenFileNames); 
      $fileNameColonString = implode(", ",$givenFileNames); 
      $query4files = ($show_only_images) ? "SELECT article_id FROM ".CPO_CONTENT_IMAGES." WHERE image_id IN (".addslashes($fileIdString).")" : "SELECT article_id FROM ".CPO_CONTENT_FILES." WHERE file_id IN (".addslashes($fileIdString).")"; 
      $query4articles = "SELECT article_id FROM ".CPO_CONTENT_HTML." WHERE html like '%".$fileNameString."%'"; 
   }

   // messages 
    switch ($show_only_images) { 
    case true: 
      $m_stilused = ($multimode) ? 
        __('At least on of the selected imgaes is still used in the following article(s):') : 
        __('The image %s is still used in the following article(s):'); 
      $m_unused   = ($multimode) ? 
          __('The images %s seem to be unused.') : 
          __('The image %s seems to be unused.'); 
      $m_confirm  = ($multimode) ? 
          __('Are you sure you want to delete the images %s?') : 
          __('Are you sure you want to delete the image %s?'); 
        break; 
    case false: 
      $m_stilused = ($multimode) ? 
        __('At least on of the selected files is still used in the following article(s):') :
        __('The file %s is still used in the following article(s):'); 
      $m_unused   = ($multimode) ? 
          __('The files %s seem to be unused.') : 
          __('The file %s seems to be unused.'); 
      $m_confirm  = ($multimode) ? 
          __('Are you sure you want to delete the files %s?') : 
          __('Are you sure you want to delete the file %s?'); 
        break; 
    } 

   $db->query($query4files); 
   while ($db->next_record()) $articles[$db->v('article_id')] = $db->v('article_id'); 
   $db->query($query4articles); 
   while ($db->next_record()) $articles[$db->v('article_id')] = $db->v('article_id'); 
   if (count($articles) > 0 )   {
      $messageText = '<span style="color:red">'. sprintf( $m_stilused , '<em>' . $fileNameColonString . '</em>')  .'</span><br /><br />'; 

      foreach ($articles AS $articleID)  { 
         $nav_id = 0;
         $query4rubrics = "SELECT name FROM ".CPO_RUBRIC." WHERE id=".$articleData[$articleID]['rubric_id'];
         $db->query($query4rubrics); 
         $db->next_record();
         $rubric_name = $db->v('name');
         $query4rubrics = "SELECT id FROM ".CPO_NAVTREE." WHERE rubric_id=".$articleData[$articleID]['rubric_id'];
         $db->query($query4rubrics);
         while ($db->next_record()) $nav_id = $db->v('id');
         $messageText .= '['.$articleData[$articleID]['article_nr'].'] [<a href="'.BASE_ABS.'_admin/index.php?navigation='.$nav_id.':'.$articleData[$articleID]['rubric_id'].'" target="_top">'.__('Rubric:').' '.htmlspecialchars($rubric_name, ENT_COMPAT, 'ISO-8859-15').'</a>] <span style="color:'.$articleData[$articleID]['color'].'">'.$articleData[$articleID]['title'].' - '.__('Status').': '.$articleData[$articleID]['state'].' </span><br />'; 
      } 
   } else { 
      $messageText = '<span style="color:green">' . sprintf( $m_unused , '<em>' . $fileNameColonString . '</em>') . '</span><br />'; 
   } 
    
   $messageText .= '<br />' . sprintf( $m_confirm, '<em>'.$fileNameColonString.'</em>'); 
   $messageText .= '<br /><br />'; 
   $messageText .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">'; 
   $messageText .= '<input type="hidden" name="action" value="reallydelete">'; 
   foreach ($givenFileIDs AS $hiddenfileID) $messageText .= '<input type="hidden" name="id[]" value="'.$hiddenfileID.'" />'; 
   $messageText .= '<input type="submit" name="yes" value="'.___('Yes, delete').'" />&nbsp;'; 
   $messageText .= '<input type="submit" name="no" value="'.___('No, do not delete').'" />'; 
   $messageText .= '</form>'; 
   $message[] = $messageText;
   if(file_exists(CPO_BASEDIR.'_include/confirmation.php')) include(CPO_BASEDIR.'_include/confirmation.php');
   else include(CPO_BASEDIR.'_include/message.php');

require(CPO_BASEDIR.'_include/footer.php');
exit;
}else{
    $message[]=__('No items were selected!');
}