<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Enhanced Delete"                                     |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.0b / January 2014

*/

if (!defined('CPO')) exit;

$fileNameReplacements = array(
    '//' => 'Ae',
    '//' => 'Oe',
    '//' => 'Ue',
    '//' => 'ss',
    '//' => 'ae',
    '//' => 'oe',
    '//' => 'ue',
    '//' => 'A',
    '//' => 'A',
    '//' => 'E',
    '//' => 'E',
    '//' => 'O',
    '//' => 'O',
    '//' => 'U', 
    '//' => 'U', 
    '//' => 'I', 
    '//' => 'I', 
    '//' => 'a', 
    '//' => 'a', 
    '//' => 'e', 
    '//' => 'e', 
    '//' => 'o', 
    '//' => 'o', 
    '//' => 'u', 
    '//' => 'u', 
    '//' => 'i', 
    '//' => 'i', 
    '/[^a-z0-9_\.-]/i' => '_',
);

function file_enhanced_delete($dateiName)  {
    global $activeModules;
    if (isset($activeModules['EnhancedDelete']['keepFiles']) && $activeModules['EnhancedDelete']['keepFiles']=="no")  {
        if (file_exists(CPO_BASEDIR.'_data/'.$dateiName)) unlink(CPO_BASEDIR.'_data/'.$dateiName);
    } else {
        if (file_exists(CPO_BASEDIR.'_data/'.$dateiName)) rename (CPO_BASEDIR.'_data/'.$dateiName, CPO_BASEDIR.'mod_enhanced_delete/preserve/'.$dateiName);
    }
}

    $db = new DB; 
   $idString=implode(',',$_POST['id']); 
    $db->query("SELECT datei FROM ".CPO_DATA." " 
              ."WHERE id IN (".addslashes($idString).")"); 
    while ($db->next_record()) { 
        $datei[] = $db->v('datei'); 
    } 
   $nameString= implode(', ',$datei); 
   if (isset($_POST['no'])) { 
      $message[] = __('Aborted by user. No file was deleted.'); 
      return; 
   } 

   $query_del = "DELETE FROM ".CPO_DATA." " 
                ."WHERE id IN (".addslashes($idString).")"; 
    DEBUG(1, $query_del, __FILE__, __LINE__); 
    $db->query($query_del); 

    foreach ($datei AS $dateiName) {
        file_enhanced_delete($dateiName);
        if (isset($activeModules['EnhancedDelete']['handleImageTool']) && $activeModules['EnhancedDelete']['handleImageTool']=="yes")  { // handle Imagetool pics
            file_enhanced_delete($activeModules['Imagetool']['prefix'].$dateiName);
            if ($activeModules['Imagetool']['keepOriginal']=="yes")  { // handle original pics
                file_enhanced_delete('original_'.$dateiName);
                $imagetool_presets = explode("\n",$activeModules['Imagetool']['presets']);
                $suffixes = explode(';',$activeModules['Imagetool']['suffix']);
                foreach($imagetool_presets AS $imagetool_preset)
                {	
                    $imagetool_preset_set = explode(";", $imagetool_preset);
                    $preset_name = (version_compare($CPO['version'], '4.1.3') >= 0) ? preg_replace(array_keys($fileNameReplacements), array_values($fileNameReplacements), $imagetool_preset_set[0]) : preg_replace('/[^a-z0-9_\.-]/i', '_',$imagetool_preset_set[0]);
                    $max_width   = (isset($imagetool_preset_set[1])) ? $imagetool_preset_set[1] : '';
                    $max_height  = (isset($imagetool_preset_set[2])) ? $imagetool_preset_set[2] : '';
                    $suffix = ($suffixes[1]) ? sprintf($suffixes[1], $preset_name) : sprintf($suffixes[0], $max_width, $max_height);
                    $originalName = 'original_'.str_replace($suffix,'',$dateiName);
                    file_enhanced_delete($originalName);
                }
            }
        }
    }

    switch ($show_only_images) { 
    case true: 
        $message[] = sprintf(__('The image(s) %s was successfully deleted.'), '<em>'.$nameString.'</em>'); 
        break; 
    case false: 
      $message[] = sprintf(__('The file(s) %s was successfully deleted.'), '<em>'.$nameString.'</em>'); 
        break; 
    } 
    
    logaction('delete files', $nameString); 
    $_POST['id'] = ''; 

