<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Form"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1e / July 2013 ==

*/

if (!defined('CPO')) exit;
$translator->addTranslation('form', CPO_BASEDIR.$moduleDirectory.'/lang');

$encAry[] = "UTF-8";
$encAry[] = "ISO-8859-15";
$encAry[] = "ISO-8859-1";
mb_detect_order($encAry);
mb_internal_encoding("iso-8859-15");
mb_http_output('iso-8859-15'); 
mb_http_input('iso-8859-15'); 
mb_regex_encoding('iso-8859-15');


if (!function_exists('tocFormHelp')) {
	function tocFormHelp($topic,$module)  {
		return 'https://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

if (!function_exists('mf_encode_Recipients')) {
    function mf_encode_Recipients($recpString, $encoding)  {
        global $newline;
        $recpArray = explode (",", $recpString);
        foreach($recpArray AS $k=>$recp)  {
            if (strpos($recp, "<")===false) continue;
            $recpArr = explode("<",trim($recp));
            $name = mb_encode_mimeheader(trim($recpArr[0]), $encoding, "Q", $newline);
            $recpArray[$k] = $name . " <" . $recpArr[1];
        }
        $recpString = implode(", ",$recpArray);
        return $recpString;
    }
}

if (!function_exists('mf_decode_entities')) {
    function mf_decode_entities($text) {
         $text= html_entity_decode($text,ENT_QUOTES,"ISO-8859-15"); #once
         $text= html_entity_decode($text,ENT_QUOTES,"ISO-8859-15"); #twice
         $text= preg_replace_callback('/&#(\d+);/m',function ($m) { return chr($m[1]); },$text); #decimal notation
         $text= preg_replace_callback('/&#x([a-f0-9]+);/mi',function ($m) { return chr("0x".$m[1]); },$text);  #hex notation
         return $text;
    }
}

$directory = basename(dirname($_SERVER['PHP_SELF'])); 

$GLOBALS['modules'][$moduleDirectory] = array(
    'directory'	  =>$moduleDirectory,
    'caption'	  =>'Form ('.$moduleDirectory.')',
    'install'	  =>'function: Form_install',
    'activate'	  =>'function: Form_activate '.$moduleDirectory,
    'deactivate'  =>'function: Form_deactivate',
    'uninstall'	  =>'function: Form_uninstall '.$moduleDirectory,
	'manage'	  =>'function: Form_manage '.$moduleDirectory,
	'owner'		  =>$cpoSystem['owner'],
	'lkey'		  =>'',
	'mod_id'	  => 18,
	//Help ***********************************+
	'helptoc' => array(
        'bersicht' 
			=> tocFormHelp('index','form'),
        '1. Eigenschaften' 
			=> tocFormHelp('features','form'),
        '2. Installation' 
			=> tocFormHelp('setup','form'),
        '3. Einstellungen' 
			=> tocFormHelp('settings','form'),
        '3.1 Templates' 
			=> tocFormHelp('templates','form'),
        '3.2 Platzhalter und Parameter' 
			=> tocFormHelp('placeholders','form')
	),
	//Texte ***********************************+
	'release'		      =>'yes',
	'mail'			      =>'yes',
	'mail_prefix'	      =>'copy: ',
	'divider'		      =>' / ',
	'recipient'		      =>$cpoSystem['admin_email'],
	'cc'		          =>'',
	'bcc'		          =>'',
	'sender'		      =>$cpoSystem['system_email'],
	'envelope'		      =>'',
	'subject'		      =>__('Online posted by %s'),
	'encoding'		      =>"0",
	'defaultError'	      =>__('Please fill in the data beneath.'),
	'defaultInputError'   =>__('Input required!'),
	'error_template'      =>'<div style="border:1px solid red;">### ERROR_MESSAGE ###<br />### FORM_FIELD ###</div>',
	'message_box'	      =>'',
	'successMessage'      =>__('Your input has been successfully saved!'),
	'conversionCode'      =>'',
	'rubric'		      =>-1,
	'template'		      =>'',
	'method'		      =>'POST',
	'showArticles'	      =>'none',
	'hideArticles'	      =>'yes',
	'pagetemplate_index'  =>1,
	'submit'		      =>__('Send input'),
	'reset'			      =>__('Discard'),
	'submit_template'     =>'', 
	// Upload
	'upload'		      =>'no',
	'fileError'		      =>__('Please select the upload files again!'),
	'warnImage'		      =>__('The uploaded file <em>%s</em> is not an image!'),
	'warnFile'		      =>__('The uploaded file <em>%s</em> is not a data file! Propably an image?'),
	'rename'		      =>'no',
	'extensions'	      =>'jpeg jpg gif png txt csv zip rar doc docx pdf xls xslx ppt pptx',
	'nonallowedExt'	      =>__('The uploaded file <em>%s</em> is no allowed filetype. Allowed filetypes: <em>%s</em>'),
	'uploaduser'	      =>1,
	// Confirmation
	'confirm'		      =>'no',
	'confirmation_text'   =>__('The following entry was approved:<br /><br/>%s'),
	'show_confirmed'      =>'yes',
	'confirmation_failed' =>__('Confirmation failed!'),
	'deleted'		      =>__('The entry was deleted!'),
	'blocked'		      =>__('The entry has been blocked!'),
	'expired'		      =>__('The entry has been archived!'),
	'auto_expire'	      =>'no',
	'expire_time'	      =>'365',
	'salt'	              =>substr(md5(time()),0,6),
	'a0'		          =>'',
	'a1'		          =>'',
	'as'		          =>'',
	'a2'		          =>'',
	'a3'		          =>'',
	'c0'		          =>'',
	'c1'		          =>'',
	'cs'		          =>'',
	'c2'		          =>'',
	'c3'		          =>'',
	'b0'		          =>'',
	'b1'		          =>'',
	'bs'		          =>'',
	'b2'		          =>'',
	'b3'		          =>'',
	'u0'		          =>'',
	'u1'		          =>'',
	'us'		          =>'',
	'u2'		          =>'',
	'u3'		          =>'',
    'remail_subject'      =>'',
	'remail_message'      =>'',
	// Captcha
	'captcha'		      =>'no',
	'captcha_error'	      =>__('Incorrect security code! Pay attention to upper and lower case letters!'),
	'captcha_template'    =>__('<!-- // Captcha-Sicherheitscode -->
<p><b>Security code:</b> Please enter the following security code in the adjacent field before sending<br />
<img src="captcha/captcha.php" border="0" title="Sicherheitscode" name="Sicherheitscode" onClick="reloadCaptcha(this);">
Enter security code here: <input type="text" name="sicherheitscode" size="5"><br />
This measure serves to avoid spam. We ask for your understanding.</p>'),
	'pic'			      =>'checker.png',
	'font'			      =>'XFILES.TTF',
	'text_color'	      =>'#FFFFFF',
	'shadow_color'	      =>'#000000',
	'style'			      =>'outline'
);

if (!function_exists('Form_manage'))  {
	function Form_manage($moduleDirectory)
	{
		global $module_status, $k;
		printIcon(	
			BASE_ABS.$moduleDirectory.'/edit.php', 
			SKIN_URL.'pic_settings.gif', 
			(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE) ? __('options') : __('not available'),
			array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE
		);
	}
}

if (!function_exists('Form_install'))  {
	function Form_install()
	{
		$imagesizedb = new DB;
		$imagesizedb->query("INSERT INTO ".CPO_OPTION." (type, options, id) VALUES ('form', '".serialize(array("installed"=>time()))."', '') ");
		$GLOBALS['message'][] = ___('The form-module was successfully installed!');
	}
}

if (!function_exists('Form_activate'))  {
	function Form_activate($moduleDirectory)
	{
		$GLOBALS['message'][] = ___('The form-module got activated.');
		$GLOBALS['message'][] = sprintf(__('If you want some example templates to be installed please run the <a href="%s">template-setup</a>.'),
		BASE_ABS.$moduleDirectory.'/setup.php');
	}
}
if (!function_exists('Form_deactivate'))  {
	function Form_deactivate()
	{
		$GLOBALS['message'][] = ___('The form-module got deactivated.');
	}
}

if (!function_exists('Form_uninstall'))  {
	function Form_uninstall($directory_uninstall)
	{
		$GLOBALS['message'][] = sprintf(___('Please remove the module directory %s to finally uninstall the form-module.'), '<em>'.htmlspecialchars($directory_uninstall, ENT_COMPAT, 'ISO-8859-15').'</em>');
	}
}

$mfbreak = false; // default state: no break

if (!isset($activeModules[$moduleDirectory]['installed']))  {
	$formdb = new DB;
	$formdb->query('SELECT options FROM '.CPO_OPTION.' '
			  ."WHERE type='form' ORDER BY id ASC LIMIT 0,1");
	while ($formdb->next_record()) {
		$options = $formdb->v('options');
		$formOpt = unserialize($options);
		if (!is_array($formOpt)) break;
		foreach ($formOpt as $key=>$v) {
			$activeModules[$moduleDirectory][$key] = $v;
		}
	}
}

initVar($activeModules[$moduleDirectory]['lkey'],'');
initVar($activeModules[$moduleDirectory]['mod_id'],'');

// check time since install & license
if (	license($activeModules[$moduleDirectory]['lkey'],$activeModules[$moduleDirectory]['mod_id']) != 1 &&
		license($activeModules[$moduleDirectory]['lkey'],$activeModules[$moduleDirectory]['mod_id']) != 2 &&
		license($activeModules[$moduleDirectory]['lkey'],$activeModules[$moduleDirectory]['mod_id']) != 3 &&
		(isset($activeModules[$moduleDirectory]['installed']) && $activeModules[$moduleDirectory]['installed']<(time()-90*24*60*60)) && 
		!isset($_POST['go']) &&
		@file_exists(CPO_BASEDIR.$activeModules[$moduleDirectory]['directory'].'/includes/producer.inc.php')
	) 
	{
	include(CPO_BASEDIR.$activeModules[$moduleDirectory]['directory'].'/includes/producer.inc.php');
	$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
		htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
	$mfbreak = true; // sorry, no form after 90 days of testing!
}

