<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Form"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1e / July 2013 ==

*/


define('CPO', true);
require_once('../_include/common.inc.php');
$directory = basename(dirname($_SERVER['PHP_SELF']));

require(CPO_BASEDIR.'_include/var_category.php');
// require(CPO_BASEDIR.'_include/secure.php'); // soll ohne Login erreichbar sein!

// langauage **************************************************************************************
if (!array_key_exists($directory, $activeModules)) {
	$translator->addTranslation('form',CPO_BASEDIR.$directory.'/lang');
}

// the includes ***********************************************************************************
include(CPO_BASEDIR.$directory.'/includes/producer.inc.php');
include(CPO_BASEDIR.$directory.'/includes/form_functions.inc.php');

$pageContent = '';
$newline = "\n"; // change to fit your needs, either \r\n or \n
$fparm = (isset($activeModules[$directory]['envelope']) && trim($activeModules[$directory]['envelope']) != '') ? $fparm = '-f'.$activeModules[$directory]['envelope'] : '' ;
$empfaenger = $activeModules[$directory]['recipient'];
$cc = '';
$bcc = '';
if (isset($activeModules[$directory]['cc']) && trim($activeModules[$directory]['cc'])!='' 
    && isset($activeModules[$directory]['cs']) && $activeModules[$directory]['cs']=='yes')  
        $cc = 'Cc: '.trim($activeModules[$directory]['cc']).$newline;
if (isset($activeModules[$directory]['bcc']) && trim($activeModules[$directory]['bcc'])!='' 
    && isset($activeModules[$directory]['bs']) && $activeModules[$directory]['bs']=='yes')  
        $bcc = 'Bcc: '.trim($activeModules[$directory]['bcc']).$newline;
$contentType = 'Content-Type: text/plain; format=flowed;"' . $newline;
if ( $activeModules[$directory]['encoding'])  {
    if ($activeModules[$directory]['encoding']=='default')  $encoding = iconv_get_encoding('output_encoding');
    else if ($activeModules[$directory]['encoding']=='iso')  $encoding = 'ISO-8859-1';
    else if ($activeModules[$directory]['encoding']=='iso15')  $encoding = 'ISO-8859-15';
    else if ($activeModules[$directory]['encoding']=='utf8')  $encoding = 'UTF-8';
    //$betreff = mb_encode_mimeheader( $betreff, $encoding, "Q", $newline);
    $empfaenger = mf_encode_Recipients($empfaenger, $encoding);
    if (isset($activeModules[$directory]['cc']) && trim($activeModules[$directory]['cc'])!='' 
        && isset($activeModules[$directory]['cs']) && $activeModules[$directory]['cs']=='yes')  
            $cc = 'Cc: '.mf_encode_Recipients(trim($activeModules[$directory]['cc']), $encoding).$newline;
    if (isset($activeModules[$directory]['bcc']) && trim($activeModules[$directory]['bcc'])!='' 
        && isset($activeModules[$directory]['bs']) && $activeModules[$directory]['bs']=='yes')  
            $bcc = 'Bcc: '.mf_encode_Recipients(trim($activeModules[$directory]['bcc']), $encoding).$newline;
    $contentType = 'Content-Type: text/plain; format=flowed; charset="'.$encoding . '"' . $newline;
}

// setting sender to prevent spam protection
// this is the mail to the recipient/admin, use the sender settings
$from = $cpoSystem['system_email'];
if (isset($activeModules[$directory]['senderUsage']) && isset($activeModules[$directory]['sender']) && $activeModules[$directory]['senderUsage'] == 'sender') $from = $activeModules[$directory]['sender'];
if (isset($activeModules[$directory]['senderUsage']) && isset($activeModules[$directory]['recipient']) && $activeModules[$directory]['senderUsage'] == 'recipient') $from = $activeModules[$directory]['recipient'];
if (isset($activeModules[$directory]['senderUsage']) && isset($activeModules[$directory]['user']) && $activeModules[$directory]['senderUsage'] == 'user') $from = $activeModules[$directory]['user'];

$from = mf_encode_Recipients($from, $encoding);

$header = 'From: '. $from . $newline .
   'Reply-To: '. $cpoSystem['system_email'] . $newline .
   $cc.
   $bcc.
   $contentType . 
   'X-Mailer: mod_form by conpresso4.de via PHP/' . phpversion();

ob_start();
if ( isset($_REQUEST['nr']) && isset($_REQUEST['hash']) && $activeModules[$directory]['confirm'] == 'yes') {
	$query = 'SELECT rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer, last_modify '
			.'FROM '.CPO_NEWS.' '
			.'WHERE nr='.(int)$_REQUEST['nr'].' ';

	$db_get = new DB;
	$db_get->query($query);

	// no article with that number found.
	if ($db_get->num_rows()<=0) {
		echo $cpoRubricSettings['noArticlesFound'];
		include(CPO_BASEDIR.$directory.'/loadfooters.php');
		exit;
	}
	
	$db_get->next_record();
    $salt = $activeModules[$directory]['salt'];

	if ( $_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'confirm'.$salt ) )  { // release **********************************
		$query = sprintf(
				 "UPDATE ".CPO_NEWS." SET artikel_archiv = 0, freigabe = 0 WHERE nr = '%s'", 
				 $db_get->v('nr')
				 );
		DEBUG(1, $query, __FILE__, __LINE__);
		$db_confirm = new DB;
		$db_confirm->query($query);

		if ($activeModules[$directory]['show_confirmed'] == 'yes')  {
			$pagetype = 'detail';
			ob_start(); 
			$GLOBALS['lastUpdated'] = 0;
			$db_template      = $db_get->v('templates_id');
			$db_nr            = $db_get->v('nr');
			$db_idx           = $db_get->v('idx');
			$db_email         = $db_get->v('email');
			$db_autor         = $db_get->v('autor');
			$db_changer       = $db_get->v('changer');
			$db_pub_datum     = $db_get->v('pub_datum');
			$db_verfallsdatum = $db_get->v('verfallsdatum');
			$db_commentary    = $db_get->v('commentary');
			$db_titel         = $db_get->v('titel');
			$db_initial       = $db_get->v('initial');
			$db_freigabe      = $db_get->v('freigabe');
			$db_rubric_id     = $db_get->v('rubric_id');
			$db_last_modify   = $db_get->v('last_modify');
			if ($GLOBALS['lastUpdated']<strtotime($db_last_modify)) {
				$GLOBALS['lastUpdated'] = strtotime($db_last_modify);
			}
			require(CPO_BASEDIR.'_include/select_template.php');
			$confirmed = ob_get_contents();                  
			ob_end_clean(); 
			$pagetype = 'index';
		}
		
		$message[] = sprintf($activeModules[$directory]['confirmation_text'], $confirmed);

        // Statusmails ************************
        if (isset($activeModules[$directory]['as']) && $activeModules[$directory]['as']=='yes') { // Mail to admin
            $betreff = __('Released').' ('.$db_get->v('nr')."): ".$db_get->v('titel');
            $betreff = mb_encode_mimeheader( $betreff, $encoding, "Q", $newline);
            $nachricht = strip_tags(sprintf($activeModules[$directory]['confirmation_text'], " [".$db_get->v('nr')."] ".$db_get->v('titel')));
            $nachricht = mf_decode_entities($nachricht);
            $nachricht = mb_convert_encoding($nachricht, $encoding, mb_detect_encoding ($nachricht) );
            if (mail($empfaenger, $betreff, mf_decode_entities($nachricht), $header, $fparm) )  {
                logaction('form confirmation confirm', $db_get->v('nr').": ".$db_get->v('titel'));
            } else {
                logaction('MAIL ERROR!', $db_get->v('nr').": ".$db_get->v('titel') . ' / Error message: ' . error_get_last()['message']);
                $mail_error = true;
            }
       }
	} else if ( $_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'delete'.$salt ) )  { // delete ***********************************
		$db_confirm = new DB;
		$db_confirm->query( sprintf( "DELETE FROM ".CPO_CONTENT_TEXT." WHERE article_id = '%s'", $db_get->v('nr') ) );
		$db_confirm->query( sprintf( "DELETE FROM ".CPO_CONTENT_HTML." WHERE article_id = '%s'", $db_get->v('nr') ) );
		$db_confirm->query( sprintf( "DELETE FROM ".CPO_CONTENT_IMAGES." WHERE article_id = '%s'", $db_get->v('nr') ) );
		$db_confirm->query( sprintf( "DELETE FROM ".CPO_CONTENT_FILES." WHERE article_id = '%s'", $db_get->v('nr') ) );
		$db_confirm->query( sprintf( "DELETE FROM ".CPO_CONTENT_URLS." WHERE article_id = '%s'", $db_get->v('nr') ) );
		$db_confirm->query( sprintf( "DELETE FROM ".CPO_NEWS." WHERE nr = '%s'", $db_get->v('nr') ) );
		$message[] = $activeModules[$directory]['deleted'];
        if (isset($activeModules[$directory]['as']) && $activeModules[$directory]['as']=='yes') { // Mail to admin
            $betreff = __('Deleted').' ('.$db_get->v('nr')."): ".$db_get->v('titel');
            $betreff = mb_encode_mimeheader( $betreff, $encoding, "Q", $newline);
            $nachricht = $activeModules[$directory]['deleted'];
            $nachricht = mf_decode_entities($nachricht);
            $nachricht = mb_convert_encoding($nachricht, $encoding, mb_detect_encoding ($nachricht) );
            if (mail($empfaenger, $betreff, mf_decode_entities($nachricht), $header, $fparm) )  {
                logaction('form confirmation confirm', $db_get->v('nr').": ".$db_get->v('titel'));
            } else {
                logaction('MAIL ERROR!', $db_get->v('nr').": ".$db_get->v('titel') . ' / Error message: ' . error_get_last()['message']);
                $mail_error = true;
            }
        }
        logaction('form confirmation delete', $db_get->v('nr').": ".$db_get->v('titel'));
	} else if ( $_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'block'.$salt ) )  { // block *************************************
		$query = sprintf(
				 "UPDATE ".CPO_NEWS." SET artikel_archiv = 0, freigabe = 2 WHERE nr = '%s'", 
				 $db_get->v('nr')
				 );
		DEBUG(1, $query, __FILE__, __LINE__);
		$db_confirm = new DB;
		$db_confirm->query($query);
		$message[] = $activeModules[$directory]['blocked'];
        if (isset($activeModules[$directory]['as']) && $activeModules[$directory]['as']=='yes') { // Mail to admin
            $betreff = __('Blocked').' ('.$db_get->v('nr')."): ".$db_get->v('titel');
            $betreff = mb_encode_mimeheader( $betreff, $encoding, "Q", $newline);
            $nachricht = $activeModules[$directory]['blocked'];
            $nachricht = mf_decode_entities($nachricht);
            $nachricht = mb_convert_encoding($nachricht, $encoding, mb_detect_encoding ($nachricht) );
            if (mail($empfaenger, $betreff, mf_decode_entities($nachricht), $header, $fparm) )  {
                logaction('form confirmation confirm', $db_get->v('nr').": ".$db_get->v('titel'));
            } else {
                logaction('MAIL ERROR!', $db_get->v('nr').": ".$db_get->v('titel') . ' / Error message: ' . error_get_last()['message']);
                $mail_error = true;
            }
        }
        logaction('form confirmation block', $db_get->v('nr').": ".$db_get->v('titel'));
	} else if ( $_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'expire'.$salt ) )  { // expire ***********************************
		$query = sprintf(
				 "UPDATE ".CPO_NEWS." SET verfallsdatum = '".date('Y-m-d H:i:s', time())."' WHERE nr = '%s'", 
				 $db_get->v('nr')
				 );
		DEBUG(1, $query, __FILE__, __LINE__);
		$db_confirm = new DB;
		$db_confirm->query($query);
		$message[] = $activeModules[$directory]['expired'];
        if (isset($activeModules[$directory]['as']) && $activeModules[$directory]['as']=='yes') { // Mail to admin
            $betreff = __('Expired').' ('.$db_get->v('nr')."): ".$db_get->v('titel');
            $betreff = mb_encode_mimeheader( $betreff, $encoding, "Q", $newline);
            $nachricht = $activeModules[$directory]['expired'];
            $nachricht = mf_decode_entities($nachricht);
            $nachricht = mb_convert_encoding($nachricht, $encoding, mb_detect_encoding ($nachricht) );
            if (mail($empfaenger, $betreff, mf_decode_entities($nachricht), $header, $fparm) )  {
                logaction('form confirmation confirm', $db_get->v('nr').": ".$db_get->v('titel'));
            } else {
                logaction('MAIL ERROR!', $db_get->v('nr').": ".$db_get->v('titel') . ' / Error message: ' . error_get_last()['message']);
                $mail_error = true;
            }
        }
        logaction('form confirmation expire', $db_get->v('nr').": ".$db_get->v('titel'));
    } else if ( 
        $_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'step0'.$salt) ||
        $_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'step1'.$salt) ||
        $_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'step2'.$salt) ||
        $_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'step3'.$salt)
        )  { // ************************************************************************************ editing ***********************************

        $step = 100; // alles offen! oder...
        if ($_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'step0'.$salt)) $step = 0;
        if ($_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'step1'.$salt)) $step = 1;
        if ($_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'step2'.$salt)) $step = 2;
        if ($_REQUEST['hash'] == md5($db_get->v('titel').$db_get->v('nr').'step3'.$salt)) $step = 3;

        autoLogin();
        $_REQUEST['fillForm'] = true;


		ob_start(); 
        $fetchedcontent = array();
        $content    = array();
        $db_content = new DB;
        $placeholders_cache = array();
        $placeholder = array();
        $db_nr = (int)$_REQUEST['nr'];
        $form_mails = false;

        $template = $db_get->v('templates_id');

        // Artikeldaten lesen
        foreach ($hdlr_parser_content as $_type=>$v) {
            doActions($hdlr_parser_content[$_type]);
        }

        $_REQUEST['content'] = $content;
        //print_r($_REQUEST['content']);
        
        include(CPO_BASEDIR.$directory.'/includes/form.inc.php');
        $pageContent = ob_get_contents();                  
        ob_end_clean(); 
        logaction('form confirmation step'.$step, $db_get->v('nr').": ".$db_get->v('titel'));

    } else { // *********************************************************************** failure ******************************************
		$message[] = $activeModules[$directory]['confirmation_failed'];
        if (isset($activeModules[$directory]['as']) && $activeModules[$directory]['as']=='yes') { // Mail to admin
            $betreff = __('Error').' ('.$db_get->v('nr')."): ".$db_get->v('titel');
            $betreff = mb_encode_mimeheader( $betreff, $encoding, "Q", $newline);
            $nachricht = $activeModules[$directory]['confirmation_failed'];
            $nachricht = mf_decode_entities($nachricht);
            $nachricht = mb_convert_encoding($nachricht, $encoding, mb_detect_encoding ($nachricht) );
            if (mail($empfaenger, $betreff, mf_decode_entities($nachricht), $header, $fparm) )  {
                logaction('form confirmation confirm', $db_get->v('nr').": ".$db_get->v('titel'));
            } else {
                logaction('MAIL ERROR!', $db_get->v('nr').": ".$db_get->v('titel') . ' / Error message: ' . error_get_last()['message']);
                $mail_error = true;
            }
        }
        logaction('form confirmation failed', $db_get->v('nr').": ".$db_get->v('titel'));
	}

    // Seitenausgabe


    if (empty($activeModules[$directory]['message_box'])) {
		include(CPO_BASEDIR.'_include/message.php');
	} else {
		include(CPO_BASEDIR.$directory.'/includes/message.php');
	}
    echo $pageContent;
}
$showForm = ob_get_clean();


// header and footer mechanism
if (($cpoRubricSettings['pagetemplate_'.$pagetype]==0 && $activeModules[$directory]['pagetemplate_index'] == -2) || $activeModules[$directory]['pagetemplate_index']==0) {
    include(CPO_BASEDIR.$directory.'/loadheaders.php');
    echo $showForm;
	include(CPO_BASEDIR.$directory.'/loadfooters.php');
    exit;
}

// fetch pagetemplate from database and build page
$pagetemplate = ($activeModules[$directory]['pagetemplate_index']==-2) ? $cpoRubricSettings['pagetemplate_'.$pagetype] : $activeModules[$directory]['pagetemplate_index'];

$db = new DB;
$db->query('SELECT pagetemplate FROM '.CPO_PAGETEMPLATES.' '
    .'WHERE id='.(int)$pagetemplate.' '
);
$db->next_record();
$pageTemplate = $db->v('pagetemplate');
$pageTagsPreg = '/<!--\s*page\s*:\s*articles\s*(?!id=)[^>]\s*-->/isU'; // nur der Artikelplatzhalter der aktuellen Rubrik, also OHNE id
$pageTemplate = preg_replace ($pageTagsPreg, $showForm, $pageTemplate);
require CPO_BASEDIR.'_include/buildpage.inc.php';
?>
