<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Form"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1f / September 2019 ==

*/
initVar($parsed_form,'');
initVar($form_success,false);
initVar($markAllFiles,0);


$newline = "\n"; // change to fit your needs, either \r\n or \n

$mailArr = array(
            'a0','as','a1','a2','a3',
            'c0','cs','c1','c2','c3',
            'b0','bs','b1','b2','b3',
            'u0','us','u1','u2','u3'
            );

// Moduleinstellungen speichern (neue Version mit automatischem Einlesen neuer Variablen)************
if (isset($_POST['go'])) {
	$new_settings = $_POST;
    foreach ($activeModules[$directory] as $k=>$v) {
        if (in_array($k,$mailArr) && !isset($_POST['cpoFormNew'][$k])) $_POST['cpoFormNew'][$k]='no';
        if (!isset($_POST['cpoFormNew'][$k])) continue;
        if (is_bool($activeModules[$directory][$k])) {
            $activeModules[$directory][$k] = (bool) $_POST['cpoFormNew'][$k];
        } else {
			$activeModules[$directory][$k] = $_POST['cpoFormNew'][$k];
		}
		if (array_key_exists($k, $new_settings['cpoFormNew'])) unset($new_settings['cpoFormNew'][$k]);
    }
    foreach ($new_settings['cpoFormNew'] as $k=>$v) {
		$activeModules[$directory][$k] = $new_settings['cpoFormNew'][$k];
	}
    $c_datum = date ("Y-m-d H:i:s", time());
    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = '%s'", 
            addslashes(serialize($activeModules[$directory])),
			$directory
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = __('Module settings were updated!');
}

// Check if target rubric has the chosen template allowed *********************************************
// $activeModules[$directory]['template']
// $activeModules[$directory]['rubric']


if (defined('CPOBACKEND') && $activeModules[$directory]['rubric'] != -1)  {
    $allowedTemplate = false;
    $db = new DB;
    $query = "SELECT templates_id "
            ."FROM ".CPO_TPL_ASSIGNMENT." "
            ."WHERE rubric_id='".$activeModules[$directory]['rubric']."' ";
    DEBUG(1, 'Load existing article-template assignments.'.$query, __FILE__, __LINE__);   
    $db->query($query);
    while($db->next_record()) {
        if ($db->v('templates_id') == $activeModules[$directory]['template']) $allowedTemplate = true;
    }

    if ($allowedTemplate === false) $message[] = __('The chosen template is not an allowed template in the chosen target rubric!') ;
}

// Check if Sendmail is chosen when using confirmation
// $activeModules[$directory]['confirm']
// $activeModules[$directory]['confirmation'] (mail|both)

// Formularauswertung mittels Parser ************************************************************
if (isset($_REQUEST['action']) && $_REQUEST['action']=="form") {


	$form_error = false;
    $mail_error = false;
    $form_mails = false;

	// Captcha-Check
	if ($activeModules[$directory]['captcha'] == "yes") {
		if(isset($_SESSION['captcha_spam']) && isset($_REQUEST["sicherheitscode"]) && $_REQUEST["sicherheitscode"] == $_SESSION['captcha_spam']){ 
			unset($_SESSION['captcha_spam']);
		} else {
			$message[] = $activeModules[$directory]['captcha_error'];
			$form_error = true;
		}
	}
   if (class_exists('antiCSRF')) {
	   if (!$antiCSRF->checkToken()) { 
			$message[] = ___('Security check failed. Please try again.'); 
			logaction('mod_form', 'CSRF check failed.'); 
			$form_error = true;
	   }
   }

	// Datei-Upload
	if ($activeModules[$directory]['upload']=="yes") {
		// um Dateien zu prfen brauchen wir schnell noch ein Feld
		// wenn error=0 dann schreiben wir den Namen ins Feld
		if (isset($_FILES['content']) && is_array($_FILES['content']['error'])) {
			foreach($_FILES['content']['error'] AS $fileplaceholder => $filedata)  {
				foreach($filedata AS $filetype => $fileerror)  {

					$_REQUEST['content'][$fileplaceholder][$filetype] = (!$fileerror) ? $fileplaceholder : '';
                    //echo $fileerror.'<br />'.$fileplaceholder.'<hr />';

					$extend = implode("|",explode(" ",trim($activeModules[$directory]['extensions'])));
					if (!preg_match("/($extend)/i", $_FILES['content']['name'][$fileplaceholder][$filetype]) && (
						isset($_FILES['content']['type'][$fileplaceholder]['image']) || isset($_FILES['content']['type'][$fileplaceholder]['file']) ) ) 
						{
						$message[] = sprintf($activeModules[$directory]['nonallowedExt'],
										$_FILES['content']['name'][$fileplaceholder][$filetype],				
										$activeModules[$directory]['extensions']);
						$form_error = true;
						$markAllFiles += 1;
					}
					if (array_key_exists('image',$_FILES['content']['type'][$fileplaceholder])  && 
						strpos($_FILES['content']['type'][$fileplaceholder]['image'],"image") === false &&
						$_FILES['content']['type'][$fileplaceholder]['image'])
					{
						$message[] = sprintf($activeModules[$directory]['warnImage'],
										$_FILES['content']['name'][$fileplaceholder][$filetype]);
						$form_error = true;
						$markAllFiles += 1;
					}
					if (array_key_exists('file',$_FILES['content']['type'][$fileplaceholder])  && 
						strpos($_FILES['content']['type'][$fileplaceholder]['file'],"text") === false &&
						strpos($_FILES['content']['type'][$fileplaceholder]['file'],"audio") === false &&
						strpos($_FILES['content']['type'][$fileplaceholder]['file'],"video") === false &&
						strpos($_FILES['content']['type'][$fileplaceholder]['file'],"application") === false &&
						$_FILES['content']['type'][$fileplaceholder]['file'])
					{
						$message[] = sprintf($activeModules[$directory]['warnFile'],
										$_FILES['content']['name'][$fileplaceholder][$filetype]);
						$form_error = true;
						$markAllFiles += 1;
					}
					$markAllFiles += $fileerror;
				}
			}
		}
	}

	// special_check.inc.php abarbeiten
    $special_check  = CPO_BASEDIR.$directory.'/includes/special_check.inc.php';
    if (!file_exists($special_check) || !is_readable($special_check)) $special_check .= '.dist'; // use dist files?
    if (file_exists($special_check) && is_readable($special_check)) include($special_check);

	// mal schauen, welche Felder "needed" sind
	include(CPO_BASEDIR.$directory.'/includes/form_parser.inc.php');
	$parsed_form = $template_datei;

	// jetzt wissen wir, ob es Fehler gibt!

	if ($form_error) 
	{
		$message[] = $activeModules[$directory]['defaultError'];
		if ($activeModules[$directory]['fileError'] && $activeModules[$directory]['upload']=="yes") $message[] = $activeModules[$directory]['fileError'];
		$displayAgain = true;
		$markAllFiles += 1;
	}
	else
	{
		$form_ok = true;

		// jetzt eintragen

		// Datei-Upload
		if ($activeModules[$directory]['upload']=="yes") {
			if (isset($_FILES['content']) && is_array($_FILES['content']['error']))  {
				foreach($_FILES['content']['error'] AS $fileplaceholder => $filedata)  {
					foreach($filedata AS $filetype => $fileerror)  {
						if ($fileerror!=0) {
							unset ($_FILES['content']['tmp_name'][$fileplaceholder][$filetype]);
						} else {
							include (CPO_BASEDIR.$directory.'/includes/fileupload.inc.php');
						}
					}
				}	
			}
		}

		if (isset($_REQUEST['nr']) && (int)$_REQUEST['nr']!=0) $data['nr'] = $_REQUEST['nr']; // editing existing entry
        $data['autor']			= (isset($data['autor'])) ? $data['autor'] : 'Anonymous';
		if ($activeModules[$directory]['release'] == 'yes')  $data['releasedby'] = (isset($data['autor'])) ? $data['autor'] : 'mod_form';
		$data['rubric_id']		= $activeModules[$directory]['rubric'];
		$data['titel']			= (isset($data['titel'])) ? $data['titel'] : __('Form input');
		$data['templates_id']	= $activeModules[$directory]['template'];
        if(strpos(",",$activeModules[$directory]['recipient'])!==false) { // more than 1 recipients given, only 1 needed
            $manyRecp = explode(",",$activeModules[$directory]['recipient']);
            $activeModules[$directory]['recipient'] = trim($manyRecp[0]);
        }
        if (isset($data['email']) && isset($data['autor']) && !empty($data['email']) && !empty($data['autor']))  { //ordentliche Mail-Adresse!
            $data['email'] = $data['autor'] . ' <' . $data['email']. '>';
        }
		$data['email']			= (isset($data['email'])) ? $data['email'] : $activeModules[$directory]['recipient'];

        // $message[] = htmlspecialchars($data['email'], ENT_COMPAT, 'ISO-8859-15');

		if (empty($data['pub_datum']))		$data['pub_datum']		= date('Y-m-d H:i:s', time());
		if ($activeModules[$directory]['auto_expire']=="yes")	$data['verfallsdatum']	= date('Y-m-d', time() + $activeModules[$directory]['expire_time']*86400 ) . ' 23:59:59';
		if (empty($data['verfallsdatum']))	$data['verfallsdatum']	= '2036-01-01 00:00:00';
        $data['usergroup'] = array();

		$article_nr = save_article($data);

		if ($activeModules[$directory]['release'] == 'no')  {  // Artikel sofort sperren!
			$query = sprintf(
					 "UPDATE ".CPO_NEWS." SET artikel_archiv = 0, freigabe = 2 WHERE nr = '%s'", 
					$article_nr
			);
			DEBUG(1, $query, __FILE__, __LINE__);
			$db_block = new DB;
			$db_block->query($query); 
		}

		if ($article_nr)
		{

			// Mail-Inhalt vorbereiten
			$db_nr					= $article_nr;
			$db_autor				= $data['autor'];
			$db_email				= $data['email'];
			$db_initial				= 'form';
			$db_template			= $data['templates_id'];
			$db_idx					= (isset($data['idx'])) ? $data['idx'] : 'zzzzzz';
			$db_pub_datum			= $data['pub_datum'];
			$db_verfallsdatum		= $data['verfallsdatum'];
			$db_titel				= $data['titel'];
			$db_changer				= 'mod_form';
			$db_rubric_id			= $data['rubric_id'];
			$db_last_modify			= date('Y-m-d H:i:s', time());
			$template_datei_full	= $db_2->v('tpl_javascript')."\n";
			$template_datei			= $db_2->v('tpl_javascript');
			$templates_id			= $template;

			$form_mails = true;
			require(CPO_BASEDIR.'_include/parser.php');
			$nachricht = $template_datei;
            $contentType = 'Content-Type: text/plain;' . $newline;
            setlocale(LC_ALL, 'de_DE');

            /* Notice:
            if any problem encounter with mb_encoding (missing characters, empty mails) you need to work on the ini-settings!
            default_charset = "iso-8859-1" 
            mbstring.internal_encoding = "iso-8859-1"
			*/
            
            $fparm = (isset($activeModules[$directory]['envelope']) && trim($activeModules[$directory]['envelope']) != '') ? $fparm = '-f'.$activeModules[$directory]['envelope'] : '' ;

            // Mail an Admin? **********************************************************************************************
			if( 
                ($activeModules[$directory]['mail']=="yes" && $activeModules[$directory]['confirm'] == 'no') ||
                ($activeModules[$directory]['confirm'] == 'yes' && (
                    ($activeModules[$directory]['a0']=='yes' && !isset($_POST['step'])) ||
                    //($activeModules[$directory]['as']=='yes') ||
                    ($activeModules[$directory]['a1']=='yes' && isset($_POST['step']) && $_POST['step']=='1') ||
                    ($activeModules[$directory]['a2']=='yes' && isset($_POST['step']) && $_POST['step']=='2') ||
                    ($activeModules[$directory]['a3']=='yes' && isset($_POST['step']) && $_POST['step']=='3')
                        )
                )
              )
			{
				$empfaenger = $activeModules[$directory]['recipient'];
				$betreff = $activeModules[$directory]['mail_prefix'].sprintf($activeModules[$directory]['subject'],$data['titel']);
				if ( $activeModules[$directory]['encoding'])  {
					if ($activeModules[$directory]['encoding']=='default')  $encoding = iconv_get_encoding('output_encoding');
					else if ($activeModules[$directory]['encoding']=='iso')  $encoding = 'ISO-8859-1';
					else if ($activeModules[$directory]['encoding']=='iso15')  $encoding = 'ISO-8859-15';
					else if ($activeModules[$directory]['encoding']=='utf8')  $encoding = 'UTF-8';
                    $betreff = mb_encode_mimeheader( $betreff, $encoding, "Q", $newline);
                    $empfaenger = mf_encode_Recipients($empfaenger, $encoding);
                    $nachricht = mf_decode_entities($template_datei);
					$nachricht = mb_convert_encoding($nachricht, $encoding, mb_detect_encoding ($nachricht) );
					//$nachricht = iconv(mb_detect_encoding ($nachricht), $encoding, $nachricht );
					$contentType = 'Content-Type: text/plain; format=flowed; charset="'.$encoding . '"' . $newline;
				}
                //echo $empfaenger;

                // setting sender to prevent spam protection
                // this is the mail to the recipient/admin, use the sender settings
                $from = $data['email'];
                if (isset($activeModules[$directory]['senderUsage']) && isset($activeModules[$directory]['sender']) && $activeModules[$directory]['senderUsage'] == 'sender') $from = $activeModules[$directory]['sender'];
                if (isset($activeModules[$directory]['senderUsage']) && isset($activeModules[$directory]['recipient']) && $activeModules[$directory]['senderUsage'] == 'recipient') $from = $activeModules[$directory]['recipient'];
                if (isset($activeModules[$directory]['senderUsage']) && isset($activeModules[$directory]['user']) && $activeModules[$directory]['senderUsage'] == 'user') $from = $activeModules[$directory]['user'];

                $from = mf_encode_Recipients($from, $encoding);

				$header = 'From: '. $from . $newline .
				   'Reply-To: '.mf_encode_Recipients($data['email'], $encoding) . $newline .
			       $contentType . 
				   'X-Mailer: mod_form by conpresso4.de via PHP/' . phpversion();
                
                // Admin-Version erzeugen (user entfernen, remail entfernen, admin entkommentieren)
                $admin_nachricht = preg_replace(array(
                    '/<!--\s*cc\s*-->.*?<!--\s*\/cc\s*-->/msi',
                    '/<!--\s*bcc\s*-->.*?<!--\s*\/bcc\s*-->/msi',
                    '/<!--\s*user\s*-->.*?<!--\s*\/user\s*-->/msi',
                    '/<!--\s*remail\s*-->.*?<!--\s*\/remail\s*-->/msi',
                    '/<!--\s*admin\s*-->/si',
                    '/<!--\s*\/admin\s*-->/si')
                    , '', $nachricht);

				if (mail($empfaenger, $betreff, mf_decode_entities($admin_nachricht), $header, $fparm) )  {
                    logaction('form input', $data['titel']);
                    logaction('mail to admin', $data['titel']);
                } else {
                    logaction('MAIL ERROR!', $data['titel'] . ' / Error message: ' . error_get_last()['message']);
                    $mail_error = true;
                }
			}
			if( 
                ($activeModules[$directory]['mail']=="yes" && $activeModules[$directory]['confirm'] == 'no'
                    && isset($activeModules[$directory]['cc']) && trim($activeModules[$directory]['cc'])!='') ||
                ($activeModules[$directory]['confirm'] == 'yes' 
                        && isset($activeModules[$directory]['cc']) 
                        && trim($activeModules[$directory]['cc'])!='' && (
                    ($activeModules[$directory]['c0']=='yes' && !isset($_POST['step'])) ||
                    //($activeModules[$directory]['as']=='yes') ||
                    ($activeModules[$directory]['c1']=='yes' && isset($_POST['step']) && $_POST['step']=='1') ||
                    ($activeModules[$directory]['c2']=='yes' && isset($_POST['step']) && $_POST['step']=='2') ||
                    ($activeModules[$directory]['c3']=='yes' && isset($_POST['step']) && $_POST['step']=='3')
                        )
                )
              )
			{ // CC-Mail
                // CC-Version erzeugen (admin entfernen, bcc entfernen, user entfernen, remail entfernen, cc entkommentieren)
                $cc_nachricht = preg_replace(array(
                    '/<!--\s*admin\s*-->.*?<!--\s*\/admin\s*-->/msi',
                    '/<!--\s*bcc\s*-->.*?<!--\s*\/bcc\s*-->/msi',
                    '/<!--\s*user\s*-->.*?<!--\s*\/user\s*-->/msi',
                    '/<!--\s*remail\s*-->.*?<!--\s*\/remail\s*-->/msi',
                    '/<!--\s*cc\s*-->/si',
                    '/<!--\s*\/cc\s*-->/si')
                    , '', $nachricht);
                $empfaenger = $activeModules[$directory]['cc'];
				if ( $activeModules[$directory]['encoding'])  {
					if ($activeModules[$directory]['encoding']=='default')  $encoding = iconv_get_encoding('output_encoding');
					else if ($activeModules[$directory]['encoding']=='iso')  $encoding = 'ISO-8859-1';
					else if ($activeModules[$directory]['encoding']=='iso15')  $encoding = 'ISO-8859-15';
					else if ($activeModules[$directory]['encoding']=='utf8')  $encoding = 'UTF-8';
                    $empfaenger = mf_encode_Recipients($empfaenger, $encoding);
                }
				if (mail($empfaenger, $betreff, mf_decode_entities($cc_nachricht), $header, $fparm) )  {
                    logaction('mail to cc', $data['titel']);
                } else {
                    logaction('MAIL ERROR!', $data['titel'] . ' / Error message: ' . error_get_last()['message']);
                    $mail_error = true;
                }
            }
			if( 
                ($activeModules[$directory]['mail']=="yes" && $activeModules[$directory]['confirm'] == 'no'
                    && isset($activeModules[$directory]['bcc']) && trim($activeModules[$directory]['bcc'])!='') ||
                ($activeModules[$directory]['confirm'] == 'yes' 
                        && isset($activeModules[$directory]['bcc']) 
                        && trim($activeModules[$directory]['bcc'])!='' && (
                    ($activeModules[$directory]['b0']=='yes' && !isset($_POST['step'])) ||
                    //($activeModules[$directory]['as']=='yes') ||
                    ($activeModules[$directory]['b1']=='yes' && isset($_POST['step']) && $_POST['step']=='1') ||
                    ($activeModules[$directory]['b2']=='yes' && isset($_POST['step']) && $_POST['step']=='2') ||
                    ($activeModules[$directory]['b3']=='yes' && isset($_POST['step']) && $_POST['step']=='3')
                        )
                )
              )
			{ // BCC-Mail
                // BCC-Version erzeugen (admin entfernen, cc entfernen, user entfernen, remail entfernen, cc entkommentieren)
                $cc_nachricht = preg_replace(array(
                    '/<!--\s*admin\s*-->.*?<!--\s*\/admin\s*-->/msi',
                    '/<!--\s*cc\s*-->.*?<!--\s*\/cc\s*-->/msi',
                    '/<!--\s*user\s*-->.*?<!--\s*\/user\s*-->/msi',
                    '/<!--\s*remail\s*-->.*?<!--\s*\/remail\s*-->/msi',
                    '/<!--\s*bcc\s*-->/si',
                    '/<!--\s*\/bcc\s*-->/si')
                    , '', $nachricht);
                $empfaenger = $activeModules[$directory]['bcc'];
				if ( $activeModules[$directory]['encoding'])  {
					if ($activeModules[$directory]['encoding']=='default')  $encoding = iconv_get_encoding('output_encoding');
					else if ($activeModules[$directory]['encoding']=='iso')  $encoding = 'ISO-8859-1';
					else if ($activeModules[$directory]['encoding']=='iso15')  $encoding = 'ISO-8859-15';
					else if ($activeModules[$directory]['encoding']=='utf8')  $encoding = 'UTF-8';
                    $empfaenger = mf_encode_Recipients($empfaenger, $encoding);
                }
				if (mail($empfaenger, $betreff, mf_decode_entities($cc_nachricht), $header, $fparm) )  {
                    logaction('mail to bcc', $data['titel']);
                } else {
                    logaction('MAIL ERROR!', $data['titel'] . ' / Error message: ' . error_get_last()['message']);
                    $mail_error = true;
                }
            }

            if ($activeModules[$directory]['confirmation']!="none")
			{
//				if ($activeModules[$directory]['confirmation']=="mail" || $activeModules[$directory]['confirmation']=="both")

                if( 
                    ($activeModules[$directory]['confirmation']=="mail" || $activeModules[$directory]['confirmation']=="both" && $activeModules[$directory]['confirm'] == 'no') ||
                    ($activeModules[$directory]['confirm'] == 'yes' && (
                        ($activeModules[$directory]['u0']=='yes' && !isset($_POST['step'])) ||
                        //($activeModules[$directory]['us']=='yes') ||
                        ($activeModules[$directory]['u1']=='yes' && isset($_POST['step']) && $_POST['step']=='1') ||
                        ($activeModules[$directory]['u2']=='yes' && isset($_POST['step']) && $_POST['step']=='2') ||
                        ($activeModules[$directory]['u3']=='yes' && isset($_POST['step']) && $_POST['step']=='3')
                            )
                    )
                  )
                {
					// Besttigungs-Mail an User ********************************************************************
					$empfaenger = $data['email'];
					$betreff = sprintf($activeModules[$directory]['subject'],$data['titel']);
					if ( $activeModules[$directory]['encoding'] )  {
                        //var_dump(iconv_get_encoding('all'));
						if ($activeModules[$directory]['encoding']=='default')  $encoding = iconv_get_encoding('output_encoding');
						else if ($activeModules[$directory]['encoding']=='iso')  $encoding = 'ISO-8859-1';
					    else if ($activeModules[$directory]['encoding']=='iso15')  $encoding = 'ISO-8859-15';
						else if ($activeModules[$directory]['encoding']=='utf8')  $encoding = 'UTF-8';
                        $betreff = mb_encode_mimeheader( $betreff, $encoding, "Q", $newline);
                        $empfaenger = mf_encode_Recipients($empfaenger, $encoding);
                        $nachricht = mf_decode_entities($template_datei);
                        $nachricht = mb_convert_encoding($nachricht, $encoding, mb_detect_encoding ($nachricht) );
                        $contentType = 'Content-Type: text/plain; format=flowed; charset="'.$encoding . '"' . $newline;
					}

                    // setting sender to prevent spam protection
                    // this is the mail to the user, always use the sender!
                    $from = $data['email'];
                    if (isset($activeModules[$directory]['sender']) && trim($activeModules[$directory]['sender']) != '') $from = $activeModules[$directory]['sender'];

                    $from = mf_encode_Recipients($from, $encoding);

                    $header = 'From: '. $from . $newline .
					   'Reply-To: '. $from . $newline .
					   $contentType . 
					   'X-Mailer: mod_form by conpresso4.de via PHP/' . phpversion();

                    // User-Version erzeugen (admin entfernen, remail entfernen, user entkommentieren)
                    $user_nachricht = preg_replace(array(
                        '/<!--\s*admin\s*-->.*?<!--\s*\/admin\s*-->/msi',
                        '/<!--\s*cc\s*-->.*?<!--\s*\/cc\s*-->/msi',
                        '/<!--\s*bcc\s*-->.*?<!--\s*\/bcc\s*-->/msi',
                        '/<!--\s*remail\s*-->.*?<!--\s*\/remail\s*-->/msi',
                        '/<!--\s*user\s*-->/si',
                        '/<!--\s*\/user\s*-->/si')
                        , '', $nachricht);

                    if (mail($empfaenger, $betreff, mf_decode_entities($user_nachricht), $header, $fparm) )  {
                        logaction('confirmation mail', $data['titel']);
                    } else {
                        logaction('MAIL ERROR!', $data['titel'] . ' / Error message: ' . error_get_last()['message']);
                        $mail_error = true;
                    }
				}

				if ($activeModules[$directory]['confirmation']=="page" || $activeModules[$directory]['confirmation']=="both")
				{
					// Besttigungs-Seite
					$db_nr = $article_nr;
					$template_datei_full = $db_2->v('tpl_detail')."\n";
					$template_datei = $db_2->v('tpl_detail');
					$templates_id = $template;

					require(CPO_BASEDIR.'_include/parser.php');
					$message[] = sprintf($activeModules[$directory]['subject'],$data['titel']) . ':<br />' . $template_datei; 
				}
			}

            if (!$mail_error) $message[] = $activeModules[$directory]['successMessage'].$activeModules[$directory]['conversionCode'];

			// Artikel lschen, wenn keine Rubrik zum Speichern gewhlt wurde
			if ($activeModules[$directory]['rubric'] == "-1") {
				$db_delentry = new DB;
				$query_delete = "DELETE FROM ".CPO_NEWS." WHERE nr = ".$article_nr;
				$db_delentry->query($query_delete); 
				$query_delete = "DELETE FROM ".CPO_CONTENT_FILES." WHERE article_id = ".$article_nr;
				$db_delentry->query($query_delete);
				$query_delete = "DELETE FROM ".CPO_CONTENT_HTML." WHERE article_id = ".$article_nr;
				$db_delentry->query($query_delete);
				$query_delete = "DELETE FROM ".CPO_CONTENT_IMAGES." WHERE article_id = ".$article_nr;
				$db_delentry->query($query_delete);
				$query_delete = "DELETE FROM ".CPO_CONTENT_TEXT." WHERE article_id = ".$article_nr;
				$db_delentry->query($query_delete);
				$query_delete = "DELETE FROM ".CPO_CONTENT_URLS." WHERE article_id = ".$article_nr;
				$db_delentry->query($query_delete);
			}

            // success!
            $form_success = true;
		}
		else
		{
			$message[] = __('An error occured while trying to save your article!');
		}
	
	}
}
?>