<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Form"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1e / July 2013 ==

*/


if (!function_exists('mf_encode_Recipients')) {
    function mf_encode_Recipients($recpString, $encoding)  {
        global $newline;
        $recpArray = explode (",", $recpString);
        foreach($recpArray AS $k=>$recp)  {
            if (strpos($recp, "<")===false) continue;
            $recpArr = explode("<",trim($recp));
            $name = mb_encode_mimeheader(trim($recpArr[0]), $encoding, "Q", $newline);
            $recpArray[$k] = $name . " <" . $recpArr[1];
        }
        $recpString = implode(", ",$recpArray);
        return $recpString;
    }
}

if (!function_exists('mf_decode_entities')) {
    function mf_decode_entities($text) {
         $text= html_entity_decode($text,ENT_QUOTES,"ISO-8859-15"); #once
         $text= html_entity_decode($text,ENT_QUOTES,"ISO-8859-15"); #twice
         $text= preg_replace_callback('/&#(\d+);/m',function ($m) { return chr($m[1]); },$text); #decimal notation
         $text= preg_replace_callback('/&#x([a-f0-9]+);/mi',function ($m) { return chr("0x".$m[1]); },$text);  #hex notation
         return $text;
    }
}


if (!function_exists('autoLogin')) {
    function autoLogin()  {
        global $activeModules, $directory, $step, $usergroup_OK;
        if ($activeModules[$directory]['confirmuser'] != 0) // Uaer einloggen
        {
            
            $hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
            $hostaddr = gethostbyname($_SERVER['REMOTE_ADDR']);

            // hier den User einloggen
            $db = new DB;
            $query = "SELECT id, name, admin, email, initial, usergroups_id, editor, language, passwd, changer "
                    ."FROM ".CPO_USER." "
                    ."WHERE admin>=0 "
                    .'AND id='.$activeModules[$directory]['confirmuser'];
            $db->query($query);
            $db->next_record();
            $_SESSION['SID_user']          = array(
                                                'id'=>$db->v('id'), 
                                                'usergroups_id'=>$db->v('usergroups_id'),
                                                'editor'=>$db->v('editor'), 
                                                'initial'=>$db->v('initial'),
                                                'email'=>$db->v('email'),
                                                'admin'=>$db->v('admin'),
                                                'language'=>$db->v('language'),
                                                'name'=>$db->v('name')
                                            );
            $_SESSION['SID_IP']             = $hostaddr;
            $_SESSION['SID_login'] = '';
            if (isset($_SESSION['SID_user']['name'])) $_SESSION['SID_login'] = $_SESSION['SID_user']['name'];

            // user was not logged in yet?
            if (!isset($_SESSION['SID_log_login_id'])) {
                $query = "INSERT INTO ".CPO_LOG_LOGIN." "
                        ."(user_id, login, last_action, ip, ip_name, browser) "
                        ."VALUES ("
                        ."'".addslashes($_SESSION['SID_user']['id'])."', " // user_id
                        ."'".date('Y-m-d H:i:s')."', "                     // login
                        ."'".date('Y-m-d H:i:s')."', "                     // last_action
                        ."'".addslashes($hostaddr)."', "                   // ip
                        ."'".addslashes($hostname)."', "                   // ip_name
                        ."'".$_SERVER['HTTP_USER_AGENT']."') ";            // browser
                $db->query($query);

                $query = "SELECT last_insert_id()";
                $db->query($query);
                $db->next_record();
                $_SESSION['SID_log_login_id'] = $db->v('last_insert_id()');

                logaction('login by mod_form', 'Stufe: '.$step);
            }
            $usergroup_OK = FALSE;

            // personalized rubrics always allow access
            if ($GLOBALS['cpoRubric']['seclevel']==SECLEVEL_PERSONALIZED
            || $GLOBALS['cpoRubric']['seclevel']==SECLEVEL_PUBLIC) 
                $usergroup_OK = true;

            // check all allowed usergroups
            $query = 'SELECT usergroups_id ' .
                     'FROM ' . CPO_RUBRIC_PERMISSION . ' ' .
                     'WHERE rubric_id = ' . (int)$GLOBALS['cpoRubric']['id'];
            $db->query($query);

            while($db->next_record()){
                if ($db->v('usergroups_id')!=$_SESSION['SID_user']['usergroups_id'])  continue;
                $usergroup_OK = true;
                break;
            }
        }
    }
}

// Achtung! Aufgrund dieser Funktion mssen Upload-Felder KEINES der Elemente des find-Array im Namen haben!
// sollte entfernt werden!
if (!function_exists('keyFix'))  {
	function keyFix($key)
	{
	  $find = array (" ",".","[","]","%","","$","?","=");
	  $replace = array ("_");
	  return str_replace($find,$replace,$key);
	}
}


if (!function_exists('checkURLsyntax'))  {
	function checkURLsyntax($url)
	{
		if(!preg_match("/(http|https)+(:\/\/)+[a-z0-9\/\.\_\?\&\=\#\:\-]+/i", $url)) { 
			return false; 
		} else {
			return true; 
		}
	}
}

if (!function_exists('modHelp'))  {
	function modHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

if (!function_exists('formlistTTFfiles'))  {
	function formlistTTFfiles($dir)  {
		$h = opendir($dir);
		while($file = readdir($h))  {
			if ($file != "." AND $file != ".." AND !is_dir($dir.$file) AND strtolower(substr($file,-4)) == ".ttf")  {
				$ttffiles[] = $file;
			}
		}
		closedir($h);
		return $ttffiles;
	}
}

if(!function_exists('formlistImageFiles')) {
	function formlistImageFiles($dir)  {
		$h = opendir($dir);
		while($file = readdir($h))  {
			if ($file != "." AND $file != ".." AND !is_dir($dir.$file) AND strtolower(substr($file,-4)) == ".png")  {
				$image_files[] = $file;
			}
		}
		closedir($h);
		return $image_files;
	}
}

