<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Form"					                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1e / July 2013 ==

*/

if (!defined('CPO')) exit;

global $content, $key, $parameters, $replacement, $_name, $activeModules, $directory, $form_error, $data, $markAllFiles, $step;

if (!defined('FORM')) define('FORM', true);

initVar($input_id,NULL);
initVar($input_size,NULL);
initVar($input_maxlength,NULL);
initVar($input_rows,NULL);
initVar($input_cols,NULL);
initVar($input_class,NULL);
initVar($input_value,NULL);
initVar($disabled,NULL);

initVar($_t,'');
initVar($parameters['content'],NULL);

// Das Template fr die Fehlermeldungen
$_err_tpl = $activeModules[$directory]['error_template'];
// Das Array der zu ersetzenden Platzhalter
$_err_search = array ('### ERROR_MESSAGE ###','### FORM_FIELD ###');

//Funktion E-Mailadresse auf Format testen 
//aus mod_contact von seventy-soft.de
if (!function_exists('check_form_email'))  {
	function check_form_email($email) {

		  // RegEx begin
		  $nonascii      = "\x80-\xff"; # Non-ASCII-Chars are not allowed

		  $nqtext        = "[^\\\\$nonascii\015\012\"]";
		  $qchar         = "\\\\[^$nonascii]";

		  $protocol      = '(?:mailto:)';

		  $normuser      = '[a-zA-Z0-9][a-zA-Z0-9_.-]*';
		  $quotedstring  = "\"(?:$nqtext|$qchar)+\"";
		  $user_part     = "(?:$normuser|$quotedstring)";

		  $dom_mainpart  = '[a-zA-Z0-9][a-zA-Z0-9._-]*\\.';
		  $dom_subpart   = '(?:[a-zA-Z0-9][a-zA-Z0-9._-]*\\.)*';
		  $dom_tldpart   = '[a-zA-Z]{2,5}';
		  $domain_part   = "$dom_subpart$dom_mainpart$dom_tldpart";

		  $regex         = "$protocol?$user_part\@$domain_part";
		  // RegEx end

		  return preg_match("/^$regex$/",$email);
	}
}
if (!function_exists('checkInputDate'))  {
	function checkInputDate($date='')
	{
		if($date!='')
		{
			$date_a = explode(".",$date);
			$year  = ($date_a[2]) ? $date_a[2] : date("Y");
			$month = ($date_a[1]) ? $date_a[1] : date("n");
			$day   = ($date_a[0]) ? $date_a[0] : date("j");
			return @checkdate ($month , $day , $year);
		}
	}
}

if (!function_exists('completeInputDate'))  {
	function completeInputDate($date='')
	{
		if($date!='')
		{
			$date_a = explode(".",$date);
			$year  = ($date_a[2]) ? $date_a[2] : date("Y");
			$month = ($date_a[1]) ? $date_a[1] : date("n");
			$day   = ($date_a[0]) ? $date_a[0] : date("j");
			return date("j.n.Y",mktime(0,0,0,$month,$day,$year));
		}
	}
}

if (isset($content[$key]['input'])) $_t = $content[$key]['input'];
//$field_name = urlencode($_name);
$field_name = $_name;

// default als Text
if (!array_key_exists('type', $parameters)) {
    $parameters['type'] = 'text';
}

if (array_key_exists('id', $parameters)) { 
    $input_id = ' id="'.$parameters['id'].'"'; 
}

if (array_key_exists('size', $parameters)) {
    $input_size = ' size="'.$parameters['size'].'"';
}

if (array_key_exists('maxlength', $parameters)) { 
    $input_maxlength = ' maxlength="'.$parameters['maxlength'].'"'; 
} 

if (array_key_exists('rows', $parameters)) {
    $input_rows = ' rows="'.$parameters['rows'].'"';
}

if (array_key_exists('cols', $parameters)) {
    $input_cols = ' cols="'.$parameters['cols'].'"';
}

if (array_key_exists('class', $parameters)) {
    $input_class = ' class="'.$parameters['class'].'"';
}

if (array_key_exists('value', $parameters)) {
    $input_value = $parameters['value'];
}

if (array_key_exists('disabled', $parameters)) {
    $disabled = ' disabled';
}

if (array_key_exists('gettext', $parameters)) {
    $_t = $content[$key]['text'];
}

if (array_key_exists('author', $parameters)) {
    $data['autor'] = $_t;
}

if (array_key_exists('authoremail', $parameters)) {
    $data['email'] = $_t;
}

if (array_key_exists('datecheck', $parameters)) {
    $_t = completeInputDate($_t);
}

if (array_key_exists('datecheck', $parameters) && array_key_exists('idx', $parameters)) {
	$date_a = explode(".",$_t);
	$year  = ($date_a[2]) ? $date_a[2] : date("Y");
	$month = ($date_a[1]) ? $date_a[1] : date("m");
	$day   = ($date_a[0]) ? $date_a[0] : date("d");
	$data['idx'] = date("ymd",mktime(0,0,0,$month,$day,$year));
}

if (!array_key_exists('datecheck', $parameters) && array_key_exists('idx', $parameters)) {
	$data['idx'] = substr($_t,0,6);
}

// Y-m-d H:i:s
// wir gehen von deutschen Formaten d.m.j aus! // FIXME kriegen wir das noch angepasst?
if (array_key_exists('verfallsdatum', $parameters) && $_t!='') {
	$_t_array = explode(".", trim($_t));
	$year  = ($_t_array[2]) ? $_t_array[2] : date("Y");
	$month = ($_t_array[1]) ? $_t_array[1] : date("m");
	$day   = ($_t_array[0]) ? $_t_array[0] : date("d");
	$data['verfallsdatum']    = sprintf("%04d-%02d-%02d 00:00:00", $year, $month, $day); 
}

if (array_key_exists('pub_datum', $parameters)) {
	$_t_array = explode(".", trim($_t));
	$year  = ($_t_array[2]) ? $_t_array[2] : date("Y");
	$month = ($_t_array[1]) ? $_t_array[1] : date("m");
	$day   = ($_t_array[0]) ? $_t_array[0] : date("d");
	$data['pub_datum']    = sprintf("%04d-%02d-%02d 00:00:00", $year, $month, $day); 
}

if (array_key_exists('title', $parameters)) {
    $data['titel'] = (isset($data['titel'])) ? $data['titel'].$activeModules[$directory]['divider'].$_t : $_t;
}

if (array_key_exists('recipient', $parameters)) { // find the right recipient
	// $activeModules[$directory]['recipient']
    $recpArray = explode (",", $activeModules[$directory]['recipient']);
    foreach($recpArray AS $recp)  {
        $recpArr = explode("<",$recp);
        if (trim($content[$key]['input']) == trim($recpArr[0]))  { // match!
            $activeModules[$directory]['recipient'] = trim($recp);
        }
    }
}


// Felder je nach Step sperren
// step = 0 alle Felder offen
// step > 0 nur Felder >= step bleiben offen
if (isset($step) && $step>0)  {
    if (array_key_exists('step', $parameters) && (int)$parameters['step'] >= $step ) {
        // keep it open
    } else {
        if (isset($content[$key]['input'])) $data['content'][$field_name.' ('.$parameters['content'].')'][$parameters['content']] = htmlspecialchars($content[$key]['input'], ENT_COMPAT, 'ISO-8859-15');
        if ($parameters['type'] == "checkbox") {
            $_t = (trim($_t) != '') ? '[x]<input type="hidden" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.$_t.'" />' : '[ ]<input type="hidden" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.$_t.'" />';
            $replacement = $_t;
            return;
        }
        $_t = (trim($_t) != '') ? 
            '<span'.$input_class.'>'.$_t.'</span><input type="hidden" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.$_t.'" />' : 
            '<input type="hidden" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.$_t.'" />';
        $replacement = $_t;
        return;
    }
}

if ($parameters['type'] == "textarea")  {
	$_t = '<textarea name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']"'.$input_rows.$input_cols.$input_id.$input_class.$disabled.'>'.$_t.'</textarea>';
}

if ($parameters['type'] == "text")  {
	$_t = '<input type="text" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.$_t.'"'.$input_size.$input_maxlength.$input_id.$input_class.$disabled.' />';
    if ($parameters['content'] == "url")  {
        $_t .= '<input type="hidden" name="content['.$field_name.' ('.$parameters['content'].')][urltext]" value="" />';
        $_t .= '<input type="hidden" name="content['.$field_name.' ('.$parameters['content'].')][urltarget]" value="" />';
        $data['content'][$field_name.' (url)']['urltext'] = '';
        $data['content'][$field_name.' (url)']['urltarget'] = '';
    }
}

// File-Upload
/*
if ($parameters['type'] == "upload")  {
	$_t = '<input type="file" name="'.$field_name.'" '.$input_size.$input_class.$disabled.' />';
}
*/
// File-Upload
if ( ($parameters['content'] == "image" || $parameters['content'] == "file") && $parameters['type'] != "hidden" )  {
	$_t = '<input type="file" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" '.$input_size.$input_class.$disabled.' />';
}

if ($parameters['type'] == "fixed")  {
	$_t = ($_t) ? 
		'<span'.$input_class.'>'.$_t.'</span><input type="hidden" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.$_t.'" />' : 
		'<input type="hidden" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.$_t.'" />';
}

if ($parameters['type'] == "datepicker")  {
	$_t = '<input id="date" onclick="javascript:void(0);" type="text" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.$_t.'"'.$input_size.$input_class.' /><a href="#" onclick="javascript: show_calendar_widget(this);return false;" id="date_link" class="calendar-link"><img src="./pics/pick.gif" border="0"></a>';
}

if ($parameters['type'] == "hidden")  {
	$_t = '<input type="hidden" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.$_t.'"'.$input_id.' />';
}

if ($parameters['type'] == "radio")  { 
   $checked = (array_key_exists('checked', $parameters)) ? ' checked="checked"' : ''; 
   if ($_REQUEST['action']=="form" || $_REQUEST['fillForm']) $checked = ($_t==$input_value) ? ' checked="checked"' : ''; 
   $_t = '<input type="radio" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.$input_value.'"'.$input_id.$input_class.$checked.$disabled.' />'; 
} 

if ($parameters['type'] == "checkbox")  { 
   $checked = (array_key_exists('checked', $parameters)) ? ' checked="checked"' : ''; 
   if ($_REQUEST['action']=="form" || $_REQUEST['fillForm']) $checked = ($_t) ? ' checked="checked"' : ''; 
   $_t = '<input type="checkbox" name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']" value="'.(($input_value)?$input_value:1).'"'.$input_id.$input_class.$checked.$disabled.' />'; 
} 

// NEU: Select-Feld aus Datenbank fllen
// Wichtig -> Der Wert mu als "value" ausgegeben werden, also "SELECT fieldname AS value ..."
if ($parameters['type'] == "select" && array_key_exists('sql2values', $parameters))  {
	$db_values = new DB;
	$db_values->query($parameters['sql2values']);
	$_t = '<select name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']"'.$input_size.$input_id.$input_class.$disabled.'>';
	if (array_key_exists('needed', $parameters) || array_key_exists('blank', $parameters)) {
		$_t .= '<option value=""></option>';
	}
	while ($db_values->next_record()) {
		$_v = $db_values->v('value');
		$selected = ($content[$key]['input']==$_v) ? ' selected="selected"' : '';
		$_t .= '<option value="'.$_v.'"'.$selected.'>'.$_v.'</option>';
	}
	$_t .= '</select>';
}

if ($parameters['type'] == "select" && array_key_exists('values', $parameters))  {
	$values = explode(",",$parameters['values']);
	$_t = '<select name="content['.$field_name.' ('.$parameters['content'].')]['.$parameters['content'].']"'.$input_size.$input_id.$input_class.$disabled.'>';
	foreach($values AS $_v)
	{
		$selected = ($content[$key]['input']==$_v) ? ' selected="selected"' : '';
		$_t .= '<option value="'.$_v.'"'.$selected.'>'.$_v.'</option>';
	}
	$_t .= '</select>';
}

// Prfungen: needed, mailcheck, datecheck etc.
if ( isset($_REQUEST['error'][$key]) || (array_key_exists('needed', $parameters) && (trim($content[$key]['input'])=='' ) || ( $markAllFiles && ($parameters['content'] == "image" || $parameters['content'] == "file") ) ) && isset($_REQUEST['action']) && $_REQUEST['action']=="form") {
	$_err_replace = array();
	if (isset($_REQUEST['error'][$key]) && is_string($_REQUEST['error'][$key])) {
		$_err_replace[0] = $_REQUEST['error'][$key];
	} elseif (isset($parameters['needed'])) {
		$_err_replace[0] = ( $parameters['needed']==1 || isset($_REQUEST['error'][$key])) ? $activeModules[$directory]['defaultInputError'] : $parameters['needed'];
	}
	$_err_replace[1] = $_t;
    $_t = str_replace($_err_search,$_err_replace,$_err_tpl);
	$form_error = true;
	$markAllFiles += 1;
}

if (isset($content[$key]['input']) && trim($content[$key]['input'])!='' && array_key_exists('mailcheck', $parameters) && !check_form_email($content[$key]['input'])) {
	$_err_replace = array (
		($parameters['mailcheck']==1) ? __('invalid mail-adress') : $parameters['mailcheck'],
		$_t
		);
    $_t = str_replace($_err_search,$_err_replace,$_err_tpl);
	$form_error = true;
	$markAllFiles += 1;
}

if (isset($content[$key]['input']) && trim($content[$key]['input'])!='' && array_key_exists('datecheck', $parameters) && !checkInputDate($content[$key]['input'])) {
	$_err_replace = array (
		($parameters['datecheck']==1) ? __('invalid date') : $parameters['datecheck'],
		$_t
		);
    $_t = str_replace($_err_search,$_err_replace,$_err_tpl);
	$form_error = true;
	$markAllFiles += 1;
}

if (isset($content[$key]['input']) && trim($content[$key]['input'])!='' && array_key_exists('urlcheck', $parameters) && !checkURLsyntax($content[$key]['input'])) {
	$_err_replace = array (
		($parameters['urlcheck']==1) ? __('invalid url') : $parameters['urlcheck'],
		$_t
		);
    $_t = str_replace($_err_search,$_err_replace,$_err_tpl);
	$form_error = true;
	$markAllFiles += 1;
}

if (isset($displayAgain) && $markAllFiles && ($parameters['content'] == "image" || $parameters['content'] == "file")) {
    $_t = str_replace($_err_search,$_err_replace,$_err_tpl);
	$form_error = true;
	$markAllFiles += 1;
}

$data['content'][$field_name.' ('.$parameters['content'].')'][$parameters['content']] = (isset($content[$key]['input'])) ? htmlspecialchars($content[$key]['input'], ENT_COMPAT, 'ISO-8859-15') : '' ;

// confirm-actions
if ($content[$key]['name'] == 'confirm')  {
	$_t = $content[$key]['text'];
}
if ($content[$key]['name'] == 'delete')  {
	$_t = $content[$key]['text'];
}
if ($content[$key]['name'] == 'block')  {
	$_t = $content[$key]['text'];
}
if ($content[$key]['name'] == 'expire')  {
	$_t = $content[$key]['text'];
}
if ($content[$key]['name'] == 'step1')  {
	$_t = $content[$key]['text'];
}
if ($content[$key]['name'] == 'step2')  {
	$_t = $content[$key]['text'];
}
if ($content[$key]['name'] == 'step3')  {
	$_t = $content[$key]['text'];
}
// NEW hash
if (array_key_exists('hash', $parameters)) {
	$_t = $content[$key]['hash'];
}

if ( $parameters['content'] == "image" && $parameters['type'] == "hidden" )  {
	$_t = '<input type="hidden" name="content['.$field_name.' (image)][id]" value="'.$_REQUEST['content'][$field_name.' (image)']['id'].'" />';
    $data['content'][$field_name.' (image)']['image_id'] = $_REQUEST['content'][$field_name.' (image)']['id'];
}

$replacement = $_t;

?>
