<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "functions" - Page-Template PHP-Functions             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.2b / January 2013 ==

*/

if (!defined('CPO')) exit;

$translator->addTranslation('functions', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['functions'] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'Page template functions',
    'install'   => 'function: functions_install',
    'activate'  => 'function: functions_activate '.$moduleDirectory,
    'deactivate'=> 'function: functions_deactivate',
    'uninstall' => 'function: functions_uninstall '.$moduleDirectory,
    'manage'	=> 'function: functions_manage'
	);

function functions_install()
{
	global $dbPrefix;
	// functions-Tabelle erzeugen
	$functionsdb = new DB;
	$query = "CREATE TABLE IF NOT EXISTS ".$dbPrefix."_mod_functions (
	  function_name varchar(100) NOT NULL,
	  function_args varchar(255) NOT NULL default '',
	  function_code text NOT NULL default '',
	  PRIMARY KEY (function_name)
	);";
	$functionsdb->query($query);
    $GLOBALS['message'][] = ___('The functions module was successfully installed!');
}
function functions_uninstall($moduleDirectory)
{
	global $translator, $dbPrefix;
	$functionsdb = new DB;
	$query = "DROP TABLE ".$dbPrefix."_mod_functions;";
	$functionsdb->query($query);
	$GLOBALS['message'][] = sprintf(__('The functions module was successfully removed from the ConPresso system. Please remove the module directory <i>%s</i> to finally uninstall the functions module!'),$moduleDirectory);

}
function functions_activate($moduleDirectory)
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";
    $GLOBALS['message'][] = ___('The functions module got activated.').$reload_navigation;
    $GLOBALS['message'][] = sprintf(__('If you want some sample function to be installed, please start the <a href="%s">functions setup</a>.'),BASE_ABS.$moduleDirectory.'/setup_functions.php');
}

function functions_deactivate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";
    $GLOBALS['message'][] = ___('The functions module got deactivated.').$reload_navigation;
}

function functions_manage()
{
	global $dbPrefix, $db, $k, $module_status;
	if(array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE)  {
		echo '<a href="'.BASE_ABS.$GLOBALS['modules']['functions']['directory'].'/edit.php"><img src="'.SKIN_URL.'pic_edit.gif" title="'.__('edit functions').'" alt="'.__('edit functions').'"></a>';
	} else {
		echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic_" style="background: url('.SKIN_URL.'pic_edit.gif);" alt="'.  __('not available').'" title="'.__('not available').'">';
	}
}

function functionpageparameters($_fparams) {
    // create an array with all parameters
    $prefix = '';
    $pageparameters = array();
    foreach (explode(';', $_fparams) as $value) {
        if (substr($value, -1)=='\\') {
            $prefix .= substr($value, 0, -1).';';
            continue;
        }
        $value = trim($prefix.$value);
        $prefix = '';
        if ($value=='') continue;

        // split 'a = b' or only 'a'
        preg_match('/\s*([^=]*)\s*(=(.*))?/', $value, $tmp);

        // no matches found?
        if (count($tmp)==0) continue;

        if (count($tmp)==2) { // only a flag
            $pageparameters[strtolower(trim($tmp[1]))] = true;
        }
        if (count($tmp)==4) { // a = b
            $pageparameters[strtolower(trim($tmp[1]))] = trim($tmp[3]);
        }
    }
	return $pageparameters;
}

function functions_navigation($moduleDirectory)
{
    $GLOBALS['navigation']['Templates'][] = array(
            'caption'=>'Page template functions',
            'url'=>BASE_REL.$moduleDirectory.'/edit.php'
        );
}

// das hier wird nun immer passieren!
// the CPO4.1 PageTemplate-Functions
if (array_key_exists('functions',$activeModules)) {

	if (isset($_SESSION['SID_user']['admin']) && $_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
		$hdlr_navigation[] = 'function: functions_navigation '.$moduleDirectory;
	}

	$theSign = 'cpopage';
	$functionContent = array();
	$functionArgs = array();
	$functionsquery = "SELECT * FROM ".$dbPrefix."_mod_functions ORDER BY function_name";
	DEBUG(2, $functionsquery, __FILE__, __LINE__);  
	$functionsdb = new DB;
	$functionsdb->query($functionsquery);
    if ($functionsdb->num_rows()>0){
        while($functionsdb->next_record()):
		$functionArgs[$functionsdb->v('function_name')] = $functionsdb->v('function_args');
		$functionContent[$functionsdb->v('function_name')] = $functionsdb->v('function_code');
        endwhile;
		foreach (array_keys($functionContent) as $functionKey) {
			try { 
                eval ( 'function '. $theSign.$functionKey.'($functionarguments) { foreach (functionpageparameters($functionarguments) AS $argkey=>$argvalue) $$argkey = $argvalue; '.$functionContent[$functionKey]. "\n" .'} ' ) ;
            } catch (Throwable $t) {
                printf( ___('There was an error: %s'),  $t->getMessage() );
            }
			try { 
                eval ( 'function '. $functionKey.'('.$functionArgs[$functionKey].') { '.$functionContent[$functionKey]. "\n" . '} ' ) ;
            } catch (Throwable $t) {
                printf( ___('There was an error: %s'),  $t->getMessage() );
            }
		}
	}
	$hdlr_parser_content['function']      = array('include: mod_functions/parser_c_functions.inc.php');
	$hdlr_parser_replacement['function']  = array('include: mod_functions/parser_r_functions.inc.php');

}
?>