<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "functions" - Page-Template PHP-Functions             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.2b / January 2013 ==

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 

$directory = basename(dirname($_SERVER['PHP_SELF'])); 

require(CPO_BASEDIR.'_include/check.php');
require(CPO_BASEDIR.'_include/header.php');

initVar($function_name, '');
initVar($function_args, '');
initVar($function_code, '');
initVar($theSign, 'cpopage');

include(CPO_BASEDIR.$activeModules['functions']['directory'].'/actions.inc.php');
include(CPO_BASEDIR.$activeModules['functions']['directory'].'/producer.inc.php');


if (isset($_REQUEST['action']) && ($_REQUEST['action']=='create' || $_REQUEST['action']=='edit')) {

	printPageHeader(
		__('Page template functions'),
		($_REQUEST['action']=='edit') ? 
			sprintf(__('In this view you can edit the user defined page template function <i>%s</i>.'),$_REQUEST['function']) :
			__('In this view you can create a new user defined page template function.')
	);
?>

<script type="text/javascript">
function textarea (boxid, link){ 
	var t=document.getElementById(boxid); 
	if(link.innerHTML=='<?php echo __('enlarge'); ?>'){ 
		t.style.height = t.offsetHeight+350+"px"; 
		link.innerHTML='<?php echo __('reduce'); ?>'; 
	} else{ 
		t.style.height = t.offsetHeight-350+"px"; 
		link.innerHTML='<?php echo __('enlarge'); ?>'; 
	} 
} 
</script>
<?php
	if ($_REQUEST['action']=='edit')  {
		$query = "SELECT * FROM ".$dbPrefix."_mod_functions WHERE function_name='".$_REQUEST['function']."' ";
		DEBUG(2, $query, __FILE__, __LINE__);  
		$db = new DB;
		$db->query($query);
		if ($db->num_rows()<1)  $message[] = __('Function not found!');
		require(CPO_BASEDIR."_include/message.php");
		$db->next_record();
		$function_name=$db->v('function_name');
		$function_args=$db->v('function_args');
		$function_code=$db->v('function_code');

	}

	echo '<form action="edit.php" method="POST">';
	echo '<input type="hidden" name="action" value="save">';
	echo '<b>function</b> <input type="text" name="function_name" value="'.$function_name.'"><b>(</b><input type="text" name="function_args" value="'.$function_args.'"><b>)</b> {<br />';
	echo '<textarea name="function_code" style="width: 95%; height: 200px;" id="function_code" class="text inputwidth">'.htmlspecialchars($function_code, ENT_COMPAT, 'ISO-8859-15').'</textarea><br />}<br /><a href="#" onClick="textarea(\'function_code\', this);return false" id="lnk">'.__('enlarge').'</a>';
	echo '<br /><br />';
	echo '<img src="'.SKIN_URL.'sym_note.gif" /> <b>'.__('Notice:').'</b> ';
	echo __('The function itself must not produce any output! Everything has to be collected into a string that is given back with <i>return</i> in the last line.');
	//echo '<br /><br />';
	//echo '<img src="../_skin/conpresso/sym_note.gif" /> <b>'.__('Notice:').'</b> ';
	//echo __('The last line <b>must not</b> be a comment!.');
	echo '';
	echo '';
	echo '';
	echo '';
	echo '';
	echo '<br><br><br><br>';
	echo '<input type="submit" value="'.__('save function').'" />';
	echo '</form>';


} else {

	printPageHeader(
		__('Page template functions'),
		__('In this view you can work on the user defined page template functions available for page templates.')
	);

		$query = "SELECT * FROM ".$dbPrefix."_mod_functions ORDER BY function_name";
		DEBUG(2, $query, __FILE__, __LINE__);  
		$db = new DB;
		$db->query($query);
		if ($db->num_rows()<1)  $message[] = __('No functions founds!');
		require(CPO_BASEDIR."_include/message.php");

    if ($db->num_rows()>0){

        echo '<table class="ruler" style="width: 100%;">';
        echo '<thead><tr>';
			echo '<th><span>'.__('Function name').'</span></th>';
			echo '<th><span>'.__('Template usage').'</span></th>';
			echo '<th><span>'.__('PHP usage').'</span></th>';
			echo '<th style="width: 10%;"><span>'.__('Action').'</span></th>';
		echo '</tr></thead><tbody>';
        while($db->next_record()):
			echo "<tr><td>";
			echo $db->v('function_name');
			echo "</td><td>";
			$args = array();
			$arglist = array();
			$args = explode(",",$db->v('function_args'));
			foreach($args as $arg) if(trim($arg)) $arglist[] = substr(trim($arg),1,strlen($arg)).'='.__('VALUE');
			$function_args = implode ("; ", $arglist);
			if ($function_args) $function_args = $function_args.';';
			echo'&lt;!-- function: '. $db->v('function_name').'; '.$function_args.' --&gt;';
			echo "</td><td>";
			echo '&lt;?php echo '.$db->v('function_name').'('.$db->v('function_args').'); ?&gt;';
			echo "</td><td>";
					echo '<a href="'.BASE_REL.$activeModules['functions']['directory'].'/edit.php?action=edit&function='.$db->v('function_name').'">';
					echo '<img align="left" src="'.SKIN_URL.'pic_edit.gif" alt="'.__('edit').'" title="'.__('edit').'" />'; 
					echo '</a>';
					echo '<a href="'.BASE_REL.$activeModules['functions']['directory'].'/edit.php?action=delete&function='.$db->v('function_name').'" onClick="return confirm(\''.__('Do you really want to delete this function?').'\')">';
					echo '<img src="'.SKIN_URL.'pic_del.gif" alt="'.__('delete').'" title="'.__('delete').'" />'; 
					echo '</a>';




			echo "</td>";
		echo "</tr>";
        endwhile;

		echo '</tbody></table>';

	}
	printIcon(
		BASE_ABS . $GLOBALS['modules']['functions']['directory'].'/edit.php?action=create', 
		BASE_ABS . $GLOBALS['modules']['functions']['directory'].'/pic_add.gif', 
		__('Create new function'),
		TRUE
		);
	echo '<a href="edit.php?action=create">'.__('Create new function').'</a><br><br><br>';

}

require(CPO_BASEDIR.'_include/footer.php');
?>
