<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "ImageSize"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.4c / September 2013

*/

if (!defined('CPO')) exit;

function reset_imagetool_values($key, $value, $name)  {
	$GLOBALS['message'][] = sprintf(__('Your input <i>%s</i> is not a valid value for "%s", so "%s" was reset to its previous value!'), $value, $name, $name);
	unset ($_POST['cpoImagetoolNew'][$key]);
}

function check_settings_imagetool($new, $active)  {
	global $activeModules;
	if ( !is_numeric(license($activeModules['Imagetool']['lkey'],$activeModules['Imagetool']['mod_id'])) || license($activeModules['Imagetool']['lkey'],$activeModules['Imagetool']['mod_id']) == 4 ) return;
	if ($new['width'] == '' || !is_numeric($new['width']))
		reset_imagetool_values('width',$_POST['cpoImagetoolNew']['width'], __('width'));
	if ($new['height'] == '' || !is_numeric($new['height']))
		reset_imagetool_values('height',$_POST['cpoImagetoolNew']['height'], __('height'));
	if ($new['screenx'] == '' || !is_numeric($new['screenx']))
		reset_imagetool_values('screenx',$_POST['cpoImagetoolNew']['screenx'], __('width'));
	if ($new['screeny'] == '' || !is_numeric($new['screeny']))
		reset_imagetool_values('screeny',$_POST['cpoImagetoolNew']['screeny'], __('height'));
	if ($new['prefix'] == '')
		reset_imagetool_values('prefix',$_POST['cpoImagetoolNew']['prefix'], __('image prefix'));
	if ($new['quality'] == '' || !is_numeric($new['quality']) || $new['quality'] < 1 || $new['quality'] > 100) 
		reset_imagetool_values('quality',$_POST['cpoImagetoolNew']['quality'], __('JPEG quality'));
}

if (!function_exists('imagetool_picture'))  {
	function imagetool_picture($filename, $type, $max_width, $max_height, $save_to, $quality, $watermark=false)  {
	//Parameter
	//	$filename	der Dateiname der Quelldatei inkl. Pfad im Dateisystem
	//	$type		der Dateityp JPG, PNG oder GIF
	//	$max_width	das maximale horizontale Mass
	//	$max_height	das maximale vertikale Mass
	//	$save_to	der Dateiname der Zieldatei inkl. Pfad im Dateisystem
	//	$quality	die Qualitt einer Ausgabe als JPG (0-100%, je hher je besser)
	//	$watermark	soll ein Wasserzeichen eingerechnet werden?

		if ($type == "JPG") $imagefile = ImageCreateFromJPEG($filename);
		if ($type == "GIF" && function_exists("ImageCreateFromGIF")) $imagefile = ImageCreateFromGIF($filename);
		if ($type == "PNG") $imagefile = ImageCreateFromPNG($filename);
		$breite = imagesx($imagefile);
		$hoehe = imagesy($imagefile);

	//	Bestimmung des Faktors (durch diesen Faktor wird spter die Grsse geteilt)
		$faktor = max ( ($breite / $max_width), ($hoehe / $max_height) );

		$standardhoehe = floor ($hoehe / $faktor);
		$standardbreite = floor ($breite / $faktor);
		
	//	Bild erstellen
		$bild = imagecreatetruecolor($standardbreite, $standardhoehe);
		imagecopyresampled($bild, $imagefile, 0, 0, 0, 0, $standardbreite, $standardhoehe, $breite, $hoehe);

	// watermark & copyright
		if (function_exists('watermark_imagetool') && $watermark) $bild = watermark_imagetool($bild);

	//	Saving & Cleaning
		if ($type == "JPG") imagejpeg($bild, $save_to, $quality);
		if ($type == "GIF" && function_exists("imagegif")) imagegif($bild, $save_to);
		if ($type == "GIF" && !function_exists("imagegif")) imagepng($bild, $save_to);
		if ($type == "PNG") imagepng($bild, $save_to);
		imagedestroy($imagefile);
		imagedestroy($bild);
	}
}

if (!function_exists('save_modulesettings'))  {
	function save_modulesettings($new_array, $active_array)  {
		global $activeModules;
		$new_settings = $_POST;
		foreach ($activeModules[$active_array] as $k=>$v) {
			if (!isset($_POST[$new_array][$k])) continue;
			if (is_bool($activeModules[$active_array][$k])) {
				$activeModules[$active_array][$k] = (bool) $_POST[$new_array][$k];
			}
			else $activeModules[$active_array][$k] = $_POST[$new_array][$k];
			if (array_key_exists($k, $new_settings[$new_array])) unset($new_settings[$new_array][$k]);
		}
		foreach ($new_settings[$new_array] as $k=>$v) {
			$activeModules[$active_array][$k] = $new_settings[$new_array][$k];
		}
		$query = sprintf(
				 "UPDATE ".CPO_MODULES." SET options ="
				." '%s' WHERE name = '".$active_array."'", 
				addslashes(serialize($activeModules[$active_array]))
		);
		DEBUG(1, $query, __FILE__, __LINE__);
		$db = new DB;
		$db->query($query); 
		$GLOBALS['message'][] = __('Module settings were updated!');   
	}
}

if (!function_exists('modHelp'))  {
	function modHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

if (!function_exists('watermark_imagetool'))  {
	function watermark_imagetool($bild)  {
		global $activeModules;
		if ($activeModules['Imagetool']['mark_copyright'] == 'yes' || $activeModules['Imagetool']['show_watermark'] == 'yes')  { 

			// PRO-Values
			$watermark_pic				= CPO_BASEDIR.$activeModules['Imagetool']['directory'] . '/' . $activeModules['Imagetool']['watermark_pic'];
			$watermark_scale			= $activeModules['Imagetool']['watermark_scale'];
			$watermark_transparency		= $activeModules['Imagetool']['watermark_transparency'];
			$copyright_border			= $activeModules['Imagetool']['copyright_border'];

			$imageTypes = array(
				'unknown', 
				'GIF', 
				'JPG', 
				'PNG'
			);

			$standardbreite = imagesx($bild); 
			$standardhoehe  = imagesy($bild); 
			//imagealphablending($bild,true);

			if ($activeModules['Imagetool']['show_watermark'] == 'yes')  { 
				// watermark
				$logo_type = getimagesize ( $watermark_pic );
				if ($imageTypes[$logo_type[2]]=='JPG')  $insert = imagecreatefromjpeg($watermark_pic); 
				if ($imageTypes[$logo_type[2]]=='GIF')  $insert = imagecreatefromgif($watermark_pic); 
				if ($imageTypes[$logo_type[2]]=='PNG')  $insert = imagecreatefrompng($watermark_pic); 
				$insert_x = imagesx($insert); 
				$insert_y = imagesy($insert); 

				if ($watermark_scale == 'yes')  {  // Wasserzeichen dehnen
				// Logo skalieren
					$logo = imagecreatetruecolor($standardbreite, $standardhoehe);
					$back = imagecolorallocate($logo, 200,200,200); 
					imagefilledrectangle($logo, 0, 0, $standardbreite, $standardhoehe, $back);
					imagecolortransparent($logo, $back);
					if ($imageTypes[$logo_type[2]]=='PNG') {
						imageAlphaBlending($logo, false); //PNG false
						imagecopyresampled($logo, $insert, 0, 0, 0, 0, $standardbreite, $standardhoehe, $insert_x, $insert_y);
						imagecopymerge_alpha($bild, $logo, 0, 0, 0, 0, $standardbreite, $standardhoehe, $watermark_transparency);  // works best with PNG
					} else {
						imageAlphaBlending($logo, true); //GIF,JPG true
						imagecopyresampled($logo, $insert, 0, 0, 0, 0, $standardbreite, $standardhoehe, $insert_x, $insert_y);
						imagecopymerge($bild, $logo, 0, 0, 0, 0, $standardbreite, $standardhoehe, $watermark_transparency); // works best with GIF,JPG
					}
				} else {
					$logo = $insert;
					// Position bestimmen
					switch ($activeModules['Imagetool']['watermark_pos'])  {
						case 1: $watermark_align = "left"; $watermark_valign = "top"; break;
						case 2: $watermark_align = "center"; $watermark_valign = "top"; break;
						case 3: $watermark_align = "right"; $watermark_valign = "top"; break;
						case 4: $watermark_align = "left"; $watermark_valign = "middle"; break;
						case 5: $watermark_align = "center"; $watermark_valign = "middle"; break;
						case 6: $watermark_align = "right"; $watermark_valign = "middle"; break;
						case 7: $watermark_align = "left"; $watermark_valign = "bottom"; break;
						case 8: $watermark_align = "center"; $watermark_valign = "bottom"; break;
						case 9: $watermark_align = "right"; $watermark_valign = "bottom"; break;
					}
					if ($watermark_align  == "left")	$watermark_x = 0;
					if ($watermark_align  == "center")	$watermark_x = $standardbreite / 2 - $insert_x / 2;
					if ($watermark_align  == "right")	$watermark_x = $standardbreite - $insert_x;
					if ($watermark_valign == "top")		$watermark_y = 0;
					if ($watermark_valign == "middle")	$watermark_y = $standardhoehe / 2 - $insert_y / 2;
					if ($watermark_valign == "bottom")	$watermark_y = $standardhoehe - $insert_y ;

					if ($imageTypes[$logo_type[2]]=='PNG') imagecopymerge_alpha($bild, $logo, $watermark_x, $watermark_y, 0, 0, $insert_x, $insert_y, $watermark_transparency);  // works best with PNG
					else imagecopymerge($bild, $logo, $watermark_x, $watermark_y, 0, 0, $insert_x, $insert_y, $watermark_transparency); // works best with GIF,JPG
				}

				// Ende watermark
			}

			if ($activeModules['Imagetool']['mark_copyright'] == 'yes')  { 

				// Copyright
				switch ($activeModules['Imagetool']['copyright_pos'])  {
					case 1: $copyright_align = "left"; $copyright_valign = "top"; break;
					case 2: $copyright_align = "center"; $copyright_valign = "top"; break;
					case 3: $copyright_align = "right"; $copyright_valign = "top"; break;
					case 4: $copyright_align = "left"; $copyright_valign = "middle"; break;
					case 5: $copyright_align = "center"; $copyright_valign = "middle"; break;
					case 6: $copyright_align = "right"; $copyright_valign = "middle"; break;
					case 7: $copyright_align = "left"; $copyright_valign = "bottom"; break;
					case 8: $copyright_align = "center"; $copyright_valign = "bottom"; break;
					case 9: $copyright_align = "right"; $copyright_valign = "bottom"; break;
				}
				$text_color = $activeModules['Imagetool']['text_color'];
				$r = hexdec(substr($text_color,1,2));
				$g = hexdec(substr($text_color,3,2));
				$b = hexdec(substr($text_color,5,2));
				$text_color = imagecolorallocate ($bild, $r, $g, $b);
				$shadow_color = $activeModules['Imagetool']['shadow_color'];
				$r = hexdec(substr($shadow_color,1,2));
				$g = hexdec(substr($shadow_color,3,2));
				$b = hexdec(substr($shadow_color,5,2));
				$shadow_color = imagecolorallocate ($bild, $r, $g, $b);
				$font = CPO_BASEDIR.$activeModules['Imagetool']['directory'] . '/' . $activeModules['Imagetool']['font'];
				$font_size = $activeModules['Imagetool']['font_size'];
				$font_angle = 0;
				$text = $activeModules['Imagetool']['copyright_content'];
				$bbox = imagettfbbox ($font_size, $font_angle, $font, $text);
				$textWidth = $bbox[2] - $bbox[0];
				$textHeight = $bbox[1] - $bbox[7];
				if ($copyright_align == "left")		$copyright_x = $copyright_border;
				if ($copyright_align == "center")	$copyright_x = $standardbreite / 2 - $textWidth / 2;
				if ($copyright_align == "right")	$copyright_x = $standardbreite - $textWidth - $copyright_border;
				if ($copyright_valign == "top")		$copyright_y = $copyright_border + $textHeight;
				if ($copyright_valign == "middle")	$copyright_y = $standardhoehe / 2 + $textHeight / 2;
				if ($copyright_valign == "bottom")	$copyright_y = $standardhoehe - $copyright_border ;
				imagettftext ($bild, $font_size, $font_angle, $copyright_x+1 , $copyright_y+1, $shadow_color, $font, $text);
				imagettftext ($bild, $font_size, $font_angle, $copyright_x, $copyright_y, $text_color, $font, $text);
				// Ende Copyright
			}
		}
		return $bild;
	}
}

if (!function_exists('greyscale'))  {
	function greyscale($image,$type)  {
		global $activeModules;
		if ($activeModules['Imagetool']['watermark_mode'] == 'greyscale' && $type != 1) {
			$img_width = imagesx($image); 
			$img_height = imagesy($image); 
			for ($y = 0; $y <$img_height; $y++) {
				for ($x = 0; $x <$img_width; $x++) { 
				$rgb = ImageColorAt($image, $x, $y);
				$red   = ($rgb >> 16) & 0xFF;
				$green = ($rgb >> 8) & 0xFF;
				$blue  = $rgb & 0xFF;
				$gray  = (int)(($red+$green+$blue)/4); 
				imagesetpixel ($image, $x, $y, ImageColorAllocate ($image, $gray,$gray,$gray));
				}
			}
		}
		return $image;
	}
}


if (!function_exists('imagecopymerge_alpha'))  {
	/** 
	 * PNG ALPHA CHANNEL SUPPORT for imagecopymerge(); 
	 * This is a function like imagecopymerge but it handle alpha channel well!!! 
	 **/ 

	// A fix to get a function like imagecopymerge WITH ALPHA SUPPORT 
	// Main script by aiden dot mail at freemail dot hu 
	// Transformed to imagecopymerge_alpha() by rodrigo dot polo at gmail dot com 
	function imagecopymerge_alpha($dst_im, $src_im, $dst_x, $dst_y, $src_x, $src_y, $src_w, $src_h, $pct){ 
		if(!isset($pct)){ 
			return false; 
		} 
		$pct /= 100; 
		// Get image width and height 
		$w = imagesx( $src_im ); 
		$h = imagesy( $src_im ); 
		// Turn alpha blending off 
		imagealphablending( $src_im, false ); 
		// Find the most opaque pixel in the image (the one with the smallest alpha value) 
		$minalpha = 127; 
		for( $x = 0; $x < $w; $x++ ) 
		for( $y = 0; $y < $h; $y++ ){ 
			$alpha = ( imagecolorat( $src_im, $x, $y ) >> 24 ) & 0xFF; 
			if( $alpha < $minalpha ){ 
				$minalpha = $alpha; 
			} 
		} 
		//loop through image pixels and modify alpha for each 
		for( $x = 0; $x < $w; $x++ ){ 
			for( $y = 0; $y < $h; $y++ ){ 
				//get current alpha value (represents the TANSPARENCY!) 
				$colorxy = imagecolorat( $src_im, $x, $y ); 
				$alpha = ( $colorxy >> 24 ) & 0xFF; 
				//calculate new alpha 
				if( $minalpha !== 127 ){ 
					$alpha = 127 + 127 * $pct * ( $alpha - 127 ) / ( 127 - $minalpha ); 
				} else { 
					$alpha += 127 * $pct; 
				} 
				//get the color index with new alpha 
				$alphacolorxy = imagecolorallocatealpha( $src_im, ( $colorxy >> 16 ) & 0xFF, ( $colorxy >> 8 ) & 0xFF, $colorxy & 0xFF, $alpha ); 
				//set pixel with the new color + opacity 
				if( !imagesetpixel( $src_im, $x, $y, $alphacolorxy ) ){ 
					return false; 
				} 
			} 
		} 
		// The image copy 
		imagecopy($dst_im, $src_im, $dst_x, $dst_y, $src_x, $src_y, $src_w, $src_h); 
	} 
}

if (!function_exists('listTTFfiles'))  {
	function listTTFfiles($dir)  {
		$h = opendir($dir);
		$files = array();
		while($file = readdir($h)) $files[] = $file;
		sort($files);
		foreach($files AS $file)  {
			if ($file != "." AND $file != ".." AND !is_dir($dir.$file) AND strtolower(substr($file,-4)) == ".ttf")  {
				$ttffiles[] = $file;
			}
		}
		closedir($h);
		return $ttffiles;
	}
}

if(!function_exists('listImageFiles')) {
	function listImageFiles($dir)  {
		$h = opendir($dir);
		$files = array();
		while($file = readdir($h)) $files[] = $file;
		sort($files);
		foreach($files AS $file)  {
			if ($file != "." AND $file != ".." AND !is_dir($dir.$file) AND (strtolower(substr($file,-4))=='.png' OR strtolower(substr($file,-4))=='.gif' OR strtolower(substr($file,-4))=='.jpg' OR strtolower(substr($file,-5))=='.jpeg'))  {
				$image_files[] = $file;
			}
		}
		closedir($h);
		return $image_files;
	}
}

?>