<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "ImageSize"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.4c / September 2013

*/

// define some vars
initVar($usePresets, false);

if (!isset($fileNameReplacements)) 
$fileNameReplacements = array(
    '//' => 'Ae',
    '//' => 'Oe',
    '//' => 'Ue',
    '//' => 'ss',
    '//' => 'ae',
    '//' => 'oe',
    '//' => 'ue',
    '//' => 'A',
    '//' => 'A',
    '//' => 'E',
    '//' => 'E',
    '//' => 'O',
    '//' => 'O',
    '//' => 'U', 
    '//' => 'U', 
    '//' => 'I', 
    '//' => 'I', 
    '//' => 'a', 
    '//' => 'a', 
    '//' => 'e', 
    '//' => 'e', 
    '//' => 'o', 
    '//' => 'o', 
    '//' => 'u', 
    '//' => 'u', 
    '//' => 'i', 
    '//' => 'i', 
    '/[^a-z0-9_\.-]/i' => '_',
);
?>

    <script type="text/javascript">
    function setImagesize()  {
        var inputs = ['preset', 'width', 'height'];
        for ( i=0; i<inputs.length; i++ ) {
            if (document.getElementById(inputs[i]) != null && document.getElementById(inputs[i]+'[]') != null) 
                document.getElementById(inputs[i]+'[]').value = document.getElementById(inputs[i]).value;
        }
        var checks = ['nozoom', 'noresize'];
        for ( i=0; i<checks.length; i++ ) {
            if (document.getElementById(checks[i]) != null && document.getElementById(checks[i]+'[]') != null) 
                if (document.getElementById(checks[i]).checked == true)
                {
                    document.getElementById(checks[i]+'[]').value = '0';
                } else {
                    document.getElementById(checks[i]+'[]').value = '';
                }
        }
    }
    </script>

<?php

//	keine Benutzerdefinierte Gre erlaubt
if (!isset($activeModules['Imagetool']['opt']['allowfreesize']) && $_SESSION['SID_user']['admin'] < $activeModules['Imagetool']['skip_restrictions'])  {
	if (trim($activeModules['Imagetool']['presets']) == '')  { // keine Presets
	print('<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> ');
	echo '<input type="hidden" name="noresize[]" value="0" />';
	printf(__('An uploaded image will be resized to fit a %s x %s frame (width x height).'),
		$activeModules['Imagetool']['width'],
		$activeModules['Imagetool']['height']
	);
	echo '<input type="hidden" name="width[]" id="width" value="'.$activeModules['Imagetool']['width'].'">';
	echo '<input type="hidden" name="height[]" id="height" value="'.$activeModules['Imagetool']['height'].'">';
	} else { // Presets vorhanden
		$usePresets = true;
		$imagetool_presets = explode("\n",$activeModules['Imagetool']['presets']);
		echo '<br />'.__('Imagesize preset:').' <select name="preset[]" id="preset" onchange="setImagesize();">';
		foreach($imagetool_presets AS $imagetool_preset)
		{	
            $imagetool_preset_entry = explode(";", $imagetool_preset);
            $imagetool_preset_set[0] = (isset($imagetool_preset_entry[0])) ? $imagetool_preset_entry[0] : '';
            $imagetool_preset_set[1] = (isset($imagetool_preset_entry[1])) ? $imagetool_preset_entry[1] : '';
            $imagetool_preset_set[2] = (isset($imagetool_preset_entry[2])) ? $imagetool_preset_entry[2] : '';
            $imagetool_preset_set[3] = (isset($imagetool_preset_entry[3])) ? $imagetool_preset_entry[3] : '';

		    $presetname = preg_replace(array_keys($fileNameReplacements), array_values($fileNameReplacements), $imagetool_preset_set[0]);
			echo '<option value="'.trim($imagetool_preset_set[1]).';'.trim($imagetool_preset_set[2]).';'.trim($imagetool_preset_set[3]).';'.trim($presetname).'">'.trim($imagetool_preset_set[0]).'</option>';
		}
		echo '</select>';
	}
}

//	Benutzerdefinierte Gre erlaubt
if (isset($activeModules['Imagetool']['opt']['allowfreesize']) || $_SESSION['SID_user']['admin'] >= $activeModules['Imagetool']['skip_restrictions'])  {
	//	Grenanpassung abschaltbar
	if (isset($activeModules['Imagetool']['opt']['allownoresize']) || $_SESSION['SID_user']['admin'] >= $activeModules['Imagetool']['skip_restrictions'])  {
		echo '<br /><input type="checkbox" name="noresize[]" id="noresize" value="0" checked="checked" onchange="setImagesize();" /> ';
//		echo '<label for="noresize[]">'.__('no resize').'</label>';
	} else {
		print('<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> ');
		echo '<input type="hidden" name="noresize[]" value="0" />';
	}
	printf(__('An uploaded image will be resized to fit a %s x %s frame (width x height).'),
		'<input type="text" class="text" name="width[]" id="width" value="'.$activeModules['Imagetool']['width'].'" size="3" maxlength="4" onchange="setImagesize();" />',
		'<input type="text" class="text" name="height[]" id="height" value="'.$activeModules['Imagetool']['height'].'" size="3" maxlength="4" onchange="setImagesize();" />'
	);
}


// es wird ein Zoom-Bild erstellt
if (isset($activeModules['Imagetool']['opt']['zooming']) && !$usePresets)  {
	//	Zoomfunktion abschaltbar
	if ($activeModules['Imagetool']['opt']['allownozoom'] || $_SESSION['SID_user']['admin'] >= $activeModules['Imagetool']['skip_restrictions'])  {
		echo '<br /><input style="margin-left:20px;" type="checkbox" name="nozoom[]" id="nozoom" value="0" checked="checked" onchange="setImagesize();" /> ';
//		echo '<label for="nozoom[]">'.__('not zoomable').'</label>';
	} else {
		print('<br /><img style="margin-left:25px;" src="'.SKIN_URL.'sym_filteron.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> ');
		echo '<input type="hidden" name="nozoom[]" id="nozoom" value="0" />';
	}
	printf(__('An additional zoomed image will be created to fit a %s x %s frame (width x height).'),
		$activeModules['Imagetool']['screenx'],
		$activeModules['Imagetool']['screeny']
	);
}


$roles = array(
	'-1'             => 'All',
	ROLE_MEMBER      => 'Member',
	ROLE_EDITOR      => 'Editor',
	ROLE_CHIEFEDITOR => 'Chief editor',
	ROLE_SUPERUSER   => 'Superuser',
	ROLE_ADMIN       => 'Admin');

if($_SESSION['SID_user']['admin'] >= $activeModules['Imagetool']['skip_restrictions']) echo '<br /><img src="'.SKIN_URL.'sym_info.gif" style="vertical-align: text-bottom;" alt="'.__('Info').'" title="'.__('Info').'"> <em>'.__('Presets and restrictions skipped for:').' '.__($roles[$_SESSION['SID_user']['admin']]).'</em>';

?>


    <script type="text/javascript">
    setImagesize();
    </script>


