<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "ImageSize"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Release 4.4c / September 2013

*/

if (!array_key_exists('Imagetool', $activeModules)) return;

initVar($prefix, '');

if (!isset($_REQUEST['noresize'][$i]) && !isset($_REQUEST['preset'][$i])) { // keine Bildgrenanpassung gewnscht!
	echo '<img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> ';
	echo __('No resizing was wanted').'<br />';
	return;
}

if (version_compare($CPO['version'], '4.1.3') >= 0) $new_filename = $newFilename; // workaround for CPO >= 4.1.3

$type			= $imageTypes[$checkImage[2]];
$max_width		= (isset($_REQUEST['width'][$i]) && $_REQUEST['width'][$i] != '') ? $_REQUEST['width'][$i] : $activeModules['Imagetool']['width'];
$max_height		= (isset($_REQUEST['height'][$i]) && $_REQUEST['height'][$i] != '') ? $_REQUEST['height'][$i] : $activeModules['Imagetool']['height'];
$screenx		= $activeModules['Imagetool']['screenx'];
$screeny		= $activeModules['Imagetool']['screeny'];
$quality		= $activeModules['Imagetool']['quality'];
$usePreset      = false;

//    echo '<pre>';
//    print_r($_REQUEST);
//    print_r($activeModules['Imagetool']);
//    echo '</pre>';

// Presets
if (isset($_REQUEST['preset'][$i]) && trim($_REQUEST['preset'][$i])!='' )  {
//    echo 'Do the preset!<br />';
    // Preset-Eingabe: Name;Breite;Hhe;zoombar(0|1)       !!!
    // wird bertragen als: Breite;Hhe;zoombar(0|1);Name  !!!
	$activeModules['Imagetool']['opt']['zooming'] = true;
	$presize = explode(";", $_REQUEST['preset'][$i]);
//    echo '<pre>';
//    print_r($presize);
//    print_r($activeModules['Imagetool']);
//    echo '</pre>';
	if ($presize[0] <= 0 || $presize[0] == '') { // kein Preset mit Werten => Abbruch
		echo '<img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> ';
		echo __('No resizing was wanted').'<br />';
		return; 
	}
	if ($presize[2] == '1') { // es wird Zoomen gewnscht, also die passenden Werte setzen
		$_REQUEST['nozoom'][$i]   = '0';
		$_REQUEST['noresize'][$i] = '0';
	} else { // oder eben nicht
		$_REQUEST['nozoom'][$i]   = '1';
		$_REQUEST['noresize'][$i] = '0';
    }
	$max_width=$presize[0];
	$max_height=$presize[1];
	$preset_name=$presize[3];
	$usePreset = true;
}
//    echo '<pre>';
//    print_r($_REQUEST);
//    print_r($activeModules['Imagetool']);
//    echo '</pre>';


// check if resizing is necessary or forced
if ($checkImage[0] <= $max_width && $checkImage[1] <= $max_height && !$activeModules['Imagetool']['opt']['forceResize'])  {
	echo '<img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> '.__('No resizing was necessary').'<br />';
	return;
}

if ($activeModules['Imagetool']['keepOriginal'] == 'yes')  {	// Original beibehalten
    //echo "copy(".$new_filename.", ".$path."original_".$prefix.$filename.")<br />";
    if (!copy($new_filename, $path.'original_'.$prefix.$filename)) {
		if ($activeModules['Imagetool']['noticeOriginal'] == 'yes') echo "failed to copy $filename...<br>\n";
	} else {
		if ($activeModules['Imagetool']['noticeOriginal'] == 'yes') echo sprintf('<img src="'.SKIN_URL.'nav_open.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> '.__('The original image was saved as <i>%s</i>.'),'original_'.$prefix.$filename).'<br />';
	    @chmod($path.'original_'.$prefix.$filename, 0666);
	}
}

//Added by Seventy Soft!!
if ($checkImage[0] <= $screenx && $checkImage[1] <= $screeny)
{
	$screenx = $checkImage[0];
	$screeny = $checkImage[1];
}

if (file_exists(CPO_BASEDIR.$activeModules['Imagetool']['directory'].'/includes/functions.inc.php'))  include_once(CPO_BASEDIR.$activeModules['Imagetool']['directory'].'/includes/functions.inc.php');

$zoom_filename = $path.$activeModules['Imagetool']['prefix'].$prefix.$filename;
$zoom_filename_string = $activeModules['Imagetool']['prefix'].$prefix.$filename;

if (isset($activeModules['Imagetool']['suffix']))  { // NEU: Dimensionen/Preset im Dateinamen ergnzen
	$old_filename = $new_filename;
	$suffixes = explode(';',$activeModules['Imagetool']['suffix']);
	$suffix = ($usePreset && $suffixes[1]) ? sprintf($suffixes[1], $preset_name) : sprintf($suffixes[0], $max_width, $max_height);
	$pathInfo = pathinfo($new_filename);
	// 'filename' was added in PHP5.2.0, but we need to support older installations
	if (!isset($pathInfo['filename'])) $pathInfo['filename'] = basename($pathInfo['basename'], $pathInfo['extension']);
	$new_filename = $pathInfo['filename'] . $suffix . (isset($pathInfo['extension']) ? '.' . $pathInfo['extension'] : '');
    $check_filename = $new_filename;
    $postfix   = '';
    $postfixNo = 0;
    while (file_exists($path . $new_filename)) {
        $postfixNo++;
        $new_filename = $pathInfo['filename'] . '-' . $postfixNo . $suffix . (isset($pathInfo['extension']) ? '.' . $pathInfo['extension'] : '');
    }
    if ($check_filename != $new_filename) {
        printf(__('This file does already exist. To avoid overwriting the old file, it was renamed to <em>%s</em>.').'<br />',
            $new_filename);
    }
    $zoom_filename = $path . $activeModules['Imagetool']['prefix'] . $new_filename;
	$zoom_filename_string = $activeModules['Imagetool']['prefix'] . $new_filename;
    $filename=$new_filename; // workaround for CPO <= 4.1.3 
    $new_filename = $path . $new_filename;
	if (version_compare($CPO['version'], '4.1.3') >= 0) $newFilename = $new_filename; // workaround for CPO >= 4.1.3
	if (file_exists($new_filename)) @unlink($new_filename); // the hard way
	rename ($old_filename, $new_filename);
}

//    echo '<pre>';
//    print_r($_REQUEST);
//    print_r($activeModules['Imagetool']);
//    echo '</pre>';

//if (isset($activeModules['Imagetool']['opt']['zooming']) && isset($_REQUEST['nozoom'][$i]) && $_REQUEST['nozoom'][$i] == '0' && isset($_REQUEST['noresize'][$i]) && $_REQUEST['noresize'][$i] == '0')  {		// Zoom-Bild erstellen
if (isset($activeModules['Imagetool']['opt']['zooming']) && isset($_REQUEST['nozoom'][$i]) && $_REQUEST['nozoom'][$i] == '0')  {		// Zoom-Bild erstellen
	$zoomX = (isset($activeModules['Imagetool']['opt']['forceResize'])) ? $activeModules['Imagetool']['screenx'] : min($checkImage[0],$screenx);
	$zoomY = (isset($activeModules['Imagetool']['opt']['forceResize'])) ? $activeModules['Imagetool']['screeny'] : min($checkImage[1],$screeny);
	imagetool_picture($new_filename, $type, $zoomX, $zoomY, $zoom_filename, $quality, true);
	echo '<img src="'.SKIN_URL.'nav_open.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> ';
	echo sprintf(__('An additional zoomed image version was saved as <i>%s</i>.'),$zoom_filename_string).'<br />';
    @chmod($zoom_filename, 0666);
}

if (isset($_REQUEST['noresize'][$i]) && $_REQUEST['noresize'][$i] == '0')  {
    imagetool_picture($new_filename, $type, $max_width, $max_height, $new_filename, $quality, false);

    $reCheckImage = @getimagesize($new_filename);
    $_FILES['uppedFiles']['size'][$i] = filesize($new_filename);

    printf('<img src="'.SKIN_URL.'nav_open.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> '.__('The image was resized to %s x %s (width x height).').'<br />',
        $reCheckImage[0],
        $reCheckImage[1]
        );
}


unset ($type, $max_height, $max_width, $quality, $reCheckImage);
?>