<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Mitgliederverwaltung"                                |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.2 / October 2020

*/

if (!defined('CPO')) exit;
$translator->addTranslation('members', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['members'] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'Work on members',
    'install'   => 'function: members_install',
    'activate'  => 'function: members_activate',
    'deactivate'=> 'function: members_deactivate',
    'uninstall' => 'function: members_uninstall'
	);

function members_install()
{
    $GLOBALS['message'][] = ___('The member-module was successfully installed!');
}
function members_uninstall()
{
	 $GLOBALS['message'][] = sprintf(__('The member-module was removed from the ConPresso-system. To finally uninstall the member-module, please remove the module directory <i>%s</i>.'),$GLOBALS['modules']['members']['directory']);

}
function members_activate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";

    $GLOBALS['message'][] = ___('The member-module got activated.').$reload_navigation;
}

function members_deactivate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";

    $GLOBALS['message'][] = ___('The member-module got deactivated.').$reload_navigation;
}

function members_navigation($moduleDirectory)
{
    $GLOBALS['navigation']['Members'][] = array(
            'caption'=>'create member',
            'url'=>BASE_REL.'mod_members/members.php?action=users_create'
        );
    $GLOBALS['navigation']['Members'][] = array(
            'caption'=>'work on members',
            'url'=>BASE_REL.'mod_members/members.php'
        );
	$GLOBALS['navigation']['Members'][] = array(
		'caption'=>'reactivate members',
		'url'=>BASE_REL.'mod_members/members.php?action=users_list_deactivated'
	);
}

if (!empty($_SESSION['SID_user']['admin'])) {
	$hdlr_navigation[] = 'function: members_navigation '.$moduleDirectory;
}
?>