<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

if (!defined('CPO')) exit;

$translator->addTranslation('navigation',CPO_BASEDIR.$moduleDirectory.'/lang');

include (CPO_BASEDIR.$moduleDirectory.'/includes/inc_defaults.inc.php');

if (!function_exists('tocHelp')) {
	function tocHelp($topic,$module)  {
		return 'http://manual.conpresso4.de/'.$module.'/'.$topic.".htm";
	}
}

$GLOBALS['modules'][$moduleDirectory] = array(
	'directory'  => $moduleDirectory,
	'caption'	 => 'Newsletter'.' ('.$moduleDirectory.')',
    'install'    => 'function: Newsletter_install '.$moduleDirectory,
    'activate'   => 'function: Newsletter_activate',
    'deactivate' => 'function: Newsletter_deactivate',
    'uninstall'  => 'function: Newsletter_uninstall '.$moduleDirectory,
    'manage'     => 'function: Newsletter_manage '.$moduleDirectory,
	'help'       => 'http://manual.conpresso4.de/newsletter/',
	'owner'      => $cpoSystem['owner'],
	'lkey'       => '',
	'mod_id'	 => 2,
	'installed'  => time(),
	'helptoc'    => array(
        'bersicht' 
			=> tocHelp('index','newsletter'),
        '1. Eigenschaften' 
			=> tocHelp('features','newsletter'),
        '2. Newsletter-Aktionen' 
			=> tocHelp('actions','newsletter'),
        '3. Empfnger' 
			=> tocHelp('recipients','newsletter'),
        '4. Einstellungen' 
			=> tocHelp('settings','newsletter'),
        '5. Rechte' 
			=> tocHelp('rights','newsletter'),
        '6. Anwendung' 
			=> tocHelp('application','newsletter')
	),
// Module settings -------------------------------------------------------------------------------------
	'rights'              => array('1'=>'111'),
	'newsletter_rubric'   => $default_newsletter_rubric,
	'newsletter_template' => $template_name,
    'list_length'         => '10',
    'confirm_delay'       => '3',
    'opt'                 => 'yes',
    'dns_check'           => 'no',
    'mail_check'          => 'yes',
    'regexp'              => '^[a-zA-Z0-9]+([\._a-zA-Z0-9-]+)*@([a-zA-Z0-9-]+\.)+([a-zA-Z]{2,12})$', // new TLDs
    'text_only'           => 'both',
    'sender_email'        => $cpoSystem['admin_email'],
    'include_pics'        => 'yes',
    'notice_to_admin'     => 'no',
    'admin_email'         => $cpoSystem['admin_email'],
    'rehearsal'           => $cpoSystem['admin_email'],
    'use_categories'      => 'yes',
    'use_ranking'         => 'no',
    'ranking_mode'        => 'upcluster',
    'default_rank'        => '3',
    'staggered'           => 'no',
    'num_to_process'      => '25',
	'log'                 => 'yes',
	'pagetemplate_index'  => 0,
	'showArticles'        => 'none',
	'hideArticles'        => 'yes',
	'showMailForm'        => 'yes',
// Newsletter conjobs -------------------------------------------------------------------------------------
    'num_per_cronjob'     => '25',
    'id_cronjob'          => substr(md5($cpoSystem['admin_email'].'id_cronjob'.time()),0,10),
    'num_per_schedule'    => '25',
    'id_schedule'         => substr(md5($cpoSystem['admin_email'].'id_schedule'.time()),0,10),
	'BASE_URL'            => $cpoSystem['base_url'],
	'CPO_BASEDIR'         => CPO_BASEDIR,
// Captcha -------------------------------------------------------------------------------------
	'captcha'             => 'no',
	'captcha_error'       => __('Wrong security code! Remind capital and small letters!'),
	'captcha_template'    => __("<!-- // Captcha-Sicherheitscode -->\n<p><b>Security code:</b> please fill in the shown code in the adjacent input field<br />\n<img src=\"captcha/captcha.php\" border=\"0\" title=\"security code\" onClick=\"reloadCaptcha(this);\">\nFill in the security code here: <input type=\"text\" name=\"sicherheitscode\" size=\"5\"><br />\nThis prevents spam messages.\n</p>"),
	'pic'			      => 'checker.png',
	'font'			      => 'XFILES.TTF',
	'text_color'	      => '#FFFFFF',
	'shadow_color'	      => '#000000',
	'style'			      => 'outline',
    'wrong_hash'          => __('Wrong or invaid hash-code for the requested action!'),
// Newsletter categories -------------------------------------------------------------------------------------
    'header'              => 'Einleitung',
    'main'                => 'Hauptteil',
    'footer'              => 'Ausleitung',
    'categories'          => 'Hardware;Software;Programmierung',
// Newsletter text elements -------------------------------------------------------------------------------------
    'css_sheet'           => '',
    'html_header'         => "<!-- Header -->\n<img src=\"".$cpoSystem['base_url'].$moduleDirectory."/demo/header.jpg\" border=\"0\" alt=\"ConPresso\" >\n<div style=\"margin-left:100px;margin-right:100px;font-size: 11px; color: #555555; font-family: Verdana,Arial,Helvetica\">\n<!-- Content -->\n\n",
    'html_footer'         => "\n\n</div>\n",
// Newsletter personalisation -------------------------------------------------------------------------------------
    'personal_fields'     => '',
    'personal_row'        => '<tr><td><!-- NL-CAPTION --></td><td><!-- NL-INPUT --></td></tr>',
    'necessary_data'      => 'Bitte ergnzen Sie eine Eingabe fr <b>%s</b>!',
// Newsletter text elements -------------------------------------------------------------------------------------
    'no_spam_text'        => 'Sie erhalten diesen Newsletter, da Sie sich auf unserer Website <a href="'.$cpoSystem['base_url'].'">'.$cpoSystem['base_url'].'</a> fr den Newsletter eingetragen haben. Diese Eintragung wurde von Ihnen ausdrcklich per Klick in einem  an Ihre eMail-Adresse gerichteten Besttigungsmail besttigt.',
    'unscribe_text'       => 'Falls Sie kein Interesse an diesem Newsletter mehr haben, knnen sie ihn nach Klick auf den folgenden Link abbestellen und damit alle ihre Daten lschen: <a href="'.$cpoSystem['base_url'].$moduleDirectory.'/index.php"> '.$cpoSystem['base_url'].$moduleDirectory.'/index.php </a>',
    'profile_link_text'   => 'Wenn Sie ihre persnlichen Einstellungen ndern mchten, dann knnen Sie das unter <a href="'.$cpoSystem['base_url'].$moduleDirectory.'/index.php"> '.$cpoSystem['base_url'].$moduleDirectory.'/index.php </a> nach Einloggen mit ihrer eMail-Adresse und dem ihnen mitgeteilten oder selbst gewhlten Passwort tun. Sollten Sie ihr Kennwort vergessen haben, knnne Sie ein neues auf der gleichen Seite anfordern!',
    'special_header_text' => 'X-Notice: Conpresso4-Newsletter',
// Newsletter frontend pages -------------------------------------------------------------------------------------
    'newsletter_list'     => '<p><!-- NL-TITLE --> (<a href="../'.$moduleDirectory.'/preview.php?action=text_preview&nr=<!-- NL-NR -->" target="_blank">Text</a>/<a href="../'.$moduleDirectory.'/preview.php?action=preview&nr=<!-- NL-NR -->" target="_blank">HTML</a>)</p>',
    'newsletter_list_length'=>'10',
    'mini_message'        => 'yes',
    'index_page'          => '
Hier knnen sie sich zum <B>'.$cpoSystem['project'].'-Newsletter</B> anmelden.<BR>
Dadurch werden Sie ber wichtige nderungen auf dieser Seite oder besondere Veranstaltungen informiert.<BR>
<BR>Die Anmeldung zu diesem Newsletter ist kostenlos.<br>Ihre Daten werden von uns nicht weitergegeben.<br>
Sie knnen sich jederzeit wieder abmelden. 
<form method="post" action="index.php">
<table border="0" cellpadding="1" cellspacing="1">
<input name="action" type="hidden" value="subscribe">
<input name="rubric" type="hidden" value="<!-- NL-RUBRIC -->">
	<tr>
      <td width="100"> Name:* </td>
		<td>
			<input type="text" name="Name" value="<!-- NL-NAME -->">
		</td>
	</tr>
	<tr>
		<td>
			eMail:
		</td>
		<td>
			<input type="text" name="eMail" value="<!-- NL-MAIL -->">
		</td>
	</tr>
	<!-- NL-DATA-ROWS -->
	<tr>
		<td> </td>
		<td><!-- NL-CAPTCHA --></td>
	</tr>
	<tr>
		<td>
		</td>
		<td>
			<input type="submit" name="subscribe" value="eintragen"> <input type="submit" name="unscribe" value="austragen">
		</td>
	</tr>
</table>
</form>

<p>* die gekennzeichneten Angaben sind optional. Gem 3 Abs. 4 und 4 des Teledienstdatenschutzgesetzes (TDDSG) weisen wir darauf hin, dass diese Angaben freiwillig sind. Sie knnen den Newsletter auch anonym bestellen.</p>
<p>Wenn Sie bereits ein Abonennt sind, knnen sie sich hier einloggen, um ihre persnlichen Einstellungen zu verndern:</p>
<form method="post" action="index.php">
<table border="0" cellpadding="1" cellspacing="1">
<input name="action" type="hidden" value="login">
<input name="rubric" type="hidden" value="<!-- NL-RUBRIC -->">
    <tr> 
      <td width="100"> eMail:</td>
      <td> <input type="text" name="eMail" value="<!-- NL-MAIL -->"> </td>
    </tr>
    <tr> 
      <td> Passwort: </td>
      <td> <input type="password" name="password" value=""> </td>
    </tr>
    <tr> 
      <td> </td>
      <td> 	<input type="submit" name="subscribe2" value="senden"> 
      		<input type="submit" name="subscribe3" value="Passwort vergessen!"> 
      </td>
    </tr>
  </table>
</form>
<p>(falls sie ihr Passwort vergessen haben, geben Sie ihre eMail Adresse ein und klicken auf "Passwort vergessen!")</p>',
    'mini_message'=>'no',
    'mini_index_page'=>'
Kostenlos versorgt Sie der <B>'.$cpoSystem['project'].'-Newsletter</B> mit allen Neuigkeiten.<BR>
Jetzt abonnieren - nie wieder etwas verpassen!<BR> 
<form method="post" action="index.php">
<input name="action" type="hidden" value="subscribe">
<input name="rubric" type="hidden" value="<!-- NL-RUBRIC -->">
eMail:<BR>
<input type="text" name="eMail" value="<!-- NL-MAIL -->"><BR>
Name (optional):<BR>
<input type="text" name="Name" value="<!-- NL-NAME -->"><BR>
<input type="submit" name="subscribe" value="Newsletter bestellen">
</form>',
    'mini_confirmation_page'=>'Vielen Dank fr Ihr Interesse an unserem Newsletter.<BR>
<BR>
Sie erhalten in in Krze eine eMail von uns, die Sie bitte durch Klicken des enthaltenen Links innerhalb von 3 Tagen besttigen. Hierdurch wird Ihre Bestellung des Newsletters abgeschlossen.',
    'hint_on_email_error'=>'Ihre Anmeldung fr den Newsletter war nicht erfolgreich, da die eMail-Adresse <I>%s</I> ungltig zu sein scheint!',
    'hint_already_in_list'=>'Ihre Anmeldung fr den Newsletter war nicht erfolgreich, da die eMail-Adresse <I>%s</I> bereits als Empfnger eingetragen ist!',
    'hint_banned'=>'Ihre Anmeldung fr den Newsletter war nicht erfolgreich, da die eMail-Adresse <I>%s</I> vom Administrator gebannt wurde!',
    'hint_on_password_error'=>'Login nicht erfolgreich! Bitte prfen Sie ihre Daten und versuchen es noch einmal!',
    'hint_no_subsrciber'=>'Die eMail-Adrese <I>%s</I> ist kein eingetragener Empfnger!',
    'hint_to_unsrciber'=>'Eine Mail mit Informationen zum Austragen wurde an die angegebene Mail-Adresse geschickt. Bitte prfen Sie Ihren Posteingang!',
    'hint_on_password_verification'=>'Eine Mail mit Informationen und einem Link zum Eintragen wurde an die angegebene Mail-Adresse geschickt. Bitte prfen Sie Ihren Posteingang!',
    'hint_on_password_change'=>'Ihr neues Passwort wurde aktiviert! Bitte loggen Sie sich nun ein, um ein eigenes zu whlen!',
    'password_change_error'=>'Fehler bei der Eingabe der Passwrter! Das neue Passwort wurde NICHT gespeichert! Bitte versuchen Sie es erneut!',
    'confirmation_page'=>'Vielen Dank fr Ihr Interesse an unserem Newsletter.<BR>
<BR>
Sie erhalten in in Krze eine eMail von uns, die Sie bitte durch Klicken des enthaltenen Links innerhalb von 3 Tagen besttigen. Hierdurch wird Ihre Bestellung des Newsletters abgeschlossen.<BR>
<BR>
Warum die E-Mail nochmals besttigen?<BR>
<BR>
Prinzipiell kann jeder Internet-User beliebige eMail-Adressen in den Verteiler eintragen. Um sicherzustellen, dass nur der Besitzer einer eMail-Adresse diese auch in den Verteiler eintragen kann, wird vom Besitzer der Adresse eine kurze Besttigung bentigt. Es wird dadurch sichergesetllt, dass der Newsletter nicht an Personen geschickt wird die dessen Erhalt nicht wnschen.<BR>
<BR>
Fr Sie ein kurzer Klick - fr uns die Sicherheit, dass wir unseren Newsletter auch nur an Interessierte verschicken.',
    'unscribe_info'=>'Sie wurden erfolgreich aus der Verteilerliste unseres Newsletters ausgetragen!',
    'auth_page'=>'<p><b>Sie wurden erfolgreich in die Verteilerliste unseres Newsletters aufgenommen!</b></p>
<br>
<p>Nun knnen Sie sich hier einloggen, um ihre persnlichen Einstellungen zu verndern:</p>
<form method="post" action="index.php">
<table border="0" cellpadding="1" cellspacing="1">
<input name="action" type="hidden" value="login">
<input name="rubric" type="hidden" value="<!-- NL-RUBRIC -->">
    <tr> 
      <td width="100"> eMail:</td>
      <td> <input type="text" name="eMail" value=""> </td>
    </tr>
    <tr> 
      <td> Passwort: </td>
      <td> <input type="password" name="password" value=""> </td>
    </tr>
    <tr> 
      <td> </td>
      <td> 	<input type="submit" name="subscribe2" value="senden"> 
      		<input type="submit" name="subscribe3" value="Passwort vergessen!"> 
      </td>
    </tr>
  </table>
</form>
<p>(falls sie ihr Passwort vergessen haben, geben Sie ihre eMail Adresse ein und klicken auf "Passwort vergessen!")</p>',
    'user_page'=>'
<form method="post" action="index.php">
<h3>Profil-Seite von <!-- NL-MAIL --></h3>
<table border="0" cellspacing="0" cellpadding="0">
  <input name="rubric" type="hidden" value="<!-- NL-RUBRIC -->">
    <tr> 
      <td>Name:</td>
      <td colspan="2"><input type="text" name="name" value="<!-- NL-NAME -->"></td>
    </tr>
    <tr> 
      <td>Kategorien:</td>
      <td colspan="2"><!-- NL-CAT-ALL --> Alle</td>
    </tr>
    <tr> 
      <td> </td>
      <td width="100" valign="top"><!-- NL-CAT-SELECT --> Auswahl</td>
      <td><!-- NL-CAT-CHECK --></td>
    </tr>
	<!-- NL-DATA-ROWS -->
    <tr> 
      <td> </td>
      <td colspan="2"><input type="submit" name="change_profile" value="Abschicken"></td>
    </tr>
    <tr> 
      <td> </td>
      <td colspan="2"> </td>
    </tr>
    <tr> 
      <td><strong>Passwort ndern</strong></td>
      <td colspan="2">  </td>
    </tr>
    <tr> 
      <td>Altes Passwort:</td>
      <td colspan="2"><input type="password" name="old_password"></td>
    </tr>
    <tr> 
      <td>Neues Passwort:</td>
      <td colspan="2"><input type="password" name="new_password"></td>
    </tr>
    <tr> 
      <td>Passwort-Wiederholung:</td>
      <td colspan="2"><input type="password" name="new_password_double"></td>
    </tr>
    <tr>
      <td> </td>
      <td colspan="2"><input type="submit" name="change_password" value="Passwort ndern">
      </td>
    </tr>
  </table>
</form>
',
    'profile_change_successful'=>'Ihr Profil wurde aktualisiert!',
    'password_change_successful'=>'Ihr Passwort wurde gendert!',
// Confirmation mail contents -------------------------------------------------------------------------------------
    'confirmation_mail_subject'=>'Newsletter - Bitte besttigen Sie Ihre Anmeldung!',
    'confirmation_mail_content'=>'Guten Tag!

Ihre eMail-Adresse [<!-- NL-MAIL -->] wurde unter
'.$cpoSystem['base_url'].' in die Verteilerliste
unseres Newsletters eingetragen.

Um zu besttigen, dass Sie unseren Newsletter an die angegebene
eMail-Adresse erhalten mchten und um die Anmeldung abzuschlieen,
klicken Sie bitte auf den folgenden Link:

<!-- NL-CONFIRMATION-LINK -->

Nachdem Sie diesen Link angeklickt haben, knnen Sie sich im
Newsletterbereich mit folgenden Daten einloggen

eMail: <!-- NL-MAIL -->
Passwort: <!-- NL-PASSWORD -->

um dort persnliche Einstellungen vorzunehmen und z.B. ihr
Passwort zu ndern. Sollten Sie ihr Passwort vergessen, knnen
Sie auch ein neues anfordern.

Hinweis:

Sollte jemand anders Ihre eMail-Adresse in den Newsletter eingetragen
haben, bitten wir fr diese eMail um Entschuldigung. Mchten Sie unseren
Newsletter nicht beziehen, ist keine Reaktion auf diese eMail notwendig.
Erhalten wir innerhalb von <!-- NL-DELAY --> Tagen keine Besttigung, wird Ihre
eMail-Adresse automatisch aus unserem Verteiler gelscht.

------------------------------------------------------------------------
Copyright (c) '.date("Y").'  '.$cpoSystem['base_url'].'
------------------------------------------------------------------------',
    'confirmed_subject'=>'Willkommen beim \''.$cpoSystem['project'].'-Newsletter\'',
    'confirmed_content'=>'Lieber Newsletter-Abonnent,

wir haben Ihre eMail-Adresse [<!-- NL-MAIL -->] in die Verteilerliste
unseres Newsletters aufgenommen.

Zuknftig informieren wir Sie bei nderungen auf der Website und
aktuelle Ereignisse.

Dieser Service ist fr Sie selbstverstndlich kostenlos.

Sie haben die Mglichkeit sich ber den folgenden Link jederzeit wieder
auszutragen:
<!-- NL-UNSCRIBE-LINK -->

------------------------------------------------------------------------
Copyright (c) '.date("Y").'  '.$cpoSystem['base_url'].'
------------------------------------------------------------------------',
    'unconfirmed_subject'=>'Willkommen beim \''.$cpoSystem['project'].'-Newsletter\'',
    'unconfirmed_content'=>'Lieber Newsletter-Abonnent,

wir haben Ihre eMail-Adresse [<!-- NL-MAIL -->] in die Verteilerliste
unseres Newsletters aufgenommen.

Zuknftig informieren wir Sie bei nderungen auf der Website und
aktuelle Ereignisse.

Dieser Service ist fr Sie selbstverstndlich kostenlos.

Sie knnen Sie sich im Newsletterbereich mit folgenden Daten einloggen

eMail: <!-- NL-MAIL -->
Passwort: <!-- NL-PASSWORD -->

um dort persnliche Einstellungen vorzunehmen und z.B. ihr
Passwort zu ndern. Sollten Sie ihr Passwort vergessen, knnen
Sie auch ein neues anfordern.

Sie haben die Mglichkeit sich ber den folgenden Link jederzeit wieder
auszutragen:
<!-- NL-UNSCRIBE-LINK -->

------------------------------------------------------------------------
Copyright (c) '.date("Y").'  '.$cpoSystem['base_url'].'
------------------------------------------------------------------------',
    'unscribe_subject'=>'Austragen vom \''.$cpoSystem['project'].'-Newsletter\'',
    'unscribe_content'=>'Lieber Newsletter-Abonnent,

mit Bedauern haben wir ihre Mail-Adresse [<!-- NL-MAIL -->] zum Lschen
vorbereitet, die unter '.$cpoSystem['base_url'].'mod_newsletter/index.php als
zu entfernen gemeldet wurde.

Durch Klick auf den folgenden Link wird Ihre Mail-Adresse und alle
zugehrigen Angaben unwiederruflich gelscht:
<!-- NL-UNSCRIBE-LINK -->

Sollten Sie keine Enfernung aus unserem Newsletter-Verteiler wnschen
oder haben Sie dies gar nicht selbst beantragt, dann ignorieren Sie
bitte dieses eMail!

------------------------------------------------------------------------
Copyright (c) '.date("Y").'  '.$cpoSystem['base_url'].'
------------------------------------------------------------------------',
    'forgotten_password_subject'=>'Neues Passwort angefordert bei \''.$cpoSystem['project'].'-Newsletter\'',
    'forgotten_password_content'=>'Lieber Newsletter-Abonnent,

fr ihre Mail-Adresse [<!-- NL-MAIL -->] wurde auf unserer Website
'.$cpoSystem['base_url'].' ein neues Passwort angefordert.

Das neue Passwort lautet: <!-- NL-NEW-PASSWORD -->

Wenn Sie sich damit auf unserer Seite einloggen, knnen und sollten
Sie dieses wieder nach Wunsch ndern.

Durch Klick auf den folgenden Link wird dieses Passwort aktiviert:
<!-- NL-NEW-PASSWORD-LINK -->

Sollten Sie dieses neue Passwort nicht selbst angefordert haben,
dann ignorieren Sie bitte dieses eMail! Selbstverstndlich bleibt
dann Ihr bisheriges Passwort gltig!

------------------------------------------------------------------------
Copyright (c) '.date("Y").'  '.$cpoSystem['base_url'].'
------------------------------------------------------------------------',
    'notice_to_admin_subject'=>'Ein neuer Eintrag im \''.$cpoSystem['project'].'-Newsletter\'',
    'notice_to_admin_content'=>'Lieber Admin,

die eMail-Adresse [<!-- NL-MAIL -->] wurde in die Verteilerliste
des Newsletters aufgenommen.

------------------------------------------------------------------------
Copyright (c) '.date("Y").'  '.$cpoSystem['base_url'].'
------------------------------------------------------------------------',
    'unscribe_to_admin_subject'=>'Lschung eines Eintrag im \''.$cpoSystem['project'].'-Newsletter\'',
    'unscribe_to_admin_content'=>'Lieber Admin,

die eMail-Adresse [<!-- NL-MAIL -->] wird aus der Verteilerliste
des Newsletters gelscht.

------------------------------------------------------------------------
Copyright (c) '.date("Y").'  '.$cpoSystem['base_url'].'
------------------------------------------------------------------------'
// END -------------------------------------------------------------------------------------
);
//}

// Hier kommen die Basis-Funktionen ***************************************************************

if (!function_exists('Newsletter_install'))  {
	function Newsletter_install($moduleDirectory)
	{
		global $dbPrefix, $db;
		include (CPO_BASEDIR.$moduleDirectory.'/includes/inc_defaults.inc.php');
		include (CPO_BASEDIR.$GLOBALS['modules'][$moduleDirectory]['directory'].'/includes/setup.inc.php');
	}
}

if (!function_exists('Newsletter_activate'))  {
	function Newsletter_activate()
	{
		// Navigation reloaden in frame "cpo_navigation"
		$reload_navigation = "<script type=\"text/javascript\">";
		$reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
		$reload_navigation .= "</script>";

		$GLOBALS['message'][] = __('The newsletter-module got activated.').$reload_navigation;
	}
}

if (!function_exists('Newsletter_deactivate'))  {
	function Newsletter_deactivate()
	{
		$reload_navigation = "<script type=\"text/javascript\">";
		$reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
		$reload_navigation .= "</script>";

		$GLOBALS['message'][] = __('The newsletter-module got deactivated.').$reload_navigation;
	}
}

if (!function_exists('Newsletter_uninstall'))  {
	function Newsletter_uninstall($moduleDirectory)
	{
		global $dbPrefix, $db;
		$GLOBALS['message'][] .= __('The newsletters, the newsletter rubric, the template an all the rights have been kept. To remove these just use the common Conpresso functions.');
		$GLOBALS['message'][] .= sprintf(__('The module was removed from the ConPresso-system. To finally uninstall the module, please remove the module directory <i>%s</i>.'),$GLOBALS['modules'][$moduleDirectory]['directory']);
	}
}



if (!function_exists('Newsletter_manage'))  {
	function Newsletter_manage($moduleDirectory)
	{
		global $dbPrefix, $db, $k, $module_status;
        $newsletter_rubric_id = '';
		$db_rubric = new DB;
		$query = "SELECT id, source_rubric_id "
		."FROM ".$dbPrefix."_rubric "
		."WHERE name = '".$moduleDirectory."'";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db_rubric->query($query);
		if ( $db_rubric->num_rows()>0 )  {
			$db_rubric->next_record();
			$newsletter_rubric_id = $db_rubric->v('id');
		}
		printIcon(
			BASE_ABS.$GLOBALS['modules'][$moduleDirectory]['directory'].'/newsletter.php?list=options', 
			SKIN_URL.'pic_settings.gif', 
			__('options'),
			array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE
		);
		printIcon(
			BASE_ABS.$GLOBALS['modules'][$moduleDirectory]['directory'].'/newsletter.php?list=rights&rubric_id='.$newsletter_rubric_id,
			SKIN_URL.'pic_rights.gif', 
			__('rights'),
			array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE
		);
	}
}

if (!function_exists('Newsletter_navigation'))  {
	function Newsletter_navigation($moduleDirectory)
	{
		global $activeModules, $translator, $dbPrefix;
		// Ermittlung Navigationsposition der Newsletterrubrik
		$newsletter_nav_id = '';
		$nav_pos_newsletter = '';
		$goto_newsletter_dir = FALSE;
		$db_rubric = new DB;
		$db_navtree = new DB;
		$query = "SELECT id, source_rubric_id "
		."FROM ".$dbPrefix."_rubric "
		."WHERE name = '".$activeModules[$moduleDirectory]['newsletter_rubric']."'";
		DEBUG(1, $query, __FILE__, __LINE__);
		$db_rubric->query($query);
		if ( $db_rubric->num_rows()>0 )  {
			$db_rubric->next_record();
			$newsletter_rubric_id = $db_rubric->v('id');
			if ($_SESSION['SID_rubric_id'] != $db_rubric->v('id'))  {
				$query = "SELECT id "
				."FROM ".$dbPrefix."_navtree "
				."WHERE rubric_id = '".$db_rubric->v('id')."'";
				DEBUG(1, $query, __FILE__, __LINE__);
				$db_navtree->query($query);
				if ( $db_navtree->num_rows()>0 )  {
					$db_navtree->next_record();
					$newsletter_nav_id = $db_navtree->v('id');
				} else {
					$newsletter_nav_id = 0;
				}
				$nav_pos_newsletter = $newsletter_nav_id .":". $db_rubric->v('id');
				$goto_newsletter_dir = TRUE;
			}
		}

		$id = $_SESSION['SID_user']['id'];
		$rights = $activeModules[$moduleDirectory]['rights'][$id];
		$permission_to_see = $rights[0];
		$permission_receivers = $rights[1];
		$permission_sending = $rights[2];
		if ($permission_to_see == '1') {

			if ($goto_newsletter_dir)  {
				$GLOBALS['navigation']['Newsletter ('.$moduleDirectory.')'][] = array(
					'caption'=>'create newsletter',
					'title'=>'create a new newsletter',
					'target'=>'_top',
					'url'=>BASE_URL.$activeModules[$moduleDirectory]['directory'].'/rubric.php?action=create&navigation='.$nav_pos_newsletter
				);
				$GLOBALS['navigation']['Newsletter ('.$moduleDirectory.')'][] = array(
					'caption'=>'work on newsletters',
					'title'=>'manage the existing newsletters',
					'target'=>'_top',
					'url'=>BASE_URL.$activeModules[$moduleDirectory]['directory'].'/rubric.php?navigation='.$nav_pos_newsletter
				);
				$GLOBALS['navigation']['Newsletter ('.$moduleDirectory.')'][] = array(
					'caption'=>'compose newsletter',
					'title'=>'composing a newsletter',
					'target'=>'_top',
					'url'=>BASE_URL.$activeModules[$moduleDirectory]['directory'].'/rubric.php?action=compose&navigation='.$nav_pos_newsletter
				);
			} else { // not sure if SID is still needed...
				$GLOBALS['navigation']['Newsletter ('.$moduleDirectory.')'][] = array(
					'caption'=>'create newsletter',
					'title'=>'create a new newsletter',
					'url'=>BASE_URL.$activeModules[$moduleDirectory]['directory'].'/newsletter.php?list=create&'.SID
				);
				$GLOBALS['navigation']['Newsletter ('.$moduleDirectory.')'][] = array(
					'caption'=>'work on newsletters',
					'title'=>'manage the existing newsletters',
					'url'=>BASE_URL.$activeModules[$moduleDirectory]['directory'].'/newsletter.php?list=letters&'.SID
				);
				$GLOBALS['navigation']['Newsletter ('.$moduleDirectory.')'][] = array(
					'caption'=>'compose newsletter',
					'title'=>'composing a newsletter',
					'url'=>BASE_URL.$activeModules[$moduleDirectory]['directory'].'/newsletter.php?list=compose&'.SID
				);
			}

			if ($permission_receivers == '1')   {
				$GLOBALS['navigation']['Newsletter ('.$moduleDirectory.')'][] = 'space';
				$GLOBALS['navigation']['Newsletter ('.$moduleDirectory.')'][] = array(
					'caption'=>'add recipient',
					'title'=>'create a new recipient',
					'url'=>BASE_URL.$activeModules[$moduleDirectory]['directory'].'/newsletter.php?action=modify'
				);
				$GLOBALS['navigation']['Newsletter ('.$moduleDirectory.')'][] = array(
					'caption'=>'work on recipients',
					'title'=>'manage the existing recipients',
					'url'=>BASE_URL.$activeModules[$moduleDirectory]['directory'].'/newsletter.php?list=email'
				);
				$GLOBALS['navigation']['Newsletter ('.$moduleDirectory.')'][] = array(
					'caption'=>'upload recipients list',
					'title'=>'upload a file',
					'url'=>BASE_URL.$activeModules[$moduleDirectory]['directory'].'/newsletter.php?list=upload'
				);
			}
		}
	}
}


if (isset($_SESSION['SID_user']['admin']) && $_SESSION['SID_user']['admin']>=ROLE_EDITOR)  {
    $hdlr_navigation[] = 'function: Newsletter_navigation '.$moduleDirectory;
}

$hdlr_parser_content[$moduleDirectory]      = array('include: '.urlencode($GLOBALS['modules'][$moduleDirectory]['directory'].'/includes/parser_c_newsletter.inc.php'));
$hdlr_parser_replacement[$moduleDirectory]  = array('include: '.urlencode($GLOBALS['modules'][$moduleDirectory]['directory'].'/includes/parser_r_newsletter.inc.php'));

// the CPO4.1 PageTemplate-Functions
if (!function_exists('cpoPageNewsletterMiniForm')) {
    function cpoPageNewsletterMiniForm($modNLdir)    { 
        global $activeModules,$translator,$dbPrefix,$cpoRubric; 
        $modNLdir = str_replace(array(';',' ','/'),'',$modNLdir);
        ob_start();
        $directory = $modNLdir;
        include_once(CPO_BASEDIR.$activeModules[$modNLdir]['directory'].'/includes/newsletter_functions.inc.php');
        include(CPO_BASEDIR.$activeModules[$modNLdir]['directory'].'/includes/actions.inc.php');
        // Seitenausgabe ********************************************************
        if ($activeModules[$modNLdir]['mini_message'] == 'yes' ) require(CPO_BASEDIR."_include/message.php");
        $form_style = "mini";
        require(CPO_BASEDIR.$activeModules[$modNLdir]['directory'].'/includes/i_index.php');
        unset ($form_style);
        $showForm = ob_get_clean();
        return $showForm;
    }
}

if (array_key_exists($moduleDirectory,$activeModules)) {
// Nach $confirm_delay Tagen wird eine nicht bestaetigte eMail-Adesse wieder geloescht!
	$now = time();
	$query = "DELETE FROM ".$dbPrefix."_mod_newsletter_adresses WHERE ctime < '".($now-($activeModules[$moduleDirectory]['confirm_delay']*86400))."' AND active = '0' AND newsletter='".$moduleDirectory."'";
	DEBUG(1, 'Lschen von Empfngern mit berflligen Besttigungen<br /><br />'.$query, __FILE__, __LINE__);
	$db_recipients = new DB;
	$db_recipients->query($query);
}


?>
