<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

if (!defined('CPO')) exit;

// Die Conpresso Artikel-Aktionen (mit angepassten Texten)

$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);
while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'articles_sort': // {{{
        if (empty($sort_id)) break;

        // FIXME article versions are not sorted?
        $db = new DB;
        $db->query('UPDATE '.$dbPrefix.'_news SET '
                  ."sort_id='".$switch_id."' "
                  ."WHERE artikel_archiv=0 "
                  ."AND nr=".$sort_nr);

        $db->query('UPDATE '.$dbPrefix.'_news SET '
                  ."sort_id='".$sort_id."' "
                  ."WHERE artikel_archiv=0 "
                  ."AND nr='".$switch_nr."'");
        logaction('switch article order', $switch_id.' <-> '.$sort_nr);
        break;
        // }}}
    case 'articles_status': // {{{ articles_status_versions, articles_status_release
    case 'articles_status_versions':
        if ($_SESSION['SID_stufe4']!=1) {
            $message[] = __('Sorry, you are not allowed to change the status of a newsletter.');
            break;
        }
    case 'articles_status_release': // for the "articles release" view
        $db = new DB;
        $query = 'SELECT article_nr, titel, autor, email, name '
                .'FROM '.CPO_NEWS.', '.CPO_RUBRIC.' '
                .'WHERE rubric_id = '.CPO_RUBRIC.'.id '
                ."AND nr='".addslashes($_REQUEST['nr'])."'";
        $db->query($query);
        $db->next_record();
        $article_nr = $db->v('article_nr');
        $titel      = $db->v('titel');
        $autor      = $db->v('autor');
        $email      = $db->v('email');
        $rubric     = $db->v('name');

        if ($_REQUEST['status']==STATE_REJECTED && !isset($_REQUEST['sendmessage'])) {
            switch ($nextaction) {
            case 'articles_status':
                $views = array('reject'); 
                break;
            case 'articles_status_versions':
                $views = array('reject_versions'); 
                break;
            case 'articles_status_release':
                $views = array('reject_release'); 
                break;
            }
            break;
        }

        $query = 'UPDATE '.CPO_NEWS.' SET '
                ."freigabe='".addslashes($_REQUEST['status'])."', "
                ."released_user_id='".addslashes($_SESSION['SID_user']['id'])."', "
                ."release_date='".addslashes(date('Y-m-d H:i:s', time()))."' "
                ."WHERE nr='".addslashes($_REQUEST['nr'])."'";
        $db->query($query);

        if ($_REQUEST['status']==STATE_RELEASED) {
           $query = 'UPDATE '.CPO_NEWS.' SET '
                   ."artikel_archiv=5 "
                   ."WHERE article_nr=".$article_nr." "
                   ."AND artikel_archiv>0";
           $db->query($query);
        }

        $m = '';
        switch ($_REQUEST['status']) {
        case STATE_RELEASED:
            $message[] = sprintf(___('The newsletter %s got released.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            logaction('release article', $_REQUEST['nr'].': '.$titel);
            break;
        case STATE_BLOCKED:
            $message[] = sprintf(___('The newsletter %s got blocked.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            logaction('blocked article', $_REQUEST['nr'].': '.$titel);
            break;
        case STATE_REJECTED:
            $message[] = sprintf(___('The newsletter %s got rejected.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            if (isset($_REQUEST['sendmessageyes'])) {
                ini_set('sendmail_from', $cpoSystem['system_email']);
                mail($email, $_REQUEST['subject'], wordwrap($_REQUEST['body']), 'FROM: '.$cpoSystem['system_email']);
                ini_restore('sendmail_from');
                $message[] = sprintf(___('A message was sent to the author %s <%s>.'), $autor, $email);
            } else {
                $message[] = sprintf(___('No message was sent to the author %s <%s>.'), $autor, $email);
            }

            logaction('reject article', $_REQUEST['nr'].': '.$titel);
            break;
        }

        switch ($nextaction) {
        case 'articles_status_versions':
            $views = array('list_versions');
            $_POST['nr'] = $article_nr;
            break;
        case 'articles_status_release':
            $views = array('list_release');
            break;
        default:
            $views = array('list');
            break;
        }
        break;
        // }}}
    case 'articles_create': // {{{
        //$_POST['nr']          = '';
        //$_POST['article_nr']  = '';
        //$_POST['auth']        = '';
        //$_POST['sort_id']     = '';
        //$_POST['freigabe']    = '';
        $_POST['content']     = array();
        $views = array('edit_form');
        break;
        // }}}
    case 'articles_modify': // {{{
        // check if article is locked by someone else...
        $query = "SELECT COUNT(*) FROM ".CPO_BLOCK." "
                ."WHERE news_nr='".addslashes($_REQUEST['nr'])."' ";
        DEBUG(1, 'Check if newsletter is locked.<br /><br />'.$query, __FILE__, __LINE__);
        $db = new DB;
        $db->query($query);
        $db->next_record();
        
        if ($db->v('COUNT(*)')>0) {
            $message[] = __('The newsletter is already in use.');
            break;
        } 

        // lock article for other editors
        $query = "INSERT INTO ".CPO_BLOCK." VALUES ("
                ."'', "
                ."'".addslashes($_REQUEST['nr'])."', "
                ."'".(date('Y-m-d H:i:s', time()))."', "
                ."'".$_SESSION['SID_log_login_id']."') ";
        $db->query($query); 

        $query = "SELECT nr, idx, auth, keywords, commentary, titel, templates_id, verfallsdatum, pub_datum, autor, email, initial, freigabe, sort_id "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".addslashes($_GET['nr'])."' ";
        $db = new DB;
        $db->query($query);
        $db->next_record();
            
        $_POST['idx']           = $db->v('idx')=='zzzzzz' ? '' : $db->v('idx');
        $_POST['nr']            = $db->v('nr');
        $_POST['auth']          = $db->v('auth');               
        $_POST['keywords']      = $db->v('keywords');         
        $_POST['commentary']    = $db->v('commentary');         
        $_POST['titel']         = $db->v('titel'); 
        $_POST['templates_id']  = $db->v('templates_id');           
        $_POST['verfallsdatum'] = $db->v('verfallsdatum');      
        $_POST['pub_datum']     = $db->v('pub_datum');          
        $_POST['autor']         = $db->v('autor'); 
        $_POST['email']         = $db->v('email');              
        $_POST['initial']       = $db->v('initial');           
        $_POST['freigabe']      = $db->v('freigabe');           
        $_POST['sort_id']       = $db->v('sort_id');            

        $_POST['content'] = array();

        // Images 
        $query = "SELECT id, fieldname, image_id "
                ."FROM ".CPO_CONTENT_IMAGES." "
                ."WHERE article_id='".$_POST['nr']."'";
        $db_form = new DB;
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (image)'] = array(
                'type'    => 'image',
                'name'    => $db_form->v('fieldname'),
                'id'      => $db_form->v('id'),
                'image_id'=> $db_form->v('image_id')
            );
        }

        // Files 
        $query = "SELECT id, fieldname, file_id "
                ."FROM ".CPO_CONTENT_FILES." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (file)'] = array(
                'type'   => 'file',
                'name'   => $db_form->v('fieldname'),
                'id'     => $db_form->v('id'),
                'file_id'=> $db_form->v('file_id')
            );
        }

        // Texts 
        $query = "SELECT id, fieldname, text "
                ."FROM ".CPO_CONTENT_TEXT." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (text)'] = array(
                'type' => 'text',
                'name' => $db_form->v('fieldname'),
                'id'   => $db_form->v('id'),
                'text' => $db_form->v('text')
            );
        }

        // HTMLs 
        $query = "SELECT id, fieldname, html "
                ."FROM ".CPO_CONTENT_HTML." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (html)'] = array(
                'type' => 'html',
                'name' => $db_form->v('fieldname'),
                'id'   => $db_form->v('id'),
                'html' => $db_form->v('html')
            );
        }

        // URLs 
        $query = "SELECT id, fieldname, url, urltext, urltarget "
                ."FROM ".CPO_CONTENT_URLS." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (url)'] = array(
                'type'      => 'url',
                'name'      => $db_form->v('fieldname'),
                'id'        => $db_form->v('id'),
                'url'       => $db_form->v('url'),
                'urltext'   => $db_form->v('urltext'),
                'urltarget' => $db_form->v('urltarget')
            );
        } 

        $views = array('edit_form');
        
        break;
        // }}}
    case 'articles_copy': // {{{
        $_POST['copy'] = true;

        $query = "SELECT nr, idx, auth, keywords, commentary, titel, templates_id, verfallsdatum, pub_datum, autor, email, initial, freigabe, sort_id "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".addslashes($_GET['nr'])."' ";
        $db = new DB;
        $db->query($query);
        $db->next_record();
            
        $_POST['idx']           = $db->v('idx')=='zzzzzz' ? '' : $db->v('idx');
        $_POST['nr']            = $db->v('nr');
        $_POST['auth']          = $db->v('auth');               
        $_POST['keywords']      = $db->v('keywords');         
        $_POST['commentary']    = $db->v('commentary');         
        $_POST['titel']         = sprintf(__('Copy of %s'), $db->v('titel'));
        $_POST['templates_id']  = $db->v('templates_id');           
        $_POST['verfallsdatum'] = $db->v('verfallsdatum');      
        $_POST['pub_datum']     = $db->v('pub_datum');          
        $_POST['autor']         = $db->v('autor'); 
        $_POST['email']         = $db->v('email');              
        $_POST['initial']       = $db->v('initial');           
        $_POST['freigabe']      = $db->v('freigabe');           
        $_POST['sort_id']       = $db->v('sort_id');            

        $_POST['content'] = array();

        // Images 
        $query = "SELECT id, fieldname, image_id "
                ."FROM ".CPO_CONTENT_IMAGES." "
                ."WHERE article_id='".$_POST['nr']."'";
        $db_form = new DB;
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (image)'] = array(
                'type'    => 'image',
                'name'    => $db_form->v('fieldname'),
                'id'      => $db_form->v('id'),
                'image_id'=> $db_form->v('image_id')
            );
        }

        // Files 
        $query = "SELECT id, fieldname, file_id "
                ."FROM ".CPO_CONTENT_FILES." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (file)'] = array(
                'type'   => 'file',
                'name'   => $db_form->v('fieldname'),
                'id'     => $db_form->v('id'),
                'file_id'=> $db_form->v('file_id')
            );
        }

        // Texts 
        $query = "SELECT id, fieldname, text "
                ."FROM ".CPO_CONTENT_TEXT." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (text)'] = array(
                'type' => 'text',
                'name' => $db_form->v('fieldname'),
                'id'   => $db_form->v('id'),
                'text' => $db_form->v('text')
            );
        }

        // HTMLs 
        $query = "SELECT id, fieldname, html "
                ."FROM ".CPO_CONTENT_HTML." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (html)'] = array(
                'type' => 'html',
                'name' => $db_form->v('fieldname'),
                'id'   => $db_form->v('id'),
                'html' => $db_form->v('html')
            );
        }

        // URLs 
        $query = "SELECT id, fieldname, url, urltext, urltarget "
                ."FROM ".CPO_CONTENT_URLS." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (url)'] = array(
                'type'      => 'url',
                'name'      => $db_form->v('fieldname'),
                'id'        => $db_form->v('id'),
                'url'       => $db_form->v('url'),
                'urltext'   => $db_form->v('urltext'),
                'urltarget' => $db_form->v('urltarget')
            );
        } 

        // create "new" article
        $_POST['nr'] = 0; // $db->v('nr');

        $views = array('edit_form');
        
        break;
        // }}}
    case 'articles_delete': // {{{
        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');
        $views = array('reallydelete');
        break;
    // }}}
    case 'articles_delete_really': // {{{
        if ($_SESSION['SID_stufe2']!=1) {
            $message[] = __('Sorry, you are not allowed to delete a newsletter.');
            break;
        }

        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_POST['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');

        if (isset($_POST['no'])) {
            $message[] = sprintf(htmlspecialchars(__('The newsletter %s was not deleted.'), ENT_COMPAT, 'ISO-8859-15'), '<i>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</i>');
            break;
        }

        // article gets marked as deleted (but not really deleted!
        $db->query("UPDATE ".CPO_NEWS." "
                  ."SET artikel_archiv=5 "
                  ."WHERE artikel_archiv=1 "
                  ."AND article_nr='".addslashes($_POST['nr'])."'"); // FIXME article_nr should always be equal to nr - changed, check if true

        $db->query("UPDATE ".CPO_NEWS." "
                  ."SET artikel_archiv=9 "
                  ."WHERE nr='".addslashes($_POST['nr'])."'");

        $message[] = sprintf(htmlspecialchars(__('The newsletter %s was successfully deleted.'), ENT_COMPAT, 'ISO-8859-15'), '<i>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</i>');

        logaction('delete article', $_POST['nr'].': '.$titel);
        break;
    // }}}
    case 'articles_save': // {{{
        if (isset($_POST['displayAgain'])) {
            $views = array('edit_form');
            break;
        }

        require(CPO_BASEDIR.'_include/check_edit.php');
        if ($fehler) {
            $views = array('edit_form');
            break;
        }

        $data = array();
        $data['rubric_id']    = $_SESSION['SID_rubric_id'];
        $data['titel']        = $_POST['titel'];
        $data['templates_id'] = $_POST['templates_id'];
        $data['autor']        = $_POST['autor'];

        $data['idx']          = $_POST['idx'];
        $data['releasedby']   = '';
        if (!empty($_POST['article_free'])) $data['releasedby'] = $_SESSION['SID_user']['id'];
        if (isset($_POST['usergroup']) && is_array($_POST['usergroup']))  $data['usergroup']  = $_POST['usergroup']; // auth
        $data['keywords']      = $_POST['keywords'];
        $data['commentary']    = $_POST['commentary'];
        $data['verfallsdatum'] = $_POST['verfallsdatum'];
        $data['pub_datum']     = $_POST['pub_datum'];
        $data['email']         = $_POST['email'];
        $data['initial']       = $_POST['initial'];
        $data['changedBy']     = $_SESSION['SID_login'];
        $data['content']       = $_POST['content'];

        $data['nr']            = $_POST['nr'];
        $data['sort_id']       = $_POST['sort_id'];

        save_article($data);

        $message[] = sprintf(htmlspecialchars(__('The newsletter %s was successfully saved.'), ENT_COMPAT, 'ISO-8859-15'), '<i>'.htmlspecialchars($_POST['titel'], ENT_COMPAT, 'ISO-8859-15').'</i>');
        logaction('save article', ($_POST['nr']!='' ? $_POST['nr'].': ' : '').$_POST['titel']);
        break; // }}}
    case 'articles_move': // {{{
        if (empty($_GET['nr'])) break;

        $_POST['nr'] = $_GET['nr'];

        $views = array('move');
        break; // }}}
    case 'articles_moveto': // {{{
        $db = new DB;
        if ($_POST['move_target']=='') break;

        // fetch used template
        $query = "SELECT templates_id FROM ".CPO_NEWS." "
                ."WHERE nr='".addslashes($_POST['nr'])."'";
        $db->query($query);
        $db->next_record();
        $templates_id = $db->v('templates_id');

        // choose possible templates from the new rubric
        $query = "SELECT source_rubric_id FROM ".CPO_RUBRIC." "
                ."WHERE id='".addslashes($_POST['move_target'])."'";
        $db->query($query);
        $db->next_record();
        $templates_rubric = $_POST['move_target'];
        if ($db->v('source_rubric_id')!=0) {
            $templates_rubric = $db->v('source_rubric_id');
        }

        // is the actual templates_id allowed in the new rubric?
        $query = "SELECT COUNT(*) FROM ".CPO_TPL_ASSIGNMENT." "
                ."WHERE templates_id='".addslashes($templates_id)."' "
                ."AND rubric_id='".addslashes($templates_rubric)."'";
        $db->query($query);
        $db->next_record();

        $standard_template = '';
        if ($db->v('COUNT(*)')<=0) {  

            $query = "SELECT settings FROM ".CPO_RUBRIC." "
                    ."WHERE id='".addslashes($templates_rubric)."'";
            $db->query($query);
            $db->next_record();
            $_x = unserialize($db->v('settings'));
            $standard_template = $_x['standard_template'];

            $message[] = htmlspecialchars(__('The actual template of the article was not allowed in the new rubric. Because of this the standard template of the new rubric was chosen as default.'), ENT_COMPAT, 'ISO-8859-15');

            $standard_template = ", templates_id = '".addslashes($standard_template)."' ";
        }

        $query = "UPDATE ".CPO_NEWS." SET "
                ."rubric_id = '".addslashes($_POST['move_target'])."' "
                .$standard_template
                ."WHERE article_nr='".addslashes($_POST['nr'])."'";
        $db->query($query); 

        $query = "SELECT titel FROM ".CPO_NEWS." "
                ."WHERE nr='".$_POST['nr']."'";
        $db->query($query);
        $db->next_record();
        $artikel_titel = $db->v('titel');

        $query = "SELECT name FROM ".CPO_RUBRIC." "
                ."WHERE id='".$_POST['move_target']."'";
        $db->query($query);
        $db->next_record();
        $move_target_name = $db->v('name');

        $message[] = sprintf(htmlspecialchars(__('The newsletter %s was successfully moved to rubric %s.'), ENT_COMPAT, 'ISO-8859-15'), 
            '<i>'.htmlspecialchars($artikel_titel, ENT_COMPAT, 'ISO-8859-15').'</i> ',
            '<i>'.htmlspecialchars($move_target_name, ENT_COMPAT, 'ISO-8859-15').'</i>');
        logaction('move article', $_POST['nr'].': '.$artikel_titel.' -> '.$_POST['move_target'].' '.$move_target_name);

        break;
        // }}}
    case 'articles_versions': // {{{
        if (empty($_GET['nr'])) break;

        $_POST['nr'] = $_GET['nr'];

        $views = array('list_versions');
        break; // }}}
    case 'articles_versions_delete': //  {{{
        $_POST['nr'] = $_GET['nr'];

        $query = "SELECT titel, article_nr "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".$_POST['nr']."'";
        $db = new DB;
        $db->query($query);
        $db->next_record();
        $titel = $db->v('titel');
        $article_nr  = $db->v('article_nr');

        $query_del = "DELETE FROM ".CPO_CONTENT_FILES." "
                    ."WHERE article_id='".addslashes($_POST['nr'])."'";
        $db->query($query_del); 

        $query_del = "DELETE FROM ".CPO_CONTENT_HTML." "
                    ."WHERE article_id = '".addslashes($_POST['nr'])."'";
        $db->query($query_del); 

        $query_del = "DELETE FROM ".CPO_CONTENT_IMAGES." "
                    ."WHERE article_id = '".addslashes($_POST['nr'])."'";
        $db->query($query_del); 

        $query_del = "DELETE FROM ".CPO_CONTENT_TEXT." WHERE "
                    ."article_id = '".addslashes($_POST['nr'])."'";
        $db->query($query_del); 

        $query_del = "DELETE FROM ".CPO_CONTENT_URLS." "
                    ."WHERE article_id = '".addslashes($_POST['nr'])."'";
        $db->query($query_del); 

        $query_del = "DELETE FROM ".CPO_NEWS." "
                    ."WHERE nr='".$_POST['nr']."'";
        $db->query($query_del); 

        $message[] = sprintf(htmlspecialchars(__('The newsletter version %s was deleted successfully.'), ENT_COMPAT, 'ISO-8859-15'), '<i>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</i>');
        logaction('delete article version', $_POST['nr'].': '.$titel);

        $_POST['nr'] = $article_nr;
        $views = array('list_versions');
        break; // }}}
    case 'articles_versions_restore': // {{{
        $restore_archiv = true;
        require(CPO_BASEDIR.'_include/article_archive.php');

        $db = new DB;
        $query = "SELECT article_nr, auth, commentary, artikel_archiv, rubric_id, templates_id, titel, datum, verfallsdatum, pub_datum, autor, email, initial, idx, released_user_id, release_date, last_modify, c_time, changer, sort_id "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".$_GET['version_nr']."' ";
        $db->query($query);
        $db->next_record();
        $archive_article_nr     = $db->v('article_nr');  
        $archive_auth           = $db->v('auth');        
        $archive_commentary     = $db->v('commentary');        
        $archive_artikel_archiv = $db->v('artikel_archiv');    
        $archive_rubric_id      = $db->v('rubric_id');         
        $archive_templates_id   = $db->v('templates_id');          
        $archive_titel          = $db->v('titel');             
        $archive_datum          = $db->v('datum');             
        $archive_verfallsdatum  = $db->v('verfallsdatum');     
        $archive_pub_datum      = $db->v('pub_datum');         
        $archive_autor          = $db->v('autor');             
        $archive_email          = $db->v('email');             
        $archive_initial        = $db->v('initial');           
        $archive_idx            = $db->v('idx');               
        $archive_released_user_id = $db->v('released_user_id');     
        $archive_release_date   = $db->v('release_date');    
        $archive_last_modify    = $db->v('last_modify');       
        $archive_c_time         = $db->v('c_time');            
        $archive_changer        = $db->v('changer');           
        $archive_sort_id        = $db->v('sort_id');           

        $archive_freigabe = $cpoSystem['release'] ? STATE_WAITING : STATE_BLOCKED;
        $artikel_archiv   = 0;
    
        $query = "REPLACE INTO ".CPO_NEWS." "
                ."(nr, artikel_archiv, article_nr, auth, commentary, rubric_id, templates_id, titel, datum, verfallsdatum, pub_datum, autor, email, initial, idx, freigabe, released_user_id, release_date, last_modify, c_time, changer, sort_id ) "
                ."VALUES ("
                ."'".$_GET['nr']."', " 
                ."'".$artikel_archiv."', "
                ."'".$archive_article_nr."', "
                ."'".$archive_auth."', "
                ."'".$archive_commentary."', "
                ."'".$archive_rubric_id."', "
                ."'".$archive_templates_id."', "
                ."'".$archive_titel."', "
                ."'".$archive_datum."', "
                ."'".$archive_verfallsdatum."', "
                ."'".$archive_pub_datum."', "
                ."'".$archive_autor."', "
                ."'".$archive_email."', "
                ."'".$archive_initial."', "
                ."'".$archive_idx."', "
                ."'".$archive_freigabe."', "
                ."'".$archive_released_user_id."', "
                ."'".$archive_release_date."', "
                ."'".date('Y-m-d H:i:s', time())."', " // last_modify
                ."'".$archive_c_time."', "          // c_time
                ."'".$_SESSION['SID_login']."', "   // changer
                ."'".$archive_sort_id."')";         // sort_id
        DEBUG(1, $query, __FILE__, __LINE__);
        $db2 = new DB;
        $db2->query($query); 

        $query = "SELECT fieldname, file_id FROM ".CPO_CONTENT_FILES." "
                ."WHERE article_id = '".$_GET['version_nr']."'";
        $db2->query($query); 
        $db3 = new DB;
        while ($db2->next_record()) {
            $query = "INSERT INTO ".CPO_CONTENT_FILES." (article_id, fieldname, file_id) "
                    ."VALUES ('".$_GET['nr']."', '".$db2->v('fieldname')."', '".$db2->v('file_id')."')";
            $db3->query($query); 
        }

        $query = "SELECT fieldname, html FROM ".CPO_CONTENT_HTML." "
                ."WHERE article_id = '".$_GET['version_nr']."'";
        $db2->query($query); 
        $db3 = new DB;
        while ($db2->next_record()) {
            $query = "INSERT INTO ".CPO_CONTENT_HTML." (article_id, fieldname, html) "
                    ."VALUES ('".$_GET['nr']."', '".$db2->v('fieldname')."', '".$db2->v('html')."')";
            $db3->query($query); 
        }

        $query = "SELECT fieldname, image_id FROM ".CPO_CONTENT_IMAGES." "
                ."WHERE article_id = '".$_GET['version_nr']."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db2->query($query); 
        $db3 = new DB;
        while ($db2->next_record()) {
            $query = "INSERT INTO ".CPO_CONTENT_IMAGES." (article_id, fieldname, image_id) "
                    ."VALUES ('".$_GET['nr']."', '".$db2->v('fieldname')."', '".$db2->v('image_id')."')";
            DEBUG(1, $query, __FILE__, __LINE__);
            $db3->query($query); 
        }

        $query = "SELECT fieldname, text FROM ".CPO_CONTENT_TEXT." "
                ."WHERE article_id = '".$_GET['version_nr']."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db2->query($query); 
        $db3 = new DB;
        while ($db2->next_record()) {
            $query = "INSERT INTO ".CPO_CONTENT_TEXT." (article_id, fieldname, text) "
                    ."VALUES ('".$_GET['nr']."', '".$db2->v('fieldname')."', '".$db2->v('text')."')";
            DEBUG(1, $query, __FILE__, __LINE__);
            $db3->query($query); 
        }

        $query = "SELECT fieldname, url, urltext, urltarget FROM ".CPO_CONTENT_URLS." "
                ."WHERE article_id = '".$_GET['version_nr']."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db2->query($query); 
        $db3 = new DB;
        while ($db2->next_record()) {
            $query = "INSERT INTO ".CPO_CONTENT_URLS." (article_id, fieldname, url, urltext, urltarget) "
                    ."VALUES ('".$_GET['nr']."', '".$db2->v('fieldname')."', '".$db2->v('url')."', '".$db2->v('urltext')."', '".$db2->v('urltarget')."')";
            DEBUG(1, $query, __FILE__, __LINE__);
            $db3->query($query); 
        }
    
        $message[] = sprintf(htmlspecialchars(__('The newsletter version %s was restored successfully.'), ENT_COMPAT, 'ISO-8859-15'), '<i>'.htmlspecialchars($archive_titel, ENT_COMPAT, 'ISO-8859-15').'</i>');
        logaction('restore article version', $archive_article_nr.': '.$archive_titel);

        $_POST['nr'] = $_GET['nr'];
        $views = array('list_versions');
        break; // }}}
    case 'articles_release': // {{{
        $views = array('list_release');
        break; // }}}
    }
}


?>