<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

if (!defined('CPO')) exit;

if (!function_exists('formlistTTFfiles'))  {
	function formlistTTFfiles($dir)  {
		$h = opendir($dir);
		while($file = readdir($h))  {
			if ($file != "." AND $file != ".." AND !is_dir($dir.$file) AND strtolower(substr($file,-4)) == ".ttf")  {
				$ttffiles[] = $file;
			}
		}
		closedir($h);
		return $ttffiles;
	}
}

if(!function_exists('formlistImageFiles')) {
	function formlistImageFiles($dir)  {
		$h = opendir($dir);
		while($file = readdir($h))  {
			if ($file != "." AND $file != ".." AND !is_dir($dir.$file) AND strtolower(substr($file,-4)) == ".png")  {
				$image_files[] = $file;
			}
		}
		closedir($h);
		return $image_files;
	}
}

?>

<script type="text/javascript"><!--

function textarea (boxid, link){ 
	var t=document.getElementById(boxid); 
	if(link.innerHTML=='<?php echo __('enlarge'); ?>'){ 
		t.style.height = t.offsetHeight+350+"px"; 
		link.innerHTML='<?php echo __('reduce'); ?>'; 
	} else{ 
		t.style.height = t.offsetHeight-350+"px"; 
		link.innerHTML='<?php echo __('enlarge'); ?>'; 
	} 
} 

function ausblenden (boxID, link) {
	if(document.getElementById(link).innerHTML=='<?php echo __('hide'); ?>'){ 
	  document.getElementById(boxID).style.display = 'none';
	  document.getElementById(link).innerHTML='<?php echo __('show'); ?>';
	  setNewsletterCookie(boxID, false, 365);
	} else {
	  document.getElementById(boxID).style.display = '';
	  document.getElementById(link).innerHTML='<?php echo __('hide'); ?>';
	  setNewsletterCookie(boxID, true, 365);
	}
}

function setNewsletterCookie(name, value, expdays) {   // gltig expdays Tage
  var now = new Date();
  var exp = new Date(now.getTime() + (1000*60*60*24*expdays));
  document.cookie = name + "=" + escape(value) + ";" +
                    "expires=" + exp.toGMTString() + ";" +
                    "path=/";
}

function openDialog(URL, name, width, height, parameters)
{
    // set some defaults if not given
    if (!name)   name   = '';
    if (!width)  width  = screen.width/2;
    if (!height) height = screen.height/2;
    if (!parameters) parameters = 'scrollbars=no, resizable=yes';

    xOffset = (screen.width  - width)/2;
    yOffset = (screen.height - height)/2;

    newwindow = window.open(URL, name, 'width='+width+', height='+height+', top='+yOffset+', left='+xOffset+', '+parameters);
    return newwindow;
}

var whichColor = '';

function pickedColor(color)
{
    if (!color) return;
    eval('document.modulesettings.'+whichColor+'.value="'+color+'";');
    eval('document.modulesettings.'+whichColor+'_show.style.backgroundColor="'+color+'";');
}

function getPickedColor()
{
    return eval(whichColor+'.value;');
}

function colorize()
{
    document.getElementById('text_color_show').style.backgroundColor = document.getElementById('text_color').value;
    document.getElementById('shadow_color_show').style.backgroundColor = document.getElementById('shadow_color').value;
}

//--> </script>

<?php
		printPageHeader(
			__('Newsletter'),
			sprintf(__('This is the newsletter-administration of the newsletter <i>%s</i>.'),$directory),
			modHelp('settings','newsletter'),
			true,
			'modules'
		);

		require(CPO_BASEDIR."_include/message.php");

// ******** GENERAL SETTINGS ***************
		echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="modulesettings">';
		echo '<input type="hidden" name="go" value="1">';
		echo '<input type="hidden" name="list" value="options">';
 
		include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/license.inc.php');

		// table header {{{
		boxHeader('newslettersettings', __('Module settings'), true);
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Email list length:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text" name="cpoNewsletterNew[list_length]" value="'.(int)$activeModules[$directory]['list_length'].'" size="3" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Confirm delay:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text" name="cpoNewsletterNew[confirm_delay]" value="'.(int)$activeModules[$directory]['confirm_delay'].'" size="3" maxlength="255">';
            echo ' '.__('days');
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Email verification:');
            echo ' (opt-in)</td>';
            echo '<td class="rightrow">';
			$yes_selected = '';
			$no_selected = '';
			if ($activeModules[$directory]['opt'] == 'yes')  $yes_selected = " selected";
			if ($activeModules[$directory]['opt'] == 'no')  $no_selected = " selected";
            echo '<select name="cpoNewsletterNew[opt]">';
			echo '<option value="yes"'.$yes_selected.'>'.__('Verification mail').' (confirmed opt-in)</option>';
			echo '<option value="no"'.$no_selected.'>'.__('no verification').' (opt-in)</option>';
            echo '</select>';
            echo '</td>';
		echo '</tr>';
		if (function_exists('checkdnsrr'))  {
			echo '<tr>';
				echo '<td class="leftrow">';
				echo __('Mailserver Check:');
				echo '</td>';
				echo '<td class="rightrow">';
				$yes_selected = '';
				$no_selected = '';
				if ($activeModules[$directory]['dns_check'] == 'yes')  $yes_selected = " selected";
				if ($activeModules[$directory]['dns_check'] == 'no')  $no_selected = " selected";
				echo '<select name="cpoNewsletterNew[dns_check]">';
				echo '<option value="yes"'.$yes_selected.'>'.__('yes').'</option>';
				echo '<option value="no"'.$no_selected.'>'.__('no').'</option>';
				echo '</select>';
				echo '</td>';
			echo '</tr>';
		}
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Email Check:');
            echo '</td>';
            echo '<td class="rightrow">';
			$yes_selected = '';
			$no_selected = '';
			if ($activeModules[$directory]['mail_check'] == 'yes')  $yes_selected = " selected";
			if ($activeModules[$directory]['mail_check'] == 'no')  $no_selected = " selected";
            echo '<select name="cpoNewsletterNew[mail_check]">';
			echo '<option value="yes"'.$yes_selected.'>'.__('check for valid mail-adress format').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('do not check for valid mail-adress format').'</option>';
            echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Email RegExp:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[regexp]" value="'.$activeModules[$directory]['regexp'].'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Mail-Format:');
            echo '</td>';
            echo '<td class="rightrow">';
			$yes_selected = '';
			$no_selected = '';
			$both_selected = '';
			if ($activeModules[$directory]['text_only'] == 'yes')  $yes_selected = " selected";
			if ($activeModules[$directory]['text_only'] == 'no')  $no_selected = " selected";
			if ($activeModules[$directory]['text_only'] == 'both')  $both_selected = " selected";
            echo '<select name="cpoNewsletterNew[text_only]">';
			echo '<option value="yes"'.$yes_selected.'>'.__('Text-Mail').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('HTML-Mail').'</option>';
			echo '<option value="both"'.$both_selected.'>'.__('HTML/Text-Mail').'</option>';
            echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Senders eMail-adress:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[sender_email]" value="'.htmlspecialchars($activeModules[$directory]['sender_email'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Include Pics in HTML-Mail:');
            echo '</td>';
            echo '<td class="rightrow">';
			$yes_selected = '';
			$no_selected = '';
			if ($activeModules[$directory]['include_pics'] == 'yes')  $yes_selected = " selected";
			if ($activeModules[$directory]['include_pics'] == 'no')  $no_selected = " selected";
            echo '<select name="cpoNewsletterNew[include_pics]">';
			echo '<option value="yes"'.$yes_selected.'>'.__('yes').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('no').'</option>';
            echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Notice to admin:');
            echo '</td>';
            echo '<td class="rightrow">';
			$yes_selected = '';
			$no_selected = '';
			if ($activeModules[$directory]['notice_to_admin'] == 'yes')  $yes_selected = " selected";
			if ($activeModules[$directory]['notice_to_admin'] == 'no')  $no_selected = " selected";
            echo '<select name="cpoNewsletterNew[notice_to_admin]">';
			echo '<option value="yes"'.$yes_selected.'>'.__('yes').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('no').'</option>';
            echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Admin eMail-adress:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[admin_email]" value="'.htmlspecialchars($activeModules[$directory]['admin_email'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Rehearsal eMail-adress:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[rehearsal]" value="'.htmlspecialchars($activeModules[$directory]['rehearsal'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Use categories:');
            echo '</td>';
            echo '<td class="rightrow">';
			$yes_selected = '';
			$no_selected = '';
			if ($activeModules[$directory]['use_categories'] == 'yes')  $yes_selected = " selected";
			if ($activeModules[$directory]['use_categories'] == 'no')  $no_selected = " selected";
            echo '<select name="cpoNewsletterNew[use_categories]">';
			echo '<option value="yes"'.$yes_selected.'>'.__('yes').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('no').'</option>';
            echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Use ranking system:');
            echo '</td>';
            echo '<td class="rightrow">';
			$yes_selected = '';
			$no_selected = '';
			if ($activeModules[$directory]['use_ranking'] == 'yes')  $yes_selected = " selected";
			if ($activeModules[$directory]['use_ranking'] == 'no')  $no_selected = " selected";
            echo '<select name="cpoNewsletterNew[use_ranking]">';
			echo '<option value="yes"'.$yes_selected.'>'.__('yes').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('no').'</option>';
            echo '</select>';
            echo '</td>';
		echo '</tr>';
		if ($activeModules[$directory]['use_ranking'] == 'yes')  {
			echo '<tr>';
				echo '<td class="leftrow">';
				echo __('Default rank:');
				echo '</td>';
				echo '<td style="width=70%;">';
				echo '<input type="text" class="text" name="cpoNewsletterNew[default_rank]" value="'.$activeModules[$directory]['default_rank'].'" size="3" maxlength="255">'."<br />";
				echo __('To increase and decrease ranking of a newsletter recipient outside ConPresso (e.g. in your online-shop) you can use the following links:').'<br />';
				echo '<a href="rank.php?action=up&receiver=_mailadress_of_receiver_&hash='.md5($cpoSystem['admin_email']).'">Upgrade-Link</a>&nbsp;&nbsp;&nbsp;';
				echo '<a href="rank.php?action=down&receiver=_mailadress_of_receiver_&hash='.md5($cpoSystem['admin_email']).'">Downgrade-Link</a><br />';
				echo __('Use a right mouse klick to copy the URL, change it to work in your system an paste it to the desired location.');
				echo '</td>';
			echo '</tr>';
			echo '<tr>';
				echo '<td class="leftrow">';
				echo __('Ranking mode:');
				echo '</td>';
				echo '<td class="rightrow">';
				$up_selected = '';
				$down_selected = '';
				$group_selected = '';
				if ($activeModules[$directory]['ranking_mode'] == 'upcluster')  $up_selected = " selected";
				if ($activeModules[$directory]['ranking_mode'] == 'downcluster')  $down_selected = " selected";
				if ($activeModules[$directory]['ranking_mode'] == 'group')  $group_selected = " selected";
				echo '<select name="cpoNewsletterNew[ranking_mode]">';
				echo '<option value="upcluster"'.$up_selected.'>'.__('upcluster').'</option>';
				echo '<option value="downcluster"'.$down_selected.'>'.__('downcluster').'</option>';
				echo '<option value="group"'.$group_selected.'>'.__('group').'</option>';
				echo '</select>';
				echo '</td>';
			echo '</tr>';
		}
        $deactivated = '';
        $deactivated_hint = '';
        $deactivated_hint_row =	'';
		if (license($activeModules[$directory]['lkey'],$activeModules[$directory]['mod_id']) != 1 &&
			license($activeModules[$directory]['lkey'],$activeModules[$directory]['mod_id']) != 3)  
			{
			$deactivated = ' disabled="disabled"';
			$deactivated_hint = '&nbsp;'.__('available in the commercial version');
			$deactivated_hint_row =	'<tr>'
					. '<td class="leftrow">'
					. __('Note:')
					. '</td>'
					. '<td class="rightrow"><img src="'.SKIN_URL.'sym_info.gif"> '
					. __('available in the commercial version')
					. '</td>'
				. '</tr>';
			$activeModules[$directory]['staggered'] = 'no';
		}
        $disabled = '';
        $disabled_hint = '';
        $disabled_hint_row = '';
		if (!license($activeModules[$directory]['lkey'],$activeModules[$directory]['mod_id']))  {
			$disabled = ' disabled="disabled"';
			$disabled_hint = '&nbsp;'.__('available in the registered version');
			$disabled_hint_row =	'<tr>'
					. '<td class="leftrow">'
					. __('Note:')
					. '</td>'
					. '<td class="rightrow"><img src="../_skin/conpresso/sym_info.gif"> '
					. __('available in the registered version')
					. '</td>'
				. '</tr>';
		}
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Staggered processing:');
            echo '</td>';
            echo '<td class="rightrow">';
			$yes_selected = '';
			$no_selected = '';
			if ($activeModules[$directory]['staggered'] == 'yes')  $yes_selected = " selected";
			if ($activeModules[$directory]['staggered'] == 'no')  $no_selected = " selected";
            echo '<select name="cpoNewsletterNew[staggered]"'.$deactivated.'>';
			echo '<option value="yes"'.$yes_selected.'>'.__('yes').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('no').'</option>';
            echo '</select>'.$deactivated_hint;
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Number of newsletters:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text" name="cpoNewsletterNew[num_to_process]" value="'.(int)$activeModules[$directory]['num_to_process'].'" size="3" maxlength="255"'.$deactivated.'>';
            echo $deactivated_hint;
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Log actions:');
            echo '</td>';
            echo '<td class="rightrow">';
			$yes_selected = '';
			$no_selected = '';
			if ($activeModules[$directory]['log'] == 'yes')  $yes_selected = " selected";
			if ($activeModules[$directory]['log'] == 'no')  $no_selected = " selected";
            echo '<select name="cpoNewsletterNew[log]">';
			echo '<option value="yes"'.$yes_selected.'>'.__('yes').'</option>';
			echo '<option value="no"'.$no_selected.'>'.__('no').'</option>';
            echo '</select>';
            echo '</td>';
		echo '</tr>';
		if (version_compare($CPO['version'], '4.1.0') >= 0) {
            echo '<tr>';
                echo '<td class="leftrow">';
                echo __('Page-Template:');
                echo '</td>';
                echo '<td class="rightrow">';
                echo '<select name="cpoNewsletterNew[pagetemplate_index]" size="1">';
                echo '<option value="-2"'
                    .($activeModules[$directory]['pagetemplate_index']==-2 ? ' selected' : '')
                    .'>--- '.__('act like enclosing rubric').' ---</option>';
                echo '<option value="0"'
                    .($activeModules[$directory]['pagetemplate_index']==0 ? ' selected' : '')
                    .'>--- '.___('Use header and footer files').' ---</option>';
                $query = 'SELECT id, name FROM '.CPO_PAGETEMPLATES.' '
                        .'ORDER BY name';
                $db->query($query);
                $_pagetemplates = array();
                while ($db->next_record()) {
                    $_pagetemplates[$db->v('id')] = $db->v('name');
                }
                foreach ($_pagetemplates as $k=>$v) {
                    echo '<option value="'.htmlspecialchars($k, ENT_COMPAT, 'ISO-8859-15').'"'
                        .($activeModules[$directory]['pagetemplate_index']==$k ? ' selected' : '')
                        .'>'.htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15').'</option>';
                }
                echo '</select>';
                echo '</td>';
            echo '</tr>';
        }
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Show articles:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<select name="cpoNewsletterNew[showArticles]" size="1">';
			$selnone = ($activeModules[$directory]['showArticles']=="none") ? ' selected="selected"' :'';
			$selbefore = ($activeModules[$directory]['showArticles']=="before") ? ' selected="selected"' :'';
			$selafter = ($activeModules[$directory]['showArticles']=="after") ? ' selected="selected"' :'';
			echo '<option value="none"'.$selnone.'>'.__('none').'</option>';
			echo '<option value="before"'.$selbefore.'>'.__('above form').'</option>';
			echo '<option value="after"'.$selafter.'>'.__('below form').'</option>';
			echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Hide articles on submit:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<select name="cpoNewsletterNew[hideArticles]" size="1">';
			$selyes = ($activeModules[$directory]['hideArticles']=="yes") ? ' selected="selected"' :'';
			$selno = ($activeModules[$directory]['hideArticles']=="no") ? ' selected="selected"' :'';
			echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
			echo '<option value="no"'.$selno.'>'.__('no').'</option>';
			echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Show mailform mockup:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<select name="cpoNewsletterNew[showMailForm]" size="1">';
			$selyes = ($activeModules[$directory]['showMailForm']=="yes") ? ' selected="selected"' :'';
			$selno = ($activeModules[$directory]['showMailForm']=="no") ? ' selected="selected"' :'';
			echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
			echo '<option value="no"'.$selno.'>'.__('no').'</option>';
			echo '</select>';
            echo '</td>';
		echo '</tr>';

		
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';
		echo '</tbody></table>';

// ******** NEWSLETTER CATEGORIES ***************
		boxHeader('newslettercategories', ($activeModules[$directory]['use_categories'] == 'yes')? __('Newsletter categories') : __('Newsletter parts'), false);
        // }}}
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Header:');
            echo '</td>';
            echo '<td style="width=70%;">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[header]" value="'.htmlspecialchars($activeModules[$directory]['header'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">'.'<br />';
            echo '</td>';
		echo '</tr>';
	if ($activeModules[$directory]['use_categories'] == 'yes')  {
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Newsletter categories').':';
            echo '</td>';
            echo '<td style="width=70%;">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[categories]" value="'.htmlspecialchars($activeModules[$directory]['categories'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">'.'<br />';
            echo __('Separate the different categories by using a semicolon (;).').'<br />';
            echo __('These are the categories that can be chosen by the customer in his profile. These are automatically included in the template so you can work on the content. Referr to the manual.');
            echo '</td>';
		echo '</tr>';
	} elseif ($activeModules[$directory]['use_categories'] == 'no')  {
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Main:');
            echo '</td>';
            echo '<td style="width=70%;">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[main]" value="'.htmlspecialchars($activeModules[$directory]['main'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">'.'<br />';
            echo '</td>';
		echo '</tr>';
	}
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Footer:');
            echo '</td>';
            echo '<td style="width=70%;">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[footer]" value="'.htmlspecialchars($activeModules[$directory]['footer'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">'.'<br />';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';
		echo '</tbody></table>';

// ******** NEWSLETTER HTML-ELEMENTS ***************
		boxHeader('newsletterhtml', __('Newsletter HTML elements'), false);
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('CSS-Style-Sheet:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[css_sheet]" value="'.htmlspecialchars($activeModules[$directory]['css_sheet'], ENT_COMPAT, 'ISO-8859-15').'">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('HTML-header:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="html_header" class="text inputwidth" name="cpoNewsletterNew[html_header]">'.htmlspecialchars($activeModules[$directory]['html_header'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'html_header\', this);return false" id="lnk">'.__('enlarge').'</a>';
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('HTML-footer:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="html_footer" class="text inputwidth" name="cpoNewsletterNew[html_footer]">'.htmlspecialchars($activeModules[$directory]['html_footer'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'html_header\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
						
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';

// ******** NEWSLETTER TEXT-ELEMENTS ***************
		boxHeader('newslettertext', __('Newsletter text elements'), false);
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('No-spam text:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="no_spam_text" class="text inputwidth" name="cpoNewsletterNew[no_spam_text]">'.htmlspecialchars($activeModules[$directory]['no_spam_text'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'no_spam_text\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Unscribe text:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="unscribe_text" class="text inputwidth" name="cpoNewsletterNew[unscribe_text]">'.htmlspecialchars($activeModules[$directory]['unscribe_text'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'unscribe_text\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Profile link text:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="profile_link_text" class="text inputwidth" name="cpoNewsletterNew[profile_link_text]">'.htmlspecialchars($activeModules[$directory]['profile_link_text'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'profile_link_text\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Special header text*:');
            echo '</td>';
            echo '<td style="width=70%;">';
            echo '<textarea style="width: 95%; height: 50px;" id="special_header_text" class="text inputwidth" name="cpoNewsletterNew[special_header_text]">'.htmlspecialchars($activeModules[$directory]['special_header_text'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'special_header_text\', this);return false" id="lnk">'.__('enlarge').'</a>'.'<br />';
            echo __('*) These settings should only be used, if you\'re familliar with email headers. If not, leave this empty!');
            echo '</td>';
		echo '</tr>';
						
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';

// ******** NEWSLETTER FRONTEND ***************
		boxHeader('newsletterfrontend', __('Newsletter frontend pages'), false);
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Index page:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="index_page" class="text inputwidth" name="cpoNewsletterNew[index_page]">'.htmlspecialchars($activeModules[$directory]['index_page'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'index_page\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Hint on email error:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[hint_on_email_error]" value="'.htmlspecialchars($activeModules[$directory]['hint_on_email_error'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Hint "already in list":');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[hint_already_in_list]" value="'.htmlspecialchars($activeModules[$directory]['hint_already_in_list'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Hint on banned adress:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[hint_banned]" value="'.htmlspecialchars($activeModules[$directory]['hint_banned'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Hint on password error:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[hint_on_password_error]" value="'.htmlspecialchars($activeModules[$directory]['hint_on_password_error'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Hint on no subscriber:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[hint_no_subsrciber]" value="'.htmlspecialchars($activeModules[$directory]['hint_no_subsrciber'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Unscribe info:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[hint_to_unsrciber]" value="'.htmlspecialchars($activeModules[$directory]['hint_to_unsrciber'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Password verification info:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[hint_on_password_verification]" value="'.htmlspecialchars($activeModules[$directory]['hint_on_password_verification'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('New password info:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[hint_on_password_change]" value="'.htmlspecialchars($activeModules[$directory]['hint_on_password_change'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Password change error:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[password_change_error]" value="'.htmlspecialchars($activeModules[$directory]['password_change_error'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Confirmation page:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="confirmation_page" class="text inputwidth" name="cpoNewsletterNew[confirmation_page]">'.htmlspecialchars($activeModules[$directory]['confirmation_page'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'confirmation_page\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Auth confirmation:');
            echo '</td>';
            echo '<td style="width=70%;">';
            echo '<textarea style="width: 95%; height: 50px;" id="auth_page" class="text inputwidth" name="cpoNewsletterNew[auth_page]">'.htmlspecialchars($activeModules[$directory]['auth_page'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'auth_page\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Unscription info:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[unscribe_info]" value="'.htmlspecialchars($activeModules[$directory]['unscribe_info'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('User Profile:');
            echo '</td>';
            echo '<td style="width=70%;">';
            echo '<textarea style="width: 95%; height: 50px;" id="user_page" class="text inputwidth" name="cpoNewsletterNew[user_page]">'.htmlspecialchars($activeModules[$directory]['user_page'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'user_page\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Message on profile change:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[profile_change_successful]" value="'.htmlspecialchars($activeModules[$directory]['profile_change_successful'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Message on password change:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[password_change_successful]" value="'.htmlspecialchars($activeModules[$directory]['password_change_successful'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Newsletter list:');
            echo '</td>';
            echo '<td style="width=70%;">';
            echo '<textarea style="width: 95%; height: 50px;" id="newsletter_list" class="text inputwidth" name="cpoNewsletterNew[newsletter_list]">'.htmlspecialchars($activeModules[$directory]['newsletter_list'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'newsletter_list\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('List length:');
            echo '</td>';
            echo '<td class="rightrow">';
				echo '<input type="text" class="text" name="cpoNewsletterNew[newsletter_list_length]" value="'.htmlspecialchars($activeModules[$directory]['newsletter_list_length'], ENT_COMPAT, 'ISO-8859-15').'" size="5" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Mini index page:');
            echo '</td>';
            echo '<td style="width=70%;">';
            echo '<textarea style="width: 95%; height: 50px;" id="mini_index_page" class="text inputwidth" name="cpoNewsletterNew[mini_index_page]">'.htmlspecialchars($activeModules[$directory]['mini_index_page'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'mini_index_page\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Mini message:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<select name="cpoNewsletterNew[mini_message]" size="1">';
			$selyes = ($activeModules[$directory]['mini_message']=="yes") ? ' selected="selected"' :'';
			$selno = ($activeModules[$directory]['mini_message']=="no") ? ' selected="selected"' :'';
			echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
			echo '<option value="no"'.$selno.'>'.__('no').'</option>';
			echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Mini confirmation page:');
            echo '</td>';
            echo '<td style="width=70%;">';
            echo '<textarea style="width: 95%; height: 50px;" id="mini_confirmation_page" class="text inputwidth" name="cpoNewsletterNew[mini_confirmation_page]">'.htmlspecialchars($activeModules[$directory]['mini_confirmation_page'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'mini_confirmation_page\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
						
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';

// ******** NEWSLETTER MAILTEXT ***************
		boxHeader('newsletterconfirmation', __('Confirmation mail contents'), false);
        // }}}

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Confirmation mail subject:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[confirmation_mail_subject]" value="'.htmlspecialchars($activeModules[$directory]['confirmation_mail_subject'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Confirmation mail content:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="confirmation_mail_content" class="text inputwidth" name="cpoNewsletterNew[confirmation_mail_content]">'.htmlspecialchars($activeModules[$directory]['confirmation_mail_content'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'confirmation_mail_content\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Confirmed subject:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[confirmed_subject]" value="'.htmlspecialchars($activeModules[$directory]['confirmed_subject'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Confirmed content:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="confirmed_content" class="text inputwidth" name="cpoNewsletterNew[confirmed_content]">'.htmlspecialchars($activeModules[$directory]['confirmed_content'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'confirmed_content\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Direct registration subject:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[unconfirmed_subject]" value="'.htmlspecialchars($activeModules[$directory]['unconfirmed_subject'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Direct registration content:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="unconfirmed_content" class="text inputwidth" name="cpoNewsletterNew[unconfirmed_content]">'.htmlspecialchars($activeModules[$directory]['unconfirmed_content'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'unconfirmed_content\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Unscribe subject:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[unscribe_subject]" value="'.htmlspecialchars($activeModules[$directory]['unscribe_subject'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Unscribe content:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="unscribe_content" class="text inputwidth" name="cpoNewsletterNew[unscribe_content]">'.htmlspecialchars($activeModules[$directory]['unscribe_content'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'unscribe_content\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Forgotten password subject:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[forgotten_password_subject]" value="'.htmlspecialchars($activeModules[$directory]['forgotten_password_subject'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Forgotten password content:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="forgotten_password_content" class="text inputwidth" name="cpoNewsletterNew[forgotten_password_content]">'.htmlspecialchars($activeModules[$directory]['forgotten_password_content'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'forgotten_password_content\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Notice to Admin subject:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[notice_to_admin_subject]" value="'.htmlspecialchars($activeModules[$directory]['notice_to_admin_subject'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Notice to Admin content:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="notice_to_admin_content" class="text inputwidth" name="cpoNewsletterNew[notice_to_admin_content]">'.htmlspecialchars($activeModules[$directory]['notice_to_admin_content'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'notice_to_admin_content\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Unscribe to Admin subject:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[unscribe_to_admin_subject]" value="'.htmlspecialchars($activeModules[$directory]['unscribe_to_admin_subject'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255">';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Unscribe to Admin content:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="unscribe_to_admin_content" class="text inputwidth" name="cpoNewsletterNew[unscribe_to_admin_content]">'.htmlspecialchars($activeModules[$directory]['unscribe_to_admin_content'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
			echo '<br /><a href="#" onClick="textarea(\'unscribe_to_admin_content\', this);return false" id="lnk">'.__('enlarge').'</a>';
            echo '</td>';
		echo '</tr>';
		
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';


// ******** NEWSLETTER PERSONALISATION ***************
		boxHeader('newsletterpersonalisation', __('Newsletter personalisation'), false);
        // }}}

		echo $disabled_hint_row;
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Fields:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 50px;" id="personal_fields" class="text inputwidth" name="cpoNewsletterNew[personal_fields]"'.$disabled.'>'.htmlspecialchars($activeModules[$directory]['personal_fields'], ENT_COMPAT, 'ISO-8859-15').'</textarea>';
            echo '<br />';
            echo __('Syntax: fieldname[;required(0|1)[;type(text|select|radio|checkbox);values(a,b,c,...)]] + LF/CR');
			echo '<br /><a href="#" onClick="textarea(\'personal_fields\', this);return false" id="lnk">'.__('enlarge').'</a>';
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Personal data row:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[personal_row]" value="'.htmlspecialchars($activeModules[$directory]['personal_row'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255"'.$disabled.' />';
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Necessary data hint:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[necessary_data]" value="'.htmlspecialchars($activeModules[$directory]['necessary_data'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255"'.$disabled.' />';
			echo '</td>';
		echo '</tr>';
						
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';
		
		
// ******** CAPTCHA SETTINGS ***************
		boxHeader('newslettercaptcha', __('Captcha settings'), false);
        // }}}

		echo $disabled_hint_row;
/*		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Use captcha:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<select name="cpoNewsletterNew[captcha]" size="1"'.$disabled.'>';
			$selyes = ($activeModules[$directory]['captcha']=="yes") ? ' selected="selected"' :'';
			$selno = ($activeModules[$directory]['captcha']=="no") ? ' selected="selected"' :'';
			echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
			echo '<option value="no"'.$selno.'>'.__('no').'</option>';
			echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Captcha error message:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[captcha_error]" value="'.htmlspecialchars($activeModules[$directory]['captcha_error'], ENT_COMPAT, 'ISO-8859-15').'" maxlength="255"'.$disabled.'>';
            echo '</td>';
		echo '</tr>'; */

		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Use captcha:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<select name="cpoNewsletterNew[captcha]" size="1"'.$disabled.'>';
			$selyes = ($activeModules[$directory]['captcha']=="yes") ? ' selected="selected"' :'';
			$selno = ($activeModules[$directory]['captcha']=="no") ? ' selected="selected"' :'';
			echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
			echo '<option value="no"'.$selno.'>'.__('no').'</option>';
			echo '</select>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Captcha template:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<textarea style="width: 95%; height: 100px;" class="text inputwidth" name="cpoNewsletterNew[captcha_template]" id="captcha_template"'.$disabled.'>'.$activeModules[$directory]['captcha_template'].'</textarea>';
            echo '<br /><a href="#" onClick="textarea(\'captcha_template\', this);return false" id="lnk">'.__('enlarge').'</a>';
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Captcha error message:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[captcha_error]" value="'.$activeModules[$directory]['captcha_error'].'" maxlength="255"'.$disabled.'>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Captcha image:');
            echo '</td>';
            echo '<td class="rightrow">';
			$wm_select = '';
			$wmfiles = formlistimagefiles(CPO_BASEDIR.$activeModules[$directory]['directory'].'/captcha');
			for ($df=0;$df<count($wmfiles);$df++)  {
				$selected = '';
				if ($activeModules[$directory]['pic'] == $wmfiles[$df])  $selected = ' checked="checked"';
				$wm_select .= '<div style="float:left;width:170px;padding:5px 0;"><input type="radio" name="cpoNewsletterNew[pic]" value="'.$wmfiles[$df].'" '.$selected.$disabled.'>&nbsp;<img src="captcha/'.$wmfiles[$df].'" align="absmiddle" /></div>'."\n ";
			}
			echo $wm_select;
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Captcha font:');
            echo '</td>';
            echo '<td class="rightrow">';
			$ttf_select = '';
			$ttffiles = formlistTTFfiles(CPO_BASEDIR.$activeModules[$directory]['directory'].'/captcha');
			for ($df=0;$df<count($ttffiles);$df++)  {
				$selected = '';
				if ($activeModules[$directory]['font'] == $ttffiles[$df])  $selected = ' checked="checked"';
				$ttf_select .= '<div style="float:left;width:170px;padding:5px 0;"><input type="radio" name="cpoNewsletterNew[font]" value="'.$ttffiles[$df].'"'.$selected.$disabled.'>&nbsp;<img src="captcha/captcha.php?font='.$ttffiles[$df].'" align="absmiddle" /></div>'."\n ";
			}
			echo $ttf_select;
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Text color:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<input type="text" class="text" id="text_color" name="cpoNewsletterNew[text_color]" value="'.strtoupper($activeModules[$directory]['text_color']).'" size="7" onchange="colorize();"'.$disabled.'><input type="text" class="text" id="text_color_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'text_color\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)"'.$disabled.'>&nbsp;&nbsp;';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Shadow color:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<input type="text" class="text" id="shadow_color" name="cpoNewsletterNew[shadow_color]" value="'.strtoupper($activeModules[$directory]['shadow_color']).'" size="7" onchange="colorize();"'.$disabled.'><input type="text" class="text" id="shadow_color_show" size="1" value="" style="cursor:hand; width=20px" readonly onClick="whichColor=\'shadow_color\'; openDialog(\'../_editor/colorpicker.php\', \'\', 530, 285)"'.$disabled.'>&nbsp;&nbsp;';
            echo '</td>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Style:');
            echo '</td>';
            echo '<td class="rightrow">';
			echo '<select name="cpoNewsletterNew[style]" size="1"'.$disabled.'>';
			$seloutline = ($activeModules[$directory]['style']=="outline") ? ' selected="selected"' :'';
			$selshadow = ($activeModules[$directory]['style']=="shadow") ? ' selected="selected"' :'';
			echo '<option value="outline"'.$seloutline.'>'.__('outline').'</option>';
			echo '<option value="shadow"'.$selshadow.'>'.__('shadow').'</option>';
			echo '</select>';
            echo '</td>';
		echo '</tr>';


		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';
		echo '</tbody></table>';


// ******** NEWSLETTER CRONJOB ***************
		boxHeader('newslettercronjob', __('Newsletter cronjob'), false);
        // }}}

		$query = "SELECT count(id) AS num_of_cronjobs FROM `".$dbPrefix."_mod_newsletter_cronjob`";
		DEBUG(1, $query, __FILE__, __LINE__); 
		$db = new DB;
		$db->query($query);
		$db->next_record();
		$num_of_cronjobs = $db->v('num_of_cronjobs');
		echo $deactivated_hint_row;
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Pending cronjob:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo $num_of_cronjobs.__(' pending newsletters');
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Number of newsletters per cronjob:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text" name="cpoNewsletterNew[num_per_cronjob]" value="'.(int)$activeModules[$directory]['num_per_cronjob'].'" size="3" maxlength="255" '.$deactivated.'/>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Cronjob identification:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[id_cronjob]" value="'.htmlspecialchars($activeModules[$directory]['id_cronjob'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255" '.$deactivated.'/>';
            echo '<br />cronjob: <br />php -f '.CPO_BASEDIR.$directory.'/cronjob.php id_cronjob='.htmlspecialchars($activeModules[$directory]['id_cronjob'], ENT_COMPAT, 'ISO-8859-15').' dir='.$activeModules[$directory]['directory'];
			$url = BASE_ABS . $directory . '/cronjob.php?id_cronjob=' . htmlspecialchars($activeModules[$directory]['id_cronjob'], ENT_COMPAT, 'ISO-8859-15') . '&dir=' . $activeModules[$directory]['directory'];
            echo '<br />URL: <br /><a href="'.$url.'" target="_blank">'.$url.'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Cronjob cancellation:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="checkbox" name="cpoNewsletterDo[cancel_cronjob]" value="cancel" '.$deactivated.'/> '.__('Cancel all pending newsletters');
			echo '</td>';
		echo '</tr>';
						
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';
		
// ******** NEWSLETTER SCHEDULER ***************
		boxHeader('newsletterscheduler', __('Newsletter scheduler'), false);
        // }}}

		$query = "SELECT count(id) AS num_of_schedules FROM `".$dbPrefix."_mod_newsletter_schedule`";
		DEBUG(1, $query, __FILE__, __LINE__); 
		$db = new DB;
		$db->query($query);
		$db->next_record();
		$num_of_schedules = $db->v('num_of_schedules');
		echo $deactivated_hint_row;
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Pending schedules:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo $num_of_schedules.__(' schedules');
			echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Number of newsletters per schedule:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text" name="cpoNewsletterNew[num_per_schedule]" value="'.(int)$activeModules[$directory]['num_per_schedule'].'" size="3" maxlength="255" '.$deactivated.'/>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('Schedule identification:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[id_schedule]" value="'.htmlspecialchars($activeModules[$directory]['id_schedule'], ENT_COMPAT, 'ISO-8859-15').'" size="20" maxlength="255" '.$deactivated.'/>';
            echo '<br />cronjob: <br />php -f '.CPO_BASEDIR.$directory.'/schedule.php id_schedule='.htmlspecialchars($activeModules[$directory]['id_schedule'], ENT_COMPAT, 'ISO-8859-15').' dir='.$activeModules[$directory]['directory'];
			$url = BASE_ABS . $directory . '/schedule.php?id_schedule=' . htmlspecialchars($activeModules[$directory]['id_schedule'], ENT_COMPAT, 'ISO-8859-15') . '&dir=' . $activeModules[$directory]['directory'];
            echo '<br />URL: <br /><a href="'.$url.'" target="_blank">'.$url.'</a>';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('BASE_URL:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[BASE_URL]" value="'.htmlspecialchars($activeModules[$directory]['BASE_URL'], ENT_COMPAT, 'ISO-8859-15').'" maxlength="255" '.$deactivated.' />';
            echo '</td>';
		echo '</tr>';
		echo '<tr>';
            echo '<td class="leftrow">';
            echo __('CPO_BASEDIR:');
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="text" class="text inputwidth" name="cpoNewsletterNew[CPO_BASEDIR]" value="'.htmlspecialchars($activeModules[$directory]['CPO_BASEDIR'], ENT_COMPAT, 'ISO-8859-15').'" maxlength="255"'.$deactivated.' />';
            echo '</td>';
		echo '</tr>';
		if ($num_of_schedules > 0)  {
			echo '<tr>';
				echo '<td class="leftrow">';
				echo __('Schedule cancellation:');
				echo '</td>';
				echo '<td class="rightrow">';
				echo '<select name="cpoNewsletterDo[schedules][]" size="'.min(5,$num_of_schedules).'" multiple="multiple">';
				$db->query('SELECT id, user, description '
					.'FROM '.$dbPrefix."_mod_newsletter_schedule");
				while ($db->next_record()) {
					echo '<option value="'.$db->v('id').'">'.$db->v('description').' / '.$db->v('user').'</option>';
				}
				echo '</select>';
				echo '<br />'.__('Select the schedules jobs to be cancelled. Multiple selections with the Ctrl-Key.');
				echo '</td>';
			echo '</tr>';
		}
		
		echo '<tr>';
            echo '<td class="leftrow">';
            echo '&nbsp;';
            echo '</td>';
            echo '<td class="rightrow">';
            echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
            echo '</td>';
		echo '</tr>';

		echo '</tbody></table>';
		
		
		echo '</form>';



?>

<script type="text/javascript">
<!--
	colorize();
//-->
</script>