<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

if (!defined('CPO')) exit;

define('NL_INI_RESTORE', false);

include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_conditionals.inc.php');

if (isset($_REQUEST['rehearsal'])) $activeModules[$directory]['staggered'] = 'no';

        $stag_info = ($activeModules[$directory]['staggered'] == 'yes') ? " <br />".__('Dont stop the processing! If the process stops although not all newsletters have been processed you have to reduce the number of newsletters to process per step!') : '';

		if (isset($_REQUEST['cronjob'])) {
			$message[] = __('Cronjob is being prepared.');
		}

        $db = new DB;
        $query = "SELECT article_nr, autor, auth, commentary, templates_id, titel, datum, verfallsdatum, pub_datum, freigabe, released_user_id, release_date, last_modify, changer, nr "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".(int)$_GET['nr']."'";
        $db->query($query);
        $db->next_record();
        $_REQUEST['title'] = $db->v('titel');
		
        printPageHeader(
			__('Newsletter'),
			__('Processing the newsletter').' "<i>'.htmlspecialchars($_REQUEST['title'], ENT_COMPAT, 'ISO-8859-15').'</i>".' . $stag_info,
			modHelp('actions','newsletter'),
			true,
			'modules'
		);

        $where_cat='';
		if ($activeModules[$directory]['use_categories'] == 'yes' && isset($_REQUEST['check_cat']) && is_array($_REQUEST['check_cat']))  {
			// Checked compilations
			$c = '';
			$d = '&';
			$where_cat = " AND ( ";
			$q_cat = "";
			foreach ($_REQUEST['check_cat'] as $v)  {
				$where_cat .= $c . "categories='".$v."' ";
				$q_cat .= $d . "check_cat[]=".$v." ";
				$c = "OR ";
			}
			$where_cat .= ")";
		}

		// Number of
		$if_ranking = '';
        $stagg_limit = '';
        $schedule_limit = '';
		if ($activeModules[$directory]['use_ranking'] == 'yes' && !isset($_REQUEST['rehearsal']))  {
			switch ($activeModules[$directory]['ranking_mode'])  {
				case 'upcluster':
					$if_ranking = "rank >= " . (int)$_REQUEST['cpoNewsletterRank']. ' AND ';
					break;
				case 'downcluster':
					$if_ranking = "rank <= " . (int)$_REQUEST['cpoNewsletterRank']. ' AND ';
					break;
				case 'group':
					$if_ranking = "rank = " . (int)$_REQUEST['cpoNewsletterRank']. ' AND ';
					break;
			}
		}
		$query = "SELECT count(id) AS send_count FROM ".$dbPrefix."_mod_newsletter_adresses WHERE ".$if_ranking."active = 1 AND newsletter='".$directory."'"
		.$where_cat;
		DEBUG(1, $query, __FILE__, __LINE__); 
		$db = new DB;
		$db->query($query);
		$db->next_record();
		$num_of_mails = $db->v('send_count'); // total mails to be sent

		$finished = FALSE;
        if ($activeModules[$directory]['staggered'] == 'yes')  {
			$num_to_process = $activeModules[$directory]['num_to_process'];
			$start_with = (!isset($_GET['start'])) ? 0 : $_GET['start'] ;
			$stagg_limit = ' LIMIT '.$start_with.','.$num_to_process;
			staggered_process(min($start_with + $num_to_process, $num_of_mails), $num_of_mails);
			if ($start_with + $num_to_process >= $num_of_mails) $finished = TRUE;
			echo "<BR><BR>";
		}

		if (isset($_REQUEST['from']) && isset($_REQUEST['to']))  {
			$schedule_limit = ' LIMIT '.(int)$_REQUEST['from'].','.(int)($_REQUEST['to']-$_REQUEST['from']);
			$activeModules[$directory]['staggered'] = "no";
		}

		if (isset($_REQUEST['schedule'])) {
			for ($start=0;$start<=$num_of_mails;$start+=$activeModules[$directory]['num_per_schedule'])  {
				$stop = min($num_of_mails,$start+$activeModules[$directory]['num_per_schedule']-1);
				$schedulequery = "INSERT INTO `".$dbPrefix."_mod_newsletter_schedule` "
								."(`user`, `description`, `post`, `request`, `get`, `from`, `to`) "
								."VALUES ('"
									.$_SESSION['SID_user']['name']."', '"
									.$_POST['schedule_name']." (".$start." ".__('to')." ".$stop.")', '"
									.serialize($_POST)."', '"
									.serialize($_REQUEST)."', '"
									.serialize($_GET)."', "
									.$start.", "
									.$stop
									.")";
				DEBUG(1, $schedulequery, __FILE__, __LINE__); 
				$scheduledb = new DB;
				$scheduledb->query($schedulequery);
			}
			$message[] = sprintf(__('Scheduled job was prepared and saved as <i>%s</i>.'),htmlspecialchars($_POST['schedule_name'], ENT_COMPAT, 'ISO-8859-15'));
			$message[] = sprintf(__('%s scheduled newsletter mails in total.'),$num_of_mails);
			require(CPO_BASEDIR."_include/message.php");
			return;
		}

		require(CPO_BASEDIR."_include/message.php");

		// ******** PREPARING THE NEWSLETTER ***************

		$boundary =		strtoupper(md5(uniqid(time()))); 
		$alt_boundary = strtoupper(md5(uniqid(time()+11111))); 
					
        $header = "FROM: ".$activeModules[$directory]['sender_email']."\n";
		$header .= "Reply-To: ".$activeModules[$directory]['sender_email']."\n"; 
		$header .= "X-Sender-IP: ".$_SERVER['REMOTE_ADDR']; 
		$header .= "\n".$activeModules[$directory]['special_header_text']."\n"; 
		if ($activeModules[$directory]['text_only'] != 'yes')  {
			$header .= "MIME-Version: 1.0\n"; 
			$header .= "Content-Type: multipart/related;\n"; 
			$header .= "	type=\"multipart/alternative\";\n";
			$header .= "	boundary=\"------" . $boundary . "\"\n"; 
		} else {
			$header .= "Content-Type: text/plain;\n";
			$header .= "	charset=\"iso-8859-1\"\n";
			$header .= "Content-Transfer-Encoding: quoted-printable\n\n";
		}

        $stylestring = '';
		if ($activeModules[$directory]['css_sheet'] != '' && $activeModules[$directory]['text_only'] != 'yes')  {
			$style = fopen($activeModules[$directory]['css_sheet'], "r");
			$stylestring = fread($style, filesize($activeModules[$directory]['css_sheet']));
		}

		// fist check for category use - if no, a single creating of mail-content is enough
		if ($activeModules[$directory]['use_categories'] == 'no')  {
			
			require(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_preview.inc.php');

			$text_content .= "\n\n".strip_tags($activeModules[$directory]['no_spam_text']);
			$text_content .= "\n\n".strip_tags($activeModules[$directory]['unscribe_text']);
			$text_content .= "\n\n".strip_tags($activeModules[$directory]['profile_link_text']);
			if (function_exists('html_entity_decode'))  {
				$text_content = html_entity_decode($text_content);
			}

			if ($activeModules[$directory]['text_only'] != 'yes')  {
				$html_content = $activeModules[$directory]['html_header'].$html_content;
				$html_content .= "<br><br>".$activeModules[$directory]['no_spam_text'];
				$html_content .= "<br><br>".$activeModules[$directory]['unscribe_text'];
				$html_content .= "<br><br>".$activeModules[$directory]['profile_link_text'];
				$html_content .= $activeModules[$directory]['html_footer'];
				if ($activeModules[$directory]['include_pics'] == 'yes')  {
					$inhalt = $html_content;
					include (CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_img_cut.inc.php');
					$html_content = $inhalt;
				}
			}
		} elseif ($activeModules[$directory]['use_categories'] == 'yes')  {	// so we need different compilations
			unset ($text_content, $html_content);								// throw away an re-create using differnt categories
			$query = "SELECT categories FROM ".$dbPrefix."_mod_newsletter_adresses WHERE active = 1 AND newsletter='".$directory."' GROUP BY categories ORDER BY categories ASC";
			DEBUG(1, $query, __FILE__, __LINE__); 
			$db_cat = new DB;
			$db_cat->query($query);
			if ( $db_cat->num_rows()>0 )  {
				while($db_cat->next_record()):
					$cat_name = str_replace (";","_",$db_cat->v('categories'));
					$cat_names[] = $cat_name;
					unset ($text_content, $html_content);		// throw away an re-create using next set of categories
					if ($db_cat->v('categories') != 'all')  {
						$categories = explode(";",$activeModules[$directory]['header'].";".$db_cat->v('categories').";".$activeModules[$directory]['footer']);
					} elseif ($db_cat->v('categories') == 'all') {
						$categories = explode(";",$activeModules[$directory]['header'].";".$activeModules[$directory]['categories'].";".$activeModules[$directory]['footer']);
					}
					require(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_preview.inc.php');
					
					$text_content .= "\n\n".strip_tags($activeModules[$directory]['no_spam_text']);
					$text_content .= "\n\n".strip_tags($activeModules[$directory]['unscribe_text']);
					$text_content .= "\n\n".strip_tags($activeModules[$directory]['profile_link_text']);
					if (function_exists('html_entity_decode'))  {
						$text_content_array[$cat_name] = html_entity_decode($text_content);
					} else {
						$text_content_array[$cat_name] = $text_content;
					}
					if ($activeModules[$directory]['text_only'] != 'yes')  {  // do the HTML too
						$html_content = $activeModules[$directory]['html_header'].$html_content;
						$html_content .= "<br><br>".$activeModules[$directory]['no_spam_text'];
						$html_content .= "<br><br>".$activeModules[$directory]['unscribe_text'];
						$html_content .= "<br><br>".$activeModules[$directory]['profile_link_text'];
						$html_content .= $activeModules[$directory]['html_footer'];
						if ($activeModules[$directory]['include_pics'] == 'yes')  {
							$inhalt = $html_content;
							include (CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_img_cut.inc.php');
							$html_content = $inhalt;
						}
						$html_content_array[$cat_name] = $html_content;
					}
					unset ($htmlmailtext, $cat_name);
				endwhile;
			}
		}
		// Mailtexte fertig!

		// table header {{{
        echo '<table class="colored" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th colspan="2"><span>'.__('Processing').'</span></th>';

		echo '</tr></thead><tbody>';
        // }}}
		
		if (isset($_REQUEST['rehearsal'])) {
			$num_of_mails = 1;
		}
		echo '<tr>';
			echo '<td class="leftrow">';
			echo __('Number of Mails to be send:');
			echo '</td>';
			echo '<td class="rightrow">';
			echo $num_of_mails;
			echo '</td>';
		echo '</tr>';
		
		// Adresses
		ini_set('sendmail_from', $activeModules[$directory]['sender_email']);
		$query = "SELECT name, hash, password, email, categories, personalize FROM ".$dbPrefix."_mod_newsletter_adresses WHERE ".$if_ranking."active = 1 AND newsletter='".$directory."'"
		.$where_cat
		.$stagg_limit
		.$schedule_limit;
		if (isset($_REQUEST['rehearsal'])) {
			$query = "SELECT name, hash, password, email, categories, personalize FROM ".$dbPrefix."_mod_newsletter_adresses WHERE newsletter='".$directory."' AND email='".addslashes($_REQUEST['rehearsal'])."' LIMIT 0,1";
		}
		DEBUG(1, $query, __FILE__, __LINE__); 
		$db = new DB;
		$db->query($query);
		echo '<tr>';
			echo '<td style="white-space: nowrap; width=30%;">';
			echo __('Delivering to email-adresses:');
			echo '</td>';
			echo '<td style="white-space: nowrap; width=70%;">';
			echo '<select size="'.min(10,$num_of_mails).'">';
			while ($db->next_record()):
				@set_time_limit(30); 
				$text_lead_in = '';
				$html_lead_in = '';
				$htmlbody = '';
				$textbody = '';
				$attachbody = '';
                $field_name = array();
                $field_replace = array();
                $article_replace = array();
                $field_with = array();
                $field_array = array();
                $replacer = array();

                if ($activeModules[$directory]['personal_fields'])  {

                    $fields = explode("\n", trim($activeModules[$directory]['personal_fields']));
                    foreach($fields AS $field)
                    {	
                        $fieldset = explode(";", trim($field));
                        $field_name[] = trim($fieldset[0]);
                        $replacer[newsletterPlaceholder(trim($fieldset[0]))] = '';
                    }

                    $receiver_personal = unserialize($db->v('personalize'));
                    foreach ($field_name AS $n)  {
                        $replacer[newsletterPlaceholder($n)] = $receiver_personal[$n];
                    }

                    foreach($conditionals AS $newPH => $PHsettings)  {
                        $replacer[newsletterPlaceholder($newPH)] = $conditionals[$newPH]['values'][$receiver_personal[$PHsettings['trigger']]];
                    }
                }
                
                // some standard placeholders
                    $replacer[newsletterPlaceholder('NL-HASH')]          = $db->v('hash'); // the hash
                    $replacer[newsletterPlaceholder('NL-MAIL')]          = $db->v('email'); // the mail-adress
                    $replacer[newsletterPlaceholder('NL-RECIPIENT')]     = $db->v('name'); // the name
                    $replacer[newsletterPlaceholder('NL-UNSCRIBE-LINK')] = BASE_URL.$activeModules[$directory]['directory'].'/index.php?action=unscribe&hash='.$db->v('hash'); // the unscribe-link
                    $replacer[newsletterPlaceholder('NL-PASSWORD')]      = $db->v('password'); // the password

				$cat_name = str_replace (array(";"," ","+"),"_",$db->v('categories'));
				$cat_string = str_replace (";"," + ",$db->v('categories'));
				echo '<option>'.$db->v('email');
				if ($activeModules[$directory]['use_categories'] == 'yes')  echo ' ('.$cat_string.')';
				echo '</option>';

				// here is where the Mail is finally created!

					if ($activeModules[$directory]['text_only'] != 'yes')  {
						$text_lead_in .= "This is a multi-part message in MIME format.\n";
						$text_lead_in .= "\n--------$boundary\n";

						$text_lead_in .= "Content-Type: multipart/alternative;\n";
						$text_lead_in .= "	boundary=\"------".$alt_boundary."\"\n\n"; 
						$text_lead_in .= "--------$alt_boundary\n";
						$text_lead_in .= "Content-Type: text/plain;\n";
						$text_lead_in .= "	charset=\"iso-8859-1\"\n";
						$text_lead_in .= "Content-Transfer-Encoding: quoted-printable\n\n";
						if ($activeModules[$directory]['use_categories'] == 'yes')  {
							$cat_header = "X-Categories: ".$cat_name."\n";
						}

					}

					if ($activeModules[$directory]['use_categories'] == 'yes')  {
						$textbody = $text_content_array[$cat_name];
					} else {
						$textbody = $text_content;
					}

					if ($activeModules[$directory]['text_only'] != 'yes')  {

						$text_lead_out = "\n--------$alt_boundary\n";

						$html_lead_in = "Content-Type: text/html;\n";
						$html_lead_in .= "	charset=\"iso-8859-1\"\n";
						$html_lead_in .= "Content-Transfer-Encoding: quoted-printable\n\n";
						
						$htmlbody = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n";
						$htmlbody .= "<HTML><HEAD>\n";
						$htmlbody .= "<STYLE>\n";

						$htmlbody .= $stylestring;

						$htmlbody .= "</STYLE>\n";
						$htmlbody .= "</HEAD>\n";
						$htmlbody .= "<BODY topmargin=\"0\" leftmargin=\"0\">\n";

						if ($activeModules[$directory]['use_categories'] == 'yes')  {
							$htmlbody .= $html_content_array[$cat_name];
						} else {
							$htmlbody .= $html_content;
						}
						
						$htmlbody .= "\n</BODY></HTML>";

						$attachbody .= "\n--------$alt_boundary--\n\n";

						if ($activeModules[$directory]['include_pics'] == 'yes')  {
							include (CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_img_add.inc.php');
						}
						$attachbody .= "\n--------$boundary--\n";
					}
					
					$mail_content = $text_lead_in
//							. qp_encoding(str_replace($field_replace, $field_with, str_replace($article_replace, $field_with, $textbody)))
							. qp_encoding(preg_replace(array_keys($replacer), array_values($replacer), $textbody))
                            . $text_lead_out
							. $html_lead_in
//							. qp_encoding(str_replace($field_replace, $field_with, str_replace($article_replace, $field_with, $htmlbody)))
							. qp_encoding(preg_replace(array_keys($replacer), array_values($replacer), $htmlbody))
							. $attachbody;
					$mail_header = $header.$cat_header;

					if (isset($_REQUEST['cronjob'])) {
						$cronjobquery = "INSERT INTO `".$dbPrefix."_mod_newsletter_cronjob` (`recipient`, `subject`, `content`, `header`) VALUES ('".$db->v('email')."', '".$db_titel."', '".$mail_content."', '".$mail_header."')";
						DEBUG(1, $cronjobquery, __FILE__, __LINE__); 
						$cronjobdb = new DB;
						$cronjobdb->query($cronjobquery);
					} else {
						@mail (
							$db->v('email'), 
							$db_titel, 
							$mail_content,
							$mail_header
						);
					}
                    $check_content = htmlspecialchars($mail_header."\n".$mail_content, ENT_COMPAT, 'ISO-8859-15');
					unset ($emailbody, $htmlmailtext, $cat_name, $mail_content, $mail_header);  // Aufrumen!

			// here the Mail is already sent!

			endwhile;

			echo '</select>';
			echo '</td>';
		echo '</tr>';
		if (NL_INI_RESTORE) ini_restore('sendmail_from');
		
		echo '</tbody></table>';

        // Use the following line for checking the mail header and content(s)
        // echo '<div style="border: 3px solid black; padding:20px;"><pre>'."\n\n\n\n\n".$check_content."\n\n\n\n\n</pre></div>";


    if (!$finished  && $activeModules[$directory]['staggered'] == 'yes')  {
		$start_with += $num_to_process;
		echo "<script language=\"JavaScript\" type=\"text/javascript\">timerID = window.setTimeout('location.href=\"".$PHP_SELF."?action=out&"
			."title=" . addslashes($_REQUEST['title'])
			."&nr=" . $_REQUEST['nr']
			."&start=" . $start_with 
			."&cpoNewsletterRank=" . $_REQUEST['cpoNewsletterRank']
			.$q_cat
			.(($_REQUEST['cronjob']=="out") ? '&cronjob=out' : '')
			."\";',5000);</script>";
		$message[] = sprintf(__("<b>%s</b> of <b>%s</b> newsletters were processed"), $start_with, $num_of_mails);
		$message[] = sprintf(__('Press %s to abort the processing OR WAIT!'), '<a href="javascript:void(0)" onclick="clearTimeout(timerID)">STOP</a>');
	} else {
		$message = __('When you see this message all newsletters have been sent!');
	}
	require(CPO_BASEDIR."_include/message.php");
	if ($activeModules[$directory]['log'] == 'yes') logaction('Newsletter sent', $_REQUEST['title']);

?>