<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php');
$help = $activeModules[$directory]['help'];

// Sprache
$directory = basename(dirname($_SERVER['PHP_SELF'])); 
$translator->addTranslation('newsletter',CPO_BASEDIR.$directory.'/lang');

$pagetype = 'default';
include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/producer.inc.php');

if (!license($activeModules[$directory]['lkey'],$activeModules[$directory]['mod_id']) && $activeModules[$directory]['installed']<(time()-90*24*60*60)) {
	require(CPO_BASEDIR.'_include/header.php');
	$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
		htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
	$message['license'] .= sprintf(___('This is a fully functional, but not registered version of %1$s. Please contact your %2$sadministrator%3$s.'),
		htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'),
		'<a href="mailto:'.htmlspecialchars($cpoSystem['admin_email'], ENT_COMPAT, 'ISO-8859-15').'">',
		'</a>'
	);

	if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
		$message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'), htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong>';
		$message['license'] .= '<br />';
		$message['license'] .= sprintf(___('The %s-license model differs between commercial and non-commercial use.'), htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'));
		$message['license'] .= '<br />';
		$message['license'] .= sprintf(___('To use the system in commercial environments you need to purchase a "license for commercial use" in the moment of project release. This license can be ordered on the %s Website%s.'), '<a href="'.$MOD['productlink'].'" target="_blank">'.htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'), '</a>');
		$message['license'] .= '<br />';
		$message['license'] .= sprintf(___('If you are using %s non-commercially, you can register for free at this point in time on the %s Website%s.'), htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'), '<a href="'.$MOD['productlink'].'" target="_blank">'.htmlspecialchars($MOD['product'], ENT_COMPAT, 'ISO-8859-15'), '</a>');
	}
	require(CPO_BASEDIR."_include/message.php");
	include(CPO_BASEDIR.'_include/footer.php');
	exit;
}

$action		= $_REQUEST['action'];
$_GET['nr']	= $_REQUEST['nr'];
require(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_preview.inc.php');

// previews on screen
if ($action =='preview' && $activeModules[$directory]['showMailForm'] == "yes")  {
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_mailheader.inc.php');
	echo '<div class="NLframe">';
	echo $activeModules[$directory]['html_header'];
	echo $html_content;
	echo "<BR><BR>".$activeModules[$directory]['no_spam_text'];
	echo "<BR><BR>".$activeModules[$directory]['unscribe_text'];
	echo "<BR><BR>".$activeModules[$directory]['profile_link_text'];
	echo $activeModules[$directory]['html_footer'];
	echo '</div>';
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_mailfooter.inc.php');
} elseif ($action =='preview' && $activeModules[$directory]['showMailForm'] == "no")  {
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_noheader.inc.php');
	echo $activeModules[$directory]['html_header'];
	echo $html_content;
	echo $activeModules[$directory]['html_footer'];
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_nofooter.inc.php');
} elseif ($action =='text_preview' && $activeModules[$directory]['showMailForm'] == "yes")  {
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_mailheader.inc.php');
	echo '<textarea class="big" rows="40">';
	echo $text_content;
	echo "\n\n".strip_tags($activeModules[$directory]['no_spam_text']);
	echo "\n\n".strip_tags($activeModules[$directory]['unscribe_text']);
	echo "\n\n".strip_tags($activeModules[$directory]['profile_link_text']);
	echo '</textarea>';
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_mailfooter.inc.php');
} elseif ($action =='text_preview' && $activeModules[$directory]['showMailForm'] == "no")  {
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_noheader.inc.php');
	echo nl2br($text_content);
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_nofooter.inc.php');
} elseif ($action =='send')  {
	// now we process the newsletter!
	// Seitenausgabe ********************************************************
	require(CPO_BASEDIR.'_include/header.php');
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_send.inc.php');
	include(CPO_BASEDIR.'_include/footer.php');
} elseif ($action =='out')  {
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/newsletter_functions.inc.php');
	require(CPO_BASEDIR.'_include/header.php');
	include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/inc_out.inc.php');
	include(CPO_BASEDIR.'_include/footer.php');
}

?>
