<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Newsletter"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

=== Version 4.3e / January 2014 ===

*/

define('CPO', true);
require_once('../_include/common.inc.php');

// Header
require(CPO_BASEDIR.'_include/header.php');

// Sprache
$directory = basename(dirname($_SERVER['PHP_SELF'])); 
$translator->addTranslation('frontend',CPO_BASEDIR.$directory.'/lang');

// Funktionen
include_once(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/newsletter_functions.inc.php');

$query = "SELECT id "
        ."FROM ".$dbPrefix."_mod_newsletter_adresses "
        ."WHERE newsletter='".$directory."' AND email='".addslashes($_REQUEST['receiver'])."' ";
DEBUG(1, $query, __FILE__, __LINE__);
$db->query($query);
$db->next_record();

if (isset($_REQUEST['action']) && isset($_REQUEST['receiver']) && isset($_REQUEST['hash']) && is_email_valid($_REQUEST['receiver'])) {
	$admin_hash = md5($cpoSystem['admin_email']);
	if (check_receiver($_REQUEST['receiver']) && $admin_hash == $_REQUEST['hash'])  {
		switch($_REQUEST['action'])  {
			case 'up':
				newsletter_receiver_up($db->v('id'));
				$message[] = sprintf(__('The rank of <i>%s</i> has been increased!'),htmlspecialchars($_REQUEST['receiver'], ENT_COMPAT, 'ISO-8859-15'));
				break;
			case 'down':
				newsletter_receiver_down($db->v('id'));
				$message[] = sprintf(__('The rank of <i>%s</i> has been decreased!'),htmlspecialchars($_REQUEST['receiver'], ENT_COMPAT, 'ISO-8859-15'));
				break;
		}
	}
} else {
	$message[] = __('Insufficient data to process your request!');
}
require(CPO_BASEDIR."_include/message.php");

// ==== footer =====
include(CPO_BASEDIR.$activeModules[$directory]['directory'].'/includes/producer.inc.php');
include(CPO_BASEDIR.'_include/footer.php');
?>