<?php 
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Populate" (Blindtexte)                               |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 0.1 / October 2020

*/

if (!defined('CPO')) exit;

$translator->addTranslation('populate', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['populate'] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'Dummy text generator',
    'install'   => 'function: populate_install',
    'activate'  => 'function: populate_activate '.$moduleDirectory,
    'deactivate'=> 'function: populate_deactivate',
    'uninstall' => 'function: populate_uninstall '.$moduleDirectory
	);

$generatorFiles = array(
    'Lorem Ipsum' => 'lorem-ipsum.txt.php',
    'Hinter den Wortbergen' => 'wortberge.txt.php',
    'Leise Schritte' => 'leise-schritte.txt.php',
    'Typo-Blindtext' => 'typoblindtext.txt.php',
    'Kafka' => 'kafka.txt.php',
    'Pangramm' => 'pangramm.txt.php',
    'Blindtext (Wikipedia)' => 'blindtexte.txt.php',
    );

function populate_install()
{
    $GLOBALS['message'][] = ___('The dummy text module was successfully installed!');
}
function populate_uninstall($moduleDirectory)
{
	 $GLOBALS['message'][] = sprintf(__('The dummy text module was successfully removed from the ConPresso system. Please remove the module directory <i>%s</i> to finally uninstall the module.'),$moduleDirectory);

}
function populate_activate($moduleDirectory)
{
    global $generatorFiles;
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";
    $dbp = new DB();
    foreach($generatorFiles AS $ck=>$cf) {
        include(CPO_BASEDIR.$moduleDirectory.'/texte/'.$cf) ;
        $query = "INSERT INTO ".CPO_SNIPPET." "
                ."(id, name, rubric_id, user_id, snippet, lastmodify) VALUES ("
                ."NULL, "
                ."'".__('Dummy text').': '.addslashes($ck)."', "
                ."'-1', "
                ."'1', "
                ."'".addslashes(implode("\n",$blindtextArray))."', "
                ."'".addslashes(date('Y-m-d H:i:s'))."' "
                .")";
        $dbp->query($query);
    }

    $GLOBALS['message'][] = ___('The dummy text module got activated.').$reload_navigation;
}

function populate_deactivate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";
    $dbp = new DB();
    $dbp->query("DELETE FROM ".CPO_SNIPPET." WHERE name LIKE '".__('Dummy text').": %' ");

    $GLOBALS['message'][] = ___('The dummy text module got deactivated.').$reload_navigation;
}

function populate_navigation($moduleDirectory)
{
    $GLOBALS['navigation']['System'][] = 'space'; 
    
    $GLOBALS['navigation']['System'][] = array(
            'caption'=>'Dummy text generator',
            'url'=>BASE_REL.$moduleDirectory.'/populate.php'
        );
}

if (isset($_SESSION['SID_user']['admin']) && $_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
    $hdlr_navigation[] = 'function: populate_navigation '.$moduleDirectory;
}

?>