<?php 
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Populate" (Blindtexte)                               |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 0.1 / October 2020

*/

define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 

require(CPO_BASEDIR.'_include/check.php');
require(CPO_BASEDIR.'_include/header.php');

//prepare some vars
/*$generatorFiles = array(
    'Lorem Ipsum' => 'lorem-ipsum.txt.php',
    'Hinter den Wortbergen' => 'wortberge.txt.php',
    'Leise Schritte' => 'leise-schritte.txt.php',
    'Typo-Blindtext' => 'typoblindtext.txt.php',
    'Kafka' => 'kafka.txt.php',
    'Pangramm' => 'pangramm.txt.php',
    'Blindtext (Wikipedia)' => 'blindtexte.txt.php',
    );*/
$articleCounts = array(
    '3-6' => array(3,6),
    '8-12' => array(8,12),
    '15-25' => array(15,25),
    '35-85' => array(35,85),
    );
$rubricCaptions = array(
    'Thema',
    'Aktuell',
    'Rubrik',
    'Berichte',
    'Abteilung'
    );
$subjekt = array(
    'Sonne',
    'Regen',
    'Schnee',
    'Sturm',
    'Gewitter',
    'Tornado',
    'Windhose',
    'Blauer Himmel',
    'Wetterchaos',
    'Kaiserwetter',
    'rger',
    'Sternschnuppen',
    'Wahnsinn',
    );
$position = array(
    'in',
    'ber',
    'bei',
    'rund um',    
    );
$location = array(
    'Mnchen',
    'Hamburg',
    'Mainz',
    'Hannover',
    'Berlin',
    );

if (isset($_POST['content'])) include('./texte/'.$generatorFiles[$_POST['content']]);

if (isset($_POST['reset']))  unset ($_POST);


// AUSWAHLEN ***************************************************************************************

    // Artikelzahl *******************************************************************************
	$count_articles_select = '<select name="articles">';
	foreach ($articleCounts AS $atext=>$acount) {
		$count_articles_select .= '<option value="'.$atext.'"'.((isset($_POST['articles']) && $_POST['articles']==$atext) ? ' selected="selected"' : '').'>'.$atext.'</option>';
	}
	$count_articles_select .= '</select>';

	// Blindtext-Auswahl *******************************************************************************
	$content_select = '<select name="content">';
	foreach ($generatorFiles AS $name=>$file) {
		$content_select .= '<option value="'.$name.'"'.((isset($_POST['name']) && $_POST['name']==$name) ? ' selected="selected"' : '').'>'.$name.'</option>';
	}
	$content_select .= '</select>';

    // Navigations-Auswahl *******************************************************************************
	$navi_select = '<select name="navi">';
		$navi_select .= '<option value="no"'.((isset($_POST['navi']) && $_POST['navi']=="no") ? ' selected="selected"' : '').'>'.__('no').'</option>';
		$navi_select .= '<option value="yes"'.((isset($_POST['navi']) && $_POST['navi']=="yes") ? ' selected="selected"' : '').'>'.__('yes').'</option>';
	$navi_select .= '</select>';

if (!isset($_POST['rubrics']) || trim($_POST['rubrics'])=='') $_POST['rubrics'] = 1;
if (!isset($_POST['paragraphs']) || trim($_POST['paragraphs'])=='') $_POST['paragraphs'] = 1;
if (!isset($_POST['levels']) || trim($_POST['levels'])=='') $_POST['levels'] = 1;

// aufrumen...
if (isset($_POST['del']))  {
    // finde und lsche Rubriken, die ausschlielich unvernderte Blindtexte beinhalten und lsche alle unvernderten Blindtexte (autor+changer=Blindtextgenerator)
    $db = new DB();
    $rubrics = array(); // query all rubrics to get id, name
    $db->query("SELECT `id`, `name` FROM `".CPO_RUBRIC."` ;");
    while ($db->next_record()) $rubrics[$db->v('id')] = $db->v('name');
    $dummyRubrics = array();
    $db->query("SELECT `rubric_id` FROM `".CPO_NEWS."` WHERE `autor` = '".__('Dummy text generator')."' AND `changer` = '".__('Dummy text generator')."' GROUP BY `rubric_id` ;");
    while ($db->next_record()) $dummyRubrics[$db->v('rubric_id')] = $rubrics[$db->v('rubric_id')];

    // only dummy texts?
    foreach($dummyRubrics AS $rk=>$rv) {
        $db->query("SELECT count(*) FROM `".CPO_NEWS."` WHERE `autor` = '".__('Dummy text generator')."' AND `changer` = '".__('Dummy text generator')."' AND `rubric_id` = ".$rk." ;");
        $db->next_record();
        $dummyCount = $db->v('count(*)');
        $db->query("SELECT count(*) FROM `".CPO_NEWS."` WHERE `rubric_id` = ".$rk." ;");
        $db->next_record();
        $totalCount = $db->v('count(*)');
        if ($dummyCount!=$totalCount) unset($dummyRubrics[$rk]); // do not delete this one!
    }
     // do the purge!
    foreach($dummyRubrics AS $rk=>$rv) { // first the 100% dummies
        $db->query("SELECT `nr`, `titel` FROM `".CPO_NEWS."` WHERE `rubric_id` = ".$rk." ;"); // find the articles
        $inSel='';
        $comma='';
        while ($db->next_record()) {
            $inSel.=$comma.$db->v('nr');
            $comma=',';
            $message[] = sprintf(__("The dummy article <em>%s</em> was purged."), $db->v('titel'));
        }
        // purge the dummy articles
        $db->query("DELETE FROM ".CPO_CONTENT_TEXT." WHERE `article_id` IN (".$inSel.") ;");
        $db->query("DELETE FROM ".CPO_CONTENT_HTML." WHERE `article_id` IN (".$inSel.") ;");
        $db->query("DELETE FROM ".CPO_CONTENT_URLS." WHERE `article_id` IN (".$inSel.") ;");
        $db->query("DELETE FROM ".CPO_CONTENT_IMAGES." WHERE `article_id` IN (".$inSel.") ;");
        $db->query("DELETE FROM ".CPO_CONTENT_FILES." WHERE `article_id` IN (".$inSel.") ;");
        $db->query("DELETE FROM ".CPO_NEWS." WHERE `nr` IN (".$inSel.") ;");
        // now purge the rubric
        $db->query("DELETE FROM `".CPO_RUBRIC."` WHERE `id` = ".$rk." ;");
        $db->query("DELETE FROM `".CPO_PERMISSION."` WHERE `rubric_id` = ".$rk." ;");
        $db->query("DELETE FROM `".CPO_TPL_ASSIGNMENT."` WHERE `rubric_id` = ".$rk." ;");
        $message[] = sprintf(__("The dummy rubric <em>%s</em> was purged."), $rv);
    }
    // purge all remaining unchanged dummy articles
    $db->query("DELETE FROM `".CPO_NEWS."` WHERE `autor` = '".__('Dummy text generator')."' AND `changer` = '".__('Dummy text generator')."' ;");
    $message[] = __("All remaining unchanged dummy articles were purged.");
    
    // done!
    $message[] = '<b>'.__("The purge is completed!").'</b>';
}

// es gibt was zu tun...
if (isset($_POST['go']))  {

    $db = new DB();
    for ($i=1;$i<=(int)$_POST['rubrics'];$i++)  {
        // Rubrik
        $db->query('SELECT name FROM '.CPO_RUBRIC);
        while ($db->next_record()) $rnames[]=$db->v('name');
        $rubricTheme = $rubricCaptions[array_rand($rubricCaptions)];
        $d=0;
        $rubricName = $rubricTheme.'_'.($d+1);
        while(in_array($rubricName, $rnames)) {
            $rubricName = $rubricTheme.'_'.($d+1);
            $d++;
        }

        $db->query("INSERT INTO ".CPO_RUBRIC." VALUES (NULL, '_rubric', '".str_replace(" ","_",$rubricName)."', 0, 0, 'a:4:{s:5:\"title\";s:".strlen($rubricName).":\"".$rubricName."\";s:18:\"pagetemplate_index\";s:1:\"1\";s:19:\"pagetemplate_detail\";s:1:\"1\";s:17:\"standard_template\";s:1:\"1\";}');");
        $db->query('SELECT last_insert_id()');
        $db->next_record();
        $rnr = $db->v('last_insert_id()');
        $db->query("INSERT INTO ".CPO_PERMISSION." VALUES (NULL, 1, ".$rnr.", 1, 1, 1, 1);");
        $db->query("INSERT INTO ".CPO_TPL_ASSIGNMENT." VALUES (NULL, ".$rnr.", 1, '0000-00-00 00:00:00', '');");
        $message[] = sprintf(__("The rubric <em>%s</em> (ID: %s) was created."), $rubricName,$rnr);


        for ($n=1;$n<=mt_rand($articleCounts[$_POST['articles']][0],$articleCounts[$_POST['articles']][1]);$n++)  {
            // Artikel
            $aTitel = $subjekt[array_rand($subjekt)].' '.$position[array_rand($position)].' '.$location[array_rand($location)];
            $db->query("INSERT INTO ".CPO_NEWS." VALUES (NULL, 0, 1, '', '', '', ".$rnr.", 1, '".$aTitel."', '".date('Y-m-d H:i:s')."', '2036-01-01 00:00:00', '".date('Y-m-d H:i:s')."', '".__('Dummy text generator')."', '".addslashes($cpoSystem['system_email'])."', 'adm', 'zzzzzzzz', 0, 1, '".date('Y-m-d H:i:s')."', '".date('Y-m-d H:i:s')."', '".date('Y-m-d H:i:s')."', '".__('Dummy text generator')."', 1);");
            $db->query('SELECT last_insert_id()'); 
            $db->next_record();
            $anr = $db->v('last_insert_id()');
            $query = "UPDATE ".CPO_NEWS." SET "
            ."article_nr='".addslashes($anr)."', " // article_nr = nr for newest article version
            ."sort_id='".addslashes($anr)."' "     // use sort_id based on nr (auto-incremented)
            ."WHERE nr='".addslashes($anr)."'";
            $db->query($query); 
            $pcount = (isset($_POST['paragraphs'])) ? min(max(1,(int)$_POST['paragraphs']),count($blindtextArray)) : 1 ;
            $subTilte = __('Dummy text').': '.$_POST['content'];
            $content = '';
            for ($p=0;$p<$pcount;$p++) $content .= $blindtextArray[$p];

            $db->query("INSERT INTO ".CPO_CONTENT_TEXT." VALUES (NULL, ".$anr.", 'Untertitel', '".$subTilte."');");
            $db->query("INSERT INTO ".CPO_CONTENT_HTML." VALUES (NULL, ".$anr.", 'Teaser', '".$content."');");
            $db->query("INSERT INTO ".CPO_CONTENT_URLS." VALUES (NULL, ".$anr.", 'Weiter-Link', '', 'Weiterlesen ', '');");
            $db->query("INSERT INTO ".CPO_CONTENT_HTML." VALUES (NULL, ".$anr.", 'Artikel-Text', '".$content."');");
            $db->query("INSERT INTO ".CPO_CONTENT_URLS." VALUES (NULL, ".$anr.", 'Zurck-Link', '', ' zurck', '');");
            $message[] = sprintf(__("The article <em>%s</em> was created."), $aTitel);
        }
    }

    // ******* auto create ********************************************************
    if ($_POST['navi'] == 'yes') {
        $message[] = __('<b>Creating navigation structure</b>');
        $db = new DB;
        $navStructure = array('Home');
        $prevnavitemID = NULL;
        $query = "DROP TABLE IF EXISTS ".CPO_NAVTREE.";";
        $db->query($query);
        $query = "CREATE TABLE ".CPO_NAVTREE." ( id int(11) NOT NULL auto_increment, l int(11) NOT NULL default '0', r int(11) NOT NULL default '0', caption varchar(255) NOT NULL default '', rubric_id int(11) NOT NULL default '0', settings text NOT NULL, PRIMARY KEY  (id), KEY l (l), KEY r (r), KEY rubric_id (rubric_id)) ENGINE=MyISAM;";
        $db->query($query);
        $query = 'INSERT INTO '.$dbPrefix.'_navtree VALUES ('
            ."'1', "
            ."'1', "
            ."'2', "
            ."'root', "
            ."'0', "
            ."'' "
            .")";
        $db->query($query);
        $db->query("SELECT id, name FROM ".CPO_RUBRIC);

        $lastLevel=0;

        while ($db->next_record()) {
            $existingRubrics[$db->v('name')] = $db->v('id');
            $nLevels=mt_rand(0,min($lastLevel+1,$_POST['levels']));
            $plus='';
            for ($x=1;$x<=$nLevels;$x++) $plus .= '+';
            if ($db->v('id')!=1) $navStructure[] = $plus.$db->v('name');
            $lastLevel=$nLevels;
        }

        // creating
        //echo "\n\n".implode("\n",$navStructure)."\n\n";
        $navitems = explode("\n",implode("\n",$navStructure));
        $prevnavitemLevel = 0; // (root)
        $id = 1; // the first one (root)
        foreach ($navitems AS $key => $navitem)  {
            if (trim($navitem)=='') continue;
            $navitemLevel = 1;
            $navitemParts = explode(';',$navitem);
            $itemCaption = (isset($navitemParts[0])) ? trim($navitemParts[0]) : '';
            $itemRubric =  (isset($navitemParts[1])) ? trim($navitemParts[1]) : NULL;
            //$itemRubricDir = (trim($navitemParts[2])) ? trim($navitemParts[2]) : '_rubric';
            //$itemRubricSecLevel = (trim($navitemParts[3])) ? trim($navitemParts[3]) : 0;
            //$itemRubricSource = (trim($navitemParts[4])) ? $existingRubrics[trim($navitemParts[4])] : 1;
            for ($n=0;$n>=0;$n++)  {
                if ($itemCaption[$n] == '+')  {
                    $navitemLevel++;
                } else {
                    break 1;
                }
            }
            $itemCaption = substr($itemCaption,$navitemLevel-1);
            
            // add entry
            if ($prevnavitemLevel == $navitemLevel)  {
                $query = 'SELECT r FROM '.CPO_NAVTREE." WHERE id='".addslashes($id)."'";
                DEBUG(1, $query, __FILE__, __LINE__);
                $db = new DB; 
                $db->query($query);
                $db->next_record();
                $rid = $db->v('r');
                if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');
                $query = 'UPDATE '.CPO_NAVTREE." SET l = l+2 WHERE l>'".addslashes($rid)."' ";
                $db->query($query);
                $query = "UPDATE ".CPO_NAVTREE." SET r = r+2 WHERE r>'".addslashes($rid)."' ";
                $db->query($query);
                $query = "INSERT INTO ".CPO_NAVTREE." (l, r, caption) VALUES ('".addslashes($rid+1)."', '".addslashes($rid+2)."', '".$itemCaption."')";
                $db->query($query);
                if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');
                $id++;
                $db->query('SELECT last_insert_id()');
                $db->next_record();
                $navitemLevels[$navitemLevel] = $db->v('last_insert_id()');
            } elseif ($prevnavitemLevel < $navitemLevel)  {
                //adding sublevel
                $query = 'SELECT r FROM '.CPO_NAVTREE." WHERE id='".addslashes($id)."'";
                $_SESSION['SID_navigation_opened'][$prevnavitemID] = true;
                $db = new DB; 
                $db->query($query);
                $db->next_record();
                $rid = $db->v('r');

                // add entry
                if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');
                $query = 'UPDATE '.CPO_NAVTREE." SET l = l+2 WHERE l>'".addslashes($rid)."' ";
                $db->query($query);
                $query = "UPDATE ".CPO_NAVTREE." SET r = r+2 WHERE r>='".addslashes($rid)."' ";
                $db->query($query);
                $query = "INSERT INTO ".CPO_NAVTREE." (l, r, caption) VALUES ('".addslashes($rid)."', '".addslashes($rid+1)."', '".$itemCaption."')";
                $db->query($query);
                if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');
                $id++;
                $db->query('SELECT last_insert_id()');
                $db->next_record();
                $navitemLevels[$navitemLevel] = $db->v('last_insert_id()');
            } elseif ($prevnavitemLevel > $navitemLevel)  {
                //back on last level
                $query = 'SELECT r FROM '.CPO_NAVTREE." WHERE id='".$navitemLevels[$navitemLevel]."'";
                DEBUG(1, $query, __FILE__, __LINE__);
                $db = new DB; 
                $db->query($query);
                $db->next_record();
                $rid = $db->v('r');
                if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');
                $query = 'UPDATE '.CPO_NAVTREE." SET l = l+2 WHERE l>'".addslashes($rid)."' ";
                $db->query($query);
                $query = "UPDATE ".CPO_NAVTREE." SET r = r+2 WHERE r>'".addslashes($rid)."' ";
                $db->query($query);
                $query = "INSERT INTO ".CPO_NAVTREE." (l, r, caption) VALUES ('".addslashes($rid+1)."', '".addslashes($rid+2)."', '".$itemCaption."')";
                $db->query($query);
                if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');
                $id++;
                $db->query('SELECT last_insert_id()');
                $db->next_record();
                $navitemLevels[$navitemLevel] = $db->v('last_insert_id()');
            }
            $message[] = sprintf(__('Navigation item <em>%s</em> created.'),$itemCaption);
            $prevnavitemLevel = $navitemLevel;
            $prevnavitemID = $id;

			// automated rubric create
			$RubricName = ($itemRubric) ? $itemRubric : $itemCaption;
			if (array_key_exists($RubricName, $existingRubrics))  {
				$query = "UPDATE ".CPO_NAVTREE." SET rubric_id='".$existingRubrics[$RubricName]."' WHERE id='".addslashes($id)."' ";
				$db->query($query);
			    $message[] = sprintf(__('Rubric <em>%s</em> already exists. Added to navigation.'),$RubricName);
			} 
        }
        $message[] = __('Navigation items were created.');
    }
}

// Die Formularseite
include(CPO_BASEDIR.$activeModules['populate']['directory'].'/producer.inc.php');

printPageHeader(
    __('Dummy text generator'),
    __('In this view you can fill the ConPresso installation with dummy texts.')
);

include(CPO_BASEDIR.'_include/message.php');
?>

<form action="populate.php" method="post">
    <table class="colored" style="width: 100%"><thead>
        <tr>
            <th colspan="2"><span><?php echo __('Dummy text settings'); ?></span></th>
        </tr>
    </thead><tbody>
		<tr>
					<td><?php echo __('Rubrics:'); ?> </td>
					<td><input type="text" name="rubrics" value="<?php echo $_POST['rubrics']; ?>" size="5"></td>
				</tr>
				<tr>
					<td><?php echo __('Articles per rubric (min-max):'); ?> </td>
					<td><?php echo $count_articles_select; ?></td>
				</tr>
				<tr>
					<td><?php echo __('Content:'); ?> </td>
					<td><?php echo $content_select; ?></td>
				</tr>
				<tr>
					<td><?php echo __('Paragraphs:'); ?> </td>
					<td><input type="text" name="paragraphs" value="<?php echo $_POST['paragraphs']; ?>" size="5"></td>
				</tr>
				<tr>
					<td><?php echo __('Create navigation:'); ?> </td>
					<td><?php echo $navi_select; ?>
                        <?php echo __('<b>NOTE:</b> An existing navigation structure will be deleted!'); ?>
                    </td>
				</tr>
				<tr>
					<td><?php echo __('Navigation levels:'); ?> </td>
					<td><input type="text" name="levels" value="<?php echo $_POST['levels']; ?>" size="5"><br />
                        <?php echo __('<b>NOTE:</b> This is a maximum value of nesting.<br />It is unlikely to reach it on higher numbers,<br />because the level can only go up 1 step a time<br />but fall back to root level any time!'); ?>
                    </td>
				</tr>
				<tr>
					<td><input type="submit" name="del" value="<?php echo __('Delete all dummy texts'); ?>" /></td>
					<td><input type="submit" name="go" value="<?php echo __('Generate dummy texts'); ?>" /> <input type="submit" name="reset" value="<?php echo __('Reset'); ?>" /></td>
				</tr>
				</table>
</form>

<?php
	require(CPO_BASEDIR.'_include/footer.php');
?>
