<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can mail you a copy immediately.          |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
|          based on work by Markus Roesel                                |
+------------------------------------------------------------------------+
  $Id: loadfooters.php,v 1.3 2005/02/13 17:37:20 balu Exp $ */
if (!defined('CPO')) exit;
$translator->addTranslation('search', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules'][$moduleDirectory] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'Search'.' ('.$moduleDirectory.')',
    'install'   => 'function: Search_install',
    'activate'  => 'function: Search_activate',
    'deactivate'=> 'function: Search_deactivate',
    'uninstall' => 'function: Search_uninstall '.$moduleDirectory,
	'manage'    => 'function: Search_manage '.$moduleDirectory,
	//'help'      => '/'.$moduleDirectory.'/help/help.php',
//	'owner'=>$cpoSystem['owner'],
//	'lkey'=>'',
	// Grundwerte
	'noOfResults'=>'10',
	'stringLength'=>'250',
	'dateFormat'=>$cpoSystem['date_format'],
	'template'=>'
<!-- START_MOD_SEARCH -->
<style>
.searchhighlight { color: red; font-weight: bold; }
</style>
<form name="suchergebnisse" method="get" action="index.php" >
    <input type="hidden" name="action" value="search" />
    <input type="hidden" name="rubric" value="<!-- SEARCH_NAV -->" />
    Bitte geben Sie Ihren Suchbegriff ein:<br />
    <input type="text" name="q" value="<!-- SEARCH_PHRASE -->" />
    <input type="submit" value="Suche">
</form>
<!-- SEARCH_MESSAGE -->

<!-- SEARCH_MATCHES -->

<div style="margin: 1em 0;">
<!-- START_SEARCH_MATCH -->
    <!-- SEARCH_NUM -->.)
    <a href="<!-- SEARCH_LINK -->"><strong><!-- SEARCH_TITLE --></strong></a>
    (Rubrik: <strong><!-- SEARCH_RUBRIC --></strong>) -
    <strong><!-- SEARCH_AUTHOR --></strong> -
    <strong><!-- SEARCH_PUB_DATE --></strong>
    Artikel-Nr.: <strong><!-- SEARCH_ARTICLE_ID --></strong><br />
    <!-- SEARCH_CONTENT -->
    <hr />
<!-- END_SEARCH_MATCH -->
</div>
<!-- SEARCH_PAGES -->
<!-- END_MOD_SEARCH -->
',
	'highlightCSS'=>'class="searchhighlight"',
	'noSearchstringText'=>__('Please enter a search phrase.'),
	'noMatchesText'=>__('No matches returned.'),
	'matchesText'=>__('The search returned %s matches.'),
	'rubricsUse'=>'off',
    'opt'=>array(
        'alibi'=>1,
        'searchAuthors'=>1,
        'searchContent'=>1,
        'searchKeywords'=>1,
        'logQueries'=>0,        
    ),
    'pagetemplate' => null,
);

$search_directory = $moduleDirectory;

if (!function_exists('Search_manage')) {
function Search_manage($moduleDirectory)
{
    global $module_status, $k;
    printIcon(	
        BASE_ABS.$moduleDirectory.'/edit.php?list=options', 
        BASE_ABS.SKIN_URL.'pic_settings.gif', 
        (array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE) ? __('edit module settings') : __('not available'),
        array_key_exists($k, $module_status) && $module_status[$k]!=MODULE_INACTIVE
    );
}
}

if (!function_exists('Search_navigation')) {
function Search_navigation()
{
    global $search_directory;
    $GLOBALS['navigation']['Search'] = array('caption'=>'Search', 'url'=>BASE_ABS . $search_directory . '/search.php');
}
}

if (isset($_SESSION['SID_user']) && $_SESSION['SID_user']['admin']>=ROLE_EDITOR) {
    $hdlr_navigation[] = 'function: Search_navigation';
}

if (!function_exists('Search_install')) {
function Search_install()
{
    $GLOBALS['message'][] = ___('The search module was successfully installed.');
}
}

if (!function_exists('Search_activate')) {
function Search_activate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";

    $GLOBALS['message'][] = ___('The search module got activated.').$reload_navigation;
}
}

if (!function_exists('Search_deactivate')) {
function Search_deactivate()
{
    // Navigation reloaden in frame "cpo_navigation"
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";

    $GLOBALS['message'][] = ___('The search module got deactivated.').$reload_navigation;
}
}

if (!function_exists('Search_uninstall')) {
function Search_uninstall($directory_uninstall)
{
    $GLOBALS['message'][] = sprintf(___('Please remove the module directory %s to finally uninstall the search module.'), '<em>'.htmlspecialchars($directory_uninstall, ENT_COMPAT, 'ISO-8859-15').'</em>');
}
}

?>
