<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can mail you a copy immediately.          |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
|          based on work by Markus Roesel                                |
+------------------------------------------------------------------------+
  $Id: loadfooters.php,v 1.3 2005/02/13 17:37:20 balu Exp $ */
if (!defined('CPO')) exit;

// define some vars
initVar($templates,array());
initVar($rubrics,array());
initVar($results,array());
if (isset($activeModules[$directory]['noOfResults'])) initVar($templates,$activeModules[$directory]['noOfResults']);
initVar($close_backend,NULL);
initVar($_REQUEST['q'],'');
initVar($sec_rubrics,'');
initVar($results,array());
initVar($_SESSION['SID_user']['id'],NULL);
initVar($quotephrases,array());
initVar($phrases,array()); // stores phrases
initVar($phraseSQL,array());
initVar($phraseSQL2,array());
initVar($phraseSQL3,array());
initVar($plusmusts,array());
initVar($musts,array()); // stores mandantory worde
initVar($mustSQL,array());
initVar($mustSQL2,array());
initVar($mustSQL3,array());
initVar($minusnomusts,array());
initVar($nomusts,array()); // stores unwanted words
initVar($nomustSQL,array());
initVar($nomustSQL2,array());
initVar($nomustSQL3,array());


// Fehlercheck
if (isset($_POST['go']) && empty($_POST['cpoSearchNew']['noOfResults'])) $_POST['cpoSearchNew']['noOfResults'] = $cpoSystem['noOfArticles'];
if (isset($_POST['go']) && empty($_POST['cpoSearchNew']['dateFormat']))  $_POST['cpoSearchNew']['dateFormat']  = $cpoSystem['date_format'];

// Moduleinstellungen speichern (neue Version mit automatischem Einlesen neuer Variablen) ************************
if (isset($_POST['go'])) {
    $new_settings = $_POST;
    foreach ($activeModules[$directory] as $k=>$v) {
        if (!isset($_POST['cpoSearchNew'][$k])) continue;
        if (is_bool($activeModules[$directory][$k])) {
            $activeModules[$directory][$k] = (bool) $_POST['cpoSearchNew'][$k];
        } else {
			$activeModules[$directory][$k] = $_POST['cpoSearchNew'][$k];
		}
		if (array_key_exists($k, $new_settings['cpoSearchNew'])) 
            unset($new_settings['cpoSearchNew'][$k]);
    }
    foreach ($new_settings['cpoSearchNew'] as $k=>$v) {
		$activeModules[$directory][$k] = $new_settings['cpoSearchNew'][$k];
	}
    $c_datum = date ("Y-m-d H:i:s", time());
    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = '%s'", 
            addslashes(serialize($activeModules[$directory])),
			$directory
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = __('Module settings were saved.');
}

if (trim($_REQUEST['q'])=='') return; // Kein Suchbegriff!
if ($close_backend && (!isset($_REQUEST['action']) || $_REQUEST['action']!='search')) return;

// Die eigentliche Suche ****************************************************************************************

// Rubrikeneinschrnkung
$qrubrics = '';
if (isset($activeModules[$directory]['rubrics']) && $activeModules[$directory]['rubricsUse'] != 'off') {
    $qrubrics = 'AND '.CPO_NEWS.'.rubric_id '.$activeModules[$directory]['rubricsUse'].' (';
    $c = '';
    foreach ($activeModules[$directory]['rubrics'] as $v) {
        $qrubrics .= $c.(int)$v;
        $c = ', ';
    }
    $qrubrics .= ') ';
}

if (!isset($activeModules[$directory]['rubrics']) 
    && $activeModules[$directory]['rubricsUse'] != 'off') {
    $qrubrics = 'AND '.CPO_NEWS.'.rubric_id '.$activeModules[$directory]['rubricsUse'].' (0)';
}

// geschlossene Rubriken und personalisierte Artikel, die der User sehen darf
$sec_rubrics .= 'AND (seclevel=0';

$db_sec = new DB;
$query = 'SELECT rubric_id FROM '.CPO_RUBRIC_PERMISSION.' '
        ."WHERE usergroups_id='".addslashes($_SESSION['SID_user']['usergroups_id'])."'";
$db_sec->query($query);
if ($db_sec->num_rows()>0)  {
    $sec_rubrics .= ' OR '.CPO_NEWS.'.rubric_id IN (';
    $c = '';
    while ($db_sec->next_record())  {
        $sec_rubrics .= $c.(int)$db_sec->v('rubric_id');
        $c = ', ';
    }
    $sec_rubrics .= ')';
}

if ($_SESSION['SID_user']['usergroups_id']>0) {
    $sec_rubrics .= " OR auth LIKE '%#".$_SESSION['SID_user']['usergroups_id']."#%'";  
}

$sec_rubrics .= ') ';

if ($close_backend) { // aber im Backend nur wenn der Redakteur auch wirklich darf!
    unset ($sec_rubrics);
    initVar($sec_rubrics,'');
}

$pub_datum     = "AND pub_datum<='".date('Y-m-d H:i:s')."' ";
$verfallsdatum = "AND verfallsdatum>'".date('Y-m-d H:i:s')."' ";
if ($close_backend && isset($_REQUEST['publicationState'])) {
    $zusatzurl .= '&amp;publicationState='.$_REQUEST['publicationState'];
    switch ($_REQUEST['publicationState']) {
    case -1: 
        $pub_datum = '';
        $verfallsdatum = '';
        break;
    case 1: // waiting for publication
        $pub_datum = "AND pub_datum>'".date('Y-m-d H:i:s')."' ";;
        $verfallsdatum = '';
        break;
    case 2: // published
        $pub_datum = "AND pub_datum<='".date('Y-m-d H:i:s')."' ";;
        $verfallsdatum = "AND verfallsdatum>'".date('Y-m-d H:i:s')."' ";
        break;
    case 3: // expired
        $pub_datum = '';
        $verfallsdatum = "AND verfallsdatum<='".date('Y-m-d H:i:s')."' ";
        break;
    }
}

// Die Freigabe
$freigabe = 'AND '.($cpoSystem['release'] 
            ? 'artikel_archiv<2 AND freigabe='.STATE_RELEASED.' ' 
            : 'artikel_archiv<1 AND freigabe!='.STATE_BLOCKED.' ');
if ($close_backend && isset($_REQUEST['releaseState'])) {
    $zusatzurl .= '&amp;releaseState='.$_REQUEST['releaseState'];
    switch ($_REQUEST['releaseState']) {
    case -1:
        $freigabe = '';
        break;
    case STATE_RELEASED:
        $freigabe = 'AND freigabe='.STATE_RELEASED.' ';
        break;
    case STATE_WAITING:
        $freigabe = 'AND freigabe='.STATE_WAITING.' ';
        break;
    case STATE_BLOCKED:
        $freigabe = 'AND freigabe='.STATE_BLOCKED.' ';
        break;
    case STATE_REJECTED:
        $freigabe = 'AND freigabe='.STATE_REJECTED.' ';
        break;
    }
}

$permission  = '';
$perm_table  = '';
$perm_stufe4 = '';
if ($_SESSION['SID_user']['id'] && $close_backend)  {
    $permission  = 'AND '.CPO_PERMISSION.'.rubric_id = '.CPO_RUBRIC.'.id '
                  .'AND '.CPO_PERMISSION.'.user_id = '.addslashes($_SESSION['SID_user']['id']).' ';
    $perm_table  = ', '.CPO_PERMISSION;
    $perm_stufe4 = ', stufe4';
}

// Ermittlung Navigationspositionen
$db_rubric = new DB;
$db_navtree = new DB;
$query = 'SELECT id, source_rubric_id '
        .'FROM '.CPO_RUBRIC.' ';
DEBUG(1, $query, __FILE__, __LINE__);
$db_rubric->query($query);
while ($db_rubric->next_record())  {
    $nav_rubric_id = $db_rubric->v('id');
    $query = 'SELECT id '
            .'FROM '.CPO_NAVTREE.' '
            ."WHERE rubric_id='".(int)$nav_rubric_id."'";
    DEBUG(1, $query, __FILE__, __LINE__);
    $db_navtree->query($query);

    $rubric_nav_id = 0;
    while($db_navtree->next_record()) {
        $rubric_nav_id = $db_navtree->v('id');
        break; // only one result wanted
    }
    $positions[$nav_rubric_id]['nav_pos'] = $rubric_nav_id .":". $nav_rubric_id;
}

$searchFor = $activeModules[$directory]['opt'];
if ($close_backend && is_array($_REQUEST['searchFor'])) {
    $searchFor = $_REQUEST['searchFor'];
    foreach ($searchFor as $k=>$v) {
        $zusatzurl .= '&amp;searchFor['.$k.']='.$v;
    }
}


$template = '';
if ($close_backend && isset($_REQUEST['template'])) {
    $zusatzurl .= '&amp;template='.$_REQUEST['template'];
    if ($_REQUEST['template']>0) 
        $template = 'AND templates_id='.(int)$_REQUEST['template'].' ';
}

$lastChangedBy = '';
if ($close_backend && isset($_REQUEST['lastChangedBy'])) {
    $zusatzurl .= '&amp;lastChangedBy='.$_REQUEST['lastChangedBy'];
    if ($_REQUEST['lastChangedBy']!=-1)
        $template = 'AND '.CPO_NEWS.".changer='".addslashes($_REQUEST['lastChangedBy'])."' ";
}

$db = new DB;

$q = trim($_REQUEST['q']); // subern
$q_array = explode(' ', $q); // Das hier kann man bestimmt optimieren


// "..." a phrase
preg_match_all('/"([^"]*)"/is', $q, $matches, PREG_SET_ORDER); 
//var_dump($matches); // nur der Inhalt in Quotes
foreach($matches AS $match) {
    $quotephrases[] = $match[0];
    $phrases[] = $match[1];
    $praseSQL[]  =  '%1$s like \'%%'.addslashes($match[1]).'%%\'';
    $praseSQL2[] = '(%1$s like \'%%'.addslashes($match[1]).'%%\' OR %2$s like \'%%'.addslashes($match[1]).'%%\')';
    $praseSQL3[] = '(%1$s like \'%%'.addslashes($match[1]).'%%\' OR %2$s like \'%%'.addslashes($match[1]).'%%\' OR %3$s like \'%%'.addslashes($match[1]).'%%\')';
}
//var_dump($phrases);
//echo "IN: ".$q;
// strip the phrases
$q = trim(str_replace($quotephrases, '', $q)); // remove already found phrases
//echo " / OUT: [".$q."]";

// + a must
preg_match_all('/\+([^\+\s]*)/is', $q, $matches, PREG_SET_ORDER); 
//var_dump($matches); // mit plus
foreach($matches AS $match) {
    $plusmusts[] = $match[0];
    $musts[] = $match[1];
    $mustSQL[]  =  '%1$s like \'%%'.addslashes($match[1]).'%%\'';
    $mustSQL2[] = '(%1$s like \'%%'.addslashes($match[1]).'%%\' OR %2$s like \'%%'.addslashes($match[1]).'%%\')';
    $mustSQL3[] = '(%1$s like \'%%'.addslashes($match[1]).'%%\' OR %2$s like \'%%'.addslashes($match[1]).'%%\' OR %3$s like \'%%'.addslashes($match[1]).'%%\')';
}
//var_dump($musts);
$q = trim(str_replace($plusmusts, '', $q)); // remove already found musts

// - a must not
preg_match_all('/\-([^\-\s]*)/is', $q, $matches, PREG_SET_ORDER); 
//var_dump($matches); // mit minus
foreach($matches AS $match) {
    $minusnomusts[] = $match[0];
    $nomusts[] = $match[1];
    $nomustSQL[]  =  '%1$s not like \'%%'.addslashes($match[1]).'%%\'';
    $nomustSQL2[] = '(%1$s not like \'%%'.addslashes($match[1]).'%%\' AND %2$s not like \'%%'.addslashes($match[1]).'%%\')';
    $nomustSQL3[] = '(%1$s not like \'%%'.addslashes($match[1]).'%%\' AND %2$s not like \'%%'.addslashes($match[1]).'%%\' AND %3$s not like \'%%'.addslashes($match[1]).'%%\')';
}
//var_dump($nomusts);
$q = trim(str_replace($minusnomusts, '', $q)); // remove already found no-musts

$q_array = explode(' ', $q);
$q_array = array_merge($q_array, $phrases, $musts);

$plusminusSQL  = (count(array_merge($mustSQL,  $nomustSQL ))>=1) ? 'AND ' . implode(" \nAND ",array_merge($mustSQL,  $nomustSQL )) . ' ' : '';
$plusminusSQL2 = (count(array_merge($mustSQL2,  $nomustSQL2 ))>=1) ? 'AND ' . implode(" \nAND ",array_merge($mustSQL2, $nomustSQL2)) . ' ' : '';
$plusminusSQL3 = (count(array_merge($mustSQL3,  $nomustSQL3 ))>=1) ? 'AND ' . implode(" \nAND ",array_merge($mustSQL3, $nomustSQL3)) . ' ' : '';

//echo $plusminusSQL;

//var_dump($q_array);

foreach ($q_array as $q) {
    if (trim($q)=='') continue; //prevent empty ones

    if (!empty($searchFor['searchAuthors'])) { // {{{
        $query = 'SELECT nr, artikel_archiv, freigabe, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, keywords, verfallsdatum, seclevel, changer, last_modify'.$perm_stufe4.' FROM '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                ."WHERE (autor like '%".addslashes($q)."%' OR changer like '%".addslashes($q)."%') "
                .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                .sprintf($plusminusSQL2, 'autor', 'changer')
                .$permission
                .$freigabe
                .$pub_datum
                .$verfallsdatum
                .$sec_rubrics
                .$template
                .$lastChangedBy
                .$qrubrics;
        //echo "\n".$query."\n<br /><br />";
        $db->query($query);
        while ($db->next_record_assoc()) {
            $results[$db->v('nr')] = $db->record();
            $results[$db->v('nr')]['result'] = $db->v('autor');
            $results[$db->v('nr')]['nav_pos'] = $positions[$db->v('rubric_id')]['nav_pos'];
            $results[$db->v('nr')]['sort_date'] = $results[$db->v('nr')]['pub_datum'];
            $results[$db->v('nr')]['fieldnamePreg'] = 
                '/<!--\s*(file|html|image|text|url|value)\s*:\s*(author)\s*(;\s*(.*?)\s*)?-->/si';
        }
    } // }}}
    if (!empty($searchFor['searchKeywords'])) { // {{{
        $query = 'SELECT nr, artikel_archiv, freigabe, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, keywords, verfallsdatum, seclevel, changer, last_modify'.$perm_stufe4.' FROM '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                ."WHERE keywords like '%".addslashes($q)."%' "
                .sprintf($plusminusSQL, 'keywords')
                .$permission
                .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                .$freigabe
                .$pub_datum
                .$verfallsdatum
                .$sec_rubrics
                .$template
                .$lastChangedBy
                .$qrubrics;
        //echo "\n".$query."\n<br /><br />";
        $db->query($query);
        while ($db->next_record_assoc()) {
            $results[$db->v('nr')] = $db->record();
            $results[$db->v('nr')]['result'] = $results[$db->v('nr')]['keywords'];
            $results[$db->v('nr')]['nav_pos'] = $positions[$db->v('rubric_id')]['nav_pos'];
            $results[$db->v('nr')]['sort_date'] = $results[$db->v('nr')]['pub_datum'];
            $results[$db->v('nr')]['fieldnamePreg'] = 
                '/<!--\s*(file|html|image|text|url|value)\s*:\s*(keywords)\s*(;\s*(.*?)\s*)?-->/si';
            /*
            if (stristr($results[$db->v('nr')]['titel'], $q)!==false) {
                $results[$db->v('nr')]['result'] = $results[$db->v('nr')]['titel'];
                $results[$db->v('nr')]['fieldnamePreg'] =
                    '/<!--\s*(file|html|image|text|url|value)\s*:\s*(title)\s*(;\s*(.*?)\s*)?-->/si';
            }
            */
        }
    } // }}}
    if (!empty($searchFor['searchComments'])) { // {{{
        $query = 'SELECT nr, commentary, artikel_archiv, freigabe, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, keywords, verfallsdatum, seclevel, changer, last_modify'.$perm_stufe4.' '
                .'FROM '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                ."WHERE commentary like '%".addslashes($q)."%' "
                .sprintf($plusminusSQL, 'commentary')
                .$permission
                .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                .$freigabe
                .$pub_datum
                .$verfallsdatum
                .$sec_rubrics
                .$template
                .$lastChangedBy
                .$qrubrics;
        //echo "\n".$query."\n<br /><br />";
        $db->query($query);
        while ($db->next_record_assoc()) {
            $results[$db->v('nr')] = $db->record();
            $results[$db->v('nr')]['result'] = $results[$db->v('nr')]['commentary'];
            $results[$db->v('nr')]['nav_pos'] = $positions[$db->v('rubric_id')]['nav_pos'];
            $results[$db->v('nr')]['sort_date'] = $results[$db->v('nr')]['pub_datum'];
            $results[$db->v('nr')]['fieldnamePreg'] = 
                '/<!--\s*(file|html|image|text|url|value)\s*:\s*(commentary)\s*(;\s*(.*?)\s*)?-->/si';

            /*
            if (stristr($results[$db->v('nr')]['titel'], $q)!==FALSE) {
                $results[$db->v('nr')]['result'] = $results[$db->v('nr')]['titel'];
                $results[$db->v('nr')]['fieldnamePreg'] =
                    '/<!--\s*(file|html|image|text|url|value)\s*:\s*(title)\s*(;\s*(.*?)\s*)?-->/si';
            }
            */
        }
    } // }}}
    if (!empty($searchFor['searchTitles'])) { // {{{
        $query = 'SELECT nr, artikel_archiv, freigabe, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, keywords, verfallsdatum, seclevel, changer, last_modify'.$perm_stufe4.' FROM '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                ."WHERE titel like '%".addslashes($q)."%' "
                .sprintf($plusminusSQL, 'titel')
                .$permission
                .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                .$freigabe
                .$pub_datum
                .$verfallsdatum
                .$sec_rubrics
                .$template
                .$lastChangedBy
                .$qrubrics;
        //echo "\n".$query."\n<br /><br />";
        $db->query($query);
        while ($db->next_record_assoc()) {
            $results[$db->v('nr')] = $db->record();
            $results[$db->v('nr')]['result'] = $results[$db->v('nr')]['titel'];
            $results[$db->v('nr')]['nav_pos'] = $positions[$db->v('rubric_id')]['nav_pos'];
            $results[$db->v('nr')]['sort_date'] = $results[$db->v('nr')]['pub_datum'];
            $results[$db->v('nr')]['fieldnamePreg'] = 
                '/<!--\s*(file|html|image|text|url|value)\s*:\s*(title)\s*(;\s*(.*?)\s*)?-->/si';
        }
    } // }}}
    if (!empty($searchFor['searchContent'])) {
        // search URL fields // {{{
        $query = 'SELECT fieldname, artikel_archiv, freigabe, nr, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, url, urltext, verfallsdatum, seclevel, changer, last_modify'.$perm_stufe4.' FROM '.CPO_CONTENT_URLS.', '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                .'WHERE '.CPO_CONTENT_URLS.'.article_id = '.CPO_NEWS.'.nr '
                .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                .$permission
                ."AND (url like '%".addslashes($q)."%' OR urltext like '%".addslashes($q)."%') "
                .sprintf($plusminusSQL2, 'url', 'urltext')
                .$freigabe
                .$pub_datum
                .$verfallsdatum
                .$sec_rubrics
                .$template
                .$lastChangedBy
                .$qrubrics;
        //echo "\n".$query."\n<br /><br />";
        $db->query($query);
        while ($db->next_record_assoc()) {
            $results[$db->v('nr')] = $db->record();
            $results[$db->v('nr')]['result'] = $results[$db->v('nr')]['url']." (".$results[$db->v('nr')]['urltext'].")";
            $results[$db->v('nr')]['nav_pos'] = $positions[$db->v('rubric_id')]['nav_pos'];
            $results[$db->v('nr')]['sort_date'] = $results[$db->v('nr')]['pub_datum'];
            $results[$db->v('nr')]['fieldnamePreg'] = '/<!--\s*(file|html|image|text|url|value)\s*:\s*('.preg_quote($results[$db->v('nr')]['fieldname'], '/').')\s*(;\s*(.*?)\s*)?-->/si';
        } // }}}
        // search images {{{
        $query = 'SELECT beschreibung, alttext, type, datei, format, artikel_archiv, freigabe, nr, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, verfallsdatum, seclevel, '.CPO_NEWS.'.changer, last_modify'.$perm_stufe4.' FROM '.CPO_CONTENT_IMAGES.', '.CPO_DATA.', '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                .'WHERE '.CPO_CONTENT_IMAGES.'.image_id = '.CPO_DATA.'.id '
                .'AND '.CPO_CONTENT_IMAGES.'.article_id = '.CPO_NEWS.'.nr '
                .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                .$permission
                ."AND (beschreibung like '%".addslashes($q)."%' OR alttext like '%".addslashes($q)."%' OR datei like '%".addslashes($q)."%') "
                .sprintf($plusminusSQL3, 'beschreibung', 'alttext', 'datei')
                .$freigabe
                .$pub_datum
                .$verfallsdatum
                .$sec_rubrics
                .$template
                .$lastChangedBy
                .$qrubrics;
        //echo "\n".$query."\n<br /><br />";
        $db->query($query);
        while ($db->next_record_assoc()) {
            $results[$db->v('nr')] = $db->record();
            $results[$db->v('nr')]['result'] = $results[$db->v('nr')]['datei'] . " (" . trim($results[$db->v('nr')]['beschreibung'] . ' '. $results[$db->v('nr')]['alttext']) . ")";
            $results[$db->v('nr')]['nav_pos'] = $positions[$db->v('rubric_id')]['nav_pos'];
            $results[$db->v('nr')]['sort_date'] = $results[$db->v('nr')]['pub_datum'];
            $results[$db->v('nr')]['fieldnamePreg'] = '/<!--\s*(file|html|image|text|url|value)\s*:\s*('.preg_quote($results[$db->v('nr')]['fieldname'], '/').')\s*(;\s*(.*?)\s*)?-->/si';
        } // }}}
        // search files // {{{
        $query = 'SELECT fieldname, beschreibung, alttext, type, datei, format, artikel_archiv, freigabe, nr, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, verfallsdatum, seclevel, '.CPO_NEWS.'.changer, last_modify'.$perm_stufe4.' FROM '.CPO_CONTENT_FILES.', '.CPO_DATA.', '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                .'WHERE '.CPO_CONTENT_FILES.'.file_id = '.CPO_DATA.'.id '
                .'AND '.CPO_CONTENT_FILES.'.article_id = '.CPO_NEWS.'.nr '
                .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                .$permission
                ."AND (beschreibung like '%".addslashes($q)."%' OR datei like '%".addslashes($q)."%') "
                .sprintf($plusminusSQL2, 'beschreibung', 'datei')
                .$freigabe
                .$pub_datum
                .$verfallsdatum
                .$sec_rubrics
                .$template
                .$lastChangedBy
                .$qrubrics;
        //echo "\n".$query."\n<br /><br />";
        $db->query($query);
        while ($db->next_record_assoc()) {
            $results[$db->v('nr')] = $db->record();
            $results[$db->v('nr')]['result'] = $results[$db->v('nr')]['datei'] . " (" . trim($results[$db->v('nr')]['beschreibung']) . ")";
            $results[$db->v('nr')]['nav_pos'] = $positions[$db->v('rubric_id')]['nav_pos'];
            $results[$db->v('nr')]['sort_date'] = $results[$db->v('nr')]['pub_datum'];
            $results[$db->v('nr')]['fieldnamePreg'] = '/<!--\s*(file|html|image|text|url|value)\s*:\s*('.preg_quote($results[$db->v('nr')]['fieldname'], '/').')\s*(;\s*(.*?)\s*)?-->/si';
        } // }}}
        // search TEXT fields // {{{
        $query = 'SELECT fieldname, artikel_archiv, freigabe, nr, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, text, verfallsdatum, seclevel, changer, last_modify'.$perm_stufe4.' FROM '.CPO_CONTENT_TEXT.', '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                .'WHERE '.CPO_CONTENT_TEXT.'.article_id = '.CPO_NEWS.'.nr '
                .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                .$permission
                ."AND text like '%".addslashes($q)."%' "
                .sprintf($plusminusSQL, 'text')
                .$freigabe
                .$pub_datum
                .$verfallsdatum
                .$sec_rubrics
                .$template
                .$lastChangedBy
                .$qrubrics;
        //echo "\n".$query."\n<br /><br />";
        $db->query($query);
        while ($db->next_record_assoc()) {
            $results[$db->v('nr')] = $db->record();
            $results[$db->v('nr')]['result'] = $results[$db->v('nr')]['text'];
            $results[$db->v('nr')]['nav_pos'] = $positions[$db->v('rubric_id')]['nav_pos'];
            $results[$db->v('nr')]['sort_date'] = $results[$db->v('nr')]['pub_datum'];
            $results[$db->v('nr')]['fieldnamePreg'] = '/<!--\s*(file|html|image|text|url|value)\s*:\s*('.preg_quote($results[$db->v('nr')]['fieldname'], '/').')\s*(;\s*(.*?)\s*)?-->/si';
        } // }}}
        // search HTML fields // {{{
        $query = 'SELECT fieldname, artikel_archiv, freigabe, nr, titel, autor, pub_datum, '.CPO_NEWS.'.rubric_id, templates_id, html, verfallsdatum, seclevel, changer, last_modify'.$perm_stufe4.' FROM '.CPO_CONTENT_HTML.', '.CPO_NEWS.', '.CPO_RUBRIC.$perm_table.' '
                .'WHERE '.CPO_CONTENT_HTML.'.article_id = '.CPO_NEWS.'.nr '
                .'AND '.CPO_NEWS.'.rubric_id = '.CPO_RUBRIC.'.id '
                .$permission
                ."AND html like '%".addslashes($q)."%' "
                .sprintf($plusminusSQL, 'html')
                .$freigabe
                .$pub_datum
                .$verfallsdatum
                .$sec_rubrics
                .$template
                .$lastChangedBy
                .$qrubrics;
        //echo "\n".$query."\n<br /><br />";
        $db->query($query);
        while ($db->next_record_assoc()) {
            $results[$db->v('nr')] = $db->record();
            $results[$db->v('nr')]['result'] = strip_tags($results[$db->v('nr')]['html']);
            $results[$db->v('nr')]['nav_pos'] = $positions[$db->v('rubric_id')]['nav_pos'];
            $results[$db->v('nr')]['sort_date'] = $results[$db->v('nr')]['pub_datum'];
            // tagsPreg
            $results[$db->v('nr')]['fieldnamePreg'] = '/<!--\s*(file|html|image|text|url|value)\s*:\s*('.preg_quote($results[$db->v('nr')]['fieldname'], '/').')\s*(;\s*(.*?)\s*)?-->/si';
        } // }}}
    }
}

if (!empty($activeModules[$directory]['opt']['logQueries'])) {
    if ($close_backend) 
        logaction('mod_search ('.$directory.')', 'Backend-Search: '.$_REQUEST['q'].' (Hits: '.count($results).')');
    else 
        logaction('mod_search ('.$directory.')', 'Frontend-Search: '.$_REQUEST['q'].' (Hits: '.count($results).')');
}

// Sortierung
//$results = SortArray($results,'sort_date','DESC');
$sort_by = array_column($results, 'sort_date');
array_multisort($sort_by, SORT_DESC, $results);
?>
