<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can mail you a copy immediately.          |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
|          based on work by Markus Roesel                                |
+------------------------------------------------------------------------+
  $Id: loadfooters.php,v 1.3 2005/02/13 17:37:20 balu Exp $ */
if (!defined('CPO')) exit;

if (!function_exists('search_multitemplate_parser')) {
function search_multitemplate_parser ($template, $ersetzungs_array, $sql_res_array)
{
    GLOBAL $bereich_ende;
    $inhalt_neu = array();
    $start_flag  = 0;
    $marke_start = 0; 
    $marke_ende  = 0;
    $bereich_start = 0;
    $plh_zeilen  = "";
    $inhalt_tpl  = explode("\n",$template);

//    while (list($zeilennummer, $zeile) = each($inhalt_tpl)) {
    foreach($inhalt_tpl AS $zeilennummer=>$zeile) {
        if ($zeilennummer > $bereich_ende) {
            if (stripos ($zeile, '<!-- START_MOD_SEARCH -->') !== false)
                $bereich_start = $zeilennummer;
            elseif (stripos ($zeile, '<!-- END_MOD_SEARCH -->') !== false) {
                $bereich_ende = $zeilennummer+1;
                break;
            }
        }
    }

    $inhalt_tpl  = explode("\n",$template);
//    while (list($zeilennummer, $zeile) = each($inhalt_tpl)) {
    foreach($inhalt_tpl AS $zeilennummer=>$zeile) {
        if (($zeilennummer>$bereich_start) && ($zeilennummer<=$bereich_ende)) {

            if ($start_flag == 0) {
	            if (stripos ($zeile, '<!-- START_SEARCH_MATCH -->') !== false) {
                    $start_flag = 1;
                    $marke_start = $zeilennummer;
                }
            } elseif (stripos ($zeile, '<!-- END_SEARCH_MATCH -->') !== false) {
                $start_flag = 0;
                $marke_ende = $zeilennummer;
            } else {
                $plh_zeilen .= $zeile;
            }
        }
    }

    $tmp_plh_zeilen = "";

    //$anzahl_sql_ergebnis = count($sql_res_array);
    for ($i = 0; $i<count($sql_res_array); $i++) {
        $tmp = $plh_zeilen;

        for ($j = 0; $j<count($ersetzungs_array); $j++) {
            $ers_tag = $ersetzungs_array[$j][0];
            $index   = $ersetzungs_array[$j][1];

            $sql_res_array[$i][$index] = stripslashes($sql_res_array[$i][$index]);
            $tmp = str_replace($ers_tag, $sql_res_array[$i][$index], $tmp);
            $tmp = stripslashes($tmp);
        }
        $tmp_plh_zeilen .= $tmp;
    }
    $plh_zeilen = $tmp_plh_zeilen;

    // Wiederherstellen des Datei-Inhalts
    for ($i = $bereich_start; $i < $bereich_ende; $i++) {

        // vor der Start-Markierung
        if ($i < $marke_start) {
            $inhalt_neu[$i] = $inhalt_tpl[$i];
        } elseif (($i >= $marke_start) && ($i < $marke_ende)) {
            // zwischen den Markierungen
            $inhalt_neu[$i] =  $plh_zeilen;
            $i = $marke_ende;  // Variable auf Zeile von marke_ende
        } else {
            // nach dem Markierungsende
            $j = $marke_start + ($i - $marke_ende);
            $inhalt_neu[$j] = $inhalt_tpl[$i];
        }
    }
    return ($inhalt_neu);
}
} // if

if (!function_exists('messageBox')) {
function messageBox($message)  
{
    if (!isset($message)) return;

    if ((!is_array($message) && strlen($message)<=0) || 
        ( is_array($message) && count($message)<=0)) {
        return;
    }

    if (!is_array($message)) $message = array($message);

    $message_box_string = '<fieldset class="message">';
    if (count($message)==1) {
        $message_box_string .= '<legend>'.___('Message').'</legend>';
        foreach ($message as $v) $message_box_string .= sprintf('<p>%s</p>', $v);
    } else {
        $message_box_string .= '<legend>'.___('Messages').'</legend>';
        $message_box_string .= '<ul>';
        foreach ($message as $v) $message_box_string .= sprintf('<li>%s</li>', $v);
        $message_box_string .= '</ul>';
    }
    $message = '';
    $message_box_string .=	'</fieldset> <br /> <br />';
    return $message_box_string;
}
}

if (!function_exists('SortArray')) { // deprecated
function SortArray() 
{				// http://www.php.net/manual/de/function.usort.php#42535
    $arguments = func_get_args();
    $array = $arguments[0];
    if (is_array($arguments[1]))  {	// mehrere Sortierkriterien in einem Array
        $multi_arg = $arguments[1];
        for ($a=0;$a<count($multi_arg);$a++)  {
            $arguments[$a+1] = $multi_arg[$a];
        }
    }

    $code = '';
    for ($c = 1; $c < count($arguments); $c += 2) {
        if (in_array($arguments[$c + 1], array("ASC", "DESC"))) {
            $code .= 'if ($a["'.$arguments[$c].'"] != $b["'.$arguments[$c].'"]) {';
            if ($arguments[$c + 1] == "ASC") {
                $code .= 'return ($a["'.$arguments[$c].'"] < $b["'.$arguments[$c].'"] ? -1 : 1); }';
            } else {
                $code .= 'return ($a["'.$arguments[$c].'"] < $b["'.$arguments[$c].'"] ? 1 : -1); }';
            }
        }
    }
    $code .= 'return 0;';
    $compare = create_function('$a,$b', $code);
    usort($array, $compare);
    return $array;
}
}

if (!function_exists('array_search_recursive')) {
function array_search_recursive( $needle, $haystack )
{
    $path = NULL;
    $keys = array_keys($haystack);
    while (!$path && (list($toss,$k)=each($keys))) {
        $v = $haystack[$k];
        if (is_scalar($v)) {
            if ($v===$needle) {
                $path = array($k);
            }
        } elseif (is_array($v)) {
            if ($path=array_search_recursive( $needle, $v )) {
                array_unshift($path,$k);
            }
        }
    }
    return $path;
}
}

if (!function_exists('array_search_bit')) {
function array_search_bit($search, $array_in)  
{
    foreach ($array_in as $key => $value)  {
        if (strpos($value, $search) !== FALSE)
        return $key;
    }
    return FALSE;
}
}

if (!function_exists('search_mini_title')) {
	function search_mini_title($freigabe='', $pub_datum='', $verfallsdatum='', $titel='', $autor='', $changer='', $nr='', $last_modify='')
	{
		$query = "SELECT COUNT(*) FROM ".CPO_NEWS." "
				."WHERE article_nr='".addslashes($nr)."' "
				."AND artikel_archiv='1'";
		DEBUG(1, 'Is there an older released version?<br /><br />'.$query, __FILE__, __LINE__);
		$db_2 = new DB;
		$db_2->query($query);
		$db_2->next_record();
		$released = ($freigabe==STATE_RELEASED && (time()>=strtotime($pub_datum) && time()<strtotime($verfallsdatum))); 

		if ($db_2->v('COUNT(*)')>0) $released = true;

		$shortTitle = substr($titel, 0, 35);
		if (strlen($titel)>35) $shortTitle .= '...';

		$mini_title_string = '<span style="vertical-align: top">';
		// FIXME: _content/show_index.php
		//printf('<a href="'.BASE_REL.'_content/show_index.php?nr=%d" target="_blank" %s>%s</a><br />',

		if ($released) {
			$mini_title_string .= sprintf('<img src="%1$s" alt="%2$s" title="%2$s" style="width: 13px; height: 13px; vertical-align: text-bottom;">&nbsp;', 
				SKIN_URL.'sym_published.gif',
				___('article published'));
		} else {
			if ($freigabe!=-1) {
				$mini_title_string .= sprintf('<img src="%1$s" alt="%2$s" title="%2$s" style="width: 13px; height: 13px; vertical-align: text-bottom;">&nbsp;', 
					SKIN_URL.'sym_not-published.gif',
					___('article not published'));
			}
		}

		$mini_title_string .= sprintf('<!-- %d --><strong>%s</strong>',
			$nr,
			empty($titel) ? '<em>'.__('no title').'</em>' : '<span title="'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'">'.$shortTitle.'</span>'
		);
		$mini_title_string .= sprintf('</span>');
		$mini_title_string .= sprintf('<img src="'.BASE_REL.'_images/transparent.gif" style="width: 1px; height: 21px;" alt="">');

		if (!empty($autor)) {
			$mini_title_string .= '<div>'.__('Author:').' '.$autor.'</div>';
		}

		$mini_title_string .= '<div style="clear: both;">'.__('Last modified by:').' ';

		if (empty($last_modify)) $mini_title_string .=  '- ';
		else {
			$query = "SELECT name FROM ".CPO_USER." "
					."WHERE user='".addslashes($changer)."'";
			DEBUG(2, 'Who did the last modification.<br /><br />'.$query, __FILE__, __LINE__);
			$db2 = new db;
			$db2->query($query);
			if ($db2->num_rows()<=0) $mini_title_string .=  '- '.$changer;
			else {
				$db2->next_record();
				$mini_title_string .= $db2->v('name');
				$mini_title_string .= ' ['.$changer.']';
			}
		}
		$mini_title_string .=  '</div>';
		return $mini_title_string;
	}
}

if (!function_exists('search_mini_status')) {
	function search_mini_status($nr='', $article_nr='', $freigabe='', $_call='', $stufe4='')
	{
		global $cpoSystem;

		if ($stufe4=='' && isset($_SESSION['SID_stufe4'])) $stufe4 = $_SESSION['SID_stufe4'];

		$query = "SELECT COUNT(*) FROM ".CPO_NEWS." "
				."WHERE article_nr='".addslashes($article_nr)."' "
				."AND artikel_archiv='1'";
		DEBUG(1, 'Is there a newer article version?<br /><br />'.$query, __FILE__, __LINE__);
		$db_2 = new DB;
		$db_2->query($query);
		$db_2->next_record();
		$newer_article = false;
		if ($db_2->v('COUNT(*)')>0) $newer_article = true;

		$pic_empty     = '<img src="'.SKIN_URL.'pic_empty.gif"  class="pic" alt="">';
		$pic_free      = '<img src="'.SKIN_URL.'pic_free.gif"   class="pic" alt="'.___('release article').'" title="'.___('release article').'" />';
		$pic_block     = '<img src="'.SKIN_URL.'pic_block.gif"  class="pic" alt="'.___('block article').'"   title="'.___('block article').'" />';
		$pic_reject    = '<img src="'.SKIN_URL.'pic_reject.gif" class="pic" alt="'.___('reject article').'"  title="'.___('reject article').'" />';
		$pic_free_s    = '<img src="'.SKIN_URL.'pic_shade.gif"  class="pic" style="background: url('.SKIN_URL.'pic_free.gif);  " alt="%1$s" title="%1$s" />';
		$pic_block_s   = '<img src="'.SKIN_URL.'pic_shade.gif"  class="pic" style="background: url('.SKIN_URL.'pic_block.gif); " alt="%1$s" title="%1$s" />';
		$pic_reject_s  = '<img src="'.SKIN_URL.'pic_shade.gif"  class="pic" style="background: url('.SKIN_URL.'pic_reject.gif);" alt="%1$s" title="%1$s" />';

		$c_free        = '<img src="'.SKIN_URL.'status_released.gif" style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('released').'" title="'.___('released').'">&nbsp;';
		$c_wait        = '<img src="'.SKIN_URL.'status_waiting.gif"  style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('waiting').'"  title="'.___('waiting').'">&nbsp;';
		$c_block       = '<img src="'.SKIN_URL.'status_blocked.gif"  style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('blocked').'"  title="'.___('blocked').'">&nbsp;';
		$c_reject      = '<img src="'.SKIN_URL.'status_rejected.gif" style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('rejected').'" title="'.___('rejected').'">&nbsp;';
		$c_reject_free = '<img src="'.SKIN_URL.'status_rejected-released.gif" style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('rejected, older article released').'" title="'.___('rejected, older article released').'">&nbsp;';
		$c_wait_free   = '<img src="'.SKIN_URL.'status_waiting-released.gif"  style="vertical-align: top; width: 57px; height: 13px; border: 0;" alt="'.___('waiting, old article released').'"    title="'.___('waiting, old article released').'">&nbsp;';


		if (strpos($_call, '?')) $_call .= '&amp;';
		else $_call .= '?';

		$mini_status_string = '';

		if (!$stufe4) {
			switch ($freigabe) {
			case STATE_RELEASED:
				$mini_status_string .= $c_free;
				$s = 'Status: released';
				$mini_status_string .= sprintf($pic_free_s,   ___('You have no rights to change the status of an article.'));
				$mini_status_string .= sprintf($pic_block_s,  ___('You have no rights to change the status of an article.'));
				$mini_status_string .= sprintf($pic_reject_s, ___('You have no rights to change the status of an article.'));
				$mini_status_string .= '<br />'.__($s);
				break;
			
			case STATE_WAITING: 
				if ($newer_article) {
					$mini_status_string .= $c_wait_free;
					$s = 'Status: waiting<br />Old version: released';
				} else {
					$mini_status_string .= $c_wait;
					$s = 'Status: waiting';
				}
				$mini_status_string .= sprintf($pic_free_s,   ___('You have no rights to change the status of an article.'));
				$mini_status_string .= sprintf($pic_block_s,  ___('You have no rights to change the status of an article.'));
				$mini_status_string .= sprintf($pic_reject_s, ___('You have no rights to change the status of an article.'));
				$mini_status_string .= '<br />'.__($s);
				break;
			
			case STATE_BLOCKED: 
				$mini_status_string .= $c_block;
				$s = 'Status: blocked';
				$mini_status_string .= sprintf($pic_free_s,   ___('You have no rights to change the status of an article.'));
				$mini_status_string .= sprintf($pic_block_s,  ___('You have no rights to change the status of an article.'));
				$mini_status_string .= sprintf($pic_reject_s, ___('You have no rights to change the status of an article.'));
				$mini_status_string .= '<br />'.__($s);
				break;
			
			case STATE_REJECTED:
				if ($newer_article) {
					$mini_status_string .= $c_reject_free;
					$s = 'Status: rejected<br />Old version: released';
				} else {
					$mini_status_string .= $c_reject;
					$s = 'Status: rejected';
				}
				$mini_status_string .= sprintf($pic_free_s,   ___('You have no rights to change the status of an article.'));
				$mini_status_string .= sprintf($pic_block_s,  ___('You have no rights to change the status of an article.'));
				$mini_status_string .= sprintf($pic_reject_s, ___('You have no rights to change the status of an article.'));
				$mini_status_string .= '<br />'.__($s);
				break;
			}
		} else {
			// user is allowed to change the status
			switch ($freigabe) {
			case STATE_RELEASED:
				$mini_status_string .= $c_free;
				$s = 'Status: released';
				if ($_call!='?') {
					$mini_status_string .= sprintf($pic_free_s, ___('The article is already released.'));
					$mini_status_string .= '<a href="'.BASE_REL.$_call.'status='.STATE_BLOCKED.'&nr='.$nr.'">';
					$mini_status_string .= $pic_block.'</a>';
					if ($cpoSystem['release']) {
						$mini_status_string .= '<a href="'.BASE_REL.$_call.'status='.STATE_REJECTED.'&nr='.$nr.'">';
						$mini_status_string .= $pic_reject.'</a>';
					}
				}
				$mini_status_string .= '<br />'.__($s);
				break;
			
			case STATE_WAITING: 
				if ($newer_article) {
					$mini_status_string .= $c_wait_free;
					$s = 'Status: waiting<br />Old version: released';
				} else {
					$mini_status_string .= $c_wait;
					$s = 'Status: waiting';
				}
				if ($_call!='?') {
					$mini_status_string .= '<a href="'.BASE_REL.$_call.'status='.STATE_RELEASED.'&nr='.$nr.'">';
					$mini_status_string .= $pic_free.'</a>';
					$mini_status_string .= sprintf($pic_block_s, ___('The article is in state waiting and can not be blocked.'));
					$mini_status_string .= '<a href="'.BASE_REL.$_call.'status='.STATE_REJECTED.'&nr='.$nr.'">';
					$mini_status_string .= $pic_reject.'</a>';
				}
				$mini_status_string .= '<br />'.__($s);
				break;
			
			case STATE_BLOCKED: 
				$mini_status_string .= $c_block;
				$s = 'Status: blocked';
				if ($_call!='?') {
					$mini_status_string .= '<a href="'.BASE_REL.$_call.'status='.STATE_RELEASED.'&nr='.$nr.'">';
					$mini_status_string .= $pic_free.'</a>';
					$mini_status_string .= sprintf($pic_block_s, ___('The article is already blocked.'));
					if ($cpoSystem['release']) {
						$mini_status_string .= '<a href="'.BASE_REL.$_call.'status='.STATE_REJECTED.'&nr='.$nr.'">';
						$mini_status_string .= $pic_reject.'</a>';
					}
				}
				$mini_status_string .= '<br />'.__($s);
				break;
			
			case STATE_REJECTED:
				if ($newer_article) {
					$mini_status_string .= $c_reject_free;
					$s = 'Status: rejected<br />Old version: released';
				} else {
					$mini_status_string .= $c_reject;
					$s = 'Status: rejected';
				}
				if ($_call!='?') {
					$mini_status_string .= '<a href="'.BASE_REL.$_call.'status='.STATE_RELEASED.'&nr='.$nr.'">';
					$mini_status_string .= $pic_free.'</a>';
					$mini_status_string .= sprintf($pic_block_s, ___('The article was rejected and can not be blocked.'));
					$mini_status_string .= sprintf($pic_reject_s, ___('The article already was rejected.'));
				}
				$mini_status_string .= '<br />'.__($s);
				break;
			}
		}
		return $mini_status_string;
	}
}

if (!function_exists('search_mini_publication')) {
	function search_mini_publication($pub_datum='', $verfallsdatum='')
	{
		global $cpoSystem;
		$mini_pub_string = '';
		if (time()<strtotime($pub_datum)) {
			// upcoming & expires
			if (strtotime($verfallsdatum)<strtotime('2036-01-01')) {
				$mini_pub_string .= '<img src="'.SKIN_URL.'pub_upcoming1.gif" alt="'.__('upcoming article').'" title="'.__('upcoming article').'" style="border: 0; width: 111px; height: 13px; vertical-align: top;">';
			}

			// upcoming & never expires
			if (strtotime($verfallsdatum)>=strtotime('2036-01-01')) {
				$mini_pub_string .= '<img src="'.SKIN_URL.'pub_upcoming2.gif" alt="'.__('upcoming article').'" title="'.__('upcoming article').'" style="border: 0; width: 111px; height: 13px; vertical-align: top;">';
			} 
		} else {
			// expired
			if (time()>=strtotime($verfallsdatum)) {
				$mini_pub_string .= '<img src="'.SKIN_URL.'pub_expired.gif" alt="'.__('expired article').'" title="'.__('expired article').'" style="border: 0; width: 111px; height: 13px; vertical-align: top;">';
			} 
			// active & expires
			if (time()<strtotime($verfallsdatum) && strtotime($verfallsdatum)<strtotime('2036-01-01')) {
				$mini_pub_string .= '<img src="'.SKIN_URL.'pub_active1.gif" alt="'.__('active article').'" title="'.__('active article').'" style="border: 0; width: 111px; height: 13px; vertical-align: top;">';
			} 
			// active & never expires
			if (time()<strtotime($verfallsdatum) && strtotime($verfallsdatum)>=strtotime('2036-01-01')) {
				$mini_pub_string .= '<img src="'.SKIN_URL.'pub_active2.gif" alt="'.__('active article').'" title="'.__('active article').'" style="border: 0; width: 111px; height: 13px; vertical-align: top;">';
			} 
		}
		$mini_pub_string .= '&nbsp;<img src="'.BASE_REL.'_images/transparent.gif" style="width: 1px; height: 21px; border: 0;" alt=""><br />';
		$mini_pub_string .= date($cpoSystem['date_format'], strtotime($pub_datum)).'<br />';

		if (strtotime($verfallsdatum)>=strtotime('2036-01-01')) $mini_pub_string .= '-';
		else $mini_pub_string .= date($cpoSystem['date_format'], strtotime($verfallsdatum));
		return $mini_pub_string;
	}
}
?>
