<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can mail you a copy immediately.          |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
|          based on work by Markus Roesel                                |
+------------------------------------------------------------------------+
  $Id: loadfooters.php,v 1.3 2005/02/13 17:37:20 balu Exp $ */
if (!defined('CPO')) exit;

// FIXME workaround after switching to doActions() for page-template
foreach ($GLOBALS as $k=>$v) global $$k;

// define some vars
initVar($_REQUEST['pos'],0);
initVar($message,array());
initVar($q_array,array());
initVar($activeModules[$directory]['stringLength'],NULL);
initVar($activeModules[$directory]['noSearchstringText'],NULL);
initVar($activeModules[$directory]['noMatchesText'],NULL);
initVar($activeModules[$directory]['highlightCSS'],NULL);
initVar($activeModules[$directory]['template'],NULL);

$suchmuster = array(); 
$ersatz = array();

//echo $activeModules[$directory]['stringLength']." / ";

$shortenBy = ($activeModules[$directory]['stringLength'])
             ? (int) ($activeModules[$directory]['stringLength']-strlen($_REQUEST['q'])/2) 
             : false;
//echo $shortenBy;
if ($_REQUEST['pos']>count($results)) {
    $_REQUEST['pos'] = count($results)-$noOfResults;
}
$i = -1;

if (isset($_REQUEST['action']) && $_REQUEST['action']=='search' && isset($_REQUEST['q']) && trim($_REQUEST['q'])=='') { // Kein Suchbegriff!
    $message[] = $activeModules[$directory]['noSearchstringText'];
}

if ($close_backend && isset($_REQUEST['action']) && $_REQUEST['action']=='search' && count($results)<=0) { // Keine Treffer!
    $message[] = $activeModules[$directory]['noMatchesText'];
}

// $num_of_matches = (count($results)>0) 
//                  ? sprintf($activeModules[$directory]['matchesText'], count($results)) 
//                  : '' ;
if ($close_backend && isset($_REQUEST['action']) && $_REQUEST['action']=='search' && count($results)>0) {
    $message[] = sprintf($activeModules[$directory]['matchesText'], count($results));
}

$sql_res_array = array();
//$q_array = explode(" ", trim($_REQUEST['q']));
//var_dump($q_array);

foreach ($q_array as $_q) {
    if (trim($_q)=='') continue; //prevent empty ones
    $suchmuster[] = '@('.preg_quote($_q,'@').')@si';
    $ersatz[]     = '<span ' . $activeModules[$directory]['highlightCSS'] . '>\1</span>';
}

if (!is_array($results)) $results = array();
foreach ($results as $k=>$v) {
    // fetch the templates into an array to avoid multiple queries...
    if (!array_key_exists($v['templates_id'], $templates)) {
        $db = new DB;
        $db->query('SELECT tpl_first, tpl_detail, tpl_javascript '
                  .'FROM '.CPO_TEMPLATES.' '
                  .'WHERE id='.(int)$v['templates_id']);
        while ($db->next_record_assoc()) {
            $templates[$v['templates_id']] = $db->record();
        }
    }

    // fetch the rubric settings into an array to avoid multiple queries...
    if (!array_key_exists($v['rubric_id'], $rubrics)) {
        $db = new DB;
        $db->query('SELECT directory, name, seclevel, settings '
                  .'FROM '.CPO_RUBRIC.' '
                  .'WHERE id='.(int)$v['rubric_id']);
        while ($db->next_record_assoc()) {
            $rubrics[$v['rubric_id']] = $db->record();
            $rubric_settings = unserialize($rubrics[$v['rubric_id']]['settings']);
            $num_of_articles = (isset($rubric_settings['noOfArticles'])) ? $rubric_settings['noOfArticles'] : $cpoRubricSettingsDefaults['noOfArticles'];
        }
    }

    // Nur die Ausgabe fr die zu zeigende Seite
    $i++;
    if ($i<$_REQUEST['pos']) continue;
    //echo $_REQUEST['pos']."/".(int)$noOfResults;
    //if ($i>=$_REQUEST['pos']+(int)$noOfResults) break; //CHECK!

    // figure out if detail or index is to be displayed
    // default is detail:
    $link = BASE_REL . $rubrics[$v['rubric_id']]['directory'] . '/detail.php?rubric=' . urlencode($rubrics[$v['rubric_id']]['name']) . '&amp;nr=' . (int)$v['nr'];
    $published = "published";

    // disable the following line, to link to the index if the content can be found there
    // $v['fieldnamePreg'] = '/^$/';

    if (preg_match($v['fieldnamePreg'], $templates[$v['templates_id']]['tpl_first'])) {
        // FIXME figure out if index or archive is to be displayed and which page...
        if (strtotime($v['verfallsdatum'])>=time()) {
            // index
            $link = BASE_REL . $rubrics[$v['rubric_id']]['directory'] . '/index.php?rubric=' . urlencode($rubrics[$v['rubric_id']]['name']) . '&amp;nr='.(int)$v['nr'].'#'.(int)$v['nr'];
        } else {
            // archive
            $link = BASE_REL . $rubrics[$v['rubric_id']]['directory'] . '/archive.php?rubric=' . urlencode($rubrics[$v['rubric_id']]['name']) . '&amp;nr='.(int)$v['nr'].'#' . (int)$v['nr'];
            $published = "not-published";
        }
    }

    $freigabestatus = '';
    $target = "searchresults";
    if ($v['freigabe'] == 2)  {
        // $freigabestatus = " [".__('blocked')."]";
        $published = "not-published";
    }
    if ($v['freigabe'] == 3)  {
        // $freigabestatus = " [".__('rejected')."]";
        $published = "not-published";
    }
    if ($v['artikel_archiv'] == 5)  {
        $freigabestatus = " [".__('old version')."]";
        $published = "not-published";
    }
    if ($v['artikel_archiv'] == 9)  {
        $freigabestatus = " [".__('deleted')."]";
        $published = "not-published";
    }
    if ($freigabestatus != '')  {
        $link = 'javascript: void(0);';
        $target = "";
    }

    foreach ($q_array as $_q) {
        if ($_q!='' && $shortenBy && strpos(strtolower($v['result']), strtolower($_q)))  {
            preg_match('/(.*?)('.preg_quote($_q).')(.*)/smi', $v['result'], $matches);
            $matches[1] = (strlen($matches[1])>$shortenBy) ? '...'.substr($matches[1], -$shortenBy) : $matches[1];
            $matches[3] = (strlen($matches[3])>$shortenBy) ? substr($matches[3], 0, $shortenBy).'...' : $matches[3];
            // $v['result'] = htmlspecialchars($matches[1], ENT_COMPAT, 'ISO-8859-15') . htmlspecialchars($matches[2], ENT_COMPAT, 'ISO-8859-15') . htmlspecialchars($matches[3], ENT_COMPAT, 'ISO-8859-15');
            $v['result'] = $matches[1].$matches[2].$matches[3];
        } else if ($shortenBy)  {
            $v['result'] = (strlen($v['result'])>$shortenBy*2) ? substr($v['result'], 0, $shortenBy*2).'...' : $v['result'];
        }
    }

    $v['result'] = preg_replace($suchmuster, $ersatz, $v['result']);
    initVar($v['article_nr'],NULL);
    initVar($v['stufe4'],NULL);

    $sql_res_array[] = array(
        $v['titel'], // 0
        $v['autor'], // 1
        date($activeModules[$directory]['dateFormat'], strtotime($v['pub_datum'])), // 2
        $v['result'], // 3
        $link, // 4
        $i+1,  // 5
        $v['nr'], // 6
        $rubrics[$v['rubric_id']]['name'], // 7
        BASE_REL."_admin/index.php?navigation=".$v['nav_pos'], // 8
        $published, // 9
        $freigabestatus, // 10
        $target, // 11
        search_mini_title($v['freigabe'], $v['pub_datum'], $v['verfallsdatum'], $v['titel'], $v['autor'], $v['changer'], $v['nr'], $v['last_modify']), // 12
        search_mini_status($v['nr'], $v['article_nr'], $v['freigabe'], '_admin/articles.php?action=articles_status_release', $v['stufe4']), // 13
        search_mini_publication($v['pub_datum'], $v['verfallsdatum']), // 14
        $v['rubric_id'], // 15
        $rubrics[$v['rubric_id']]['directory'] // 16
    );
}

$replace_array[] = array ('<!-- SEARCH_TITLE -->',        '0');
$replace_array[] = array ('<!-- SEARCH_AUTHOR -->',       '1');
$replace_array[] = array ('<!-- SEARCH_PUB_DATE -->',     '2');
$replace_array[] = array ('<!-- SEARCH_CONTENT -->',      '3');
$replace_array[] = array ('<!-- SEARCH_LINK -->',         '4');
$replace_array[] = array ('<!-- SEARCH_NUM -->',          '5');
$replace_array[] = array ('<!-- SEARCH_ARTICLE_ID -->',   '6');
$replace_array[] = array ('<!-- SEARCH_RUBRIC -->',       '7');
$replace_array[] = array ('<!-- SEARCH_RUBRIC_LINK -->',  '8');
$replace_array[] = array ('<!-- SEARCH_PUBLISHED -->',    '9');
$replace_array[] = array ('<!-- SEARCH_STATUS -->',      '10');
$replace_array[] = array ('<!-- SEARCH_TARGET -->',      '11');
$replace_array[] = array ('<!-- SEARCH_MINI_TITLE -->',  '12');
$replace_array[] = array ('<!-- SEARCH_MINI_STATUS -->', '13');
$replace_array[] = array ('<!-- SEARCH_MINI_PUB -->',    '14');
$replace_array[] = array ('<!-- SEARCH_RUBRIC_ID -->',   '15');
$replace_array[] = array ('<!-- SEARCH_RUBRIC_DIR -->',  '16');

$message_string = messageBox($message);

$parsed = search_multitemplate_parser($activeModules[$directory]['template'], $replace_array, $sql_res_array);

initVar($page_string,'');
initVar($_REQUEST['action'],'');
initVar($pagination,'');
initVar($_REQUEST['rubric'],'');

//while (list($zeile, $page_row) = each ($parsed)) {
foreach ($parsed AS $zeile=>$page_row) {
    $page_string .= $page_row;
}

$matches = '';
if ($_REQUEST['action']=='search') {
    $matches = count($results)>0 
        ? sprintf($activeModules[$directory]['matchesText'], count($results)) : 
        $activeModules[$directory]['noMatchesText'];
}

$page_string = str_replace('<!-- SEARCH_PHRASE -->',     htmlspecialchars($_REQUEST['q'], ENT_QUOTES, 'ISO-8859-15'),      $page_string);
$page_string = str_replace('<!-- SEARCH_PAGES -->',      $pagination,         $page_string);
$page_string = str_replace('<!-- SEARCH_NAV -->',        htmlspecialchars($_REQUEST['rubric'], ENT_QUOTES, 'ISO-8859-15'), $page_string);
$page_string = str_replace('<!-- SEARCH_MESSAGE -->',    $message_string,     $page_string);
$page_string = str_replace('<!-- SEARCH_MATCHES -->',    $matches, $page_string);
if (isset($activeModules[$directory]['tableHead'])) $page_string = str_replace('<!-- SEARCH_TABLE_HEAD -->', (count($results)>0 ? $activeModules[$directory]['tableHead'] : ''),        $page_string);
if (isset($activeModules[$directory]['tableFoot'])) $page_string = str_replace('<!-- SEARCH_TABLE_FOOT -->', (count($results)>0 ? $activeModules[$directory]['tableFoot'] : ''),        $page_string);

if (!isset($mute)) echo $page_string;
