<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Templates"				                             |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

== Version: 4.1 / October 2020 ==

*/

if (!defined('CPO')) exit;
$translator->addTranslation('templates', CPO_BASEDIR.$moduleDirectory.'/lang');

$GLOBALS['modules']['templates'] = array(
    'directory' => $moduleDirectory,
    'caption'   => 'Templates export / import',
    'install'   => 'function: templates_install '.$moduleDirectory,
    'activate'  => 'function: templates_activate '.$moduleDirectory,
    'deactivate'=> 'function: templates_deactivate',
    'uninstall' => 'function: templates_uninstall '.$moduleDirectory
	);

$ok  = '<span style="color: #0c0; font-weight: bold;">'.__('Ok,').'</span> ';
$nok = '<span style="color: #f00; font-weight: bold;">'.__('Problem:').'</span> ';
$pok = '<span style="color: #fa0; font-weight: bold;">'.__('Note:').'</span> ';
$sol = '<span style="color: #00f; font-weight: bold;">'.__('Solution:').'</span> ';

function templates_install($moduleDirectory)
{
    $GLOBALS['message'][] = __('The templates module was successfully installed!');
	if (!is_writeable(CPO_BASEDIR.$moduleDirectory.'/files')) { 
		$GLOBALS['message'][] = $nok.sprintf(__('The directory <em>%s</em> is not writeable.'),$moduleDirectory.'/files');
		$GLOBALS['message'][] = $sol.sprintf(__('Please make sure that the user your webserver is running as has write access to the <em>%s</em> directory. Usually you can use your FTP client or command line tools to do so.'),$moduleDirectory);
	}
}
function templates_uninstall($moduleDirectory)
{
	 $GLOBALS['message'][] = sprintf(__('The templates module was removed from the ConPresso system. Please remove the module directory <i>%s</i> to finally uninstall the templates-module.'),$moduleDirectory);

}
function templates_activate($moduleDirectory)
{
	global $ok, $nok, $pok, $sol;
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";
    $GLOBALS['message'][] = __('The templates module got activated.').$reload_navigation;
	if (!is_writeable(CPO_BASEDIR.$moduleDirectory.'/files')) { 
		$GLOBALS['message'][] = $nok.sprintf(__('The directory <em>%s</em> is not writeable.'),$moduleDirectory.'/files');
		$GLOBALS['message'][] = $sol.sprintf(__('Please make sure that the user your webserver is running as has write access to the <em>%s</em> directory. Usually you can use your FTP client or command line tools to do so.'),$moduleDirectory);
	}
}

function templates_deactivate()
{
    $reload_navigation = "<script type=\"text/javascript\">";
    $reload_navigation .= "parent.cpo_navigation.location.href=\"../_admin/frame_navigation.php\";";
    $reload_navigation .= "</script>";
    $GLOBALS['message'][] = __('The templates module got deactivated.').$reload_navigation;
}

function templates_navigation($moduleDirectory)
{
    $GLOBALS['navigation']['Templates'][] = 'space'; 
    
    $GLOBALS['navigation']['Templates'][] = array(
            'caption'=>'export / import',
            'url'=>BASE_REL.$moduleDirectory.'/templates.php'
        );
}

if (isset($_SESSION['SID_user']['admin']) && $_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
    $hdlr_navigation[] = 'function: templates_navigation '.$moduleDirectory;
}

?>